<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use Illuminate\Support\Facades\Input;

use App\PropertyGallery;

use App\PropertyDetails;

use App\PropertyAmenity;

use App\PropertyRate;

use App\User;

use Response;

use Mail;

use DB;

class PropertyDetails extends Model
{
    protected $table = 'property_details';

    public static function getRecentPropertiesList($id){

        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $id = isset($id)?$id:'';
    	$properties = DB::table('property_details as pd')
    				 ->select('pd.*', 'pg.image_name as image', 'pg.property_gallery_id as pg_id',
                        (DB::raw('(SELECT count(cpd.click_time) FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id=pd.property_id) last_one_day_record')),

                        (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                        (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                        (DB::raw("(SELECT (CASE 
                            WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                CASE 
                                    WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                            WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                CASE
                                    WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                            WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                CASE
                                    WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                            ELSE
                                CASE
                                    WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                        END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                     )
    				 ->leftJoin('property_gallery as pg', 'pg.property_id','=','pd.property_id')
    				 ->orderBy('pd.created_at', 'desc')
                     ->groupBy('pd.property_id')
                     ->where("pd.verified", 'yes')
                     ->where("pd.property_id", '!=', $id)
                     ->where("pd.status", 'active')    				
    				 ->get();

    	if($properties){			 

    		return Response::json(array('message'=>'success', 'ip_address'=>$ip, 'properties_details'=>$properties));

    	}else{

    		return Response::json(array('message'=>'error', 'property_details'=>'There are no properties.'));
    	}
    	
    }

    public static function getSinglePropertyDetailsById($id, $deal_id){


        $result = array();

        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $property_rates     = DB::table('property_rate as pr')
                                ->select('pr.*')
                                ->where('pr.property_id', $id)
                                ->get();
                    
        $property_gallery   = DB::table('property_gallery as pg')
                                ->select('pg.*')
                                ->where('pg.property_id', $id)
                                ->get();

        $dealsQuery              = DB::table('deals as d')
                                ->select('d.*')
                                ->where('d.property_id', $id);
        if($deal_id){

            $dealsQuery->where('d.id', $deal_id);
                                
        }else{

            $dealsQuery->whereRaw('d.to_date >= CURDATE()');
        }                                
        
        $deals = $dealsQuery->get();

        if(count($deals)){

            $deal_click = 'yes';
        }else{
            $deal_click = 'no';
        }                                                               

        $property_details   = DB::table('property_details as pd')
                                ->select(
                                    'pd.*',
                                    'pd.status as prop_status',
                                    'pd.address as property_address',
                                    'pd.description as property_description',
                                    'pa.*', 
                                    'u.*',                                    
                                    (DB::raw('(SELECT count(cpd.click_time)+1 FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id='.$id.') last_one_day_record')),

                                    (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                                    (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                                    (DB::raw("(SELECT (CASE 
                                        WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                            CASE 
                                                WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                                        WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                                        WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                                        ELSE
                                            CASE
                                                WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                                    END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                                )
                                ->leftJoin('property_amenity as pa', 'pa.property_id','=','pd.property_id')                               
                                ->leftJoin('users as u', 'u.id', '=','pd.user_id')
                                ->where('pd.property_id', $id)                                
                                ->get(); 

        $property_testimonials = DB::table('testimonials as t')
                                ->select(
                                    't.*', 
                                    DB::raw('DATE_FORMAT(t.created_at, "%d-%m-%Y") as tcreated_at'),
                                    'pd.property_title')
                                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                                ->where('t.status', 'publish')
                                ->where('pd.property_id', $id)  
                                ->orderBy('t.created_at', 'desc')
                                ->offset(0)->limit(10)
                                ->get();
                                
        $latitude  = $property_details[0]['latitude'];
        $longitude = $property_details[0]['longitude'];                                
		$near_by			   = DB::select("SELECT pd.*, ( 6371 * acos( cos( radians(" . $latitude . ") ) * cos( radians( pd.latitude ) ) * cos( radians( pd.longitude ) - radians(" . $longitude . ") ) + sin( radians(" . $latitude . ") ) * sin( radians( pd.latitude ) ) ) ) AS distance FROM property_details as pd where pd.verified='yes' and pd.status='active' group by pd.property_id HAVING distance < 5");			                                                                             
		$result['near_by']         			= $near_by;
        $result['property_details']         = $property_details;
        $result['property_rates']           = $property_rates;
        $result['property_gallery']         = $property_gallery;
        $result['property_testimonials']    = $property_testimonials;
        $result['deals']                    = $deals;
        $result['deal_click']               = $deal_click;

        return $result;    	
    }

    public static function getUserSimilarProperties($request){
    	
    	$properties = DB::table('property_details as pd')
    				 ->select('pd.*', 'pg.image_name as image', 'pg.property_gallery_id as pg_id')
    				 ->leftJoin('property_gallery as pg', 'pg.property_id','=','pd.property_id')
    				 ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
    				 ->orderBy('pd.created_at', 'desc')
    				 ->where('u.id', $request['owner_id'])
                     ->where('pd.property_id', '!=', $request['property_id'])
                     ->where("pd.verified", 'yes')
                     ->where("pd.status", 'active')
                     ->groupBy('pd.property_id')
    				 ->get();
    	if($properties){

    		return Response::json(array('message'=>'success', 'property_details'=>$properties));

    	}else{

    		return Response::json(array('message'=>'error', 'property_details'=>'No properties found with this owner, Please try another'));
    	}			 
    }

    public static function getSimilarPropertiesByLocation($id, $latitude, $longitude){
        

        $properties = DB::select("SELECT pd.*, pg.image_name as image, pg.property_gallery_id as pg_id,  ( 6371 * acos( cos( radians(" . $latitude . ") ) * cos( radians( pd.latitude ) ) * cos( radians( pd.longitude ) - radians(" . $longitude . ") ) + sin( radians(" . $latitude . ") ) * sin( radians( pd.latitude ) ) ) ) AS distance FROM property_details as pd left join property_gallery as pg on pg.property_id=pd.property_id where pd.property_id!=".$id." and pd.verified='yes' and pd.status='active' group by pd.property_id HAVING distance < 5");    

                           
        if($properties){

            return Response::json(array('message'=>'success', 'property_details'=>$properties));

        }else{

            return Response::json(array('message'=>'error', 'property_details'=>'No properties found!'));
        }                      
    }

    public static function getUserSearchResults($request){

       // print_r($request->all());die();
        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $id = isset($id)?$id:'';

        $searchPropertiesQuery = DB::table('property_details as pd')
                                 ->select('pd.*','pa.*', 'pg.image_name', 'pbd.start_date', 'pbd.end_date',
                                 	(DB::raw('(SELECT count(cpd.click_time)+1 FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id=pd.property_id) last_one_day_record')),

                                    (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                                    (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                                 	(DB::raw("(SELECT (CASE 
												WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
												    CASE 
												    	WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
												WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
													CASE
														WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
												WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
													CASE
														WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
												ELSE
													CASE
														WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
											END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                                 )
                                 ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                                 ->leftJoin('property_preblock_details as pbd', 'pbd.property_id', '=', 'pd.property_id')
                                 ->leftJoin('property_amenity as pa', 'pa.property_id', '=', 'pd.property_id');
                           

        if($request->has('city')){

            $searchPropertiesQuery->whereRaw("pd.city LIKE '%".$request['city']."%'"); 

        }

        $min_price  = $request->has('min_price')?$request['min_price']:null;
        $max_price  = $request->has('max_price')?$request['max_price']:null;
       
        if(isset($min_price)){ 
            
                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week >= ".$min_price."");
            
        } 

        if(isset($min_price) && isset($max_price)){ 
            if($min_price<$max_price){    

                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week >= ".$min_price.""); 

                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week <= ".$max_price."");
            }
            
        } 


        $arrival_time       = $request->has('arrival_time')?$request['arrival_time']:null;
        $departure_time     = $request->has('departure_time')?$request['departure_time']:null;
        
       $pre_prop_id = array();
        if(isset($arrival_time) && isset($departure_time)){           
            $preBlockPropQuery = DB::table('property_preblock_details as pbd')
                                     ->select('pbd.property_id', 'pbd.start_date', 'pbd.end_date');                          
                                     
            $preBlockPropQuery->whereRaw("pbd.start_date <= '".$departure_time."'"); 
            $preBlockPropQuery->whereRaw("pbd.end_date   >= '".$arrival_time."'");  
            $preblockProp = $preBlockPropQuery->get();            
            if(count($preblockProp)>0){
              foreach ($preblockProp as $pre) {
               $res = array();               
               $res = $pre['property_id'];   
               array_push($pre_prop_id, $res);
              }
            }            
      }          
        if($request->has('space_type')){

            $searchPropertiesQuery->whereRaw("pd.space_type LIKE '%".$request['space_type']."%'"); 
        }

        if($request->has('guest_limit')){ //echo $request['guest_limit'];die();

            $searchPropertiesQuery->whereRaw("pd.guest_limit >= ". $request['guest_limit'] .""); 
        }

        if($request->has('single_room')){
            
            $searchPropertiesQuery->whereRaw("pd.single_room <= ". $request['single_room'] .""); 
            
        }

        if($request->has('double_room')){
            
            $searchPropertiesQuery->whereRaw("pd.double_room <= ". $request['double_room'] .""); 
              
        }

        if($request->has('twin_room')){
            
            $searchPropertiesQuery->whereRaw("pd.twin_room  <= ".$request['twin_room']."");                        
        }

        if($request->has('other_room')){
            
            $searchPropertiesQuery->whereRaw("pd.other_room  <= ".$request['other_room']."");                        
        }

        if($request->has('minimum_stay')){
            if($request['minimum_stay']=='Any'){
                $searchPropertiesQuery->whereRaw("pd.minimum_stay >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.minimum_stay >= ". $request['minimum_stay'] .""); 
            }
        }

        
        if($request->has('bathroom')){
            if($request['bathroom']=='Any'){
                $searchPropertiesQuery->whereRaw("pd.bathroom >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.bathroom >= ". $request['bathroom'] .""); 
            }
        }

        if($request->has('tv')){

            $searchPropertiesQuery->whereRaw("pa.tv LIKE '%".$request['tv']."%'"); 
        }

        if($request->has('twenty_four_hour_security')){

            $searchPropertiesQuery->whereRaw("pa.twenty_four_hour_security LIKE '%".$request['twenty_four_hour_security']."%'"); 
        }

        if($request->has('air_conditioning')){

            $searchPropertiesQuery->whereRaw("pa.air_conditioning LIKE '%".$request['air_conditioning']."%'"); 
        }

        if($request->has('barbq_equipment')){

            $searchPropertiesQuery->whereRaw("pa.barbq_equipment LIKE '%".$request['barbq_equipment']."%'"); 
        }

        if($request->has('beach_access')){

            $searchPropertiesQuery->whereRaw("pa.beach_access LIKE '%".$request['beach_access']."%'"); 
        }

        if($request->has('access_books')){

            $searchPropertiesQuery->whereRaw("pa.access_books LIKE '%".$request['access_books']."%'"); 
        }

        if($request->has('cable_tv')){

            $searchPropertiesQuery->whereRaw("pa.cable_tv LIKE '%".$request['cable_tv']."%'"); 
        }

        if($request->has('car')){

            $searchPropertiesQuery->whereRaw("pa.car LIKE '%".$request['car']."%'"); 
        }

        if($request->has('central_heating')){

            $searchPropertiesQuery->whereRaw("pa.central_heating LIKE '%".$request['central_heating']."%'"); 
        }

        if($request->has('close_to_public_transport')){

            $searchPropertiesQuery->whereRaw("pa.close_to_public_transport LIKE '%".$request['close_to_public_transport']."%'"); 
        }

        if($request->has('coffee_maker')){

            $searchPropertiesQuery->whereRaw("pa.coffee_maker LIKE '%".$request['coffee_maker']."%'"); 
        }

        if($request->has('conference_centre')){

            $searchPropertiesQuery->whereRaw("pa.conference_centre LIKE '%".$request['conference_centre']."%'"); 
        }

        if($request->has('cooking_facilities')){

            $searchPropertiesQuery->whereRaw("pa.cooking_facilities LIKE '%".$request['cooking_facilities']."%'"); 
        }

        if($request->has('cot_available')){

            $searchPropertiesQuery->whereRaw("pa.cot_available LIKE '%".$request['cot_available']."%'"); 
        }

        if($request->has('country_club')){

            $searchPropertiesQuery->whereRaw("pa.country_club LIKE '%".$request['country_club']."%'"); 
        }
        if($request->has('dishwasher')){

            $searchPropertiesQuery->whereRaw("pa.dishwasher LIKE '%".$request['dishwasher']."%'"); 
        }
        if($request->has('dvd_player')){

            $searchPropertiesQuery->whereRaw("pa.dvd_player LIKE '%".$request['dvd_player']."%'"); 
        }
        if($request->has('electricity')){

            $searchPropertiesQuery->whereRaw("pa.electricity LIKE '%".$request['electricity']."%'"); 
        }
        if($request->has('ensuite')){

            $searchPropertiesQuery->whereRaw("pa.ensuite LIKE '%".$request['ensuite']."%'"); 
        }
        if($request->has('european_appliances')){

            $searchPropertiesQuery->whereRaw("pa.european_appliances LIKE '%".$request['european_appliances']."%'"); 
        }
        if($request->has('couples_preferred')){

            $searchPropertiesQuery->whereRaw("pa.couples_preferred LIKE '%".$request['couples_preferred']."%'"); 
        }
        if($request->has('game_console')){

            $searchPropertiesQuery->whereRaw("pa.game_console LIKE '%".$request['game_console']."%'"); 
        }
        if($request->has('garage')){

            $searchPropertiesQuery->whereRaw("pa.garage LIKE '%".$request['garage']."%'"); 
        }
        if($request->has('gas')){

            $searchPropertiesQuery->whereRaw("pa.gas LIKE '%".$request['gas']."%'"); 
        }
        if($request->has('gated_community')){

            $searchPropertiesQuery->whereRaw("pa.gated_community LIKE '%".$request['gated_community']."%'"); 
        }
        if($request->has('golf')){

            $searchPropertiesQuery->whereRaw("pa.golf LIKE '%".$request['golf']."%'"); 
        }
        if($request->has('gymnasium')){

            $searchPropertiesQuery->whereRaw("pa.gymnasium LIKE '%".$request['gymnasium']."%'"); 
        }
        if($request->has('high_chair')){

            $searchPropertiesQuery->whereRaw("pa.high_chair LIKE '%".$request['high_chair']."%'"); 
        }
        if($request->has('horse_riding')){

            $searchPropertiesQuery->whereRaw("pa.horse_riding LIKE '%".$request['horse_riding']."%'"); 
        }
        if($request->has('house_swap')){

            $searchPropertiesQuery->whereRaw("pa.house_swap LIKE '%".$request['house_swap']."%'"); 
        }
        if($request->has('internet_access')){

            $searchPropertiesQuery->whereRaw("pa.internet_access LIKE '%".$request['internet_access']."%'"); 
        }
        if($request->has('laundry_facilities')){

            $searchPropertiesQuery->whereRaw("pa.laundry_facilities LIKE '%".$request['laundry_facilities']."%'"); 
        }
        if($request->has('local_golf_course')){

            $searchPropertiesQuery->whereRaw("pa.local_golf_course LIKE '%".$request['local_golf_course']."%'"); 
        }
        if($request->has('local_grocery_store')){

            $searchPropertiesQuery->whereRaw("pa.local_grocery_store LIKE '%".$request['local_grocery_store']."%'"); 
        }
        if($request->has('tv')){

            $searchPropertiesQuery->whereRaw("pa.tv LIKE '%".$request['tv']."%'"); 
        }
        if($request->has('music')){

            $searchPropertiesQuery->whereRaw("pa.music LIKE '%".$request['music']."%'"); 
        }
        if($request->has('sports_facilities')){

            $searchPropertiesQuery->whereRaw("pa.sports_facilities LIKE '%".$request['sports_facilities']."%'"); 
        }
        if($request->has('games_facilities')){

            $searchPropertiesQuery->whereRaw("pa.games_facilities LIKE '%".$request['games_facilities']."%'"); 
        }
        if($request->has('microwave')){

            $searchPropertiesQuery->whereRaw("pa.microwave LIKE '%".$request['microwave']."%'"); 
        }
        if($request->has('oven_hob')){

            $searchPropertiesQuery->whereRaw("pa.oven_hob LIKE '%".$request['oven_hob']."%'"); 
        }
        if($request->has('fridge')){

            $searchPropertiesQuery->whereRaw("pa.fridge LIKE '%".$request['fridge']."%'"); 
        }
        if($request->has('freezer')){

            $searchPropertiesQuery->whereRaw("pa.freezer LIKE '%".$request['freezer']."%'"); 
        }
        if($request->has('washing_machine')){

            $searchPropertiesQuery->whereRaw("pa.washing_machine LIKE '%".$request['washing_machine']."%'"); 
        }
        if($request->has('parking')){

            $searchPropertiesQuery->whereRaw("pa.parking LIKE '%".$request['parking']."%'"); 
        }
        if($request->has('safe')){

            $searchPropertiesQuery->whereRaw("pa.safe LIKE '%".$request['safe']."%'"); 
        }
        if($request->has('hair_dryer')){

            $searchPropertiesQuery->whereRaw("pa.hair_dryer LIKE '%".$request['hair_dryer']."%'"); 
        }
        if($request->has('iron')){

            $searchPropertiesQuery->whereRaw("pa.iron LIKE '%".$request['iron']."%'"); 
        }
        if($request->has('restaurant_cafe')){

            $searchPropertiesQuery->whereRaw("pa.restaurant_cafe LIKE '%".$request['restaurant_cafe']."%'"); 
        }
        if($request->has('private_pool')){

            $searchPropertiesQuery->whereRaw("pa.private_pool LIKE '%".$request['private_pool']."%'"); 
        }
        if($request->has('commual_pool')){

            $searchPropertiesQuery->whereRaw("pa.commual_pool LIKE '%".$request['commual_pool']."%'"); 
        }
        if($request->has('private_jacuzzi')){

            $searchPropertiesQuery->whereRaw("pa.private_jacuzzi LIKE '%".$request['private_jacuzzi']."%'"); 
        }
        if($request->has('communal_jacuzzi')){

            $searchPropertiesQuery->whereRaw("pa.communal_jacuzzi LIKE '%".$request['communal_jacuzzi']."%'"); 
        }
        if($request->has('private_garden')){

            $searchPropertiesQuery->whereRaw("pa.private_garden LIKE '%".$request['private_garden']."%'"); 
        }
        if($request->has('communal_garden')){

            $searchPropertiesQuery->whereRaw("pa.communal_garden LIKE '%".$request['communal_garden']."%'"); 
        }
        if($request->has('maid_service')){

            $searchPropertiesQuery->whereRaw("pa.maid_service LIKE '%".$request['maid_service']."%'"); 
        }
        if($request->has('pets_welcome')){

            $searchPropertiesQuery->whereRaw("pa.pets_welcome LIKE '%".$request['pets_welcome']."%'"); 
        }
        if($request->has('smoking_allowed')){

            $searchPropertiesQuery->whereRaw("pa.smoking_allowed LIKE '%".$request['smoking_allowed']."%'"); 
        }
        if($request->has('mobility_impaired')){

            $searchPropertiesQuery->whereRaw("pa.mobility_impaired LIKE '%".$request['mobility_impaired']."%'"); 
        } 
            
             $searchPropertiesQuery->whereRaw("pd.verified LIKE '%yes%'");
             $searchPropertiesQuery->whereRaw("pd.status LIKE '%active%'");
             $searchPropertiesQuery->whereNotIn("pd.property_id", $pre_prop_id);             
             $searchPropertiesQuery->groupBy('pd.property_id');
             $searchPropertiesQuery->orderBy('pd.created_at', 'desc');            
             

             $rdata['prop'] = $searchPropertiesQuery->get(); 
            
             if($rdata){            

                return Response::json(array('message'=>'success', 'properties_details'=>$rdata));

             }else{

                return Response::json(array('message'=>'error', 'property_details'=>'There are no properties with given requirement.'));
             }  
              
         
        }


    public static function addPropertyDetails($request){

        $propertyObj = new PropertyDetails;

        if($request->has('address')){
            $address = isset($request['address'])?$request['address']:'';
            $propertyObj->address = $address;
        }
        if($request->has('user_id')){
            $user_id = isset($request['user_id'])?$request['user_id']:'';
            $propertyObj->user_id = $user_id;
        }
        if($request->has('latitude')){

            $latitude = isset($request['latitude'])?$request['latitude']:'';
            $propertyObj->latitude = $latitude;
        }
        if($request->has('longitude')){

            $longitude = isset($request['longitude'])?$request['longitude']:'';
            $propertyObj->longitude = $longitude;
        }
        if($request->has('house_no')){

            $house_no = isset($request['house_no'])?$request['house_no']:'';
            $propertyObj->house_no = $house_no;
        }
        if($request->has('security_deposit_amount')){

            $security_deposit_amount = isset($request['security_deposit_amount'])?$request['security_deposit_amount']:'';
            $propertyObj->security_deposit_amount = $security_deposit_amount;
        }
        if($request->has('floor_name')){

            $floor_name = isset($request['floor_name'])?$request['floor_name']:'';
            $propertyObj->floor_name = $floor_name;
        }
        if($request->has('street_name')){

            $street_name = isset($request['street_name'])?$request['street_name']:'';
            $propertyObj->street_name = $street_name;
        }
        if($request->has('town')){

            $town = isset($request['town'])?$request['town']:'';
            $propertyObj->town = $town;
        }
        if($request->has('city')){

            $city = isset($request['city'])?$request['city']:'';
            $propertyObj->city = $city;
        }
        if($request->has('area_code')){

            $area_code = isset($request['area_code'])?$request['area_code']:'';
            $propertyObj->area_code = $area_code;
        }
        if($request->has('state')){

            $state = isset($request['state'])?$request['state']:'';
            $propertyObj->state = $state;
        }
        if($request->has('country')){
            $country = isset($request['country'])?$request['country']:'';
            $propertyObj->country = $country;
        }
        if($request->has('property_title')){

            $property_title = isset($request['property_title'])?$request['property_title']
            :'';
            $propertyObj->property_title = $property_title;
        }
        if($request->has('description')){

            $description = isset($request['description'])?$request['description']:'';
            $propertyObj->description = $description;
        }

        if($request->has('space_type')){
            $space_type = isset($request['space_type'])?$request['space_type']:'';
            $propertyObj->space_type = $space_type;
        }
        if($request->has('guest_limit')){

            $guest_limit = isset($request['guest_limit'])?$request['guest_limit']:'';
            $propertyObj->guest_limit = $guest_limit;
        }
        if($request->has('single_room')){

            $single_room = isset($request['single_room'])?$request['single_room']:'';
            $propertyObj->single_room = $single_room;
        }
        if($request->has('double_room')){
            $double_room = isset($request['double_room'])?$request['double_room']:'';
            $propertyObj->double_room = $double_room;
        }
        if($request->has('twin_room')){
            $twin_room = isset($request['twin_room'])?$request['twin_room']:'';
            $propertyObj->twin_room = $twin_room;
        }
        if($request->has('other_room')){
            $other_room = isset($request['other_room'])?$request['other_room']:'';
            $propertyObj->other_room = $other_room;
        }
        if($request->has('bathroom')){

            $bathroom = isset($request['bathroom'])?$request['bathroom']:'';
            $propertyObj->bathroom = $bathroom;
        }   
        if($request->has('standard_rate_per_day')){

            $standard_rate_per_day = isset($request['standard_rate_per_day'])?$request['standard_rate_per_day']:'';
            $propertyObj->standard_rate_per_day = $standard_rate_per_day;
        }
        if($request->has('standard_rate_per_week')){

            $standard_rate_per_week = isset($request['standard_rate_per_week'])?$request['standard_rate_per_week']:'';
            $propertyObj->standard_rate_per_week = $standard_rate_per_week;
        }
        if($request->has('minimum_stay')){

            $minimum_stay = isset($request['minimum_stay'])?$request['minimum_stay']:'';
            $propertyObj->minimum_stay = $minimum_stay;
        }    
        if($request->has('verified')){

            $verified = isset($request['verified'])?$request['verified']:'';
            $propertyObj->verified = $verified;
        }        
        

        if($request->has('status')){

            $status = isset($request['status'])?$request['status']:'';
            $propertyObj->status = $status;
        }
            $propertyObj->created_at  = date('Y-m-d H:i:s');
            $propertyObj->updated_at  = date('Y-m-d H:i:s');
         
            $propertyObj->save();

        $propId = $propertyObj->id;

        if($request->hasfile('main_image_name')){

            $directory = public_path().'/uploads/property_images/'.$propId.'/'; 

                if (!file_exists($directory)) {
                    mkdir($directory, 0777, true);
                }
                $files   = $request->file('main_image_name');                
                $gallery = '';
                
                $img     = 'main_image.'.$files->getClientOriginalExtension(); 
                $files->move($directory,$img);
                
                $gallery = DB::table('property_details')
                              ->where('property_id', $propId)
                              ->update([
                                'property_image' => $img,
                             ]);         
                
        }

        
        if($request->hasfile('image_name')){ 
            $images= PropertyGallery::savePropertyImages($request, $propId);
        }

        if($request->has('amenities')){

            $amenities = PropertyAmenity::savePropertyAmenities($request, $propId);
        }

        if($request->has('prop_rates')){
           
            $price = PropertyRate::savePropertyRates($request, $propId);

        } 
       // print_r($propertyObj);die();
        if($propertyObj){

            return Response::json(array('success'=>'1', 'message'=>'Property added successfully', 'property_details'=>$propertyObj));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Property not added successfully, Please try again'));
        }
       
    }

    /*public static function deletePropertyDetails($request){

       $propId      = isset($request['property_id'])?$request['property_id']:'';

       $property    = DB::table('property_details')->where('property_id', $propId)->delete();

        if($property){

            return Response::json(array('success'=>'1', 'message'=>'Property details deleted successfully!'));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Property details not deleted successfully!'));
        }
             
    }*/ 

    public static function editPropertyDetails($request){
     
        $result = array();

        if(isset($request['property_id']) && isset($request['property_id'])){

            $eproperty      = PropertyDetails::getExistingPropertyDetails($request['property_id']);
           
            $address        = isset($request['address'])?$request['address']:$eproperty['address'];           
            $user_id        = isset($request['user_id'])?$request['user_id']:$eproperty['user_id'];  
            
            $user_mail_details = PropertyDetails::getUserDetailsById($user_id);
            $latitude       = isset($request['latitude'])?$request['latitude']:$eproperty['latitude'];            
            $longitude      = isset($request['longitude'])?$request['longitude']:$eproperty['longitude'];   
            $house_no       = isset($request['house_no'])?$request['house_no']:$eproperty['house_no'];
            $floor_name     = isset($request['floor_name'])?$request['floor_name']:$eproperty['floor_name'];
            $street_name    = isset($request['street_name'])?$request['street_name']:$eproperty['street_name'];
            $town           = isset($request['town'])?$request['town']:$eproperty['town'];
            $city           = isset($request['city'])?$request['city']:$eproperty['city'];        
            $area_code      = isset($request['area_code'])?$request['area_code']:$eproperty['area_code'];
            $state          = isset($request['state'])?$request['state']:$eproperty['state'];
            $country        = isset($request['country'])?$request['country']:$eproperty['country'];
            $property_title = isset($request['property_title'])?$request['property_title']
            :$eproperty['property_title'];
            $description    = isset($request['description'])?$request['description']:$eproperty['description'];
            $space_type     = isset($request['space_type'])?$request['space_type']:$eproperty['space_type'];
            $guest_limit    = isset($request['guest_limit'])?$request['guest_limit']:$eproperty['guest_limit'];
            $single_room                = isset($request['single_room'])?$request['single_room']:$eproperty['single_room'];
            $double_room                = isset($request['double_room'])?$request['double_room']:$eproperty['double_room'];
            $twin_room                  = isset($request['twin_room'])?$request['twin_room']:$eproperty['twin_room'];
            $other_room                 = isset($request['other_room'])?$request['other_room']:$eproperty['other_room'];   
            
            $bathroom       = isset($request['bathroom'])?$request['bathroom']:$eproperty['bathroom'];            
            $standard_rate_per_day      = isset($request['standard_rate_per_day'])?$request['standard_rate_per_day']:$eproperty['standard_rate_per_day'];
            $standard_rate_per_week     = isset($request['standard_rate_per_week'])?$request['standard_rate_per_week']:$eproperty['standard_rate_per_week'];
            $minimum_stay               = isset($request['minimum_stay'])?$request['minimum_stay']:$eproperty['minimum_stay'];
            $verified                   = isset($request['verified'])?$request['verified']:$eproperty['verified'];
            $status                     = isset($request['status'])?$request['status']:$eproperty['status'];
            $security_deposit_amount    = isset($request['security_deposit_amount'])?$request['security_deposit_amount']:$eproperty['security_deposit_amount'];
                         
                         
                $data   = DB::table('property_details as pd')
                            ->where('pd.property_id', $request['property_id'])
                            ->update(array(
                                'address'           => $address,
                                'verified'          => $verified,
                                'status'            => $status,
                                'user_id'           => $user_id,
                                'latitude'          => $latitude,
                                'longitude'         => $longitude,
                                'house_no'          => $house_no,
                                'street_name'       => $street_name,
                                'town'              => $town,
                                'floor_name'        => $floor_name,
                                'city'              => $city,
                                'area_code'         => $area_code,
                                'state'             => $state,
                                'country'           => $country,
                                'property_title'    => $property_title,
                                'description'       => $description,
                                'space_type'        => $space_type,
                                'guest_limit'       => $guest_limit,
                                'single_room'                => $single_room,
                                'double_room'                => $double_room,
                                'twin_room'                  => $twin_room,
                                'other_room'                 => $other_room,
                                'bathroom'                   => $bathroom,
                                'standard_rate_per_day'      => $standard_rate_per_day,
                                'standard_rate_per_week'     => $standard_rate_per_week,
                                'minimum_stay'               => $minimum_stay,
                                'security_deposit_amount'    => $security_deposit_amount
                            ));

                if($verified=='yes' && $request['sentMail']=='yes'){

                    $mail =  Mail::send('emails.property-activate', ['user_mail_details'=>$user_mail_details], function ($m) use ($user_mail_details) {

                                $m->from('info@direct-owners.com', 'Direct Owners');

                                $m->to($user_mail_details['email'])->subject('Property activation mail');
                            });
                           
                }            

               $main_image=''; $propertyRate='';  $propertyGallery = '';    $propertyAmenity='';

                if($request->hasfile('main_image_name')){

                    $directory = public_path().'/uploads/property_images/'.$request['property_id'].'/'; 

                    if (!file_exists($directory)) {
                        mkdir($directory, 0777, true);
                    }
                    $files       = $request->file('main_image_name');                
                    $gallery     = '';
                    
                    $img         = 'main_image.'.$files->getClientOriginalExtension(); 
                    $main_image  = $files->move($directory,$img);
                    
                    $main_image1 = DB::table('property_details')
                                  ->where('property_id', $request['property_id'])
                                  ->update([
                                    'property_image' => $img,
                                 ]);         
                    
                 } 
                    
                if(isset($request['property_id'])){

                    $propertyRate   = PropertyRate::savePropertyRates($request, $request['property_id']);
                }   

                if(isset($request['property_id']) && $request->hasfile('image_name')){
                   
                    $propertyGallery = PropertyGallery::savePropertyImages($request, $request['property_id']);                            
                } 

                if(isset($request['property_id'])){

                    $propertyAmenity = PropertyAmenity::editPropertyAmenityDetails($request);
                }                   

            
            if($main_image || $data || $propertyRate || $propertyGallery || $propertyAmenity){

                return Response::json(array('success'=>'1', 'message'=>'Property details edited successfully!'));
            }else{

                return Response::json(array('success'=>'0', 'message'=>'Property details not edited!'));
            }                  

        }

    } 

    public static function getUserDetailsById($id){

        $data = DB::table('users as u')
                ->select('u.id', DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.email')
                ->where('u.id', $id)
                ->first();
        return $data;         
    } 

    public static function getExistingPropertyDetails($propId){ 

        $property = DB::table('property_details as pd')
                    ->select('pd.*')
                    ->where('property_id', $propId)
                    //->where("pd.verified", 'yes')
                    //->where("pd.status", 'active')
                    ->first();
        return $property;
    }

    public static function getPropertiesDetails($request){
        $property = '';
        if(isset($request['status']) && $request['verified']){
        if($request['status']=='active' && $request['verified']=='yes') {
                $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('pd.verified', 'yes')
                    ->where('pd.status', 'active')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
            }
        if($request['status']!='active' || $request['status']=='active' && $request['verified']!='yes') { 
                $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where("pd.status", '!=', 'active')
                    ->where("pd.verified", '!=' ,'yes')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
        }
       }            
        
            if($property){

                return Response::json(array('success'=>'1', 'properties_details'=>$property));

            }else{

                return Response::json(array('success'=>'0', 'properties_details'=>'No results found'));
            }            
    }

    public static function getMinMaxValues(){

       /* $property =  DB::select('select  min(LEAST(standard_rate_per_day, standard_rate_per_week)) as min_price, max(GREATEST(standard_rate_per_day, standard_rate_per_week)) as max_price from property_details where verified="verified" and status="active"');*/

        $property = DB::table('property_details as pd')
                    ->select(DB::raw('MAX(pd.standard_rate_per_week) AS max_price'))
                    ->where("pd.verified", 'yes')
                    ->where("pd.status", 'active')
                    ->first();
                    
        if($property){

            return Response::json(array('success'=>'1', 'data'=>$property));

        }
    }

    public static function getActivePropertiesDetails(){

        $property = DB::table('property_details as pd')
                    ->select('pd.*')
                    ->where("pd.verified", 'yes')
                    ->where("pd.status", 'active')
                    ->get();
                    
        if($property){

            return Response::json(array('success'=>'1', 'properties_details'=>$property));

        }else{
            
            return Response::json(array('success'=>'0', 'properties_details'=>'No properties are there!'));                                               
        }

    }

    public static function getUserPropertiesDashborad($request){

        if(isset($request['status']) && $request['verified']){
        if($request['status']=='active' && $request['user_id'] && $request['verified']=='yes') {
                $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->where('pd.verified', 'yes')
                    ->where('pd.status', 'active')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
            }
        if($request['status']!='active' || $request['status']=='active' && $request['verified']!='yes' && $request['user_id']) { 
                $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->where("pd.status", '!=', 'active')
                    ->where("pd.verified", '!=' ,'yes')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
        }
       }
        if($request['user_id'] && !isset($request['verified']) && !isset($request['status'])) {
                $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
        }
        
            if($property){

                return Response::json(array('success'=>'1', 'properties_details'=>$property));

            }else{

                return Response::json(array('success'=>'0', 'properties_details'=>'No results found'));
            }            
    }      

    public static function getOwnerDashboardStats($input){

        $result = array();

        $allpropertiesCount     = DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])                                
                                  ->count();

        $activePropertiesCount  = DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])
                                  ->where("pd.status", '=', 'active')
                                  ->where("pd.verified", '=' ,'yes')                                
                                  ->count();

        $inactivePropertiesCount= DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])
                                  ->where("pd.status", '!=', 'active')
                                  ->where("pd.verified", '!=' ,'yes')                               
                                  ->count(); 

        $enquiriesCount        = DB::table('property_enquiry as pe')
                                  ->select('pe.*')
                                  ->where('pe.owner_id', $input['owner_id'])
                                  ->count();

        $notificationsCount    = DB::table('property_notifications as pn')
                                  ->select('pn.*')
                                  ->count();                                      

         $result['allpropertiesCount'] = $allpropertiesCount;
         $result['activePropertiesCount'] = $activePropertiesCount;
         $result['inactivePropertiesCount'] = $inactivePropertiesCount;
         $result['enquiriesCount'] = $enquiriesCount;
         $result['notificationsCount'] = $notificationsCount;             

        if($result){

            return Response::json(array('success'=>'1', 'properties_details'=>$result));

        }else{
            
            return Response::json(array('success'=>'0', 'properties_details'=>'No properties are there!'));                                               
        }                                                                   

    }

    public static function getCountriesList(){

        $countries = DB::table('country as c')
                     ->select('c.*')
                     ->get();
        if($countries){

            return Response::json(array('success'=>'1', 'countries'=>$countries));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No countries are there!'));                                               
        }             
    }

    public static function getCitiesByCountry($id){

        $cities = DB::table('city as cs')
                     ->select('cs.*')
                     ->join('country as c', 'c.id', '=', 'cs.countryid')
                     ->where('cs.countryid', $id)
                     ->get();
        if($cities){

            return Response::json(array('success'=>'1', 'cities'=>$cities));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No cities are there!'));                                               
        }             

    }

    public static function getCitiesListToSearch(){

        $cities = DB::select("select distinct `pd`.`city`, COUNT(property_id) from `property_details` as `pd` where `pd`.`city` != '' and `pd`.`status` ='active' group by `pd`.`city` order by count(property_id) DESC, pd.city asc limit 0,10");

        /*$cities = DB::table('property_details as pd')
                      ->select('pd.city')
                      ->groupBy('pd.city')
                      ->distinct('pd.city')
                      ->where('pd.city', '!=', '')
                      ->orderBy('pd.city', 'asc') 
                      ->get();*/  
        if($cities){

            return Response::json(array('success'=>'1', 'cities'=>$cities));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No cities are there!'));                                               
        }    

    }

    public static function getAllPropertiesDetailsList(){

         $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->orderBy('pd.created_at', 'desc')
                    ->get();

        if($property){

            return Response::json(array('success'=>'1', 'property'=>$property));

        }else{
            
            return Response::json(array('success'=>'0', 'property'=>'No properties are there!'));                                               
        } 
    }


    public static function getDeletePropertyDetailsById($ids){

        $prop_images  = PropertyDetails::getDeletePropertyImageDirectory($ids);

        $property_details    = DB::table('property_details')->whereIn('property_id', $ids)->delete();
        $property_amenity    = DB::table('property_amenity')->whereIn('property_id', $ids)->delete();
        $property_gallery    = DB::table('property_gallery')->whereIn('property_id', $ids)->delete();
        $property_preblock_details    = DB::table('property_preblock_details')->whereIn('property_id', $ids)->delete();
        $property_rate       = DB::table('property_rate')->whereIn('property_id', $ids)->delete();   

        if($property_details){

            return Response::json(array('success'=>'1', 'message'=>'Property details deleted successfully!'));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Property details not deleted successfully!'));
        }     
    }

    public static function getDeletePropertyImageDirectory($ids){
        foreach($ids as $id){
          $dir = public_path().'/uploads/property_images/'.$id.'/';  
          if(is_dir($dir)){
            foreach(glob($dir . '/*') as $file) { 
              if(is_dir($file)) delete_files($file); else unlink($file); 
            } rmdir($dir); 
          }
        }
    }
}
