<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use Illuminate\Support\Facades\Request;

use Redirect;

use Response;

use Validator;

use Session;

use Hash;

use DB;

class Admin extends Model
{
   protected $table = 'admin';

   public static function adminLoginCheck($request){


        $data = Admin::getUserDetailsWithEmail($request['username']);
        
        if($data){ 
           //If admin is found
            if(Hash::check($request['password'], $data['password'])){
              
              $x = Admin::updateUserToken($data['id']);              
            
              // Put admin into session
              $array= array('id' => $data['id'], 'name'=>$data['first_name'].' '.$data['surname'], 'email' => $data['username'] ,'token'=>$x, 'time' => $data['updated_at']);
              
              Session::push('admin_logged_in', $array);
              
              //return to home with success message
                $input['successMsg'] = 'Your have successfuly Logged in.';
                
                if(Session::has('admin_logged_in')){
                  return Redirect::route('admin.dashboard')->withInput($input);
                }else{
                  return Redirect::route('admin.login');
                }
            }
           
      }  
 }
   public static function getUserDetailsWithEmail($username){

        $data = DB::table('admin')
                    ->select('*')
                    ->where('username', $username)
                    ->first();

        return $data;
    }

     public static function updateUserToken($user_id) {

        $token  = str_random(40);
        $data   = DB::table('admin as u')
                    ->where('u.id', $user_id)
                    ->update(array(
                        'token' => $token,
                  ));
                    
        return $token;
    }   

    public static function getUpdateAdminProfile($request){
        
        if($request['admin_id']){
          $edata  = DB::table('admin')
                      ->select('*')
                      ->where('id', $request['admin_id'])
                      ->first();

          $first_name = isset($request['first_name'])?$request['first_name']:$edata['first_name'];
          $surname    = isset($request['surname'])?$request['surname']:$edata['surname'];
          $username   = isset($request['username'])?$request['username']:$edata['username'];
          
          $data       = DB::table('admin')
                        ->where('id', $request['admin_id'])
                        ->update(array(
                            'first_name'  => $first_name,
                            'surname'     => $surname,
                            'username'    => $username,
                        ));
                      
          return $data;
        }
    }

    public static function getAdminDashboardStats(){

      $result = array();

            $allpropertiesCount     = DB::table('property_details as pd')
                                      ->select('pd.*')
                                      ->count();

            $activePropertiesCount  = DB::table('property_details as pd')
                                      ->select('pd.*')
                                      ->where("pd.status", '=', 'active')
                                      ->where("pd.verified", '=' ,'yes')                                
                                      ->count();

            $inactivePropertiesCount= DB::table('property_details as pd')
                                      ->select('pd.*')
                                      ->where("pd.status", '!=', 'active')
                                      ->orWhere("pd.verified", '!=' ,'yes')                               
                                      ->count(); 

            $enquiriesCount         = DB::table('property_enquiry as pe')
                                      ->select('pe.*')
                                      ->count();

			      $cancelBookingsCount    = DB::table('booknow_property_details')
                                      ->select('id')
                                      ->where('block_type', '!=', 'preblock')
                                      ->where('payment_status', 'yes')
                                      ->whereRaw('departure_time >= CURDATE()')
                                      ->where('owner_cancel_request', 'yes')
                                      ->where('admin_cancel_status', '')
                                      ->count();
            
            $accounts = DB::table('invoices as in')
                        ->join('property_details as pd', 'pd.user_id', '=', 'in.user_id')
                        ->join('users as u', 'u.id', '=', 'pd.user_id')
                        ->select(
                          'u.id',
                          DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
                          DB::raw('(SELECT COUNT(u.id) FROM users as u where u.id= pd.user_id GROUP BY pd.user_id) properties'),
                          DB::raw('DATE_FORMAT(in.renewal_date, "%d-%m-%Y") as renewal_date'),
                          DB::raw('DATE_FORMAT(in.expiry_date, "%d-%m-%Y") as expiry_date'),    
                          //DATE('in.renewal_date'),//'date(in.renewal_date)',
                          //DATE('in.expiry_date'),
                          'in.price',
                          (DB::raw("(CASE 
                              WHEN CURDATE()>=in.expiry_date AND in.status='pending' THEN 'Expired' 
                              WHEN in.status = 'pending' THEN 'Pending'
                              WHEN in.status = 'paid' THEN 'Paid'              
                                          
                          END) status"))
                        )
                        ->get();                                                                               
             $result['accountsCount']           = count($accounts);
             $result['allpropertiesCount']      = $allpropertiesCount;
             $result['cancelBookingsCount']     = $cancelBookingsCount;
             $result['activePropertiesCount']   = $activePropertiesCount;
             $result['inactivePropertiesCount'] = $inactivePropertiesCount;
             $result['enquiriesCount']          = $enquiriesCount;

            return $result;
    }

    public static function getAdminDetails($id){
          
          $data = DB::table('admin')
                    ->select('*')
                    ->where('id', $id)
                    ->first();

          return $data;
    }
}
