<?php

namespace App\Http\Controllers\Api\Properties;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\PropertyBooknow;
use App\PropertyDetails;
use App\Http\Requests;
use App\IXR_Client;
use DateInterval;
use DatePeriod;
use Validator;
use DateTime;
use Artisan;
use Response;
use Mail;
use Log;
use DB;
use Config;
class PropertyBooknowController extends Controller
{ 
    public function __construct(){
      
      $this->from_email             = Config::get('app.email_from_address');
      $this->_s3_path               = Config::get('filesystems.s3_path');
    }
    
    public function convertEnquiryAsBooking(Request $request){

      $enq_id = isset($request['enq_id'])?$request['enq_id']:'';
      $enquiry_details = DB::table('property_enquiry')->select('*')->where('id', $enq_id)->first();

      $enq = $this->saveEnquiryDetails($enquiry_details, $enq_id);

      return $enq;

    }

    public function saveEnquiryDetails($input, $enq_id){

      //Log::info(print_r($input, true));

      //die();
      $booknowObj = new PropertyBooknow();

      $checkDates = $this->checkPropertyPreblockDetails($input);
        
        if($checkDates){
            return Response::json(array('success'=>0, 'message'=>'You cannot block property some dates are already blocked'));            
        }else{
          if(isset($input['arrival_time'])){
            $booknowObj->arrival_time                 = $input['arrival_time'];
          }
          if(isset($input['departure_time'])){
            $booknowObj->departure_time               = $input['departure_time'];
          }
          if(isset($input['paid_amount'])){
            $booknowObj->paid_amount                  = $input['paid_amount'];
          }
          if(isset($input['booking_amount'])){
            $booknowObj->booking_amount               = $input['booking_amount'];
          }
          if(isset($input['security_deposit'])){
            $booknowObj->security_deposit             = $input['security_deposit'];
          }
          if(isset($input['owner_security_deposit'])){
            $booknowObj->owner_security_deposit       = $input['owner_security_deposit'];
          }
          if(isset($input['guest_limit'])){
            $booknowObj->guest_limit                  = $input['guest_limit'];
          }
          if(isset($input['first_name'])){
            $booknowObj->first_name                   = ucwords($input['first_name']);
          }
          if(isset($input['surname'])){
            $booknowObj->surname                      = ucwords($input['surname']);
          }
          if(isset($input['phone'])){
            $booknowObj->phone                        = $input['phone'];
          }
          if(isset($input['email'])){
            $booknowObj->email                        = $input['email'];
          }
          if(isset($input['message'])){
            $booknowObj->message                      = $input['message'];
          }
          if(isset($input['property_id'])){
            $booknowObj->property_id                  = $input['property_id'];
          }
          if(isset($input['coupon'])){
            $booknowObj->coupon                       = $input['coupon'];
          }
          if(isset($input['deal_discount'])){
            $booknowObj->deal_discount                = $input['deal_discount'];
          }
          if(isset($input['owner_id'])){
            $booknowObj->owner_id                     = $input['owner_id'];
            //$booknowObj->owner_paypal_email           = $input['owner_paypal_email'];
          }

          $booknowObj->enq_id                         = $enq_id;
          
          //$booknowObj->payment_status                 = 'yes';
          $booknowObj->save();
          //$booknow  = $this->getPropertyBooknowDetailsById($booknowObj->id);     

          //$chk_img = $_SERVER['SERVER_NAME']."/uploads/property_images/".$booknowObj->id;
          //Log::info(print_r($chk_img.' img_path', true));
          //die();
          if($booknowObj){        

            $mail = $this->updateEnquiryBookingStatus($booknowObj->id);  
            $update_enq = DB::table('property_enquiry')->where('id', $enq_id)->update(array('convert_booking_status'=>1));
            if($mail){

              return Response::json(array('success'=>1, 'message'=>'Booking has been done successfully!'));  
            }else{
              return Response::json(array('success'=>0, 'message'=>'Booking has been done successfully but one of the emailer was not sent, please check with IT Team'));  
            }            

          }else{

            return Response::json(array('success'=>0, 'message'=>'Booking has not been done, Please try again.'));
          } 
        }
    }

    public function updateEnquiryBookingStatus($bid){

      $data = DB::table('booknow_property_details')->where('id', $bid)->update(array('payment_status'=>'yes', 'block_type'=>'banking', 'payment_type'=> 'Banking', 'booking_review_status'=>1));
      //Log::info(print_r($data.' here', true));
      if($data){
          //Log::info(print_r($data.' view cleared here', true));
          
          $booking = PropertyBooknow::getPropertyBooknowDetailsById($bid);

          $mail1 =  Mail::send('emails.property-booking-client', ['booking'=>$booking, '_s3_path'=>$this->_s3_path], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['email'])->subject('Booking Confirmation from Direct-Owners');
          });

          $mail2 =  Mail::send('emails.property-booking-owner', ['booking'=>$booking, '_s3_path'=>$this->_s3_path], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['owner_mail'])->subject('You have received a booking confirmation email');
          });
 
        if($mail1 && $mail2){
          $mail_status = 1;
        }else{
          $mail_status = '';
        }  
        return $mail_status;
      }else{

        return '';
      }

    }
    
    public function savePropertyBooknow(Request $request){

        $request = $request->all();

        //Log::info(print_r($_SERVER['SERVER_NAME'].': SERVER_NAME', true));
        $selected_cardtype = isset($request['selected_cardtype']) && $request['selected_cardtype']?$request['selected_cardtype']:'';

        if($selected_cardtype=='credit_card'):

            $propertyBooknowRule = array('owner_id'     => 'required',                                
                                 'arrival_time'         => 'required',
                                 'departure_time'       => 'required|different:arrival_time',
                                 'guest_limit'          => 'required',
                                 'first_name'           => 'required',
                                 'surname'              => 'required',
                                 'property_id'          => 'required', 
                                 'phone'                => 'required|regex:/[0-9]{9}/', 
                                 'email'                => 'email|required', 
                                 'message'              => 'required'
                                );
            //Log::info(print_r($propertyBooknowRule, true)); 
            $msg = array(
                    'different'=>'Entry and Exit on same day not allowed, please change the departure'
                   );

        else:

            $propertyBooknowRule = array('owner_id'     =>'required',                                
                                 'arrival_time'         =>'required',
                                 'departure_time'       =>'required|different:arrival_time',
                                 'guest_limit'          =>'required',
                                 'first_name'           =>'required',
                                 'surname'              =>'required',
                                 'property_id'          =>'required', 
                                 'phone'                =>'required|regex:/[0-9]{9}/', 
                                 'owner_paypal_email'   =>'required',
                                 'email'                =>'email|required', 
                                 'message'              =>'required');

            $msg = array(
                    'different'=>'Entry and Exit on same day not allowed, please change the departure',
                    'owner_paypal_email.required'=>'Unfortunately the owner has not set up a PayPal account to receive payment. <br>Please contact the owner to agree an alternative payment channel.'

                   );

        endif;
            
        

        $validator = Validator::make(

            $request, $propertyBooknowRule, $msg
            
        );
        if(!$validator->fails()){

            $enquiries = $this->savePropertyBooknowDetails($request);

            return $enquiries;

        }else{
        
            // $enquiries = PropertyBooknow::savePropertyBooknowDetails($request);
    
            // return $enquiries;
            Log::info(print_r('selected_cardtype: '.$selected_cardtype, true));
            if($selected_cardtype='paypal'):
                if(!$request['owner_paypal_email']){

                   $send_email_to_owner = $this->sendPaypalEmailRequestToOwner($request['property_id']);
                }
            endif;            

            return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
        }
    }

    public function savePropertyBooknowDetails($input){

      $booknowObj = new PropertyBooknow();

      $checkDates = $this->checkPropertyPreblockDetails($input);
        
        if($checkDates){
            return Response::json(array('success'=>'2', 'message'=>'You cannot add property some dates are blocked'));            
        }else{
          if(isset($input['arrival_time'])){
            $booknowObj->arrival_time                 = $input['arrival_time'];
          }
          if(isset($input['departure_time'])){
            $booknowObj->departure_time               = $input['departure_time'];
          }
          if(isset($input['paid_amount'])){
            $booknowObj->paid_amount                  = $input['paid_amount'];
          }
          if(isset($input['booking_amount'])){
            $booknowObj->booking_amount               = $input['booking_amount'];
          }
          if(isset($input['security_deposit'])){
            $booknowObj->security_deposit             = $input['security_deposit'];
          }
          if(isset($input['owner_security_deposit'])){
            $booknowObj->owner_security_deposit       = $input['owner_security_deposit'];
          }
          if(isset($input['guest_limit'])){
            $booknowObj->guest_limit                  = $input['guest_limit'];
          }
          if(isset($input['first_name'])){
            $booknowObj->first_name                   = ucwords($input['first_name']);
          }
          if(isset($input['surname'])){
            $booknowObj->surname                      = ucwords($input['surname']);
          }
          if(isset($input['phone'])){
            $booknowObj->phone                        = $input['phone'];
          }
          if(isset($input['email'])){
            $booknowObj->email                        = $input['email'];
          }
          if(isset($input['message'])){
            $booknowObj->message                      = $input['message'];
          }
          if(isset($input['property_id'])){
            $booknowObj->property_id                  = $input['property_id'];
          }
          if(isset($input['coupon'])){
            $booknowObj->coupon                       = $input['coupon'];
          }
          if(isset($input['owner_deal_amount'])){
            $booknowObj->deal_discount                = $input['owner_deal_amount'];
          }
          if(isset($input['selected_currency_symbol'])){
            $booknowObj->selected_currency_symbol     = $input['selected_currency_symbol'];
          }

          if(isset($input['selected_currency_name'])){
            $booknowObj->selected_currency_name       = $input['selected_currency_name'];
          }

          if(isset($input['owner_id'])){
            $booknowObj->owner_id                     = $input['owner_id'];
            $booknowObj->owner_paypal_email           = $input['owner_paypal_email'];
          }
      
          $booknowObj->payment_status                 = 'no';
          $booknowObj->save();
          $booknow  = $this->getPropertyBooknowDetailsById($booknowObj->id);     

          //$chk_img = $_SERVER['SERVER_NAME']."/uploads/property_images/".$booknowObj->id;
          //Log::info(print_r($chk_img.' img_path', true));
          //die();
          if($booknowObj){        

            return Response::json(array('message'=>'success', 'booknow_details'=>$booknowObj, 'result'=>'Booking Details saved successfully'));

          }else{

            return Response::json(array('message'=>'error', 'booknow_details'=>'Booknow details not saved, Please try again.'));
          } 
        }
      } 

    public function convertCurrency($selected_curreny, $amount, $ctype){

      $req_url = 'https://api.exchangerate-api.com/v4/latest/'.$selected_curreny;
      $response_json = file_get_contents($req_url);

      // Continuing if we got a result
      if(false !== $response_json) {

          // Try/catch for json_decode operation
          try {

          // Decoding
          $response_object = json_decode($response_json);

          // YOUR APPLICATION CODE HERE, e.g.
          $base_price = $amount; // Your price in USD
          $currency_price = round(($base_price * $response_object->rates->$ctype), 2);
          
          return  $currency_price;
          }
          catch(Exception $e) {
              // Handle JSON parse error...
          }
      }
    }  

    public function saveBookingPaymentStatus(Request $request){
        
      $data                = $request->all();
      
      $propertyBooknowRule = array(
                               'paymentBooking'       =>'required',                                
                               'payment_method_token' =>'required',
                               'full_name'            =>'required',
                               'month'                =>'required',
                               'year'                 =>'required',
                               'cvv'                  =>'required',                               
                               'amount'               =>'required');  

      $validator = Validator::make(

          $data, $propertyBooknowRule
          
      );
      if($validator->fails()){
          return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
      }else{

        require( storage_path().'/class-IXR.php' );
        $cardholder_name  =  isset($data['full_name'])?explode(' ',$data['full_name']):'';
        $cardholder_month =  isset($data['month'])?$data['month']:'';
        $cardholder_year  =  isset($data['year'])?$data['year']:'';
        $arrival_time     =  isset($data['arrival_time'])?$data['arrival_time']:'';
        $departure_time   =  isset($data['departure_time'])?$data['departure_time']:'';
        $paid_amount      =  isset($data['amount'])?$data['amount']:'';
        $currency_name    =  isset($data['currency_name'])?$data['currency_name']:'';
        $token            =  isset($data['payment_method_token'])?$data['payment_method_token']:'';
        $selected_card    =  'Credit Card';

        $booking_id       = isset($data['paymentBooking'])?$data['paymentBooking']:'';
        $bookingDepartureTime = isset($data['bookingDepartureTime'])?$data['bookingDepartureTime']:date('Y-m-d');
        $bookingArrivalTime = isset($data['bookingArrivalTime'])?$data['bookingArrivalTime']:date('Y-m-d');
        $method           = 'tmt.spreedly.addBooking';      
        $site_id          = 0;             
        $url              = 'https://trustmytravel.com/xmlrpc.php';
        $site_id          = 0;       
        $first_name       = isset($cardholder_name[0])?$cardholder_name[0]:'';
        $last_name        = isset($cardholder_name[1])?$cardholder_name[1]:'';
        $prop_owner       = DB::table('booknow_property_details')->select('owner_id','email', 'message')->where('id',$booking_id)->first();
        

        $user_id          = isset($prop_owner['owner_id'])?$prop_owner['owner_id']:'';
        $email            = isset($prop_owner['email'])?$prop_owner['email']:'';
        $message          = isset($prop_owner['message'])?$prop_owner['message']:'';
        
        $owner_details    = DB::table('users')->select('basic_currency', 'tmt_api_token')->where('id', $user_id)->first();
        $owner_currency   = $owner_details?$owner_details['basic_currency']:'';
        $tmt_username     = 'token';  
        $tmt_api_token    = isset($owner_details['tmt_api_token'])?$owner_details['tmt_api_token']:'';
        $payable_amount   = $this->convertCurrency($currency_name, $paid_amount, $owner_currency); 
        Log::info(print_r($payable_amount, true));
        $booking_data     = array(
                              'firstname'               => $first_name,
                              'surname'                 => $last_name,
                              'email'                   => $email,
                              'address'                 => '-',
                              'city'                    => '-',
                              'country'                 => '-',
                              'postcode'                => '-',
                              'date'                    => $bookingArrivalTime,
                              'date_end'                => $bookingDepartureTime,
                              'currency'                => $owner_currency,
                              'total'                   => $payable_amount,
                              'line_items'              => $message,
                              'payment_method_token'    => $token, 
                            ); 
        
        Log::info(print_r($booking_data, true)); 
        Log::info(print_r('booking tmt data', true));          
        //die();  
        $client   = new IXR_Client( $url );      
        $client->query( $method, $site_id, $tmt_username, $tmt_api_token, $booking_data );      
        $response = $client->getResponse();
        //$response = array('success'=>true, 'faultCode'=>200, 'faultString' => 'Payment success');
        //Log::info(print_r($response, true));  
        //$this->updateTMTBookingStatus($booking_id); 
        $result =  isset($response['success']) && $response['success']=='true'?$response['success']:''; 
        $error  =  isset($response['faultCode']) ? $response['faultString']:'';       
        if($result){         
          
          $update     = DB::table('booknow_property_details')->whereRaw('id="'.$booking_id.'"')->update(array('payment_type'=>$selected_card, 'payment_token'=>$token));
          //Log::info(print_r('payment status update '.$update, true));    
          $this->updateTMTBookingStatus($booking_id);
          if($update) {  

            return Response::json(array('success'=>1, 'message'=>'Payment has been done successfully'), 200);
          }else{

            return Response::json(array('success'=>0, 'message'=>'Something went wrong, please check'), 200);
          } 
        }else{
          if($error!=''){

            return Response::json(array('success'=>0, 'message'=> $error), 200);  

          }else{

            return Response::json(array('success'=>0, 'message'=>'Payment has not completed successfully. Please try again later!'), 200);
          }          
        }
      }   
    }

    public function updateTMTBookingStatus($bid){

      $data = DB::table('booknow_property_details')->where('id', $bid)->update(array('payment_status'=>'yes', 'booking_review_status'=>1));
      Log::info(print_r($data.' here', true));
      if($data){
          Log::info(print_r($data.' view cleared here', true));
          
          $booking = PropertyBooknow::getPropertyBooknowDetailsById($bid);

          $mail1 =  Mail::send('emails.property-booking-client', ['booking'=>$booking], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['email'])->subject('Booking Confirmation from Direct-Owners');
          });

          $mail2 =  Mail::send('emails.property-booking-owner', ['booking'=>$booking], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['owner_mail'])->subject('You have received a booking confirmation email');
          });
 
          Log::info(print_r('tmt mail1: '.$mail1.', tmt mail:'.$mail2, true));
        return Response::json(array('success'=>'1', 'message'=>'Property Booked successfully'));
      }else{

        return Response::json(array('success'=>'0', 'message'=>'Property not booked successfully, please try again'));
      }

    }

    public function getPropertyBooknowDetailsById($id){
      $data = DB::table('booknow_property_details as pb')
            ->select('pb.*',
               'pb.id as booking_id',
               'pd.description as property_description',
               'pd.property_image',
               'pb.guest_limit as guest',
               DB::raw('DATE_FORMAT(pb.arrival_time, "%d %b %Y") as barrival_time'),
               DB::raw('DATE_FORMAT(pb.departure_time, "%d %b %Y") as bdeparture_time'),
               'pb.guest_limit as bguest', 'pd.*', 
               DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
               DB::raw('CONCAT(pb.first_name, " ", pb.surname) AS user_name'), 
               'u.email as owner_mail'
              )
            ->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
            ->leftJoin('users as u', 'u.id', '=', 'pb.owner_id')
            ->where('pb.id', $id)
            ->first();
      return $data;
    }  

    public function sendPaypalEmailRequestToOwner($prop_id){

        $owner_details = DB::table('property_details as pd')
                         ->leftJoin('users as u', 'pd.user_id', '=', 'u.id')
                         ->select(
                            'u.email', 
                            'pd.property_title',
                            DB::raw('CONCAT(u.first_name, " ", u.surname) AS name')
                         )
                         ->where('pd.property_id', $prop_id)
                         ->first();

         $mail1 =  Mail::send('emails.owner-paypal-email-request', ['owner_details'=>$owner_details], function ($m) use ($owner_details) {

            $m->from($this->from_email, 'Direct Owners');

            $m->to($owner_details['email'])->subject('Paypal Owner Email Request');
         });


    }

    public function deleteBookingById(Request $request){

        $data = PropertyBooknow::deleteBookingById($request['book_id']);

        return $data;
    }

    public function updateBookingStatus(Request $request){
     
      Log::info(print_r($request->all(), true));
      $bid  = $request['book_id'];
      $data = DB::table('booknow_property_details')->where('id', $bid)->update(array('payment_status'=>'yes','payment_type'=>'Paypal', 'booking_review_status'=>1));

      if($data){
          //Artisan::call('view:clear');
          $booking = PropertyBooknow::getPropertyBooknowDetailsById($bid);

          $mail1 =  Mail::send('emails.property-booking-client', ['booking'=>$booking], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['email'])->subject('Booking Confirmation from Direct-Owners');
          });

          Log::info(print_r($mail1. 'paypal mail1 confirmation', true));
          $mail2 =  Mail::send('emails.property-booking-owner', ['booking'=>$booking], function ($m) use ($booking) {

              $m->from($this->from_email, 'Direct Owners');

              $m->to($booking['owner_mail'])->subject('You have received a booking confirmation email');
          });
          Log::info(print_r($mail2. 'paypal mail2 confirmation', true));
        return Response::json(array('success'=>'1', 'message'=>'Property Booked successfully'));
      }else{

        return Response::json(array('success'=>'0', 'message'=>'Property not booked successfully, please try again'));
      }
    }

    public function getOwnerPropertyBookings(Request $request){
        //Log::info(print_r('2345', true));
        $data = PropertyBooknow::getOwnerPropertyBookings($request['owner_id']);

        return $data;
    }

    public function getUpcomingPropertiesToCancel(Request $request){

        $data = PropertyBooknow::getUpcomingPropertiesToCancel($request['owner_id']);

        return $data;
    }

    public function getOwnerPaidPropertyBookings(Request $request){

        $data = PropertyBooknow::getOwnerPaidPropertyBookings($request['owner_id'], $request['list'], $request['propId']);

        return $data;
    }    

    public function getCheckPropertyAvailability(Request $request){

        $data = $this->checkPropertyPreblockDetails($request);

        if($data!=0){

            return Response::json(array('success'=>1, 'message'=>'Some dates are already blocked please try with other dates'), 200);

        }else{

            return Response::json(array('success'=>0), 200);    
        }
    }

    public function checkPropertyPreblockDetails($request){

        $existingDates = $this->getExistingPropertyDetails($request['property_id']);
        
        //Log::info(print_r($existingDates, true));

        $sStartDate = gmdate("Y-m-d", strtotime($request['arrival_time']));  
        $sEndDate   = gmdate("Y-m-d", strtotime($request['departure_time']));          
        
        // Start the variable off with the start date  
        $data[] = $sStartDate;  

        // Set a 'temp' variable, sCurrentDate, with  
        // the start date - before beginning the loop  
        $sCurrentDate = $sStartDate;  

        // While the current date is less than the end date  
        while($sCurrentDate < $sEndDate){  
         // Add a day to the current date  
         $sCurrentDate = gmdate("Y-m-d", strtotime("+1 day", strtotime($sCurrentDate)));  

         // Add this new day to the aDays array  
         $data[] = $sCurrentDate;  
        }
        

        if($existingDates){ 

            $result = count(array_intersect($data, $existingDates));
            
            return $result;
        }else{
          
            return 0;
        }
        
    }

    public function getExistingPropertyDetails($id){

         $dates =  DB::table('booknow_property_details as pbd')
                ->select('ppd.id', 'ppd.property_id', 'ppd.start_date', 'ppd.end_date', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date')
                ->leftJoin('property_preblock_details as ppd', 'ppd.property_id', '=', 'pbd.property_id')
                ->where('pbd.property_id', $id)
                ->where('pbd.payment_status', 'yes')
                ->where('pbd.owner_cancel_request','!=', 'no')
                ->where('pbd.admin_cancel_status','!=', 'yes')
                ->get();
                //Log::info(print_r($dates, true));
        if(count($dates)){
            $data = array();
            $dates_arr      = array();
            foreach ($dates as $d) {
                
                
                $current        = strtotime($d['start_date']);
                $last           = strtotime($d['end_date']);
                $output_format  = 'Y-m-d';
                $step           = "+1 day";
                while( $current <= $last ) {

                    $dates_arr[] = date($output_format, $current);
                    $current = strtotime($step, $current);
                }              
                
            }   

            return $dates_arr;
        }else{                
            return 0;
        }               

    }

    public function getChangeBookingStatusFromOwner(Request $request){


        $request    = $request->all();

        $cancelRule = array(
                        'preblock_comment'=>'required',
                        'owner_cancel_request'=>'required'
                      );

        $validator = Validator::make(

            $request, $cancelRule
            
        );
        if(!$validator->fails()){

            $cancel_property = $this->getUpdateOwnerCancelRequest($request);

            return $cancel_property;

        }else{

            return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 200);
        }
         
    }

    public function getUpdateOwnerCancelRequest($request){

        $property_booked_id    = $request['property_booking_id'];

         if($request['owner_cancel_request']=='yes'){

            $update = DB::table('booknow_property_details')
                        ->where('id', $property_booked_id)
                        ->update(
                            array(
                                'owner_cancel_request'=>'yes',
                                'cancel_comment'=>$request['preblock_comment']
                            )
                        );
            if($update){

                return Response::json(array('success'=>1, 'message'=>'Cancel booking request sent to Admin successfully!'), 200);
            }else{

                return Response::json(array('success'=>0, 'message'=>'Cancel booking request not sent to Admin, try again.'), 200);
            } 
         }
    }

    public function getCheckPropertySpecialRateDates(Request $request){

        $property_id    = $request['property_id'];
        $arrival_time   = $request['arrival_time'];
        $departure_time = $request['departure_time'];
        $currency_name  = isset($request['currency_name'])?strtoupper($request['currency_name']):'';
        $prop_rates     = DB::table('property_rate as pr')                        
                           ->select('pr.*')                          
                           ->leftJoin('deals as d', 'd.property_id', '=', 'pr.property_id')
                           ->where('pr.property_id', $property_id)
                           ->groupBy("pr.property_rate_id")
                           ->get();       
                         
        $result         = array();
        $response       = array();

        $currency_rate  = $currency_name=='EUR'?1:PropertyDetails::convertCurrency($currency_name);
        foreach ($prop_rates as $pr) {
            
            $dates      = array();
            $current    = strtotime($pr['start_date']);
            $last       = strtotime($pr['end_date']);
           
            while( $current <= $last ) {

                $dates[] = date('Y-m-d', $current);
                $current = strtotime('+1 day', $current);
            }
         

            $rdates                  = $this->checkBlockedDates($arrival_time, $departure_time);
            $rate_per_week           = !empty($pr['rate_per_week'])?round(($currency_rate*$pr['rate_per_week']),2):'';
            $rate_per_day            = !empty($pr['rate_per_day'])?round(($currency_rate*$pr['rate_per_day']),2):'';
            //$rdates['rate']          = $pr['rate_per_week']?$pr['rate_per_week']:$pr['rate_per_day'];
            $rdates['rate']          = $pr['rate_per_week']?$rate_per_week:$rate_per_day;
            $rdates['type']          = $pr['rate_per_week']?'week':'day';
            $rdates['minimum_stay']  = $pr['minimum_stay'];
            
            $mdata  =   array_intersect($dates, $rdates);             

            $check_array = $rdates;
            unset($check_array['rate']);
            unset($check_array['minimum_stay']);
            unset($check_array['type']);
            
            //if(count($mdata)==count($check_array)){
            if(count($mdata)>0){

               if(array_filter($mdata)){  
                  
                   $response =  $rdates; 

                }else{ 

                   array_push($response,  '');
                } 
            }
                       
        }

          $response_result = array_filter($response);
             
          if(count($response_result)){
            
               return Response::json(array('success'=>1, 'message'=>'Selected dates has special rates!', 'data'=>$response_result), 200);
          }else{

               return Response::json(array('success'=>0, 'message'=>'Selected dates has no special rates!'), 200);                
          }
    }

    function checkBlockedDates($start, $end){

        $dates      = array();
        $current    = strtotime($start);
        $last       = strtotime($end);

        while( $current <= $last ) {

            $dates[] = date('Y-m-d', $current);
            $current = strtotime('+1 day', $current);
        }

        return $dates;
            
    }

    public function getBookingDetailsForEmailView(Request $request){

        $booking_id = $request['booking_id'];

        $booking = PropertyBooknow::getPropertyBooknowDetailsById($booking_id);

        $chk_img = $_SERVER['DOCUMENT_ROOT']."/uploads/property_images/".$booking['property_id']."/".$booking['property_image'];
        
        if(file_exists($chk_img)){
            
          $img = "/uploads/property_images/".$booking['property_id']."/".$booking['property_image'];
        }else{
          
          $img = "/uploads/property_images/default.jpg";
        }

        $year = date('Y');

        if($booking){

            return Response::json(array('success'=>1, 'date'=>$year, 'img_src'=>$img, 'data'=>$booking));
        }else{

            return Response::json(array('success'=>0, 'data'=>'No Data Found'));
        }
    }

    public function getCheckOwnerPropertyAvailability(Request $request)
    {

        $property_id    = $request['property_id'];
        $year           = $request['year'];

        if($property_id):
          $preblockQuery = DB::table('booknow_property_details as pbd')
                  ->select(
                      'pbd.id as booking_id', 
                      'pbd.property_id',
                      DB::raw('CONCAT(pbd.first_name, " ", pbd.surname) AS name'),
                      'pbd.guest_limit as guests',
                      'pbd.paid_amount as total_amount',
                      'pbd.preblock_comment as comment',
                      'pbd.block_type',
                      'pbd.deal_discount',
                      DB::raw('DATE_FORMAT(pbd.created_at, "%d-%m-%Y") as booked_at'),
                      //DB::raw('DATE_FORMAT(ppd.start_date, "%d-%m-%Y") as start_date'),
                      //DB::raw('DATE_FORMAT(ppd.end_date, "%d-%m-%Y") as end_date'), 
                      DB::raw('DATE_FORMAT(pbd.arrival_time, "%d-%m-%Y") as start_date'), 
                      DB::raw('DATE_FORMAT(pbd.departure_time, "%d-%m-%Y") as end_date'),
                      //DB::raw('DATE_FORMAT(ppd.start_date, "%Y-%m-%d") as startDate'),
                      //DB::raw('DATE_FORMAT(ppd.end_date, "%Y-%m-%d") as endDate'), 
                      DB::raw('DATE_FORMAT(pbd.arrival_time, "%Y-%m-%d") as startDate'), 
                      DB::raw('DATE_FORMAT(pbd.departure_time, "%Y-%m-%d") as endDate')
                      )
                  ->leftJoin('property_preblock_details as ppd', 'ppd.property_id', '=', 'pbd.property_id');
          if($year){

              $preblockQuery->whereRaw("(CASE 
                          WHEN year(ppd.end_date) != '' THEN year(ppd.end_date) = ".$year."
                          WHEN year(pbd.departure_time) != '' THEN year(pbd.departure_time) = ".$year."                                      
                                      
                      END)");
              $preblockQuery->whereRaw('YEAR(pbd.departure_time) =  '.$year);
          }   

          if($property_id){

              $preblockQuery->whereRaw('pbd.property_id = "'.$property_id.'"');

          }     
                  
          $data = $preblockQuery->whereRaw('pbd.payment_status = "yes"')
                  ->whereRaw('pbd.owner_cancel_request != "no"')
                  ->whereRaw('pbd.admin_cancel_status != "yes"')
                  ->groupBy('pbd.arrival_time')
                  ->get();        
        else:
          $data = ''; 
        endif;                         

        if($data){             

            return Response::json(array('success'=>'1', 'details'=>$data));

        }else{

            return Response::json(array('success'=>'0', 'details'=>'No dates are booked'));
        }
    }

}
