<?php

namespace App\Http\Controllers\Api\Properties;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\PropertyEnquiry;
use App\PropertyBooknow;
use App\Http\Requests;
use DateTime;

use DatePeriod;

use DateInterval;
use Response;
use Mail;
use Validator;
use Log;
use DB;
use Config;
class PropertyEnquiryController extends Controller
{

    public function __construct(){
      
       $this->from_email             = Config::get('app.email_from_address');
       $this->_s3_path               = Config::get('filesystems.s3_path');
    }


    public function getPropertyEnquiries(Request $request){

    	/*$request = $request->all();

    	$propertyEnqRule = array('owner_id'=>'required');

    	$validator = Validator::make(

            $request, $propertyEnqRule
            
        );
    	if(!$validator->fails()){*/

    		$enquiries = PropertyEnquiry::getPropertyEnquiries($request);

    		return $enquiries;

    	/*}else{

    		return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
    	}*/			
    }

    public function checkPropertyPreblockDetails($request){

        $existingDates = $this->getExistingPropertyDetails($request['property_id']);
        
        $start  = new DateTime($request['arrival_time']);
        $end    = new DateTime($request['departure_time']);

        $daterange = new DatePeriod($start, new DateInterval('P1D'), $end);
        $data = array();

        foreach($daterange as $date){
            array_push($data, $date->format("Y-m-d"));
        }
        
        if($existingDates){ 

            $result = count(array_intersect($data, $existingDates));

            return $result;
        }else{
            return 0;
        }
        
    }


    public function getExistingPropertyDetails($id){


        /*$dates = DB::table('property_preblock_details as ppd')
            ->select('ppd.id', 'ppd.property_id', 'ppd.start_date', 'ppd.end_date', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date')
            ->leftJoin('booknow_property_details as pbd', 'pbd.property_id', '=', 'ppd.property_id')
            ->where('ppd.property_id', $id)
            ->where('pbd.payment_status', 'yes')
            ->get();*/

         $dates =  DB::table('booknow_property_details as pbd')
                ->select('ppd.id', 'ppd.property_id', 'ppd.start_date', 'ppd.end_date', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date')
                ->leftJoin('property_preblock_details as ppd', 'ppd.property_id', '=', 'pbd.property_id')
                ->where('pbd.property_id', $id)
                ->where('pbd.payment_status', 'yes')
                ->where('pbd.owner_cancel_request','!=', 'no')
                ->where('pbd.admin_cancel_status','!=', 'yes')
                ->get();
                              
        if(count($dates)){
            $data = array();
            $dates_arr      = array();
            foreach ($dates as $d) {
                
                
                $current        = strtotime($d['start_date']);
                $last           = strtotime($d['end_date']);
                $output_format  = 'Y-m-d';
                $step           = "+1 day";
                while( $current <= $last ) {

                    $dates_arr[] = date($output_format, $current);
                    $current = strtotime($step, $current);
                }              
                
            }   

            return $dates_arr;
        }else{                
            return 0;
        }               

    }

    public function savePropertyEnquiry(Request $request){

        $request = $request->all();
        $input =  $request;
        //Log::info(print_r($request, true)); 
        //die();
        $propertyEnqRule = array('owner_id'=>'required','arrival_time'=>'required','departure_time'=>'required','guest_limit'=>'required','first_name'=>'required','surname'=>'required', 'property_id'=>'required', 'phone'=>'required|regex:/[0-9]{9}/', 'email'=>'email|required', 'message'=>'required');

        $validator = Validator::make(

            $request, $propertyEnqRule
            
        );
        if(!$validator->fails()){

            $enquiry    = new PropertyEnquiry();

            $booknowObj = new PropertyBooknow();

            $checkDates = $this->checkPropertyPreblockDetails($input);
              
            if($checkDates){

                return Response::json(array('success'=>'2', 'message'=>'You cannot add property some dates are blocked'));
                
            }else{

              if(isset($input['arrival_time'])){
                $enquiry->arrival_time      = $input['arrival_time'];
              }
              if(isset($input['departure_time'])){
                $enquiry->departure_time    = $input['departure_time'];
              }
              if(isset($input['guest_limit'])){
                $enquiry->guest_limit       = $input['guest_limit'];
              }
              if(isset($input['first_name'])){
                $enquiry->first_name        = $input['first_name'];
              }
              if(isset($input['surname'])){
                $enquiry->surname           = $input['surname'];
              }
              if(isset($input['phone'])){
                $enquiry->phone             = $input['phone'];
              }
              if(isset($input['email'])){
                $enquiry->email             = $input['email'];
              }
              if(isset($input['message'])){
                $enquiry->message           = $input['message'];
              }
              if(isset($input['property_id'])){
                $enquiry->property_id       = $input['property_id'];
              }
              if(isset($input['paid_amount'])){
                $enquiry->paid_amount       = $input['paid_amount'];
              }
              if(isset($input['security_deposit'])){
                $enquiry->security_deposit       = $input['security_deposit'];
              }
              if(isset($input['booking_amount'])){
                $enquiry->booking_amount       = $input['booking_amount'];
              }
              if(isset($input['owner_id'])){
                $enquiry->owner_id          = $input['owner_id'];        
                $owner = PropertyEnquiry::getOwnerDetailsById($input['owner_id']);        
              }

              if(isset($input['owner_security_deposit'])){
                $enquiry->owner_security_deposit       = $input['owner_security_deposit'];
              }

              if(isset($input['coupon'])){
                $enquiry->coupon                       = $input['coupon'];
              }
              if(isset($input['owner_deal_amount'])){
                $enquiry->deal_discount                = $input['owner_deal_amount'];
              }

              if(isset($input['selected_currency_symbol'])){
                $enquiry->selected_currency_symbol     = $input['selected_currency_symbol'];
              }

              if(isset($input['selected_currency_name'])){
                $enquiry->selected_currency_name       = $input['selected_currency_name'];
              }

              $enquiry->enq_status = 1;

              //exit;
              $enquiry->save();
              //print_r($enquiry->id);die();
              $enq = PropertyEnquiry::getPropertyEnquiryDetails($enquiry->id);
              //print_r($enq);die();
             // $emails = array($input['email'], $owner['email']);
             
              if($enquiry){

                //$omail = array($owner['email']);

                $mail =  Mail::send('emails.enquiry-client', ['enq'=>$enq, '_s3_path'=>$this->_s3_path], function ($m) use ($enq) {

                    $m->from($this->from_email, 'Direct Owners');

                    $m->to($enq['email'])->subject('Confirmation of your Enquiry from Direct-Owners');
                });

                $mail =  Mail::send('emails.enquiry-owner', ['enq'=>$enq, '_s3_path'=>$this->_s3_path], function ($m) use ($enq) {

                    $m->from($this->from_email, 'Direct Owners');

                    $m->to($enq['owner_mail'])->subject('New Guest Enquiry from Direct-Owners');
                });

                return Response::json(array('message'=>'success', 'enquiry_details'=>$enquiry, 'status'=>'Your enquiry has been sent successfully. The owner will contact you soon.'));
                

              }else{

                return Response::json(array('message'=>'error', 'enquiry_details'=>'Enquiry not saved successfully, Please try again.'));
              } 
          }

        }else{

            return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
        }
    }

    public function getAllEnquiriesList(){

        $enquiries = PropertyEnquiry::getAllEnquiriesList();

        return $enquiries;
    }

    public function deletePropertyEnquiry($id){        

            $enquiries = PropertyEnquiry::deletePropertyEnquiryDetails($id);

            return $enquiries;       
    }

    public function getOwnerEnquiriesList(Request $request){

        $request = $request->all();

        $data = '';
        $loc = '';
        if(isset($request['list'])){
            if($request['list']=='1' && $request['ownerId']){
              
              $data = DB::table('property_enquiry as pe')
                      ->select('pd.property_title', DB::raw('DATE_FORMAT(pe.created_at, "%d/%m/%Y") as enquired_on'),'pd.property_id',DB::raw('DATE_FORMAT(pe.arrival_time, "%d/%m/%Y") as earrival'),DB::raw('DATE_FORMAT(pe.departure_time, "%d/%m/%Y") as edeparture'))
                      ->leftJoin('property_details as pd', 'pd.user_id', '=', 'pe.owner_id')
                      ->where('pe.owner_id', $request['ownerId'])
                      ->groupBy('pd.property_id')
                      ->where('pd.status', 'active')
                      ->orderBy('pe.id', 'desc')
                      ->get();  
              $loc = 1; 
            }
        }

        if(isset($request['list'])){
            if($request['list']!='1' && $request['ownerId']){
             
              $data = DB::table('property_enquiry as pe')
                      ->select('pe.*', 'pd.property_title', DB::raw('DATE_FORMAT(pe.created_at, "%d/%m/%Y") as enquired_on'),'pd.property_id',DB::raw('DATE_FORMAT(pe.arrival_time, "%d/%m/%Y") as earrival'),DB::raw('DATE_FORMAT(pe.departure_time, "%d/%m/%Y") as edeparture'))
                      ->join('property_details as pd', 'pd.property_id', '=', 'pe.property_id')
                      ->where('pe.owner_id', $request['ownerId'])   
                      ->where('pd.status', 'active')             
                      ->groupBy('pe.id')
                      ->orderBy('pe.id', 'desc')
                      ->get();     
              $loc = 2;                  
            }
        }
        if(isset($request['propId']) && $request['propId']!='' && isset($request['ownerId'])){ 

            $data = DB::table('property_enquiry as pe')
                    ->select('pe.*','pe.arrival_time as at',DB::raw('DATE_FORMAT(pe.created_at, "%d/%m/%Y") as enquired_on'),DB::raw('DATE_FORMAT(pe.arrival_time, "%d/%m/%Y") as earrival'),DB::raw('DATE_FORMAT(pe.departure_time, "%d/%m/%Y") as edeparture'),'pe.departure_time as dt', 'pd.*')
                    ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
                    ->where('pe.owner_id', $request['ownerId'])
                    ->where('pd.status', 'active')
                    ->where('pe.property_id', $request['propId'])
                    ->orderBy('pe.id', 'desc')
                    ->get();
            $loc = 3;
        }else if(!isset($request['list'])){

            $data = DB::table('property_enquiry as pe')
                      ->select('pe.*','pe.arrival_time as at',DB::raw('DATE_FORMAT(pe.created_at, "%d/%m/%Y") as enquired_on'), 'pe.departure_time as dt', 'pd.*',DB::raw('DATE_FORMAT(pe.arrival_time, "%d/%m/%Y") as earrival'),DB::raw('DATE_FORMAT(pe.departure_time, "%d/%m/%Y") as edeparture'))
                      ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
                      ->where('pe.owner_id', $request['ownerId'])
                      ->where('pd.status', 'active')
                      //->where('pe.property_id', $request['propId'])
                      ->orderBy('pe.id', 'desc')
                      ->get();
            $loc = 4;
        } 
          
        if($data){      

            return Response::json(array('message'=>'success','loc'=>$loc, 'enquiry_details'=>$data));

        }else{

            return Response::json(array('message'=>'error', 'loc'=>$loc, 'enquiry_details'=>'There are no enquiries.'));
        }
    }

    public function getEnquiriesById($id){


        $check_read = DB::table('property_enquiry')->select('enq_status')->where('id', $id)->first();

        $check_mark = $check_read?$check_read['enq_status']:'';

        if($check_mark==1){
            
            $update = DB::table('property_enquiry')->where('id', $id)->update(array('enq_status'=>2));           
        }else{
            $update = 0;
        }

        $data = DB::table('property_enquiry as pe')
            ->select(
              'pe.*',
              'pe.id as enq_id',
              'pe.guest_limit as guest',
              DB::raw('DATE_FORMAT(pe.arrival_time, "%d %b %Y") as earrival_time'),
              DB::raw('DATE_FORMAT(pe.departure_time, "%d %b %Y") as edeparture_time'),
              'pd.*', 
              DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
              DB::raw('CONCAT(pe.first_name, " ", pe.surname) AS customer_name'), 
              'u.email as owner_mail',
              'pd.property_title',
              'pd.property_id'
            )
            ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
            ->leftJoin('users as u', 'u.id', '=', 'pe.owner_id')
            ->where('pe.id', $id)
            ->first();

      if($data){

          return Response::json(array('success'=>'1', 'reload'=>$update, 'enquiry_details'=>$data));
      }else{

          return Response::json(array('success'=>'0', 'enquiry_details'=>'No details found'));
      }
    }

    public function getEnquiryDetailsForEmailView(Request $request){

        $enq_id = $request['enq_id'];

        $enq = PropertyEnquiry::getPropertyEnquiryDetails($enq_id);

        $chk_img = $_SERVER['DOCUMENT_ROOT']."/uploads/property_images/".$enq['property_id']."/".$enq['property_image'];
        
        if(file_exists($chk_img)){
            
          $img = "https://direct-owners.com/uploads/property_images/".$enq['property_id']."/".$enq['property_image'];
        }else{
          
          $img = "https://direct-owners.com/uploads/property_images/default.jpg";
        }

        $year = date('Y');

        if($enq){

            return Response::json(array('success'=>1, 'date'=>$year, 'img_src'=>$img, 'data'=>$enq));
        }else{

            return Response::json(array('success'=>0, 'data'=>'No Data Found'));
        }
    }
}
