<?php

namespace App\Http\Controllers\Api\Properties;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use Validator;

use App\Testimonials;

use Response;

use DB;
use Log;
class TestimonialsController extends Controller
{
    
    public function saveTestimonials(Request $request){

    	$request = $request->all();	
		//Log::info(print_r($request, true));
		$saveRules = array(
			'name' => 'required',
			//'designation' =>'required',
			'rating'=>'required',
			'testimonial' =>'required',
			//'property_id'	=> 'required',
			'owner_id'		=>'required'
		);
		
		$validator = Validator::make(

			$request, $saveRules

		);

		if($validator->fails()){
//Log::info(print_r('$request fails', true));
			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
		}else{
			Log::info(print_r('before save', true));
			$data = Testimonials::saveTestimonials($request);
//Log::info(print_r('after save', true));
			return $data;

		}
    }

    public function updateTestimonial(Request $request){

    	$request = $request->all();	
		//Log::info(print_r($request, true));
		$updatedRules = array(
			'name' 			=> 'required',
			'id'			=> 'required',
			//'designation' 	=> 'required',
			'testimonial' 	=> 'required',
			//'property_id'	=> 'required'
		);
		
		$validator = Validator::make(

			$request, $updatedRules

		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
		}else{

			$id 		 = $request['id'];
	    	$edata 		 = Testimonials::getTestimonialById($id);


	    	$name 		 = isset($request['name'])?$request['name']:$edata['name'];
	        $designation        = isset($request['designation'])?$request['designation']:$edata['designation'];
	    	$rating      = isset($request['rating'])?$request['rating']:$edata['rating'];
	        $status = '';
	        if(isset($request['status']) && isset($request['status1']) && $request['status']=='on' && $request['status1']=='no'){

	            $status = 'publish';
	        }else if(isset($request['status1']) && $request['status1']=='no'){
	            $status = '';
	        }else{
	            $status = $edata['status'];
	        }

	        $admin_status = '';
	        if(isset($request['admin_status']) && isset($request['admin_status1']) && $request['admin_status']=='on' && $request['admin_status1']=='no'){

	            $admin_status = 'active';
	        }else if(isset($request['admin_status1']) && $request['admin_status1']=='no'){
	            $admin_status = '';
	        }else{
	            $admin_status = $edata['admin_status'];
	        }
	        
	    	$testimonial = isset($request['testimonial'])?$request['testimonial']:$edata['testimonial'];
	    	$property_id = isset($request['property_id'])?$request['property_id']:$edata['property_id'];
	    	$owner_id 	 = isset($request['owner_id'])?$request['owner_id']:$edata['owner_id'];
	    	$priority 	 = isset($request['priority'])?$request['priority']:$edata['priority'];

	    	$data = DB::table('testimonials')
	    			->where('id', $id)
	    			->update(array(
	    				'name'		 =>$name,
	                    'designation'=>$designation,
	    				'rating'     =>$rating,
	                    'status'     =>$status,
	                    'admin_status'=>$admin_status,
	    				'testimonial'=>$testimonial,
	    				//'property_id'=>$property_id,
	    				'owner_id'   =>$owner_id,
	    				'priority'	 =>$priority
	    			));

	    	if($data){

	    		$result = Testimonials::getTestimonialById($id);

	    		return Response::json(array('success'=>'1', 'result'=>$result, 'message'=>'Review updated successfully'));
	    	}else{

	    		return Response::json(array('error'=>'0', 'message'=>'Review not updated, please try again'));
	    	}
		}	
    }

    public static function deleteTestimonial(Request $request){
    	
    	$request = $request->all();	
		
		$deleteRules = array(
			'id'			=> 'required',
		);
		
		$validator = Validator::make(

			$request, $deleteRules

		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
		}else{

    		$data = Testimonials::deleteTestimonial($request['id']);

			return $data;
		}
    }

    public function getTestimonials(){

    	$data = Testimonials::getTestimonials();

    	return $data;
    }

    public function getOwnerTestimonials(Request $request){

    	$request = $request->all();	
		
		$listRules = array(
			'owner_id'=> 'required',
		);
		
		$validator = Validator::make(

			$request, $listRules

		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
		}else{

    		$data = Testimonials::getOwnerTestimonials($request['owner_id']);

			return $data;
		}
    }

    public function getTestimonialById(Request $request){

    	$request = $request->all();	
		
		$listRules = array(
			'id'=> 'required',
		);
		
		$validator = Validator::make(

			$request, $listRules

		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
		}else{

    		$data = Testimonials::getTestimonialByIdJsonResult($request['id']);

			return $data;
		}
    }

    public function getTestimonialByProprity(){

    	$data = DB::table('testimonials as t')
    			->select('t.*', 'pd.property_title')
    			->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
    			->leftJoin('users as u', 'u.id','=', 'pd.user_id')
    			->where('t.status', 'publish')
    			->where('u.status', 'active')
    			->where('t.admin_status', 'active')
    			->orderBy('t.priority', 'asc')
    			->offset(0)->limit(10)
    			->get();
//echo $data;
    	if($data){

			return Response::json(array('success'=>1, 'result'=>$data));
		}else{

    		return Response::json(array('success'=>0, 'message'=>'No testimonials found!'));
		}		
    }
}
