<?php

namespace App\Http\Controllers\Auth;

use Tymon\JWTAuth\Facades\JWTAuth;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use GuzzleHttp\Client;

use DateTime;

use App\User;

use Hash;

use Mail;

use DB;
class SocialAuthController extends Controller
{
    /**
     * Login with Facebook.
     */
    public function facebook(Request $request)
    {
        $client = new Client();
        $client_fb_secret = '13091e904800fcc057a81c9be2741fa5';
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'redirect_uri' => $request->input('redirectUri').'/',
            'client_secret' => $client_fb_secret,
        ];    
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('GET', 'https://graph.facebook.com/v2.5/oauth/access_token', [
            'query' => $params
         ]);  
        $accessToken = json_decode($accessTokenResponse->getBody(), true);
        // Step 2. Retrieve profile information about the current user.
        $fields = 'id,email,first_name,last_name,link,name';
        $profileResponse = $client->request('GET', 'https://graph.facebook.com/v2.5/me', [
            'query' => [
                'access_token' => $accessToken['access_token'],
                'fields' => $fields
            ]
        ]);
        $profile = json_decode($profileResponse->getBody(), true);

        if($profile){

           $user = DB::table('users as u')
                   ->select('u.*')
                   ->where('u.email', $profile['email'])
                   ->first();
           if($user){        
               if($user['email_verification']==''){
                    $user_mail = array($profile['email']);
                    $name = $profile['first_name'].' '.$profile['last_name'];
                    $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                    $m->from('info@directowners.com', 'Direct Owners');

                                    $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                });
               }         
           } 
                 
           if(!$user){        
                $data = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'fb_id' => $profile['id'],
                            'first_name' => $profile['first_name'],
                            'surname' => $profile['last_name'],
                            'email' => $profile['email'],
                            'facebook_url' => $profile['link'],
                            'created_datetime' => new DateTime
                        ));
                $user = DB::table('users as u')
                   ->select('u.*')
                   ->where('u.id', $data)
                   ->first();
                if($user['email_verification']==''){
                    $user_mail = array($profile['email']);
                    $name = $profile['first_name'].' '.$profile['last_name'];
                    $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                    $m->from('info@directowners.com', 'Direct Owners');

                                    $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                });
               } 
            }else{
                $data = DB::table('users as u')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'facebook_url'=>$profile['link'],
                            'fb_id'=>$profile['id']
                      ));                
            }
        }


        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {   
            $message = ['success'=>'1'];   
            $token = Hash::make($profile['email']);

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first();

            if ($user)
            {   
                
                return response()->json(compact('token','message','user'));
            }
            //$token = explode(' ', $request->header('Authorization'))[1];
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'fb_id' => $profile['id'],
                            'first_name' => $profile['first_name'],
                            'surname' => $profile['last_name'],
                            'email' => $profile['email'],
                            'facebook_url' => $profile['link'],
                            'created_datetime' => new DateTime
                        ));

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $duser)
                   ->first();

            /*$user_up = DB::table('users as u')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['email'],
                            'fb_id'=>$profile['id'],
                            'first_name'=>$profile['first_name'],
                            'surname'=>$profile['last_name']
                      ));
*/
                     
            return response()->json(compact('token','message' ,'user'));                       
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {   
            $message = ['success'=>'1'];
            $token = Hash::make($profile['email']);
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first();

            

            if ($user)
            {                   
                $user_up = DB::table('users as u')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['email'],
                            'fb_id'=>$profile['id'],
                            'first_name'=>$profile['first_name'],
                            'surname'=>$profile['last_name']
                      ));

                return response()->json(compact('token','message', 'user'));
            }

            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'fb_id' => $profile['id'],
                            'first_name' => $profile['first_name'],
                            'surname' => $profile['last_name'],
                            'email' => $profile['email'],                            
                            'facebook_url' => $profile['link'],
                            'created_datetime' => new DateTime
                        ));

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $duser)
                   ->first();                        
            return response()->json(compact('token','message','user'));
        }
    }
    


    /**
     * Login with Google.
     */
    public function google(Request $request)
    {
        $client = new Client();
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'client_secret' => 'YyHivpitxUJVE_sq9kiAbqR7',
            'redirect_uri' => $request->input('redirectUri'),
            'grant_type' => 'authorization_code',
            
        ];
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('POST', 'https://accounts.google.com/o/oauth2/token', [
            'form_params' => $params
        ]);
        $accessToken = json_decode($accessTokenResponse->getBody(), true);

        // Step 2. Retrieve profile information about the current user.
        $profileResponse = $client->request('GET', 'https://www.googleapis.com/plus/v1/people/me/openIdConnect', [
            'headers' => array('Authorization' => 'Bearer ' . $accessToken['access_token'])
        ]);
        $profile = json_decode($profileResponse->getBody(), true);//print_r($profile);die();
        

        if($profile){

           $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first();

               if($user['email_verification']==''){
                    $user_mail = array($profile['email']);
                    $name = $profile['given_name'].' '.$profile['family_name'];
                    $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                    $m->from('info@directowners.com', 'Direct Owners');

                                    $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                });
               }  
             
                   
        }

        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {   

            $token = Hash::make($profile['email']);

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first(); 

            $message = ['success'=>'1'];
            if ($user)
            {   
                $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $user['id'])
                   ->first();

                $duser = DB::table('users as u')                        
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));
                return response()->json(compact('token', 'message' ,'user'), 409);
                
            }   
                $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first();            

                $duser = DB::table('users as u')                       
                        ->where('u.id', $profile['email'])
                        ->update(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));
            
            return response()->json(compact('token','message', 'user'));
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {   
            $message = ['success'=>'1'];
            $token = Hash::make($profile['email']);    
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['email'])
                   ->first();
            if ($user)
            {                

                $duser = DB::table('users')                        
                        ->where('id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));

                 $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $user['id'])
                   ->first();

                return response()->json(compact('token', 'message' ,'user'));
            }
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],                            
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $duser)
                   ->first();
                return response()->json(compact('token', 'message' ,'user'));
        }
    }
    
     /**
     * Login with LinkedIn.
     */
    public function linkedin(Request $request)
    {   

        $client_secret_id = '6GRVEaW1viv1JeSC';
        $client = new Client();
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'client_secret' => $client_secret_id,
            'redirect_uri' => $request->input('redirectUri'),
            'grant_type' => 'authorization_code',
        ];
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('POST', 'https://www.linkedin.com/uas/oauth2/accessToken', [
            'form_params' => $params
        ]);
        $accessToken = json_decode($accessTokenResponse->getBody(), true);
        // Step 2. Retrieve profile information about the current user.
        $profileResponse = $client->request('GET', 'https://api.linkedin.com/v1/people/~:(id,first-name,last-name,email-address)', [
            'query' => [
                'oauth2_access_token' => $accessToken['access_token'],
                'format' => 'json'
            ]
        ]);
        $profile = json_decode($profileResponse->getBody(), true);        

        if($profile){

               $user = DB::table('users as u')
                       ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                       ->where('u.email', $profile['emailAddress'])
                       ->first();
               if(!$user){        
                   if($user['email_verification']==''){
                        $user_mail = array($profile['emailAddress']);
                        $name = $profile['firstName'].' '.$profile['lastName'];
                        $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                        $m->from('info@directowners.com', 'Direct Owners');

                                        $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                    });
                   }     
               }                   
            }
        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {
            $token = Hash::make($profile['emailAddress']);
            $message = ['success'=>'1'];
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['emailAddress'])
                   ->first();

            if ($user)
            {      
                $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['emailAddress'])
                   ->first(); 
                $duser = DB::table('users as u')
                        ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['emailAddress'],
                            'linkedin_id'=>$profile['id'],
                            'first_name'=>$profile['firstName'],
                            'surname'=>$profile['lastName'],
                      ));
                       
                return response()->json(compact('token', 'message' ,'user'));                
            }            

            
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'linkedin_id' => $profile['id'],
                            'first_name' => $profile['firstName'],
                            'surname' => $profile['lastName'],
                            'email' => $profile['emailAddress'],                        
                            'created_datetime' => new DateTime
                        ));

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $duser)
                   ->first();
            
            return response()->json(compact('token', 'message' ,'user'));
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {   
            $token = Hash::make($profile['emailAddress']);
            $message = ['success'=>'1'];
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['emailAddress'])
                   ->first();
            
            if ($user)
            {   
                $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.email', $profile['emailAddress'])
                   ->first();

                $duser = DB::table('users as u')                        
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['emailAddress'],
                            'linkedin_id'=>$profile['id'],
                            'first_name'=>$profile['firstName'],
                            'surname'=>$profile['lastName'],
                      ));

                return response()->json(compact('token', 'message' ,'user'));
            }
           
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'linkedin_id' => $profile['id'],
                            'first_name' => $profile['firstName'],
                            'surname' => $profile['lastName'],
                            'email' => $profile['emailAddress'],                        
                            'created_datetime' => new DateTime
                        ));

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification')
                   ->where('u.id', $duser)
                   ->first();            

            return response()->json(compact('token', 'message' ,'user'));
        }
    }
}
