<?php

namespace App\Http\Controllers\Auth;

use Tymon\JWTAuth\Facades\JWTAuth;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use GuzzleHttp\Client;

use DateTime;

use App\User;

use Hash;

use Mail;
use Config;
use DB;
use Log;
class SocialAuthController extends Controller
{   
    public function __construct(){
      
       $this->from_email             = Config::get('app.email_from_address');
    }
    
    /**
     * Login with Facebook.
     */
    public function facebook(Request $request)
    {
        $client = new Client();
        $client_fb_secret = '13091e904800fcc057a81c9be2741fa5';
        Log::info(print_r($request->input('redirectUri').' --- request uri', true));
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'redirect_uri' => $request->input('redirectUri').'/',
            'client_secret' => $client_fb_secret,
            'http_errors' => false 
        ];    
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('GET', 'https://graph.facebook.com/v2.5/oauth/access_token', [
            'query' => $params
         ]);  
        $accessToken = json_decode($accessTokenResponse->getBody(), true);
        // Step 2. Retrieve profile information about the current user.
        $fields = 'id,email,first_name,last_name,link,name';
        $profileResponse = $client->request('GET', 'https://graph.facebook.com/v2.5/me', [
            'query' => [
                'access_token' => $accessToken['access_token'],
                'fields' => $fields
            ]
        ]);
        $profile = json_decode($profileResponse->getBody(), true);       

        Log::info(print_r($profile, true));
        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {   
            $message = ['success'=>'1'];   
            $token = Hash::make($profile['email']);

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['email'])
                   ->first();

            if ($user)
            {   
                $user_details = DB::table('users as u')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['email'],
                            'fb_id'=>$profile['id'],
                            'first_name'=>$profile['first_name'],
                            'surname'=>$profile['last_name']
                      ));                                          

                $renewal_check = User::getCheckUserRenewalStatus($user['id']);  

                $user = $this->getUserDetails($user['id']);

                return response()->json(compact('token','message','user'));
            }
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'fb_id' => $profile['id'],
                            'first_name' => $profile['first_name'],
                            'surname' => $profile['last_name'],
                            'email' => $profile['email'],
                            'facebook_url' => $profile['link'],
                            'created_datetime' => new DateTime
                        ));

            $user = $this->getUserDetails($duser);  
                   
            $mail = $this->fbVerificationMail($profile);  
                     
            return response()->json(compact('token','message' ,'user'));                       
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {   
            $message = ['success'=>'1'];
            $token = Hash::make($profile['email']);
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['email'])
                   ->first();

            

            if ($user)
            {                   
                $user_up = DB::table('users as u')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['email'],
                            'fb_id'=>$profile['id'],
                            'first_name'=>$profile['first_name'],
                            'surname'=>$profile['last_name']
                      ));                

                $renewal_check = User::getCheckUserRenewalStatus($user['id']); 

                $user = $this->getUserDetails($user['id']);       
                        
                return response()->json(compact('token','message', 'user'));
            }

            $profile_link = isset($profile['link'])?$profile['link']:'';
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'fb_id' => $profile['id'],
                            'first_name' => $profile['first_name'],
                            'surname' => $profile['last_name'],
                            'email' => $profile['email'],                            
                            'facebook_url' => $profile_link,
                            'created_datetime' => new DateTime
                        ));

            $user = $this->getUserDetails($duser);              

            $mail = $this->fbVerificationMail($profile);            

            return response()->json(compact('token','message','user'));
        }
    }

    function getUserDetails($id){

      $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token', 'u.status')
                   ->where('u.id', $id)
                   ->first();
      return $user;
    }


    function fbVerificationMail($profile){

        if($profile){

           $user = DB::table('users as u')
                   ->select('u.*')
                   ->where('u.email', $profile['email'])
                   ->first();
           if($user){        
               if($user['email_verification']==''){
                    $user_mail = array($profile['email']);
                    $name = $profile['first_name'].' '.$profile['last_name'];
                    $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                    $m->from($this->from_email, 'Direct Owners');

                                    $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                });
               }         
           }            
        } 
    } 


    /**
     * Login with Google.
     */
    public function google(Request $request)
    {
        $client = new Client();
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'client_secret' => 'YyHivpitxUJVE_sq9kiAbqR7',
            'redirect_uri' => $request->input('redirectUri'),
            'grant_type' => 'authorization_code',
            
        ];
        Log::info(print_r('google $params', true));
        Log::info(print_r($params, true));
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('POST', 'https://accounts.google.com/o/oauth2/token', [
            'form_params' => $params
        ]);
        $accessToken = json_decode($accessTokenResponse->getBody(), true);

        // Step 2. Retrieve profile information about the current user.
        //https://www.googleapis.com/plus/v1/people/me/openIdConnect
        $profileResponse = $client->request('GET', 'https://www.googleapis.com/oauth2/v3/userinfo?', [
            'headers' => array('Authorization' => 'Bearer ' . $accessToken['access_token'])
        ]);
        $profile = json_decode($profileResponse->getBody(), true);//rint_r($profile);die();              

        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {  

            $token = Hash::make($profile['email']);

            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['email'])
                   ->first(); 

            $message = ['success'=>'1'];
            if ($user)
            {    
                $user = $this->getUserDetails($user['id']);

                $duser = DB::table('users as u')                        
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],                            
                            'created_datetime' => new DateTime
                        ));

                $renewal_check = User::getCheckUserRenewalStatus($user['id']);

                $user = $this->getUserDetails($user['id']);
                        
                return response()->json(compact('token', 'message' ,'user'), 409);
                
            }    
                $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],                            
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));

                $user = $this->getUserDetails($duser);   

                $mail = $this->googleVerificationMail($profile);

                return response()->json(compact('token', 'message' ,'user'));            
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {    
            $message = ['success'=>'1'];
            $token = Hash::make($profile['email']);    
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['email'])
                   ->first();
            if ($user)
            {                 

                $duser = DB::table('users')                        
                        ->where('id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],
                            'created_datetime' => new DateTime
                        ));                

                $renewal_check = User::getCheckUserRenewalStatus($user['id']);

                $user = $this->getUserDetails($user['id']);
                   
                return response()->json(compact('token', 'message' ,'user'));
            }

            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'google_id' => $profile['sub'],
                            'first_name' => $profile['given_name'],
                            'surname' => $profile['family_name'],
                            'email' => $profile['email'],                            
                            //'profile_pic' => $profile['picture'],
                            //'google_plus_url'=>$profile['profile'],
                            'created_datetime' => new DateTime
                        ));

            $user = $this->getUserDetails($duser); 

            $mail = $this->googleVerificationMail($profile);  

            return response()->json(compact('token', 'message' ,'user'));
        }
    }

   function googleVerificationMail($profile){

      if($profile){

           $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['email'])
                   ->first();

               if($user['email_verification']==''){
                    $user_mail = array($profile['email']);
                    $name = $profile['given_name'].' '.$profile['family_name'];
                    $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                    $m->from($this->from_email, 'Direct Owners');

                                    $m->to($user_mail)->subject('Mail verification from Direct Owners');
                                });
               }  
             
                   
        }
    }
    
     /**
     * Login with LinkedIn.
     */
    public function linkedin(Request $request){   

        //$client_secret_id = '6GRVEaW1viv1JeSC';
        $client_secret_id = 'QB3D8OC1mpEu2GgL';
        $client = new Client();
        $params = [
            'code' => $request->input('code'),
            'client_id' => $request->input('clientId'),
            'client_secret' => $client_secret_id,
            'redirect_uri' => $request->input('redirectUri'),
            'grant_type' => 'authorization_code',
        ];
        //Log::info(print_r($params.' params', true));
        // Step 1. Exchange authorization code for access token.
        $accessTokenResponse = $client->request('POST', 'https://www.linkedin.com/oauth/v2/accessToken', [
            'form_params' => $params
        ]);
        $accessToken = json_decode($accessTokenResponse->getBody(), true);
        //Log::info(print_r($accessToken.' accessToken', true));
        // Step 2. Retrieve profile information about the current user.
        $profileResponse = $client->request('GET', 'https://api.linkedin.com/v2/me?projection=(r_liteprofile)', [
            'query' => [
                'oauth2_access_token' => $accessToken['access_token'],
                'format' => 'json'
            ]
        ]);

        $profile = json_decode($profileResponse->getBody(), true);    
        // Step 3a. If user is already signed in then link accounts.
        if ($request->header('Authorization'))
        {
            $token = Hash::make($profile['emailAddress']);
            $message = ['success'=>'1'];
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['emailAddress'])
                   ->first();

            if ($user)
            {                  

                $duser = DB::table('users as u')
                        ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['emailAddress'],
                            'linkedin_id'=>$profile['id'],
                            'first_name'=>$profile['firstName'],
                            'surname'=>$profile['lastName'],
                      ));                

                $renewal_check = User::getCheckUserRenewalStatus($user['id']);

                $user = $this->getUserDetails($user['id']);  
                       
                return response()->json(compact('token', 'message' ,'user'));                
            }            

            
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'linkedin_id' => $profile['id'],
                            'first_name' => $profile['firstName'],
                            'surname' => $profile['lastName'],
                            'email' => $profile['emailAddress'],                        
                            'created_datetime' => new DateTime
                        ));
            
            $user = $this->getUserDetails($duser);   

            $mail = $this->linkedinVerificationMail($profile);

            return response()->json(compact('token', 'message' ,'user'));
        }
        // Step 3b. Create a new user account or return an existing one.
        else
        {   
            $token = Hash::make($profile['emailAddress']);
            $message = ['success'=>'1'];
            $user = DB::table('users as u')
                   ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                   ->where('u.email', $profile['emailAddress'])
                   ->first();
            
            if ($user)
            {                  

                $duser = DB::table('users as u')                        
                        ->where('u.id', $user['id'])
                        ->update(array(
                            'token' => str_random(40),
                            'email'=>$profile['emailAddress'],
                            'linkedin_id'=>$profile['id'],
                            'first_name'=>$profile['firstName'],
                            'surname'=>$profile['lastName'],
                      ));                 

                $renewal_check = User::getCheckUserRenewalStatus($user['id']);

                $user = $this->getUserDetails($user['id']);      

                return response()->json(compact('token', 'message' ,'user'));
            }
           
            $duser = DB::table('users')
                        ->insertGetId(array(
                            'token' => str_random(40),
                            'linkedin_id' => $profile['id'],
                            'first_name' => $profile['firstName'],
                            'surname' => $profile['lastName'],
                            'email' => $profile['emailAddress'],                        
                            'created_datetime' => new DateTime
                        ));
            
            $user = $this->getUserDetails($duser);  
            
            $mail = $this->linkedinVerificationMail($profile);

            return response()->json(compact('token', 'message' ,'user'));
        }
    }

    function linkedinVerificationMail($profile){

        if($profile){

         $user = DB::table('users as u')
                 ->select(DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.id', 'u.profile_pic','u.email', 'u.email_verification', 'u.phone_verification','u.password as auth_token')
                 ->where('u.email', $profile['emailAddress'])
                 ->first();
         if($user){        
             if($user['email_verification']==''){
                  $user_mail = array($profile['emailAddress']);
                  $name = $profile['firstName'].' '.$profile['lastName'];
                  $mail =  Mail::send('emails.signup-email-verification', ['name'=>$name,'id'=>$user['id'],'email' => $user_mail], function ($m) use ($user_mail) {

                                  $m->from($this->from_email, 'Direct Owners');

                                  $m->to($user_mail)->subject('Mail verification from Direct Owners');
                              });
             }     
         }                   
      }
    }

}
