<?php

namespace App\Http\Controllers\Properties;
use App\Http\Controllers\Api\Properties\PropertyBooknowController;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests;
use Illuminate\Support\Facades\Input;
use App\PropertyBooknow;
use App\PropertyDetails;
use App\IXR_Client;
use App\Invoices;
use Validator;
use Response;
use App\User;
use Config;
use Mail;
use Log;
use DB;
class PayPalController extends Controller
{   
    public function __construct(){
      
       $this->from_email             = Config::get('app.email_from_address');
       $this->_s3_path               = Config::get('filesystems.s3_path');
    }

    public function payPalTransaction($item_name, $amount){
    	$request            = Input::all();
      $newObj             = new PropertyBooknowController;
      $selected_currency  = isset($request['currency_name'])?strtoupper($request['currency_name']):'';
      $currency_symbol    = isset($request['currency_symbol'])?$request['currency_name']:'';
      $currency_rate      = $selected_currency=='GBP'?1:$newObj->convertCurrency($selected_currency, $amount, 'GBP'); 
      $final_amount       = $amount;
    	include(storage_path().'/paypal.php');
    }

    public function payPalTransactionForBookingProperty($item_name, $amount,$pid){
        $request            = Input::all();
        $newObj             = new PropertyBooknowController;
        $selected_currency  = isset($request['currency_name'])?strtoupper($request['currency_name']):'';
        $currency_rate      = $selected_currency=='EUR'?1:$newObj->convertCurrency($selected_currency, $amount, 'EUR'); 
        $final_amount       = $amount;//$currency_rate;
        Log::info(print_r($final_amount.' final amount', true));
        include(storage_path().'/book_paypal.php');
    }

    public function getPaypalResponseBack(Request $request){

        Log::info(print_r('paypal $request->all()', true));
        Log::info(print_r($request->all(), true));

        $data   = $request->all();
        $status = isset($data['op'])?$data['op']:'';
        $bid    = isset($request['book_id'])?$request['book_id']:'';
        $amount = isset($request['amount'])?$request['amount']:'';
        $pid    = isset($request['pid'])?$request['pid']:'';
        $host = $_SERVER['SERVER_NAME']; 

        if($host=='localhost'){

          $this_page = 'http://localhost:8080/direct_owners/public/#/invoices';

        }else if($host=='fixontheday.com'){

          
          $this_page = 'http://'.$host.'/#/property-details/'.$pid;

        }else{
          
          $this_page = 'https://'.$host.'/#/property-details/'.$pid;
        }
        if($status=='success'){

            $data   = DB::table('booknow_property_details')->where('id', $bid)->update(array('payment_status'=>'yes','payment_type'=>'Paypal'));

            if($data){
                  //Artisan::call('view:clear');
                  $booking = PropertyBooknow::getPropertyBooknowDetailsById($bid);

                  $mail1 =  Mail::send('emails.property-booking-client', ['booking'=>$booking, '_s3_path'=>$this->_s3_path], function ($m) use ($booking) {

                      $m->from($this->from_email, 'Direct Owners');

                      $m->to($booking['email'])->subject('Booking Confirmation from Direct-Owners');
                  });

                  Log::info(print_r($mail1. 'paypal mail1 confirmation', true));
                  $mail2 =  Mail::send('emails.property-booking-owner', ['booking'=>$booking, '_s3_path'=>$this->_s3_path], function ($m) use ($booking) {

                      $m->from($this->from_email, 'Direct Owners');

                      $m->to($booking['owner_mail'])->subject('You have received a booking confirmation email');
                  });
                  Log::info(print_r($mail2. 'paypal mail2 confirmation', true));
                $response_array = array(
                    'status' => $status,
                    'amount' => $amount,
                    'message' => 'You have successfully booked the property. Your total booking amount is €'.$amount.'.
                              Please check your email for more details.',
                    'redirect_page' => $this_page,
                );  

                return view('paypal_status', compact('response_array'));
                //return Response::json(array('success'=>'1', 'message'=>$response_array));
            }
        }else{

            $response_array = array(
                'status' => $status,
                'amount' => $amount,
                'message' => 'Payment process declined, please try again!',
                'redirect_page' => $this_page,
            ); 

            return view('paypal_status', compact('response_array'));
            //return Response::json(array('success'=>'0', 'message'=>'Payment process declined, please try again!'));
        }
        
    }


    public function getOwnerInvoicePaypalResponseBack(Request $request){

        $data               = $request->all();
        $status             = isset($data['op'])?$data['op']:'';
        $invoice_id         = isset($request['invoice_id'])?$request['invoice_id']:'';
        $amount             = isset($request['amount'])?$request['amount']:'';
        $item_name          = isset($request['item_name'])?$request['item_name']:'';
        $currency_name      = isset($request['currency_name'])?$request['currency_name']:'';
        $currency_symbol    = isset($request['currency_symbol'])?$request['currency_symbol']:'';
        $payment_type       = 'Paypal';
        $host = $_SERVER['SERVER_NAME']; 

        if($host=='localhost'){

          $this_page = 'http://localhost/direct_owners/public/#/invoices';

        }else if($host=='fixontheday.com'){

          
          $this_page = 'http://'.$host.'/#/invoices';

        }else{
          
          $this_page = 'https://'.$host.'/#/invoices';
        }
        if($status=='success'){

            $prop_owner       = DB::table('invoices')->select('user_id', 'expiry_date', 'renewal_date')->where('id',$invoice_id)->first();
                   
            $user_id          = isset($prop_owner['user_id'])?$prop_owner['user_id']:'';

            $payment_db_status  =  $this->updateTMTBookingStatus($user_id, $invoice_id, $payment_type, $currency_name, $currency_symbol, $amount);

            if($payment_db_status){

                $response_array = array(
                    'status' => $status,
                    'amount' => $amount,
                    'message' => 'You have successfully renewed your account. Paid amount is '.$currency_symbol.' '.$amount.'.
                              Please check your email for more details.',
                    'redirect_page' => $this_page,
                );  

                return view('paypal_status', compact('response_array'));
            }else{

                $response_array = array(
                    'status' => $status,
                    'amount' => $amount,
                    'message' => 'Payment process declined, please try again!',
                    'redirect_page' => $this_page,
                ); 

                return view('paypal_status', compact('response_array'));
            }
            
        }else{

            $response_array = array(
                'status' => $status,
                'amount' => $amount,
                'message' => 'Payment process declined, please try again!',
                'redirect_page' => $this_page,
            ); 

            return view('paypal_status', compact('response_array'));
        }

    }

    public function getTMTOwnerInvoiceResponseBack(Request $request){

      $data                = $request->all();
      //Log::info(print_r($data, true));
      //die();
      $propertyBooknowRule = array(                              
                               'payment_method_token' =>'required',
                               'full_name'            =>'required',
                               'month'                =>'required',
                               'year'                 =>'required',
                               'cvv'                  =>'required',                               
                               'amount'               =>'required');  

      $validator = Validator::make(

          $data, $propertyBooknowRule
          
      );
      if($validator->fails()){
    //Log::info(print_r($validator->getMessageBag()->first(), true));
          return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 400);
      }else{

        require( storage_path().'/class-IXR.php' );
        $cardholder_name  =  isset($data['full_name'])?explode(' ',$data['full_name']):'';
        $cardholder_month =  isset($data['month'])?$data['month']:'';
        $cardholder_year  =  isset($data['year'])?$data['year']:'';
        $paid_amount      =  isset($data['amount'])?$data['amount']:'';
        $token            =  isset($data['payment_method_token'])?$data['payment_method_token']:'';
        $selected_card    =  'Credit Card';//isset($data['selected_card'])?$data['selected_card']:'';
        $currency_name    = isset($request['currency_name'])?strtoupper($request['currency_name']):'';
        $currency_symbol  = isset($request['currency_symbol'])?$request['currency_symbol']:'';
        $booking_id       = isset($data['id'])?$data['id']:'';
        //Log::info(print_r('before mail', true));
        // $this->updateTMTBookingStatus($booking_id);
        //die();  
        $method               = 'tmt.spreedly.addBooking';      
        $site_id              = 0;             
        $url                  = 'https://trustmytravel.com/xmlrpc.php';//'https://staging.trustmytravel.com/xmlrpc.php';             
        $site_id              = 0;             
        
        //Log::info(print_r($data['full_name'], true));
        //Log::info(print_r($cardholder_name, true));
        $first_name       = isset($cardholder_name[0])?$cardholder_name[0]:'';
        $last_name        = isset($cardholder_name[1])?$cardholder_name[1]:'';
        $prop_owner       = DB::table('invoices')->select('user_id', 'expiry_date', 'renewal_date')->where('id',$booking_id)->first();
        

        
        $user_id          = isset($prop_owner['user_id'])?$prop_owner['user_id']:'';
        $expiry_date      = isset($prop_owner['expiry_date'])?date('Y-m-d',strtotime($prop_owner['expiry_date'])):'';
        $renewal_date     = isset($prop_owner['renewal_date'])?date('Y-m-d',strtotime($prop_owner['renewal_date'])):'';

        $owner_details    = DB::table('users')->select(DB::raw('CONCAT(first_name, " ", surname) AS name'), 'email')->where('id', $user_id)->first();
        $email            = isset($owner_details['email'])?$owner_details['email']:'';
        $name             = isset($owner_details['name'])?$owner_details['name']:'';
        $owner_currency   = 'GBP';
        $base_currency    = 'GBP'; 
        $tmt_username     = 'token';     
        $tmt_api_token    = '956c7deb3eaf43032f9d75effae74859b0fcaa0e';
        $newObj           = new PropertyBooknowController;
        $payable_amount   = $newObj->convertCurrency($currency_name, $paid_amount, $owner_currency); 
        $today            = date('Y-m-d'); 
        $booking_data     = array(
                              'firstname'               => $first_name,
                              'surname'                 => $last_name,
                              'email'                   => $email,
                              'address'                 => '-',
                              'city'                    => '-',
                              'country'                 => '-',
                              'postcode'                => '-',
                              'date'                    => $renewal_date,
                              'date_end'                => $expiry_date,
                              'currency'                => $owner_currency,
                              'total'                   => $payable_amount,
                              'line_items'              => 'Account renewal by '.$name,
                              'payment_method_token'    => $token, 
                            ); 
        
        
        $client   = new IXR_Client( $url );      
        $client->query( $method, $site_id, $tmt_username, $tmt_api_token, $booking_data );      
        $response = $client->getResponse();
        //$response = array('success'=>true, 'faultCode'=>200, 'faultString' => 'Payment success');
        //$this->updateTMTBookingStatus($booking_id); 
        $result =  isset($response['success']) && $response['success']=='true'?$response['success']:''; 
        $error  =  isset($response['faultCode']) ? $response['faultString']:'';       
        if($result){         
          
          $tmt_booking_id =  isset($response['booking_id'])?$response['booking_id']:'';
          $update     = DB::table('invoices')->whereRaw('id="'.$booking_id.'"')->update(array('response_id'=>$tmt_booking_id));
          $payment_db_status  =  $this->updateTMTBookingStatus($user_id, $booking_id, $selected_card, $currency_name, $currency_symbol, $paid_amount);
          if($payment_db_status) {  

            return Response::json(array('success'=>1, 'message'=>'Payment has been done successfully'), 200);
          }else{

            return Response::json(array('success'=>0, 'message'=>'Something went wrong, please check'), 200);
          } 
        }else{
          if($error!=''){

            return Response::json(array('success'=>0, 'message'=> $error), 200);  

          }else{

            return Response::json(array('success'=>0, 'message'=>'Payment has not completed successfully. Please try again later!'), 200);
          }          
        }
      }   
    }

    public function updateTMTBookingStatus($uid, $id, $payment_type, $currency_name, $currency_symbol, $payable_amount){

        $data = Invoices::getUpdateOwnerRenewalData($uid, $id, $payment_type, $currency_name, $currency_symbol, $payable_amount);

        return $data;
    }

    public function convertCurrency($amount, $ctype, $base_currency){

      $req_url = 'https://api.exchangerate-api.com/v4/latest/'.$base_currency;
      $response_json = file_get_contents($req_url);

      // Continuing if we got a result
      if(false !== $response_json) {

          // Try/catch for json_decode operation
          try {

          // Decoding
          $response_object = json_decode($response_json);

          // YOUR APPLICATION CODE HERE, e.g.
          $base_price = $amount; // Your price in USD
          $currency_price = round(($base_price * $response_object->rates->$ctype), 2);
          Log::info(print_r('base_price: '.$base_price, true));
          Log::info(print_r('cptype: '.$response_object->rates->$ctype, true));
          Log::info(print_r('cp: '.$currency_price, true));
          return  $currency_price;
          }
          catch(Exception $e) {
              // Handle JSON parse error...
          }
      }
    }
}
