<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use DB;

class AccountController extends Controller
{
    public function getAccountsList(){

        $users = DB::table('users as u')
                 ->select('u.id',DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.email')
                 ->orderBy('name', 'asc')
                 ->get();

        $invoices = DB::table('invoices as in')
                 ->select('in.renewal_date', 'in.expiry_date')
                 ->get();           
    	return view('super_admin.accounts', compact('users', 'invoices'));
    }

     public function getAccountJsonList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'id', 
                    'name',
                    'properties',
                    'renewal_date',                                    
                    'expiry_date',
                    'price',
                    'status',
                    'id'
                 );

            try {    
                DB::enableQueryLog();
                
                /**
                 * Database query object selection
                 */
                $query = DB::table('invoices as in');  
                	
                 /**
                 * Database query joins
                 */		
                $query->join('property_details as pd', 'pd.user_id', '=', 'in.user_id')
                      ->join('users as u', 'u.id', '=', 'pd.user_id');	    

                /**
                 * field selection
                 */
                $query->select(
                    'u.id',
                    DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
                    DB::raw('(SELECT COUNT(u.id) FROM users as u where u.id= pd.user_id GROUP BY pd.user_id) properties'),
                    DB::raw('DATE_FORMAT(in.renewal_date, "%d-%m-%Y") as renewal_date'),
                    DB::raw('DATE_FORMAT(in.expiry_date, "%d-%m-%Y") as expiry_date'),    
                    //DATE('in.renewal_date'),//'date(in.renewal_date)',
                    //DATE('in.expiry_date'),
                    'in.price',
                    (DB::raw("(CASE 
                        WHEN CURDATE()>=in.expiry_date AND in.status='pending' THEN 'Expired' 
                        WHEN in.status = 'pending' THEN 'Pending'
                        WHEN in.status = 'paid' THEN 'Paid'              
                                    
                    END) status"))                   
                );  
                
               //echo "<pre>"; print_r($query->toSql()); exit;
                /**
                 * Default where clasue
                 */

                if ($data['name']!=''){

                    $query->whereRaw(

                        "u.id = ". (int)$data['name']
                    );
                }

                if ($data['expiry_from']!=''){

                    $query->whereRaw(
                        "in.expiry_date >= '".date('Y-m-d', strtotime($data['expiry_from']))."'"
                    );
                }

                if ($data['expiry_to']!=''){

                    $query->whereRaw(
                        "in.expiry_date < '".date('Y-m-d', strtotime($data['expiry_to']))."'"
                    );
                }

                if ($data['status']!=''){

                    if($data['status']=='expired'){
                        $query->whereRaw(
                            "CURDATE()>=in.expiry_date AND in.status='pending'"                            
                        );
                    }else if($data['status']=='pending'){
                        $query->whereRaw(

                            "CURDATE()<=in.expiry_date AND in.status='pending'"
                        );
                    }else{
                        $query->whereRaw(
                            "in.status = '". $data['status'] ."'"
                        );
                    }
                } 


                $cmsCount = count($query->get());
                /**
                 * Order by
                 */
                
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }                 
                

                /**
                 * Get
                 */
                $cms = $query->get();
            } catch(\Exception $e) {
                $cms = [];
                $cmsCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $cmsCount;
            $response['recordsFiltered'] = $cmsCount;

            $response['data'] = $cms;

            return response()->json($response);
        }
    }

    public function getUserAccountJsonList($uid){

    	 $query = DB::table('invoices as in')
    	 		  ->select('in.*')
    	 		  ->where('in.user_id', $uid)
    	 		  ->get();
    	 if($query){
    	  return response()->json(array('success'=>1, 'data'=>$query), 200);		  
    	 }else{
    	  return response()->json(array('success'=>0, 'data'=>'No results found!'), 400);		  	
    	 }

    }


}
