<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Admin;

use App\Http\Requests;

use Validator;

use Session;

use Redirect;
use Log;
class AdminController extends Controller
{


    public function adminLogin(){

    	return view('super_admin.admin-login');
    }

    public function adminLoginCheck(Request $request){
    	
        // store all inputs in a variable
        $input = $request->all();         
        //define the rules of validation
        $rules = array(
            'username' => 'required|email',
            'password' => 'required'
        );    

        // Passing input with defined rules through validator class
        $validation = Validator::make($input, $rules);
          //if validation fails
          if ($validation->fails())
          {
            //redirect back with validation errors
            return Redirect::route('admin.login')->withErrors($validation);
          }// if validation is passed
          else
          {

        	$login = Admin::adminLoginCheck($request);            
            
        	if($login){ 

                return $login;  
                
            }else{

             $message = ['msg' => 'Username or password is incorrect. '  ];

             return Redirect::action('SuperAdmin\AdminController@adminLogin')->withErrors($message);
             
            }

         }  	
    }

    public function adminLogout(){

    	Session::flush();

	    return Redirect::route('admin.login');
    }

    public function getAdminProfile(){

        $session = Session::all();

        $id = $session['admin_logged_in']['0']['id'];     

        $admin = Admin::getAdminDetails($id);

        return view('super_admin.edit-admin', compact('admin'));
    }

    public function getUpdateAdminProfile(Request $request){

       $request = $request->all();

       $updateRules = array(
            'first_name'    => 'required',
            'surname'       =>'required',
            'username'      =>'required|unique:admin,username,'.$request['admin_id']
        );
        
        $validator = Validator::make(

            $request, $updateRules

        );

        if($validator->fails()){

            return Redirect::route('admin.profile-page')->withErrors($validator);

        }else{

       
           $data = Admin::getUpdateAdminProfile($request);           

           return Redirect::route('admin.profile-page');

        }   
    }
}
