<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use Response;

use Session;

use Redirect;

use App\CMS;

use DB;

use Log;
class CmsController extends Controller
{
    public function getCmsList(){
    				
    	return view('super_admin.cms');

    }

    public function getDisplayHowtoRegisterPage(){
        
        $last_file = DB::table('registation_pdf_details')->select('name', 'original_name')->orderBy('id', 'desc')->first();

        return view('super_admin.how-to-register', compact('last_file'));  
    }

    public function saveRegisterPdf(Request $request){
        
        try{

            if ($request->hasFile('pdf_name')) { 
                
                $file = $request->file('pdf_name');

                //Log::info(print_r($file, true));
                $directory = public_path().'/uploads/'; 

                if (!file_exists($directory)) {
                    mkdir($directory, 0777, true);
                }
                
                $img  = time().'.'.$file->getClientOriginalExtension();
               
                $original_name = $file->getClientOriginalName();

                if($file->move($directory,$img)){    

                    $date = date('Y-m-d H:i:s');
                    $save = DB::table('registation_pdf_details')->insertGetId(array('name'=>$img, 'original_name'=>$original_name, 'created_at'=>$date, 'updated_at'=>$date));           
                    //Log::info(print_r('success', true));
                    $response = array('success'=>1, 'message'=> 'PDF uploaded successfully!');
                    return response()->json($response);
                    
                }else{

                    $response = array('success'=>0, 'message'=> 'PDF not uploaded');
                    return response()->json($response);
                }
            }
        }catch(\Exception $e){

            $response = array('success'=>0, 'message'=> $e->getMessage());
            return response()->json($response);    
        }

    }

    public function getDisplayHowtoAddDealPage(Request $request){

        $last_file = DB::table('deal_pdf_details')->select('name', 'original_name')->orderBy('id', 'desc')->first();

        return view('super_admin.how-to-add-deal', compact('last_file'));  
    }

    public function saveAddDealPdf(Request $request){
        
        try{

            if ($request->hasFile('pdf_name')) { 
                
                $file = $request->file('pdf_name');

                //Log::info(print_r($file, true));
                $directory = public_path().'/uploads/'; 

                if (!file_exists($directory)) {
                    mkdir($directory, 0777, true);
                }
                
                $img  = time().'.'.$file->getClientOriginalExtension();
               
                $original_name = $file->getClientOriginalName();

                if($file->move($directory,$img)){    

                    $date = date('Y-m-d H:i:s');
                    $save = DB::table('deal_pdf_details')->insertGetId(array('name'=>$img, 'original_name'=>$original_name, 'created_at'=>$date, 'updated_at'=>$date));           
                    //Log::info(print_r('success', true));
                    $response = array('success'=>1, 'message'=> 'PDF uploaded successfully!');
                    return response()->json($response);
                    
                }else{

                    $response = array('success'=>0, 'message'=> 'PDF not uploaded');
                    return response()->json($response);
                }
            }
        }catch(\Exception $e){
            print_r($e->getMessage(), true);
            $response = array('success'=>0, 'message'=> $e->getMessage());
            return response()->json($response);    
        }

    }

    public function getRegisterPDFDetailsInJsonFormat(Request $request){

        $last_file      = DB::table('registation_pdf_details')->select('name', 'original_name')->orderBy('id', 'desc')->first();

        $name           = $last_file?$last_file['name']:'how_to_register.pdf';
        $original_name  = $last_file?$last_file['original_name']:'how_to_register.pdf';


        $arrayName      = array('name' => $name, 'original_name'=>$original_name);
        if($arrayName){

            return Response::json(array('success'=>1, 'cms'=>$arrayName));
        }               
    }   

    public function getDealPDFDetailsInJsonFormat(Request $request){

        $last_file      = DB::table('deal_pdf_details')->select('name', 'original_name')->orderBy('id', 'desc')->first();

        $name           = $last_file?$last_file['name']:'deal_help_text.pdf';
        $original_name  = $last_file?$last_file['original_name']:'deal_help_text.pdf';


        $arrayName      = array('name' => $name, 'original_name'=>$original_name);
        if($arrayName){

            return Response::json(array('success'=>1, 'cms'=>$arrayName));
        }               
    }   
    

    public function getCMSDetailsById($id){

    	$cms = DB::table('cms')
    			->select('*')
    			->where('id', $id)
    			->first();
    	return view('super_admin.edit-cms', compact('cms'));

    }

    
	public function getCMSDetailsInJsonFormat($id){
        //echo $id;
                  
        $cms = DB::table('cms')
            ->select('*')
            ->where('id', $id)
            ->first();

		if($cms){

			return Response::json(array('success'=>'1', 'cms'=>$cms));
		}    			
	}	
    public function getupdateCMS(Request $request){


    	

	    	if(isset($request['id']) && $request['id']!=5){                

	    		$data = CMS::find($request['id']);
	    		$data->title = $request['title'];
	    		$data->description = html_entity_decode($request['description']);
	    		$data->save();

	    		if($data){

	    			return Redirect::route('admin.cms-list');
	    		}    				
	    	}else{

                if ($request->hasFile('pdf_name')) { 
                    
                    $file = $request->file('pdf_name');
                    $directory = public_path().'/uploads/'; 

                    if (!file_exists($directory)) {
                        mkdir($directory, 0777, true);
                    }

                    $data = CMS::find($request['id']);
                    
                    $img  = 'deal_help_text.'.$file->getClientOriginalExtension();

                    if($file->move($directory,$img)){               

                        $data->title        = $request['title'];
                        $data->description  = $img;
                        $data->save();                        
                        Session::flash('message', "PDF uploaded successfully!");
                        return Redirect::back();
                        
                    }
                }
            }
    }

    public function getCmsJsonList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'id', 
                    'title',
                    'id',                                    
                 );

            try {    
                DB::enableQueryLog();
                
                /**
                 * Database query object selection
                 */
                $query = DB::table('cms');

                /**
                 * field selection
                 */
                $query->select(
                    'id',
                    'title' 
                );               

                       

                $cmsCount = count($query->get());
                /**
                 * Order by
                 */
                //echo "<pre>"; print_r($query->toSql()); exit;
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $cms = $query->get();
            } catch(\Exception $e) {
                $cms = [];
                $cmsCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $cmsCount;
            $response['recordsFiltered'] = $cmsCount;

            $response['data'] = $cms;

            return response()->json($response);
        }
    }
}
