<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use DB;

class EnquiriesController extends Controller
{
    public function getEnquiriesList(){

        $email = DB::table('property_enquiry as pe')
             ->select('pe.email')
             ->orderBy('pe.created_at', 'desc')
             ->groupBy('pe.email')
             ->get();
        $arrival = DB::table('property_enquiry as pe')
             ->select('pe.arrival_time as at')
             ->orderBy('pe.created_at', 'desc')
             ->groupBy('pe.arrival_time')
             ->get();
        $departure = DB::table('property_enquiry as pe')
             ->select('pe.departure_time as dt')
             ->orderBy('pe.created_at', 'desc')
             ->groupBy('pe.departure_time')
             ->get();             
        $prop = DB::table('property_enquiry as pe')
             ->select('pd.property_title')
             ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
             ->groupBy('pd.property_title')
             ->orderBy('pd.created_at', 'desc')
             ->get();           

    	return view('super_admin.enquiries', compact('email', 'prop', 'arrival', 'departure'));

    }

    public function getDisplayEnquiriesList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'id', 
                    'name',
                    'email',
                    'at',                    
                    'dt', 
                    'property_title',
                    'id',
                    'id'
                    

                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table('property_enquiry as pe');

                /**
                 * field selection
                 */
                $query->select(
                    'pe.id',
                     DB::raw('CONCAT(pe.first_name, " ", pe.surname) AS name'),
                    'pe.email', 
                    'pe.arrival_time as at', 
                    'pe.departure_time as dt', 
                    'pd.property_title'
                );

                /**
                 * join section
                 */
                $query->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id');

                /**
                 * default orderby
                 */
                //$query->orderBy('pe.created_at', 'desc');
                
                                
                /**
                 * Default where clasue
                 */

                if ($data['email']!=''){

                    $query->whereRaw(
                        "pe.email = '". $data['email'] ."'"
                    );
                }

                if ($data['arrival_time']!=''){

                    $query->whereRaw(
                        "pe.arrival_time = '". $data['arrival_time'] ."'"
                    );
                }

                if ($data['departure_time']!=''){

                    $query->whereRaw(
                        "pe.departure_time = '". $data['departure_time'] ."'"
                    );
                }

                if ($data['property_title']!=''){

                    $query->whereRaw(
                        "pd.property_title = '". $data['property_title'] ."'"
                    );
                }        

                $enquiriesCount = count($query->get());
                /**
                 * Order by
                 */
                //echo "<pre>"; print_r($query->toSql()); exit;
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $enquiries = $query->get();
            } catch(\Exception $e) {
                $enquiries = [];
                $enquiriesCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $enquiriesCount;
            $response['recordsFiltered'] = $enquiriesCount;

            $response['data'] = $enquiries;

            return response()->json($response);
        }
    }
}
