<?php

namespace App\Http\Controllers\SuperAdmin;
use Intervention\Image\Facades\Image as Image;
use Illuminate\Support\Facades\Storage;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\HolidayEssentials;

use App\Http\Requests;

use Validator;

use Response;

use Config;

use Log;

use DB;
class HolidayEssentialsController extends Controller
{

	public function __construct(){      
       $this->_s3_path               = Config::get('filesystems.s3_path');
    }

	public function addHolidayEssentialView(Request $request){

		$activities_list = Config::get('dropdown.activities_list');

		return view ('super_admin.holiday-essentials.add-holiday-essential', compact('activities_list'));
	}

	public function editHolidayEssentialView($id){
		
		$activities_list 	= Config::get('dropdown.activities_list');
		$_s3_path			= $this->_s3_path;
		if($id){

			$data 			= DB::table('holiday_essentials')->select('*')->where('id', $id)->first();
			
			return view ('super_admin.holiday-essentials.edit-holiday-essential', compact('activities_list','data', '_s3_path'));
		}
	}
    public function addHolidayEssential(Request $request){

    	$request  = $request->all();

    	//Log::info(print_r($request, true));

    	//exit;
		$addRules = array(
						'activities_list'       =>'required',
                        'name'          		=>'required',
                        'description'         	=>'required',
                        'address'            	=>'required',
                        'web_link'         		=>'required|website'					
					);

		Validator::extend('website', function ($attribute, $value, $parameters, $validator) {
		  return filter_var($value, FILTER_VALIDATE_URL);
		});

		$message = array(
                     'web_link.website' => 'Invalid URL'
                   );
		$validator = Validator::make(

			$request, $addRules, $message
		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 200);
		}else{

			
			$local_directory        = public_path().'/uploads/holiday_essentials'; 
            $directory              = 'uploads/holiday_essentials'; 
            if (!file_exists($local_directory)) {
                mkdir($local_directory, 0777, true);
            }	

            if(isset($request['image_file'])){
	            $files   		 = $request['image_file'];                
	            $gallery 		 = '';
	            
	            $filename     		 = 'he'.time().'.'.$files->getClientOriginalExtension(); 
	            $files->move($local_directory,$filename);
	            $local_img 		 = $local_directory.'/'.$filename;
	            $image           = Image::make($local_img);
                $resize_image    = $image->fit(640,427)->stream();
                //Move the uploaded file to temp directory
                $upload_success  = Storage::disk('s3')->put($directory.'/'.$filename, $resize_image->__toString(), 'public');
               
                if($upload_success){
                 unlink($local_directory.'/'.$filename);
                }
	        }else{
	        	$filename     = '';
	        }

			$hobj 				= new HolidayEssentials;
			$hobj->owner_id 	= $request['owner_id'];
			$hobj->name 		= $request['name'];
			$hobj->description 	= $request['description'];
			$hobj->address 		= $request['address'];
			$hobj->lat 			= $request['latitude'];
			$hobj->lng 			= $request['longitude'];
			$hobj->web_link 	= $request['web_link'];
			$hobj->activity 	= $request['activities_list'];
			$hobj->image 		= $filename;
			$hobj->save();

			if($hobj){

				return Response::json(array('success'=>1, 'message'=>'Data added successfully!'), 200);	
			}else{

				return Response::json(array('success'=>0, 'message'=>'Data not added, please try again!'), 200);
			}
		}
    }

    public function getHolidayEssentialList(Request $request){

    	$owner_id = isset($request['owner_id'])?$request['owner_id']:'';

    	if($owner_id){

    		$property = DB::table('holiday_essentials')
	                    ->select('*')
	                    ->where('owner_id', $owner_id)                        
	                    ->orderBy('created_at', 'desc')
	                    ->get();
			
			if($property){

                return Response::json(array('success'=>1, 'data'=>$property));

            }else{

                return Response::json(array('success'=>0, 'data'=>'No results found'));
            }                       
    	}else{

    		return Response::json(array('success'=>0, 'data'=>'No results found'));	
    	}
    }

    public function getSearchResults(Request $request){

    	$searchQuery = DB::table('holiday_essentials')
    								->select('*', 
    									(DB::raw("(CASE 
					                        WHEN LENGTH(description)>70 THEN concat(SUBSTRING(description, 1, 70), '...') ELSE description	
					                    END) sdesc")) 
    								);

		if($request->has('city')){          
                
            $searchQuery->whereraw("address like '%".$request['city']."%'");  
        }

        if($request->has('activities_list') && $request['activities_list']!='all'){          
                
            $searchQuery->whereraw("activity like '%".$request['activities_list']."%'");  
        } 

        $searchQuery->orderBy('created_at', 'desc'); 
        $result    = $searchQuery->get();
        if($result){            

            return Response::json(array('success'=>1, '_s3_path'=>$this->_s3_path, 'he_details'=>$result));

        }else{

            return Response::json(array('success'=>0, '_s3_path'=>$this->_s3_path, 'he_details'=>'There are no properties with given requirement.'));
        }   								
    }


    public function getSaveClicks(Request $request){

    	$id = isset($request['id'])?$request['id']:'';

    	if($id){

    		$existing_count = DB::table('holiday_essentials')->select('no_of_clicks')->where('id', $id)->first();

    		$count = $existing_count?$existing_count['no_of_clicks']+1:0;

    		$update = DB::table('holiday_essentials')->where('id', $id)->update(array('no_of_clicks'=>$count));

    		if($update){            

		        return Response::json(array('success'=>1));

		    }else{

		        return Response::json(array('success'=>0));
		    }
    	}
    }

    public function getHEById(Request $request){

    	$id = isset($request['id'])?$request['id']:'';

    	if($id){

    		$data = DB::table('holiday_essentials')->select('*')->where('id', $id)->first();

    		if($data){            

		        return Response::json(array('success'=>1, 'data'=>$data));

		    }else{

		        return Response::json(array('success'=>0));
		    }

    	}else{

    		return Response::json(array('success'=>0));
    	}
    }

    public function updateHolidayEssential(Request $request){

    	$request1  = $request->all();
    	//Log::info(print_r($request1, true));
		$addRules = array(
						'activities_list'       =>'required',
                        'name'          		=>'required',
                        'description'         	=>'required',
                        'address'            	=>'required',
                        'web_link'         		=>'required|website'					
					);

		Validator::extend('website', function ($attribute, $value, $parameters, $validator) {
		  return filter_var($value, FILTER_VALIDATE_URL);
		});

		$message = array(
                     'web_link.website' => 'Invalid URL'
                   );
		$validator = Validator::make(

			$request1, $addRules, $message
		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 200);
		}else{

			$id 				= $request['id'];

			$hobj 				= HolidayEssentials::find($id);

			$local_directory	= public_path().'/uploads/holiday_essentials/'; 
			$directory 			= 'uploads/holiday_essentials/'; 

            if (!file_exists($local_directory)) {
                mkdir($local_directory, 0777, true);
            }

            if(isset($request['image_file'])){

            	$eimg = $hobj->image;
            	$epath = $directory.'/'.$eimg;
	            $del_from_storage   =  Storage::disk('s3')->delete($epath);

            	$files   = $request['image_file'];                
	            $gallery = '';
	            
	            $filename     = 'he'.time().'.'.$files->getClientOriginalExtension(); 
	            $files->move($directory,$filename);

	            $local_img 		 = $local_directory.'/'.$filename;
	            $image           = Image::make($local_img);
                $resize_image    = $image->fit(640,427)->stream();
                //Move the uploaded file to temp directory
                $upload_success  = Storage::disk('s3')->put($directory.'/'.$filename, $resize_image->__toString(), 'public');
               
                if($upload_success){
                 unlink($local_directory.'/'.$filename);
                }

            }else{
            	$filename 	 = '';
            }
            
            
			
			if($request->has('name')){
				
				$hobj->name 	= $request['name'];	
			}
			if($request->has('description')){
				
				$hobj->description 	= $request['description'];	
			}
			if($request->has('address')){
				
				$hobj->address 	= $request['address'];	
			}
			if($request->has('latitude')){
				
				$hobj->lat 	= $request['latitude'];	
			}
			if($request->has('longitude')){
				
				$hobj->lng 	= $request['longitude'];	
			}
			if($request->has('web_link')){
				
				$hobj->web_link 	= $request['web_link'];	
			}
			if($request->has('activities_list')){
				
				$hobj->activity 	= $request['activities_list'];	
			}
			if($request->has('owner_id')){
				
				$hobj->owner_id 	= $request['owner_id'];	
			}
			if($filename){
				
				$hobj->image 	= $filename;	
			}

			$hobj->update();

			if($hobj){

				return Response::json(array('success'=>1, 'message'=>'Data updated successfully!'), 200);	
			}else{

				return Response::json(array('success'=>0, 'message'=>'Data not updated, please try again!'), 200);
			}
		}
    }

    public function getDisplayHEList(Request $request){

    	$_s3_path			= $this->_s3_path;
    	return view ('super_admin.holiday-essentials.holiday-essentials-list', compact('_s3_path'));
    }

    public function getDisplayHEJsonList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(                                         
                    'id', 
                    'name',
                    'image',
                    'web_link',
                    'address'                                 
                 );

            try {    
                DB::enableQueryLog();
                
                /**
                 * Database query object selection
                 */
                $query = DB::table('holiday_essentials');

                /**
                 * field selection
                 */
                $query->select(
                    'id', 
                    'name',
                    'image',
                    'web_link',
                    'address'
                ); 

                       

                $heCount = count($query->get());
                /**
                 * Order by
                 */
                //echo "<pre>"; print_r($query->toSql()); exit;
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }                                 

                /**
                 * Get
                 */
                $heDetails = $query->get();
            } catch(\Exception $e) {//echo "<pre>"; print_r($query->toSql()); exit;
                $heDetails = [];
                $heCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $heCount;
            $response['recordsFiltered'] = $heCount;

            $response['data'] = $heDetails;

            return response()->json($response);
        }
    }

    public function deleteHE(Request $request){

    	$request1  = $request->all();
    	
		$rules = array(
						'id'       =>'required'				
					);

		
		
		$validator = Validator::make(

			$request1, $rules
		);

		if($validator->fails()){

			return Response::json(array('success'=>0, 'message'=>$validator->getMessageBag()->first()), 200);
		}else{

			$id 			= $request['id'];
			$img_data 		= DB::table('holiday_essentials')->select('image')->where('id', $id)->first();

			$eimg 			= $img_data?$img_data['image']:'';
			$directory 		= public_path().'/uploads/holiday_essentials/'; 
			$epath 			= $directory.'/'.$eimg;
			if($eimg && file_exists($epath)){
				
            	unlink($epath);	
			}
            

			$data 	= DB::table('holiday_essentials')->where('id', $id)->delete();

			if($data){

				return Response::json(array('success'=>1, 'message'=>'Data deleted successfully!'), 200);	
			}else{

				return Response::json(array('success'=>0, 'message'=>'Data not deleted, please try again!'), 200);
			}
		}
    }
}
