<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use App\PropertyDetails;

use DB;
use Config;
class PropertiesController extends Controller
{
    public function __construct(){
      
       $this->_s3_path               = Config::get('filesystems.s3_path');
    }

    public function getPropertiesList(){

    	$countries = DB::table('property_details as pd')
    			->select('pd.property_id', 'pd.country')
    			->groupBy('pd.country')
    			->get();
        if(isset($_GET['status']) && $_GET['status']=='active')
        {

        	$status = 'active';	
        }else if(isset($_GET['status']) && $_GET['status']=='inactive'){

        	$status = 'inactive';	
        }else{

        	$status = '';
        }

        $_s3_path = $this->_s3_path;
    	return view('super_admin.property-list', compact('countries', 'status', '_s3_path'));

    }

    public function editPropertyDetails($id){
		
        $property_id = $id; 
		$prop = PropertyDetails::getSuperAdminSinglePropertyDetailsById($id, '');	
        $_s3_path = $this->_s3_path;
         
		return view('super_admin.edit-property', compact('prop', 'property_id', '_s3_path'));    	
    }

    /**
     * properties list in Json Format
     * @param  Request $request [description]
     * @return String           List of properties in Json Sting 
     */
    public function properties(Request $request)
    {
    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'property_image', 
                    'property_title',
                    'space_type',
                    'country',
                    'standard_rate_per_week',                      
                    'created_at',
                    'status',
                    'property_id', 
                    'week_rate',
                    'min_week_rate',
                    '_s3_path'

                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table(
                    'property_details as pd'
                );

                /**
                 * field selection
                 */
                $query->select(
                	'pd.*',
                    DB::raw('pd.standard_rate_per_week'),
                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate')),
                	'pg.image_name'
                );
                //$query->addBinding($this->_s3_path, '_s3_path');
                /**
                 * Joins :Start
                 */
                $query->leftJoin(
                	'property_gallery as pg', 
                	'pg.property_id', 
                	'=',
                	'pd.property_id'
                );
                //->orderBy('pd.created_at', 'desc');
                
                /**
                 * Joins :End
                 */
                                
                /**
                 * Default where clasue
                 */

                if ($data['country']!=''){

	                $query->whereRaw(
	                    "pd.country = '". $data['country'] ."'"
	                );
	            }

	            if ($data['space_type']!=''){

	                $query->whereRaw(
	                    "pd.space_type = '". $data['space_type'] ."'"
	                );
	            }

	            if ($data['status']!=''){

	                $query->whereRaw(
	                    "pd.status = '". $data['status'] ."'"
	                );
	            }

                /*if (isset($data['remind_to_user']) && $data['remind_to_user'] == 'active') {
                    $query->whereRaw(
                        "at_notes_remind_to.user_id != 0"
                    );
                }*/

                /**
                 * Search Filter
                 */
                if (isset($data['search']['value']) && $data['search']['value'] != '') {
                    // where conditions
                    $query->where(function($query) use ($data) {
                        $query
                            ->orWhereRaw("pd.country LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.property_title LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.space_type LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.status LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.standard_rate_per_week LIKE '%".$data['search']['value']."%'");                                       
                    });                
                }

                

                $query->groupBy('pd.property_id');

                $propertiesCount = count($query->get());
                /**
                 * Order by
                 */

                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $properties = $query->get();
            } catch(\Exception $e) {
                $properties = [];
                $propertiesCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $propertiesCount;
            $response['recordsFiltered'] = $propertiesCount;

            $response['data'] = $properties;

            return response()->json($response);
        }    
    }
    

     /**
     * properties list in Json Format
     * @param  Request $request [description]
     * @return String           List of properties in Json Sting 
     */
    public function getOwnerPropertiesList(Request $request)
    {
        $data = $request->all();
        $owner_id = isset($data['owner_id'])?$data['owner_id']:'';
        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'property_image', 
                    'property_title',
                    'space_type',
                    'country',
                    'standard_rate_per_week',                      
                    'created_at',
                    'status',
                    'property_id', 
                    'week_rate',
                    'min_week_rate'

                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table(
                    'property_details as pd'
                );

                /**
                 * field selection
                 */
                $query->select(
                    'pd.*',
                    DB::raw('pd.standard_rate_per_week'),
                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate')),
                    'pg.image_name'
                );

                /**
                 * Joins :Start
                 */
                $query->leftJoin(
                    'property_gallery as pg', 
                    'pg.property_id', 
                    '=',
                    'pd.property_id'
                );
                //->orderBy('pd.created_at', 'desc');
                
                /**
                 * Joins :End
                 */
                                
                /**
                 * Default where clasue
                 */

                if ($data['country']!=''){

                    $query->whereRaw(
                        "pd.country = '". $data['country'] ."'"
                    );
                }

                if ($data['space_type']!=''){

                    $query->whereRaw(
                        "pd.space_type = '". $data['space_type'] ."'"
                    );
                }

                if ($data['status']!=''){

                    $query->whereRaw(
                        "pd.status = '". $data['status'] ."'"
                    );
                }

                /*if (isset($data['remind_to_user']) && $data['remind_to_user'] == 'active') {
                    $query->whereRaw(
                        "at_notes_remind_to.user_id != 0"
                    );
                }*/

                /**
                 * Search Filter
                 */
                if (isset($data['search']['value']) && $data['search']['value'] != '') {
                    // where conditions
                    $query->where(function($query) use ($data) {
                        $query
                            ->orWhereRaw("pd.country LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.property_title LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.space_type LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.status LIKE '%".$data['search']['value']."%'");
                        $query
                            ->orWhereRaw("pd.standard_rate_per_week LIKE '%".$data['search']['value']."%'");                                       
                    });                
                }

                
                $query->where('user_id', $owner_id);
                $query->groupBy('pd.property_id');

                $propertiesCount = count($query->get());
                /**
                 * Order by
                 */

                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $properties = $query->get();
            } catch(\Exception $e) {
                $properties = [];
                $propertiesCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $propertiesCount;
            $response['recordsFiltered'] = $propertiesCount;

            $response['data'] = $properties;

            return response()->json($response);
        }    
    }
}
