<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\PropertyBooknow;

use App\Http\Requests;

use Response;

use Mail;

use DB;
use Config;
class PropertyBookingController extends Controller
{   
    public function __construct(){
      
       $this->from_email             = Config::get('app.email_from_address');
    }
    public function displayPropertyBookingPage(){
        $arrival = DB::table('booknow_property_details as pb')
             ->select('pb.arrival_time as at')
             ->orderBy('pb.created_at', 'desc')
             ->groupBy('pb.arrival_time')
             ->get();
        $departure = DB::table('booknow_property_details as pb')
             ->select('pb.departure_time as dt')
             ->orderBy('pb.created_at', 'desc')
             ->groupBy('pb.departure_time')
             ->get();             
        $prop = DB::table('booknow_property_details as pb')
             ->select('pd.property_title')
             ->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
             ->groupBy('pd.property_title')
             ->orderBy('pd.created_at', 'desc')
             ->get();

    	$bookings = DB::table('booknow_property_details as pb')
            ->select('pb.*','pb.guest_limit as booking_guest_limit',DB::raw("DATE_FORMAT(pb.arrival_time, '%d-%m-%Y') as barrival_time"),DB::raw("DATE_FORMAT(pb.departure_time, '%d-%m-%Y') as bdeparture_time"), 'pd.*', DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.email as owner_mail')
            ->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
            ->leftJoin('users as u', 'u.id', '=', 'pb.owner_id')
            ->get();

    	return view('super_admin.property-bookings', compact('bookings', 'prop', 'arrival', 'departure'));
    }

    public function getDisplayCancelBookedPropertyPage(){

    	$prop = DB::table('booknow_property_details as pb')
             ->select('pd.property_title')
             ->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
             ->groupBy('pd.property_title')
             ->orderBy('pd.created_at', 'desc')
             ->get();

        return view('super_admin.cancel-bookings', compact('prop'));
    }

    public function getCancelBookedProperty(Request $request){

        $booking_id    = $request['booking_id'];

         if($request['admin_cancel_status']=='yes'){

            $update = DB::table('booknow_property_details')
                        ->where('id', $booking_id)
                        ->update(
                            array(
                                'admin_cancel_status'=>'yes',                                
                            )
                        );
            if($update){

                return Response::json(array('success'=>1, 'message'=>'Booking has been cancelled successfully!'), 200);
            }else{

                return Response::json(array('success'=>0, 'message'=>'Booking has not been cancelled!, try again.'), 200);
            } 
         }else if($request['admin_cancel_status']=='no'){

            $update = DB::table('booknow_property_details')
                        ->where('id', $booking_id)
                        ->update(
                            array(
                                'admin_cancel_status'=>'no',                                
                            )
                        );
            if($update){

                return Response::json(array('success'=>1, 'message'=>'Owner booking cancel request disapproved successfully'), 200);
            }else{

                return Response::json(array('success'=>0, 'message'=>'There is something went wrong!'), 200);
            } 
         }
    }

    public function getDisplayPropertyBookingsJsonList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                    'id', 
                    'name',
                    'property_title',
                    'at',                    
                    'dt',
					'paid_amount',
                    'status',
					'created_at'
                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table('booknow_property_details as pb');

                /**
                 * field selection
                 */
                $query->select(
                    'pb.id',
					 DB::raw('CONCAT("€ ", pb.paid_amount) as paid_amount'),
                     DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
                     DB::raw("DATE_FORMAT(pb.arrival_time, '%d-%m-%Y') as at"), 
                     DB::raw("DATE_FORMAT(pb.departure_time, '%d-%m-%Y') as dt"), 
					 DB::raw("DATE_FORMAT(pb.created_at, '%d-%m-%Y') as created_at"), 
                    'pd.property_title',
                     DB::raw("CONCAT(UCASE(LEFT(pb.payment_status, 1)), 
                             SUBSTRING(pb.payment_status, 2)) as status")
                );

                /**
                 * join section
                 */
                $query->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
                	  ->leftJoin('users as u', 'u.id', '=', 'pb.owner_id')
                      ->where('block_type', '!=', 'preblock');

                /**
                 * default orderby
                 */
                //$query->orderBy('pe.created_at', 'desc');
                
                                
                /**
                 * Default where clasue
                 */

                /*if ($data['email']!=''){

                    $query->whereRaw(
                        "pe.email = '". $data['email'] ."'"
                    );
                }*/  

                if ($data['arrival_time']!=''){

                    $query->whereRaw(
                        "pb.arrival_time >= '".date('Y-m-d', strtotime($data['arrival_time']))."'"
                    );
                }

                if ($data['departure_time']!=''){

                    $query->whereRaw(
                        "pb.departure_time <= '". date('Y-m-d', strtotime($data['departure_time'])) ."'"
                    );
                }

                if ($data['property_title']!=''){

                    $query->whereRaw(
                        "pd.property_title = '". $data['property_title'] ."'"
                    );
                }

                if ($data['paypal_status']!=''){

                    $query->whereRaw(
                        "pb.payment_status = '". $data['paypal_status'] ."'"
                    );
                }      

                $bookingsCount = count($query->get());
                /**
                 * Order by
                 */
                
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
               //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $bookings = $query->get();
            } catch(\Exception $e) {//echo "<pre>"; print_r($query->toSql()); exit;

                $bookings = [];
                $bookingsCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $bookingsCount;
            $response['recordsFiltered'] = $bookingsCount;

            $response['data'] = $bookings;
			
            return response()->json($response);
        }
    }

    public function getDisplayRequestedCancelBookingsJsonList(Request $request){

        $data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                    'id', 
                    'name',
                    'property_title',
                    'at',                    
                    'dt',
                    'paid_amount',
                    'status',
                    'created_at',
                    'owner_cancel_request',
                    'cancel_booking_status',
                    'email',
                    'cancel_comment'
                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table('booknow_property_details as pb');

                /**
                 * field selection
                 */
                $query->select(
                    'pb.id',
                    'u.email',
                     DB::raw('CONCAT("€ ", pb.paid_amount) as paid_amount'),
                     DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
                     DB::raw("DATE_FORMAT(pb.arrival_time, '%d-%m-%Y') as at"), 
                     DB::raw("DATE_FORMAT(pb.departure_time, '%d-%m-%Y') as dt"), 
                     DB::raw("DATE_FORMAT(pb.created_at, '%d-%m-%Y') as created_at"), 
                    'pd.property_title',
                     DB::raw("CONCAT(UCASE(LEFT(pb.payment_status, 1)), 
                             SUBSTRING(pb.payment_status, 2)) as status"),
                     'pb.owner_cancel_request',
                     'pb.admin_cancel_status',
                     'pb.cancel_comment',
                     'pb.departure_time'
                );

                /**
                 * join section
                 */
                $query->leftJoin('property_details as pd', 'pd.property_id','=','pb.property_id')
                      ->leftJoin('users as u', 'u.id', '=', 'pb.owner_id')
                      ->where('block_type', '!=', 'preblock')
                      ->where('payment_status', 'yes')
                      ->whereRaw('pb.departure_time >= CURDATE()')
                      ->where('owner_cancel_request', 'yes');

                /**
                 * default orderby
                 */
                //$query->orderBy('pe.created_at', 'desc');
                
                                
                /**
                 * Default where clasue
                 */

                /*if ($data['email']!=''){

                    $query->whereRaw(
                        "pe.email = '". $data['email'] ."'"
                    );
                }*/ 

                

                if ($data['property_title']!=''){

                    $query->whereRaw(
                        "pd.property_title = '". $data['property_title'] ."'"
                    );
                }

                if ($data['cancel_status']!=''){

                	if($data['cancel_status']=='request'){

                		$query->whereRaw(
                        		"pb.admin_cancel_status = ''"
	                    		)->whereRaw(
	                        	"pb.owner_cancel_request = ''"
	                    		);
                	}

                	if($data['cancel_status']=='in_progress'){
                		
                		$query->whereRaw(
                        		"pb.admin_cancel_status = ''"
	                    		)->whereRaw(
	                        	"pb.owner_cancel_request = 'yes'"
	                    		);		
                	}

                	if($data['cancel_status']=='completed'){
                		
                		$query->whereRaw(
                        		"pb.admin_cancel_status = 'yes'"
	                    		)->whereRaw(
	                        	"pb.owner_cancel_request = 'yes'"
	                    		);
                	}

                	if($data['cancel_status']=='rejected'){

                		$query->whereRaw(
                        		"pb.admin_cancel_status = 'no'"
	                    		)->whereRaw(
	                        	"pb.owner_cancel_request = 'yes'"
	                    		);
                		
                	}                    
                }      

                $bookingsCount = count($query->get());
                /**
                 * Order by
                 */
                
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
               //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $bookings = $query->get();
            } catch(\Exception $e) {
            	//print_r($e->getMessage());

                $bookings = [];
                $bookingsCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $bookingsCount;
            $response['recordsFiltered'] = $bookingsCount;

            $response['data'] = $bookings;
            
            return response()->json($response);
        }
    }

    public function getUserBookedPropertyDetails(Request $request){
        //Log::info(print_r('1111', true));
        $booking_id = $request['booking_id'];

        $property_details = DB::table('property_details as pd') 
                                ->leftJoin('booknow_property_details as bpd', 'bpd.property_id', '=', 'pd.property_id')
                                ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                                ->select(
                                     DB::raw("DATE_FORMAT(bpd.created_at, '%d-%m-%Y') as booking_date"),
                                    'bpd.payment_type',
                                    'pd.property_title',
                                    'pd.property_id',
                                    'pd.standard_rate_per_week as rate_per_week',
                                    'pd.standard_rate_per_day as rate_per_night',
                                    DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
                                    'u.email',
                                    'u.phone',
                                    'pd.minimum_stay',
                                    'pd.city',
                                    'pd.state',
                                    'pd.area_code',
                                    'pd.country'
                                )                                 
                               ->where('bpd.id', $booking_id)
                               ->first();
                               //Log::info(print_r($property_details, true));
        if($property_details){

            $response = array('success'=>1, 'message'=>'Property details found', 'data'=>$property_details);

            return response()->json($response);
        }else{

            $response = array('success'=>0, 'message'=>'No property details found');

            return response()->json($response);
        }
    }

    public function getSendCancelMailToHolidayMaker(Request $request)
    {

        $id = DB::table('cancel_mail_status')->insertGetId(
                        [
                            'subject'       => $request['send_email_subject'], 
                            'message'       => $request['send_email_message'],
                            'booking_id'    => $request['prop_booked_id'],
                            'created_at'    => date('Y-m-d h:i:s'),
                            'updated_at'    => date('Y-m-d h:i:s')        
                        ]
                );

        if($id){

            $booking_details = DB::table('booknow_property_details as bpd')               
                                ->select(
                                    DB::raw('CONCAT(bpd.first_name, " ", bpd.surname) AS name'),
	                                DB::raw("DATE_FORMAT(bpd.created_at, '%d/%m/%y') as created_at"),
	                                DB::raw("DATE_FORMAT(bpd.arrival_time, '%d-%m-%Y') as arrival_time"),
	                                DB::raw("DATE_FORMAT(bpd.departure_time, '%d-%m-%Y') as departure_time"),
	                                DB::raw('CONCAT("€ ", bpd.security_deposit) as security_deposit'),
	                                DB::raw('CONCAT("€ ", bpd.paid_amount) as total_paid_amount'),
	                                DB::raw('CONCAT("€ ", bpd.booking_amount) as booking_amount'),
	                                DB::raw('CONCAT("€ ", bpd.deal_discount) as deal_discount'),
	                                DB::raw('CONCAT("€ ", bpd.owner_security_deposit) as owner_security_deposit'),
	                                DB::raw('CONCAT("€ ", bpd.coupon) as coupon'),
	                                'bpd.message',
	                                'bpd.email',
	                                'bpd.phone',
	                                'bpd.guest_limit',
	                                'bpd.property_id',
	                                'bpd.id',
	                                'pd.property_title'
                                )
                               ->leftJoin('property_details as pd', 'pd.property_id', '=', 'bpd.property_id') 
                               ->where('bpd.id', $request['prop_booked_id'])
                               ->first();                                           

                                
            $template_data  = array(
                                'hsubject'=>$request['send_email_subject'],
                                'hmessage'=>$request['send_email_message'],
                                'hname'   =>$booking_details['name'],
                                'hemail'  =>$booking_details['email'],
                              );


            $send_mail      = $this->sendCancelStatusMailHolidayMaker($template_data, $booking_details);

            return $send_mail;

        }else{

            $response = array(
                        'success'=>0, 
                        'message'=>'Something went wrong, please try again'
                        );

            return response()->json($response);    
        }

    }

    public function sendCancelStatusMailHolidayMaker($template_data, $booking_details){


        $mail =  Mail::send('emails.property-booking-cancellation', ['template_data'=>$template_data, 'booking'=>$booking_details], function ($m) use ($template_data) {

                                $m->from($this->from_email, 'Direct Owners');

                                $m->to($template_data['hemail'])->subject($template_data['hsubject']);
                            });

        if($mail){

            $response = array('success'=>1, 'message'=>'Mail sent successfully');

            return response()->json($response);
        }else{

            $response = array('success'=>0, 'message'=>'Mail not sent successfully');

            return response()->json($response);
        }
    }   

    public function getUserPropertyBookingDetails(Request $request){

        $booking_id = $request['booking_id'];

        $check_read = DB::table('booknow_property_details')->select('booking_review_status')->where('id', $booking_id)->first();

        $check_mark = $check_read?$check_read['booking_review_status']:'';

        if($check_mark==1){
            
            $update = DB::table('booknow_property_details')->where('id', $booking_id)->update(array('booking_review_status'=>2));           
        }else{
            $update = 0;
        }

        $booking_details = DB::table('booknow_property_details as bpd')               
                            ->select(
                                DB::raw('CONCAT(bpd.first_name, " ", bpd.surname) AS name'),
                                DB::raw("DATE_FORMAT(bpd.created_at, '%d/%m/%y') as created_at"),
                                DB::raw("DATE_FORMAT(bpd.arrival_time, '%d-%m-%Y') as arrival_time"),
                                DB::raw("DATE_FORMAT(bpd.departure_time, '%d-%m-%Y') as departure_time"),
                                DB::raw('bpd.security_deposit as security_deposit'),
                                DB::raw('bpd.paid_amount as total_paid_amount'),
                                DB::raw('bpd.deal_discount as deal_discount'),
                                DB::raw('bpd.coupon as coupon'),
                                'bpd.message',
                                'bpd.selected_currency_symbol',
                                'bpd.email',
                                'bpd.phone',
                                'bpd.guest_limit',
                                'bpd.property_id',
                                'bpd.id',
                                'pd.property_title'
                            )
                           ->leftJoin('property_details as pd', 'pd.property_id', '=', 'bpd.property_id')
                           ->where('bpd.id', $booking_id)
                           ->first();

        if($booking_details){

            $response = array('success'=>1, 'reload'=>$update, 'message'=>'Booking details found', 'data'=>$booking_details);

            return response()->json($response);
        }else{

            $response = array('success'=>0, 'message'=>'No booking details found');

            return response()->json($response);
        }

    }
}
