<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use DB;

use Log;

use Config;
class PropertyOwnersController extends Controller
{   

    public function __construct(){
      
       $this->_s3_path               = Config::get('filesystems.s3_path');
    }

    public function owners(){

        $owners = DB::table('users as u')
                ->select('u.id',DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.email')
                ->get();

        $countries = DB::table('property_details as pd')
                ->select('pd.property_id', 'pd.country')
                ->groupBy('pd.country')
                ->get();
        if(isset($_GET['status']) && $_GET['status']=='active')
        {

            $status = 'active'; 
        }else if(isset($_GET['status']) && $_GET['status']=='inactive'){

            $status = 'inactive';   
        }else{

            $status = '';
        }
        

    	return view('super_admin.owners', compact('owners','countries', 'status'));
    }

    public function addOwner(Request $request){    	

    	return view('super_admin.add-owner');	    		
    }

    public function editOwner($id){
        $user_id = $id; 
        $_s3_path = $this->_s3_path;
        return view('super_admin.edit-owner', compact('user_id', '_s3_path'));      
    }

    /**
     * owners list in Json Format
     * @param  Request $request [description]
     * @return String           List of owners in Json Sting 
     */
    public function ownersList(Request $request)
    {
        $data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'id', 
                    'name',
                    'email',
                    'phone',                    
                    'id', 
                    'status'

                );

            try {    
                DB::enableQueryLog();

                /**
                 * Database query object selection
                 */
                $query = DB::table('users as u');

                /**
                 * field selection
                 */
                $query->select(
                    'u.id', 
                     DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 
                     'u.email', 
                     'u.phone',
                     (DB::raw('(SELECT count(pd.property_id) from property_details as pd where pd.user_id = u.id) as no_of_properties')),
                     'u.status'
                );
                //->orderBy('u.created_datetime', 'desc');
                //echo "<pre>"; print_r($query->toSql()); exit;
                                
                /**
                 * Default where clasue
                 */

                if ($data['owner_name']!=''){

                    $query->whereRaw(
                        "CONCAT(u.first_name, ' ', u.surname) = '". $data['owner_name'] ."'"
                    );
                }

                if ($data['email']!=''){

                    $query->whereRaw(
                        "u.email = '". $data['email'] ."'"
                    );
                }

                if ($data['owner_status']!=''){

                    $query->whereRaw(
                        "u.status = '". $data['owner_status'] ."'"
                    );
                }      

                $ownersCount = count($query->get());
                /**
                 * Order by
                 */

                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $owners = $query->get();
            } catch(\Exception $e) {
                $owners = [];
                $ownersCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $ownersCount;
            $response['recordsFiltered'] = $ownersCount;

            $response['data'] = $owners;

            return response()->json($response);
        }    
    }   

}
