<?php

namespace App\Http\Controllers\SuperAdmin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use App\Testimonials;

use DB;

class TestimonialsController extends Controller
{

	public function getDisplayAddTestimonialsPage(){

		$property = DB::table('property_details as pd')
    			->select('pd.property_id', 'pd.property_title', 'user_id')
    			->where('status', 'active')
    			->where('verified', 'yes')
    			->get();

		return view('super_admin.add-testimonial', compact('property'));
	}

	public function getDisplayTestimonialsPage(){

		return view('super_admin.testimonials');
	}

	public function getDisplayEditTestimonialsPage($id){
		
        $testimonial = DB::table('testimonials as t')
                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                ->select('t.*', 'pd.property_title',  DB::raw('DATE_FORMAT(t.created_at, "%d-%m-%Y") as testimonial_created_at'))
                ->where('t.id', $id)
                ->first();
                
    	$property = DB::table('property_details as pd')
    			->select('pd.property_id', 'pd.property_title', 'user_id')
    			->where('status', 'active')
    			->where('verified', 'yes')
    			->get();		
                //print_r($testimonial); die();
		return view('super_admin.edit-testimonial', compact('property', 'testimonial'));
	}
    

    public function getTestimonialsJsonList(Request $request){

    	$data = $request->all();

        //echo "<pre>"; print_r($data); exit;
        if (isset($data['draw'])) {

            $columnArray
                = array(
                                         
                    'id', 
                    'name',
                    'testimonial',
                    'property_title',
                    'status',
                    'admin_status',
                    'testimonial_created_at',
                    'priority',
                    'id',
                    'id'                                    
                 );

            try {    
                DB::enableQueryLog();
                
                /**
                 * Database query object selection
                 */
                $query = DB::table('testimonials as t')->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id');

                /**
                 * field selection
                 */
                $query->select(
                    't.id',
                    't.name',
                    't.testimonial',
                    't.priority',
                    'pd.property_title',
                    't.status',
                    (DB::raw("(CASE                         
                        WHEN t.status = 'publish' THEN 'Favourite'
                        WHEN t.status = '' THEN '-'              
                                    
                    END) status")),
                    DB::raw('DATE_FORMAT(t.created_at, "%d-%m-%Y") as testimonial_created_at'),
                    (DB::raw("(CASE                         
                        WHEN t.admin_status = 'active' THEN 'Published'
                        WHEN t.admin_status = '' and t.status = 'publish' THEN 'Not Approved by super admin'              
                                    
                    END) admin_status"))  
                ); 

                if ($data['testimonial_status']!=''){

                    if($data['testimonial_status']=='active') 
                    {
                       $status = 'active';
                    }else if($data['testimonial_status']=='not_by_admin'){
                       $status = '';
                       $query->whereRaw(

                        "t.status = 'publish'"
                       );
                    }else{
                       $status = '';
                       $query->whereRaw(

                        "t.status = ''"
                       );
                    }
                    $query->whereRaw(

                        "t.admin_status = '". $status ."'"
                    );
                }              

                $query->orderBy('t.created_at', 'desc');        

                $testimonialCount = count($query->get());
                /**
                 * Order by
                 */
                //echo "<pre>"; print_r($query->toSql()); exit;
                
                if (isset($data['order'])) {
                    $query->orderBy(
                        $columnArray[$data['order'][0]['column']],
                        $data['order'][0]['dir']
                    );
                }
                /**
                 * Apply limit
                 */
                if ($data['length'] != -1) {
                    $query->skip($data['start'])->take($data['length']);
                }
                  
                //echo "<pre>"; print_r($query->toSql()); exit;

                /**
                 * Get
                 */
                $testimonial = $query->get();
            } catch(\Exception $e) {//echo "<pre>"; print_r($query->toSql()); exit;
                $testimonial = [];
                $testimonialCount = 0;
            }    

            $response['draw'] = $data['draw'];
            $response['recordsTotal'] = $testimonialCount;
            $response['recordsFiltered'] = $testimonialCount;

            $response['data'] = $testimonial;

            return response()->json($response);
        }
    }
}
