<?php

namespace App\Http\Controllers\WebAccess;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use App\Http\Requests;

use App\Admin;

use Validator;

use Session;

use Redirect;

use DB;

use Hash;

class WebAccessController extends Controller
{
    public function stagingLogin(){

    	return view('web_access.staging-login');
    }

    public function stagingLoginCheck(Request $request){
    	
        // store all inputs in a variable
        $input = $request->all(); 

        //define the rules of validation
        $rules = array(
            'username' => 'required|email',
            'password' => 'required'
        );    

        // Passing input with defined rules through validator class
        $validation = Validator::make($input, $rules);
          //if validation fails
          if ($validation->fails())
          {
            //redirect back with validation errors
            return Redirect::route('web_access.staging-login')->withErrors($validation);
          }// if validation is passed
          else
          {

          	//print_r($request->all()); exit;

        	$login = $this->stagingAdminLoginCheck($request);            
            

        	if($login){ 

                return $login;  
                
            }else{

             $message = ['msg' => 'Username or password is incorrect. '  ];

             return Redirect::action('WebAccess\WebAccessController@stagingLogin')->withErrors($message);
             
            }

         }  	
    }

    public function stagingAdminLoginCheck($request){

    	$data = $this->getUserDetailsWithEmail($request['username']);
        
        if($data){ 
           //If admin is found
            if(Hash::check($request['password'], $data['password'])){
              
              $x = $this->updateUserToken($data['id']);              
            
              // Put admin into session
              $array= array('id' => $data['id'], 'name'=>$data['first_name'].' '.$data['surname'], 'email' => $data['username'] ,'token'=>$x, 'time' => $data['updated_at']);
              
              Session::push('staging_admin_logged_in', $array);
              
              //return to home with success message
                $input['successMsg'] = 'Your have successfuly Logged in.';
                
                if(Session::has('staging_admin_logged_in')){
                  return Redirect::route('prop.homepage')->withInput($input);
                }else{
                  return Redirect::route('staging.login');
                }
            }
           
      }
    }

    public function getUserDetailsWithEmail($username){

        $data = DB::table('admin')
                    ->select('*')
                    ->where('username', $username)
                    ->first();

        return $data;
    }

     public function updateUserToken($user_id) {

        $token  = str_random(40);
        $data   = DB::table('admin as u')
                    ->where('u.id', $user_id)
                    ->update(array(
                        'token' => $token,
                  ));
                    
        return $token;
    }
}
