<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Session\Store;
use Illuminate\Support\Facades\Route;
use Request;
use Session;
use App\Admin;
use Redirect;

class AdminMiddleware {

    protected $session;
    protected $timeout = 1200;

    public function __construct(Store $session){
        $this->session = $session;
    }
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
    // If route is other than login route or signup route
        if( Route::currentRouteName() != "admin.login" && Route::currentRouteName() != "admin.login-check" && Route::currentRouteName() != 'admin.logout' && Route::currentRouteName() != 'admin.view-cms-json-list')
            { 
                $input= Request::all();
                $session = Session::all();
                $token= (isset($session['admin_logged_in'][0]['id']) ? $session['admin_logged_in'][0]['id'] : ""); 

                // If user is set
                if(!empty($token))
                {
                    //If user is not found

                    if(! $user= Admin::where('id', $token )->first())
                    {
                        $message = [                            
                            'msg' => 'Token expired! Please login to continue!',
                            ];
                        return Redirect::action('SuperAdmin\AdminController@adminLogin')->withErrors($message);
                    }
                }

                // If user is not set
                else{
                    $message = ['msg' => 'Please Login first '  ];

                    return Redirect::action('SuperAdmin\AdminController@adminLogin')->withErrors($message);
                                            
                }

            }else if(Route::currentRouteName() == "admin.login"){
                
                $session = Session::all();

                $token= (isset($session['admin_logged_in'][0]['id']) ? $session['admin_logged_in'][0]['id'] : ""); 

                // If user is set
                if(!empty($token))
                {
                    return Redirect::action('SuperAdmin\IndexController@dashboard');
                }
            }

    return $next($request);

  }

}