<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Session\Store;
use Illuminate\Support\Facades\Route;
use Request;
use Session;
use App\Admin;
use Redirect;

class WebMiddleware {

    protected $session;
    protected $timeout = 1200;

    public function __construct(Store $session){
        $this->session = $session;
    }
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    { 
    // If route is other than login route or signup route
        if( Route::currentRouteName() != "staging.login" && Route::currentRouteName() != "staging.login-check")
            { 
                $input= Request::all();
                $session = Session::all();
                $token= (isset($session['staging_admin_logged_in'][0]['id']) ? $session['staging_admin_logged_in'][0]['id'] : ""); 

                // If user is set
                if(!empty($token))
                {
                    //If user is not found

                    if(! $user= Admin::where('id', $token )->first())
                    {
                        $message = [                            
                            'msg' => 'Token expired! Please login to continue!',
                            ];
                        return Redirect::action('WebAccess\WebAccessController@stagingLogin')->withErrors($message);
                    }
                }

                // If user is not set
                else{
                    
                    $message = ['msg' => 'Please Login first '  ];

                    return Redirect::action('WebAccess\WebAccessController@stagingLogin')->withErrors($message);
                                            
                }

            }else if(Route::currentRouteName() == "staging.login"){
                
                $session = Session::all();

                $token= (isset($session['staging_admin_logged_in'][0]['id']) ? $session['staging_admin_logged_in'][0]['id'] : ""); 

                // If user is set
                if(!empty($token))
                {
                    return Redirect::action('Properties\PropertiesController@getDisplayHomePage');
                }
            }

    return $next($request);

  }

}