<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the controller to call when that URI is requested.
|
*/

Route::get('send-testimonial-link', array('uses'=>'Api\Properties\PropertyDetailsController@getCheckHolidayMakerDepartureTime', 'as'=>'send-testimonial-link'));

//Route::group(['middleware' => 'web_token'], function () {

Route::post('staging-admin/login-check',array('uses'=>'WebAccess\WebAccessController@stagingLoginCheck', 'as'=>'staging.login-check'));

Route::get('staging-admin/login', array('uses'=>'WebAccess\WebAccessController@stagingLogin', 'as'=>'staging.login'));	

Route::get('/', 
	array(
		'uses'=>'Properties\PropertiesController@getDisplayHomePage', 
		'as'=>'prop.homepage'
	)
);

Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('cache:clear');
    return 'clear done';
});

Route::get('/config-cache', function() {
    $exitCode = Artisan::call('config:cache');
    return 'config done';
});
Route::any('paypal/{item}/{amount}', array('uses'=>'Properties\PayPalController@payPalTransaction', 'as'=>'prop.paypal'));

Route::any('paypal-owner-payment-response', array('uses'=>'Properties\PayPalController@getOwnerInvoicePaypalResponseBack', 'as'=>'paypal-owner-payment-response'));

Route::post('tmt-owner-payment-response', array('uses'=>'Properties\PayPalController@getTMTOwnerInvoiceResponseBack', 'as'=>'tmt-owner-payment-response'));

Route::any('book-property-paypal/{item}/{amount}/{prop_id}', array('uses'=>'Properties\PayPalController@payPalTransactionForBookingProperty', 'as'=>'prop.book-property-paypal'));

Route::get('paypal-response', array('uses'=>'Properties\PayPalController@getPaypalResponseBack', 'as'=>'paypal-response'));


Route::any('auth/facebook', 'Auth\SocialAuthController@facebook');

Route::any('auth/google', 'Auth\SocialAuthController@google');

Route::any('auth/linkedin', 'Auth\SocialAuthController@linkedin');

Route::any('email', array('uses'=>'Properties\PropertiesController@getDisplayEmail', 'as'=>'prop.email'));

Route::get('send-test-link', array('uses'=>'Api\Properties\PropertyDetailsController@testLink', 'as'=>'send-test-link'));


// Route for api's
Route::group(['prefix' => 'api/v1'], function () {
	
	Route::get('get-aws-link', array('uses'=>'Api\Properties\PropertyDetailsController@getAWSLink', 'as'=>'get-aws-link'));

	Route::post('scan-file-virus', array('uses'=>'Api\Properties\PropertyDetailsController@getScantheFileForVirus', 'as'=>'scan-file-virus'));
	Route::post('scan-multiple-files-virus', array('uses'=>'Api\Properties\PropertyDetailsController@getScanMultipleFilesForVirus', 'as'=>'scan-multiple-files-virus'));
	//currency rate route
	Route::any('get-currency-rate', array('uses'=>'Api\Properties\PropertyDetailsController@getCurrencyRate', 'as'=>'get-currency-rate'));
	// signup
	Route::any('signup', array('uses'=>'Api\Properties\UserController@userSignUp', 'as'=>'user.signup'));
	// login
	Route::any('signin', array('uses'=>'Api\Properties\UserController@userLogin', 'as'=>'user.login'));
	//Route for update user details
	Route::post('update-user', array('uses'=>'Api\Properties\UserController@getUpdateUserDetails', 'as'=>'updateUser'));
	//Route for delete user details
	Route::post('delete-user', array('uses'=>'Api\Properties\UserController@getDeleteUserDetails', 'as'=>'deleteUser'));
	//Route for reset password
	Route::post('change-password', array('uses'=>'Api\Properties\UserController@changePassword', 'as'=>'changePassword'));
	//Route for user details by id
	Route::post('user-details', array('uses'=>'Api\Properties\UserController@getUserDetailsById', 'as'=>'userDetails'));
	//dashboard
	Route::any('all-users', array('uses'=>'Api\Properties\UserController@getUsersList', 'as'=>'user.allUsers'));
	//latest properties api for home page
	Route::get('recent-properties-list/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getRecentPropertiesList', 'as'=>'recentProperties'));
	//Property Single Page Route
	Route::get('property-details/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getSinglePropertyDetailsById', 'as'=>'propertyDetails'));
	//Route for similar properties by owner
	Route::post('similar-properties', array('uses'=>'Api\Properties\PropertyDetailsController@getUserSimilarProperties', 'as'=>'similarProperties'));
	//Route for get search results
	Route::get('search-results', array('uses'=>'Api\Properties\PropertyDetailsController@getSearchPageResults', 'as'=>'searchResults'));
	//Rote for add property details
	Route::post('add-property', array('uses'=>'Api\Properties\PropertyDetailsController@addProperty', 'as'=>'addProperty'));
 
    Route::post("add-propery-step-one",array('uses'=>'Api\Properties\PropertyDetailsController@addPropertyStepOne', 'as'=>'addPropertyStepOne'));

	Route::post("add-propery-step-two",array('uses'=>'Api\Properties\PropertyDetailsController@addPropertyStepTwo', 'as'=>'addPropertyStepTwo'));

	Route::post("add-propery-step-three",array('uses'=>'Api\Properties\PropertyDetailsController@addPropertyStepThree', 'as'=>'addPropertyStepThree'));

	Route::post("add-propery-step-four",array('uses'=>'Api\Properties\PropertyDetailsController@addPropertyStepFour', 'as'=>'addPropertyStepFour'));

	Route::post("add-propery-step-five",array('uses'=>'Api\Properties\PropertyDetailsController@addPropertyStepFive', 'as'=>'addPropertyStepFive'));
 
	//Delete property details
	Route::post('delete-property', array('uses'=>'Api\Properties\PropertyDetailsController@deletePropertyDetails', 'as'=>'deleteProperty'));
	
	
	//Api for get all properties details
	Route::post('all-properties', array('uses'=>'Api\Properties\PropertyDetailsController@getAllPropertiesDetails', 'as'=>'allProperties'));
	//Api for get all active properties details
	Route::post('all-user-properties', array('uses'=>'Api\Properties\PropertyDetailsController@getUserPropertiesDashborad', 'as'=>'allProperties'));
	//Api for get all active properties details
	Route::post('update-tmt-token', array('uses'=>'Api\Properties\PropertyDetailsController@getUpdateAccessToken', 'as'=>'updateAccessToken'));	
	//Api for get max and min values from database
	Route::get('property-minmax-rates', array('uses'=>'Api\Properties\PropertyDetailsController@getMinMaxValues', 'as'=>'minMaxValues'));
	//Api for get all user properties enquiries
	Route::post('all-property-enquiries', array('uses'=>'Api\Properties\PropertyEnquiryController@getPropertyEnquiries', 'as'=>'userEnquiries'));

	//Api for get owner dashboard stats
	Route::post('onwer-dashboard-stats', array('uses'=>'Api\Properties\PropertyDetailsController@getOwnerDashboardStats', 'as'=>'ownerDashboardStats'));

	//Api to save property enquiry details
	Route::post('save-property-enquiry', array('uses'=>'Api\Properties\PropertyEnquiryController@savePropertyEnquiry', 'as'=>'propertyEnquiry'));

	//Api to save property enquiry details
	Route::post('convert-enquiry-as-booking', array('uses'=>'Api\Properties\PropertyBooknowController@convertEnquiryAsBooking', 'as'=>'convert-enquiry-as-booking'));

	//Api to delete property enquiry details
	Route::get('delete-property-enquiry/{id}', array('uses'=>'Api\Properties\PropertyEnquiryController@deletePropertyEnquiry', 'as'=>'deletePropertyEnquiry'));

	//Api to get countries list
	Route::get('all-countries', array('uses'=>'Api\Properties\PropertyDetailsController@getCountriesList', 'as'=>'allCountries'));
	//Api to get cities list by country
	Route::post('city-by-country', array('uses'=>'Api\Properties\PropertyDetailsController@getCitiesByCountry', 'as'=>'allCitiesCountry'));

	//Api to search record exists or not
	Route::post('search-record', array('uses'=>'Api\Properties\PropertyDetailsController@getRecordCount', 'as'=>'recordCount'));

	//Api to search record exists or not
	Route::get('search-cities-list', array('uses'=>'Api\Properties\PropertyDetailsController@getCitiesToSearch', 'as'=>'searchCities'));
	//Api to get all notifications for listing
	Route::get('notifications', array('uses'=>'Api\Properties\PropertyNotificationsController@getNotificationsList', 'as'=>'notifications'));

	//Api to get all user notifications for listing
	Route::get('user-notifications', array('uses'=>'Api\Properties\PropertyNotificationsController@getUserNotificationsList', 'as'=>'user-notifications'));
	//Api to get all user enquiries for listing
	Route::post('user-enquiries', array('uses'=>'Api\Properties\PropertyEnquiryController@getOwnerEnquiriesList', 'as'=>'user-enquiries'));

	//Property Single Page Route
	Route::get('all-single-property-details/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getAllSinglePropertyDetailsById', 'as'=>'allPropertyDetails'));
	//Delete property rate in edit property form Route
	Route::get('delete-property-rate', array('uses'=>'Api\Properties\PropertyDetailsController@deletePropertyRate', 'as'=>'deletePropertyRate'));
	//Delete property image in edit property form Route
	Route::get('delete-property-image', array('uses'=>'Api\Properties\PropertyDetailsController@deletePropertyImage', 'as'=>'deletePropertyImage'));
	//Save Preblock property details
	Route::post('save-preblock-property', array('uses'=>'Api\Properties\PropertyDetailsController@savePreblockProperty', 'as'=>'savePreblock'));

	//Get Preblock property details
	Route::get('all-preblock-properties/{action}/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getAllPreblockPropertyDetails', 'as'=>'getDetails'));

	//Get Owner Preblock property details
	Route::get('all-owner-preblock-properties/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getAllOwnerPreblockPropertyDetails', 'as'=>'getOwnerPreblockDetails'));

	//Get Owner Preblock property details by property id
	Route::get('all-owner-preblock-properties-by-id', array('uses'=>'Api\Properties\PropertyDetailsController@getAllOwnerPreblockPropertyDetailsById', 'as'=>'all-owner-preblock-properties-by-id'));

	//Get Preblock property blocked dates
	Route::get('blocked-dates/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getPreblockPropertyBlockedDates', 'as'=>'blockedDates'));

	//Get Property rates blocked dates
	Route::get('property-rate-blocked-dates/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getPropertyRateBlockedDates', 'as'=>'property-rate-blocked-dates'));

	//Get Property rates blocked dates
	Route::get('admin-property-rate-blocked-dates/{id}', array('uses'=>'Api\Properties\PropertyDetailsController@getAdminPropertyRateBlockedDates', 'as'=>'admin-property-rate-blocked-dates'));

	//Set user email verification status yes
	Route::get('email-verification/{status}/{id}', array('uses'=>'Api\Properties\UserController@updateUserEmailVerificationStatus', 'as'=>'emailVerification'));

	//Send OTP to user mobile api
	Route::get('mobile-verification/{mobile}/{id}', array('uses'=>'Api\Properties\UserController@sendUserOTP', 'as'=>'mobileVerification'));
	//Check user OTP
	Route::get('check-otp/{otp}/{id}', array('uses'=>'Api\Properties\UserController@checkUserOTP', 'as'=>'checkUserOTP'));
	//Api for get all properties details irrespective of status
	Route::get('all-properties-list', array('uses'=>'Api\Properties\PropertyDetailsController@getAllPropertiesDetailsList', 'as'=>'allPropertiesList'));
	//Api for get all enquiries irrespective of status
	Route::get('all-enquiries-list', array('uses'=>'Api\Properties\PropertyEnquiryController@getAllEnquiriesList', 'as'=>'allEnquiriesList'));

	//Api for get notification details by id
	Route::get('notification/{id}', array('uses'=>'Api\Properties\PropertyNotificationsController@getNotificationsById', 'as'=>'owner-notifications'));

	//Api for get enquiry details by id
	Route::get('enquiries/{id}', array('uses'=>'Api\Properties\PropertyEnquiryController@getEnquiriesById', 'as'=>'owner-enquiries'));
	//Api for getting similar properties based on location
	Route::get('property-similar-properties', array('uses'=>'Api\Properties\PropertyDetailsController@getSimilarPropertiesByLocation', 'as'=>'locationSimilarProperties'));

	//Api for getting owner pay details
	Route::get('invoices/{id}', array('uses'=>'Api\Properties\InvoicesController@getUserInvoiceDetails', 'as'=>'owner-invoices'));

	//Api for update owner pay details
	Route::get('invoice-renewal/{uid}/{invoidId}', array('uses'=>'Api\Properties\InvoicesController@updateOwnerRenewalData', 'as'=>'owner-pay-renewal'));

	//Api for getting owner renewal account status
	Route::get('invoice-renewal/{uid}', array('uses'=>'Api\Properties\InvoicesController@getOwnerRenewalStatus', 'as'=>'owner-renewal-status'));
	//Conatct us
	Route::post('save-contact-details', array('uses'=>'Api\Properties\ContactUsController@saveContactDetails', 'as'=>'contact'));

	//Save Property clicks
	Route::post('save-property-clicks', array('uses'=>'Api\Properties\PropertyDetailsController@savePropertyClicks', 'as'=>'save-property-clicks'));

	//Save Property clicks
	Route::post('save-last-property-clicks', array('uses'=>'Api\Properties\PropertyDetailsController@savePropertyEveryClick', 'as'=>'save-last-property-clicks'));

	
	//Save Testimonials
	Route::post('save-testimonials', array('uses'=>'Api\Properties\TestimonialsController@saveTestimonials', 'as'=>'save-testimonials'));

	//Update Testimonials
	Route::post('update-testimonial', array('uses'=>'Api\Properties\TestimonialsController@updateTestimonial', 'as'=>'update-testimonial'));

	//Delete Testimonial
	Route::get('delete-testimonial', array('uses'=>'Api\Properties\TestimonialsController@deleteTestimonial', 'as'=>'delete-testimonial'));	  

	//Get Testimonials  
	Route::get('testimonials-list', array('uses'=>'Api\Properties\TestimonialsController@getTestimonials', 'as'=>'testimonials-list'));

	//Get Owner Testimonials  
	Route::get('owner-testimonials-list', array('uses'=>'Api\Properties\TestimonialsController@getOwnerTestimonials', 'as'=>'owner-testimonials-list'));

	//Get Testimonial By Id
	Route::get('testimonial-by-id', array('uses'=>'Api\Properties\TestimonialsController@getTestimonialById', 'as'=>'testimonial-by-id'));

	//Get Testimonial By Id
	Route::get('testimonial-by-priority', array('uses'=>'Api\Properties\TestimonialsController@getTestimonialByProprity', 'as'=>'testimonial-by-priority'));

	//Get Benifit to display
	Route::get('benifits-to-display', array('uses'=>'Api\Properties\SignupBenifitsController@getBenifitsListToDisplay', 'as'=>'benifits-to-display'));

	//Api to save favourite property
	Route::post('save-favourite-property', array('uses'=>'Api\Properties\FavouritePropertyController@saveUserFavouriteProperty', 'as'=>'save-favourite-property'));

	//Api to delete favourite property
	Route::get('delete-favourite-property', array('uses'=>'Api\Properties\FavouritePropertyController@deleteUserFavouriteProperty', 'as'=>'save-favourite-property'));

	//Api to get user favourite properties
	Route::get('get-user-favourites', array('uses'=>'Api\Properties\FavouritePropertyController@getUserFavouritesByIp', 'as'=>'get-user-favourites'));

	//Api to save property booking details
	Route::post('save-property-booking', array('uses'=>'Api\Properties\PropertyBooknowController@savePropertyBooknow', 'as'=>'save-property-booking'));

	//Api to delete property booking details when payment not done
	Route::get('delete-property-booking', array('uses'=>'Api\Properties\PropertyBooknowController@deleteBookingById', 'as'=>'delete-property-booking'));

	//Api to update property booking status when payment done
	Route::get('update-booking-status', array('uses'=>'Api\Properties\PropertyBooknowController@updateBookingStatus', 'as'=>'update-booking-status'));	

	//Api to get owner property bookings
	Route::get('owner-property-bookings', array('uses'=>'Api\Properties\PropertyBooknowController@getOwnerPropertyBookings', 'as'=>'owner-property-bookings'));

	//Api to get owner property bookings
	Route::get('upcoming-cancel-property-bookings', array('uses'=>'Api\Properties\PropertyBooknowController@getUpcomingPropertiesToCancel', 'as'=>'upcoming-cancel-property-bookings'));	

	//Api to get check property availability
	Route::get('property-availability', array('uses'=>'Api\Properties\PropertyBooknowController@getCheckPropertyAvailability', 'as'=>'property-availability'));

	//Api to special rate property dates
	Route::get('check-special-property-rate-dates', array('uses'=>'Api\Properties\PropertyBooknowController@getCheckPropertySpecialRateDates', 'as'=>'check-special-property-rate-dates'));

	//Api to get owner property bookings dates to cancel
	Route::get('owner-property-bookings', array('uses'=>'Api\Properties\PropertyBooknowController@getOwnerPaidPropertyBookings', 'as'=>'owner-property-bookings'));

	//Api to request super admin to cancel the property booking
	Route::get('cancel-property-bookings-request', array('uses'=>'Api\Properties\PropertyBooknowController@getChangeBookingStatusFromOwner', 'as'=>'owner-property-bookings'));

	//Api to get deals
	Route::get('owner-deals-list', array('uses'=>'Api\Properties\DealsController@getOwnerDealsList', 'as'=>'owner-deals-list'));

	//Api to add deals
	Route::post('add-deals', array('uses'=>'Api\Properties\DealsController@addDeals', 'as'=>'add-deals'));

	//Api to booking payment
	Route::post('booking-payment', array('uses'=>'Api\Properties\PropertyBooknowController@saveBookingPaymentStatus', 'as'=>'booking-payment'));

	//Api to add deals
	Route::get('delete-deal', array('uses'=>'Api\Properties\DealsController@deleteDeal', 'as'=>'delete-deal'));

	//Api to get deal details by id
	Route::get('deals-by-id/{id}', array('uses'=>'Api\Properties\DealsController@getDealsById', 'as'=>'deals-by-id'));

	//Api to add deals
	Route::post('update-deals', array('uses'=>'Api\Properties\DealsController@updateDeals', 'as'=>'update-deals'));

	//Api to get deal properties
	Route::get('get-deal-properties', array('uses'=>'Api\Properties\DealsController@getDealProperties', 'as'=>'get-deal-properties'));	

	//Api to get more deal properties
	Route::get('get-property-deals', array('uses'=>'Api\Properties\DealsController@getPropertyOtherDeals', 'as'=>'get-property-deals'));	
	//Save Property clicks
	Route::post('save-property-deal-clicks', array('uses'=>'Api\Properties\DealsController@savePropertyDealClicks', 'as'=>'save-property-deal-clicks'));

	//filter deails
	Route::get('get-filetered-deals', array('uses'=>'Api\Properties\DealsController@getFilterDeals', 'as'=>'get-filetered-deals'));

	//get property countries list
	Route::get('get-countries-list', array('uses'=>'Api\Properties\DealsController@getPropertyCountriesList', 'as'=>'get-countries-list'));


	//get property cities by countries list
	Route::get('get-cities-by-country', array('uses'=>'Api\Properties\DealsController@getPropertyCitiesByCountriesList', 'as'=>'get-cities-by-country'));

	//get filter deal request
	Route::get('get-filter-deal-request', array('uses'=>'Api\Properties\DealsController@getFilterDealRequest', 'as'=>'get-filter-deal-request'));

	//
	Route::get('check-property-coupons', array('uses'=>'Api\Properties\DealsController@checkCouponsForProperty', 'as'=>'check-property-coupons'));

	Route::get('check-property-coupons-availability', array('uses'=>'Api\Properties\DealsController@checkCouponsForPropertyAvailability', 'as'=>'check-property-coupons-availability'));	

	Route::get('load-more-deals', array('uses'=>'Api\Properties\DealsController@getLoadMoreDeals', 'as'=>'load-more-deals'));

	Route::get('update-preblock-comment', array('uses'=>'Api\Properties\PropertyDetailsController@getUpdatePreblockComment', 'as'=>'update-preblock-comment'));

	Route::get('filter-deals', array('uses'=>'Api\Properties\DealsController@getOwnerFilterDeals', 'as'=>'filter-deals'));

	Route::get('property-booking-details', array('uses'=>'SuperAdmin\PropertyBookingController@getUserPropertyBookingDetails', 'as'=>'property-booking-details'));

	Route::get('booked-property-details', array('uses'=>'SuperAdmin\PropertyBookingController@getUserBookedPropertyDetails', 'as'=>'booked-property-details'));

	Route::get('property-deal-dates', array('uses'=>'Api\Properties\DealsController@getPropertyDealDates', 'as'=>'property-deal-dates'));

	Route::get('forgot-password-request', array('uses'=>'Api\Properties\UserController@getRequestForgotPassword', 'as'=>'forgot-password-request'));

	Route::post('reset-owner-password', array('uses'=>'Api\Properties\UserController@getResetOwnerPassword', 'as'=>'reset-owner-password'));

	Route::get('check-owner-subscription-period', array('uses'=>'Api\Properties\UserController@getCheckOwnerSubscriptionPeriod', 'as'=>'check-owner-subscription-period'));

	Route::get('test-cron', array('uses'=>'Api\Properties\UserController@getCheckTestCronJob', 'as'=>'test-cron'));

	Route::get('cproperty-country-list', array('uses'=>'Api\Properties\PropertyDetailsController@getOnLoadCPropertyCountriesList', 'as'=>'cproperty-country-list'));

	Route::get('property-city-by-country-list', array('uses'=>'Api\Properties\PropertyDetailsController@getPropertyCityByCountriesList', 'as'=>'property-city-by-country-list'));

	Route::get('property-country-by-city-list', array('uses'=>'Api\Properties\PropertyDetailsController@getPropertyCountriesByCityList', 'as'=>'property-country-by-city-list'));

	Route::get('property-all-city-by-country-list', array('uses'=>'Api\Properties\PropertyDetailsController@getPropertyAllCityByCountriesList', 'as'=>'property-all-city-by-country-list'));

	Route::get('check-deal-help-file', array('uses'=>'Api\Properties\DealsController@getCheckDealHelpPdf', 'as'=>'check-deal-help-file'));

	Route::get('view-email-enquiry-details', array('uses'=>'Api\Properties\PropertyEnquiryController@getEnquiryDetailsForEmailView', 'as'=>'view-email-enquiry-details'));

	Route::get('view-email-booking-details', array('uses'=>'Api\Properties\PropertyBooknowController@getBookingDetailsForEmailView', 'as'=>'view-email-booking-details'));

	// Route::get('send-testimonial-link', array('uses'=>'Api\Properties\PropertyDetailsController@getCheckHolidayMakerDepartureTime', 'as'=>'send-testimonial-link'));

	Route::get('property-details-by-id', array('uses'=>'Api\Properties\PropertyDetailsController@getReviewPropertyDetailsById', 'as'=>'property-details-by-id'));

	Route::get('owner-property-availability', array('uses'=>'Api\Properties\PropertyBooknowController@getCheckOwnerPropertyAvailability', 'as'=>'owner-property-availability'));

	//Route for get search results
	Route::get('he-search-results', array('uses'=>'SuperAdmin\HolidayEssentialsController@getSearchResults', 'as'=>'he-search-results'));	

	Route::get('count-he-clicks', array('uses'=>'SuperAdmin\HolidayEssentialsController@getSaveClicks', 'as'=>'count-he-clicks'));
});

//});

//Edit property details		
	Route::post('api/v1/edit-property', array('uses'=>'Api\Properties\PropertyDetailsController@editPropertyDetails', 'as'=>'editProperty'));

	Route::get('super-admin/register-json-list', array('uses'=>'SuperAdmin\CmsController@getRegisterPDFDetailsInJsonFormat', 'as'=>'admin.view-register-json-list'));

	Route::get('super-admin/deal-name', array('uses'=>'SuperAdmin\CmsController@getDealPDFDetailsInJsonFormat', 'as'=>'admin.deal-name'));
	
Route::group(['middleware' => 'access_token'], function () {	

	// he routes start
	Route::get('super-admin/add-holiday-essential', array('uses'=>'SuperAdmin\HolidayEssentialsController@addHolidayEssentialView', 'as'=>'add-holiday-essential'));

	Route::post('super-admin/add-holiday-essential', array('uses'=>'SuperAdmin\HolidayEssentialsController@addHolidayEssential', 'as'=>'add-holiday-essential'));

	Route::get('super-admin/list-holiday-essential', array('uses'=>'SuperAdmin\HolidayEssentialsController@getHolidayEssentialList', 'as'=>'list-holiday-essential'));

	Route::get('super-admin/holiday-essential-by-id', array('uses'=>'SuperAdmin\HolidayEssentialsController@getHEById', 'as'=>'holiday-essential-by-id'));	

	Route::get('super-admin/edit-holiday-essential/{id}', array('uses'=>'SuperAdmin\HolidayEssentialsController@editHolidayEssentialView', 'as'=>'edit-holiday-essential'));

	Route::post('super-admin/update-holiday-essential', array('uses'=>'SuperAdmin\HolidayEssentialsController@updateHolidayEssential', 'as'=>'update-holiday-essential'));

	Route::get('super-admin/delete-he', array('uses'=>'SuperAdmin\HolidayEssentialsController@deleteHE', 'as'=>'delete-he'));

	Route::get('super-admin/holiday-essential-list', array('uses'=>'SuperAdmin\HolidayEssentialsController@getDisplayHEList', 'as'=>'holiday-essential-list'));

	Route::get('super-admin/holiday-essential-json-list', array('uses'=>'SuperAdmin\HolidayEssentialsController@getDisplayHEJsonList', 'as'=>'holiday-essential-json-list'));
	// he routes end

	Route::post('super-admin/login-check',array('uses'=>'SuperAdmin\AdminController@adminLoginCheck', 'as'=>'admin.login-check'));

	Route::get('super-admin/logout', array('uses'=>'SuperAdmin\AdminController@adminLogout', 'as'=>'admin.logout'));

	Route::get('super-admin/login', array('uses'=>'SuperAdmin\AdminController@adminLogin', 'as'=>'admin.login'));

	Route::get('super-admin/dashboard', array('uses'=>'SuperAdmin\IndexController@dashboard', 'as'=>'admin.dashboard'));

	Route::get('super-admin/profile', array('uses'=>'SuperAdmin\AdminController@getAdminProfile', 'as'=>'admin.profile-page'));

	Route::post('super-admin/update-profile', array('uses'=>'SuperAdmin\AdminController@getUpdateAdminProfile', 'as'=>'admin.profile-update-page'));

	Route::get('super-admin/owners', array('uses'=>'SuperAdmin\PropertyOwnersController@owners', 'as'=>'admin.owners'));

	Route::get('super-admin/add-owner', array('uses'=>'SuperAdmin\PropertyOwnersController@addOwner', 'as'=>'admin.add-owner'));

	Route::get('super-admin/edit-owner/{id}', array('uses'=>'SuperAdmin\PropertyOwnersController@editOwner', 'as'=>'admin.edit-owner'));

	Route::post('super-admin/save-owner', array('uses'=>'SuperAdmin\PropertyOwnersController@saveOwnerDetails', 'as'=>'admin.save-owner'));	

	Route::get('super-admin/owners-list', array('uses'=>'SuperAdmin\PropertyOwnersController@ownersList', 'as'=>'admin.owners-list'));

	Route::get('super-admin/properties', array('uses'=>'SuperAdmin\PropertiesController@getPropertiesList', 'as'=>'admin.properties'));

	Route::get('super-admin/owner-properties', array('uses'=>'SuperAdmin\PropertiesController@getOwnerPropertiesList', 'as'=>'admin.owner-properties'));

	Route::get('super-admin/edit-property-details/{id}', array('uses'=>'SuperAdmin\PropertiesController@editPropertyDetails', 'as'=>'admin.edit-property-details'));

	Route::get('super-admin/property-list', array('uses'=>'SuperAdmin\PropertiesController@properties', 'as'=>'admin.property-list'));

	Route::get('super-admin/enquiries', 
		   array('uses'=>'SuperAdmin\EnquiriesController@getEnquiriesList', 'as'=>'admin.enquiries'));

	Route::get('super-admin/enquiries-list', 
		   array('uses'=>'SuperAdmin\EnquiriesController@getDisplayEnquiriesList', 'as'=>'admin.enquiries-list'));

	Route::get('super-admin/notifications', array('uses'=>'SuperAdmin\NotificationsController@getDisplaynotifications', 'as'=>'admin.notifications'));

	Route::get('super-admin/notifications-list', array('uses'=>'SuperAdmin\NotificationsController@getDisplayNotificationsList', 'as'=>'admin.notifications-list'));

	Route::get('super-admin/add-notification', array('uses'=>'SuperAdmin\NotificationsController@addNotification', 'as'=>'admin.add-notification'));

	Route::post('super-admin/save-notification', array('uses'=>'SuperAdmin\NotificationsController@saveNotification', 'as'=>'admin.save-notification'));

	Route::get('super-admin/notification/{action}/{id}', array('uses'=>'SuperAdmin\NotificationsController@getModifynotifications', 'as'=>'admin.modify-notification'));

	Route::post('super-admin/notification/updateData', array('uses'=>'SuperAdmin\NotificationsController@getupdateNotifications', 'as'=>'admin.update-notification'));

	Route::get('super-admin/cms', array('uses'=>'SuperAdmin\CmsController@getCmsList', 'as'=>'admin.cms-list'));

	Route::get('super-admin/cms-list', array('uses'=>'SuperAdmin\CmsController@getCmsJsonList', 'as'=>'admin.cms-json-list'));

	Route::get('super-admin/edit-cms/{id}', array('uses'=>'SuperAdmin\CmsController@getCMSDetailsById', 'as'=>'admin.edit-cms-list'));

	Route::get('super-admin/cms-json-list/{id}', array('uses'=>'SuperAdmin\CmsController@getCMSDetailsInJsonFormat', 'as'=>'admin.view-cms-json-list'));

	Route::get('super-admin/accounts-list', array('uses'=>'SuperAdmin\AccountController@getAccountJsonList', 'as'=>'admin.accounts-json-list'));

	Route::get('super-admin/user-accounts-list/{uid}', array('uses'=>'SuperAdmin\AccountController@getUserAccountJsonList', 'as'=>'admin.user-accounts-json-list'));

	Route::post('super-admin/cms/updateData', array('uses'=>'SuperAdmin\CmsController@getupdateCMS', 'as'=>'admin.update-cms'));

	Route::get('super-admin/accounts', array('uses'=>'SuperAdmin\AccountController@getAccountsList', 'as'=>'admin.accounts-list'));

	// How to Register Start
	Route::get('super-admin/how-to-register', array('uses'=>'SuperAdmin\CmsController@getDisplayHowtoRegisterPage', 'as'=>'admin.how-to-register'));

	Route::post('super-admin/save-register-pdf', array('uses'=>'SuperAdmin\CmsController@saveRegisterPdf', 'as'=>'admin.save-register-pdf'));
	// How to Register End

	// How to Add Deal Start
	Route::get('super-admin/how-to-add-deal', array('uses'=>'SuperAdmin\CmsController@getDisplayHowtoAddDealPage', 'as'=>'admin.how-to-add-deal'));

	Route::post('super-admin/save-add-deal', array('uses'=>'SuperAdmin\CmsController@saveAddDealPdf', 'as'=>'admin.save-add-deal'));
	// How to Add Deal End

	Route::get('super-admin/testimonials', array('uses'=>'SuperAdmin\TestimonialsController@getDisplayTestimonialsPage', 'as'=>'admin.testimonials'));

	Route::get('super-admin/add-testimonials', array('uses'=>'SuperAdmin\TestimonialsController@getDisplayAddTestimonialsPage', 'as'=>'admin.testimonials'));

	Route::get('super-admin/edit-testimonial/{id}', array('uses'=>'SuperAdmin\TestimonialsController@getDisplayEditTestimonialsPage', 'as'=>'admin.edit-testimonial'));

	Route::get('super-admin/testimonials-list', array('uses'=>'SuperAdmin\TestimonialsController@getTestimonialsJsonList', 'as'=>'admin.testimonials-list'));

	Route::get('super-admin/signup-benifits', array('uses'=>'SuperAdmin\SignupBenifitsController@getDisplayBenifitsPage', 'as'=>'admin.benifits-list'));

	Route::get('super-admin/add-benifits', array('uses'=>'SuperAdmin\SignupBenifitsController@getDisplayAddBenifitPage', 'as'=>'admin.add-benifits'));

	Route::post('super-admin/save-benifits', array('uses'=>'SuperAdmin\SignupBenifitsController@saveBenifits', 'as'=>'admin.save-benifits'));

	Route::get('super-admin/benifits-json-list', array('uses'=>'SuperAdmin\SignupBenifitsController@getBenifitsJsonList', 'as'=>'admin.benifits-json-list'));

	Route::get('super-admin/edit-benifits/{id}', array('uses'=>'SuperAdmin\SignupBenifitsController@getDisplayBenifitsEditPage', 'as'=>'admin.edit-benifits'));

	Route::post('super-admin/update-benifits', array('uses'=>'SuperAdmin\SignupBenifitsController@getUpdateBenifitsList', 'as'=>'admin.update-benifits-list'));

	Route::get('super-admin/delete-benifits', array('uses'=>'SuperAdmin\SignupBenifitsController@getDeleteBenifitsById', 'as'=>'admin.delete-benifits'));

	Route::get('super-admin/property-bookings', array('uses'=>'SuperAdmin\PropertyBookingController@displayPropertyBookingPage', 'as'=>'admin.proeprty-bookings'));

	Route::get('super-admin/property-bookings-json-list', array('uses'=>'SuperAdmin\PropertyBookingController@getDisplayPropertyBookingsJsonList', 'as'=>'admin.property-bookings-json-list'));

	Route::get('super-admin/cancel-bookings', array('uses'=>'SuperAdmin\PropertyBookingController@getDisplayCancelBookedPropertyPage', 'as'=>'admin.cancel-bookings'));	

	Route::get('super-admin/delete-bookings', array('uses'=>'SuperAdmin\PropertyBookingController@getCancelBookedProperty', 'as'=>'admin.delete-bookings'));

	Route::get('super-admin/cancel-property-bookings-json-list', array('uses'=>'SuperAdmin\PropertyBookingController@getDisplayRequestedCancelBookingsJsonList', 'as'=>'admin.cancel-property-bookings-json-list'));

	Route::get('super-admin/flash-sales', array('uses'=>'SuperAdmin\FlashSalesController@getDisplayFlashSales', 'as'=>'admin.flash-sales'));

	Route::get('super-admin/flash-sales-json-list', array('uses'=>'SuperAdmin\FlashSalesController@getDisplayFlashSalesJsonList', 'as'=>'admin.flash-sales-json-list'));

	Route::get('super-admin/flash-sales/{action}', array('uses'=>'SuperAdmin\FlashSalesController@getDisplayAddFlashSalePage', 'as'=>'admin.flash-sales-page'));

	Route::post('super-admin/save-flash-sales', array('uses'=>'SuperAdmin\FlashSalesController@getSaveFlashSaleDetails', 'as'=>'admin.save-flash-sales'));

	Route::get('super-admin/delete-flash-sale', array('uses'=>'SuperAdmin\FlashSalesController@getDeleteFlashSale', 'as'=>'admin.delete-flash-sale'));

	//Api to cities by country
	Route::get('super-admin/cities-by-country', array('uses'=>'SuperAdmin\FlashSalesController@getCitiesListByCountry', 'as'=>'cities-by-country'));

	Route::get('super-admin/send-cancel-mail-to-holidaymaker', array('uses'=>'SuperAdmin\PropertyBookingController@getSendCancelMailToHolidayMaker', 'as'=>'send-cancel-mail-to-holidaymaker'));

	Route::get('super-admin/property-countries', array('uses'=>'SuperAdmin\FlashSalesController@getPropertyCountries', 'as'=>'property-countries'));
 
 Route::post('super-admin/edit-property-details/scan-file-virus', array('uses'=>'Api\Properties\PropertyDetailsController@getScantheFileForVirus', 'as'=>'scan-file-virus'));
 
 Route::post('super-admin/edit-property-details/scan-multiple-files-virus', array('uses'=>'Api\Properties\PropertyDetailsController@getScanMultipleFilesForVirus', 'as'=>'scan-multiple-files-virus-super-admin'));

});
