<?php

namespace App;
use Intervention\Image\Facades\Image as Image;
use Illuminate\Support\Facades\Storage;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Input;

use App\PropertyGallery;

use App\PropertyDetails;

use App\PropertyAmenity;

use App\PropertyRate;

use App\Clamav;

use App\User;

use Response;

use Mail;
use Log;
use DB;

class PropertyDetails extends Model
{
    protected $table = 'property_details';

    public static function getRecentPropertiesList($id, $selected_currency, $page_title){

        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $id = isset($id)?$id:'';
        $propertiesSql = DB::table('property_details as pd')
                     ->select('pd.*', 'pg.image_name as image', 'pg.property_gallery_id as pg_id',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate')),
                        (DB::raw('(SELECT count(cpd.click_time) FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id=pd.property_id) last_one_day_record')),

                        (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                        (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                        (DB::raw('(SELECT ( CAST(sum(t.rating) AS UNSIGNED) / (count(t.rating)*5))* 100 FROM testimonials as t WHERE t.property_id=pd.property_id and t.status="publish" and t.admin_status="active") testimonial_rating')),


                        (DB::raw("(SELECT (CASE 
                            WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                CASE 
                                    WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                            WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                CASE
                                    WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                            WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                CASE
                                    WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                            ELSE
                                CASE
                                    WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                        END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                     )
                     ->leftJoin('property_gallery as pg', 'pg.property_id','=','pd.property_id')
                     ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                     ->orderBy('pd.created_at', 'desc')
                     ->groupBy('pd.property_id')
                     ->where("pd.verified", 'yes')
                     ->where('u.status', 'active')
                     ->where("pd.property_id", '!=', $id)
                     ->where("pd.status", 'active');        
        
        if($page_title=='home'){
            $rproperties = $propertiesSql->skip(0)->take(3)->get();
        }else{
            $rproperties = $propertiesSql->get();
        }
        

        if($selected_currency){

            $main_array = array();

            $currency_rate = $selected_currency=='EUR'?1:PropertyDetails::convertCurrency($selected_currency); 
            foreach ($rproperties as $key => $p) {

                $prop_rate = $p['standard_rate_per_week']?$p['standard_rate_per_week']:$p['min_week_rate'];
                $final_prop_rate = round(($prop_rate * $currency_rate));
                $data['property_id']    = $p['property_id'];
                $data['property_title'] = $p['property_title'];
                $data['property_image'] = $p['property_image'];
                $data['city']           = $p['city'];
                $data['space_type']     = $p['space_type'];
                $prop_rate              = $final_prop_rate;                
                $data['converted_amount']= $prop_rate;
                array_push($main_array, $data);
            }
        }

        if($selected_currency){

            $properties = $main_array;
        }else{

            $properties = $rproperties;
        }

        if($properties){             

            return $properties;

        }else{

            return '';
        }
        
    }

    public static function convertCurrency($ctype){

        $currency = strtoupper($ctype);        
        $req_url = 'https://api.exchangeratesapi.io/latest?base=EUR';
        $response_json = file_get_contents($req_url);

        // Continuing if we got a result
        if(false !== $response_json) {

          // Try/catch for json_decode operation
          try {

          // Decoding
          $response_object = json_decode($response_json);

          // YOUR APPLICATION CODE HERE, e.g.
          //$base_price = $amount; // Your price in USD
          //Log::info(print_r($base_price * $response_object->rates->$ctype.' resulter amount', true));
          $currency_price = $response_object->rates->$currency;
          
          return  $currency_price;
          }
          catch(Exception $e) {
              // Handle JSON parse error...
          }
        }
    } 

    public static function getSinglePropertyDetailsById($id, $deal_id, $currency_name, $currency_symbol){


        $result = array();

        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $currency_rate  = $currency_name=='EUR'?1:PropertyDetails::convertCurrency($currency_name);

        $property_rates     = DB::table('property_rate as pr')
                                ->select(
                                    'pr.*',
                                    DB::raw('DATE_FORMAT(pr.start_date, "%b %d, %Y") as sstart_date'),
                                    DB::raw('DATE_FORMAT(pr.end_date, "%b %d, %Y") as send_date')
                                )
                                ->where('pr.property_id', $id)
                                ->get();
                    
        $property_gallery   = DB::table('property_gallery as pg')
                                ->select('pg.*')
                                ->where('pg.property_id', $id)
                                ->get();

        $dealsQuery              = DB::table('deals as d')
                                ->select('d.*')
                                ->where('d.property_id', $id);
        if($deal_id){

            $dealsQuery->where('d.id', $deal_id);
                                
        }else{

            $dealsQuery->whereRaw('d.to_date >= CURDATE()');
        }                                
        
        $deals = $dealsQuery->get();

        if(count($deals)){

            $deal_click = 'yes';
        }else{
            $deal_click = 'no';
        }                                                               

        $spl_min_week_rate = DB::table('property_rate')->select(DB::raw('min(rate_per_week) as rate_per_week'))->where('property_id', $id)->groupBy(DB::raw('week(CURDATE())'))->first();

        $spl_min_rate = DB::table('property_rate')->select(DB::raw('min(rate_per_week) as rate_per_week'))->where('property_id', $id)->whereRaw('end_date >= CURDATE()')->first();

                
        $property_details_query = DB::table('property_details as pd')
                                ->select(
                                    'u.*',
                                    'pa.*',
                                    'pd.*',
                                    'pd.status as prop_status',
                                    'pd.address as property_address',
                                    'pd.description as property_description',
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id="'.$id.'" group by week(CURDATE())) week_rate')),
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id="'.$id.'" and pr.start_date >= CURDATE() ) min_week_rate')),
                                    DB::raw('DATE_FORMAT(u.created_datetime, "%d/%m/%Y") as user_created_datetime'), 
                                    (DB::raw('(SELECT count(cpd.click_time)+1 FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id='.$id.') last_one_day_record')),

                                    (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                                    (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                                    (DB::raw("(SELECT (CASE 
                                        WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                            CASE 
                                                WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                                        WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                                        WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                                        ELSE
                                            CASE
                                                WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                                    END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                                );
        $property_details_query->addSelect(DB::raw('"'.$currency_rate.'" as currency_rate'));
        $property_details = $property_details_query->leftJoin('property_amenity as pa', 'pa.property_id','=','pd.property_id')                               
                                ->leftJoin('users as u', 'u.id', '=','pd.user_id')
                                ->where('pd.property_id', $id)
                                ->where('u.status', 'active')                                
                                ->get(); 

        $property_array = PropertyDetails::calculatePropertyRates($property_details, $currency_rate);                              
                                
                                
        $prop_min_rate  = $property_details[0]['standard_rate_per_week'];
        
        //$srate_per_week = !empty($spl_min_week_rate)?round(($currency_rate*$spl_min_week_rate['rate_per_week']),2):!empty($spl_min_rate)?round(($currency_rate*$spl_min_rate['rate_per_week']),2):0;
        
        if($spl_min_week_rate['rate_per_week']){
            $srate_per_week = round(($currency_rate*$spl_min_week_rate['rate_per_week']),2);
        }else if($spl_min_rate['rate_per_week']){
            $srate_per_week = round(($currency_rate*$spl_min_rate['rate_per_week']),2);
        }else{
            $srate_per_week = 0;
        }
       
        $property_testimonials = DB::table('testimonials as t')
                                ->select(
                                    't.*', 
                                    DB::raw('DATE_FORMAT(t.created_at, "%d-%m-%Y") as tcreated_at'),
                                    'pd.property_title')
                                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                                ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                                ->where('u.status', 'active')
                                ->where('t.status', 'publish')
                                ->where('t.admin_status', 'active')
                                ->where('pd.property_id', $id)  
                                ->orderBy('t.created_at', 'desc')
                                ->offset(0)->limit(10)
                                ->get();
                                
        $latitude  = $property_details[0]['latitude'];
        $longitude = $property_details[0]['longitude'];                                
        $near_by               = DB::select("SELECT pd.*, ( 6371 * acos( cos( radians(" . $latitude . ") ) * cos( radians( pd.latitude ) ) * cos( radians( pd.longitude ) - radians(" . $longitude . ") ) + sin( radians(" . $latitude . ") ) * sin( radians( pd.latitude ) ) ) ) AS distance FROM property_details as pd left join users as u on u.id = pd.user_id where u.status='active' and pd.verified='yes' and pd.status='active' group by pd.property_id HAVING distance < 10");         

        $result['near_by']                  = $near_by;
        $result['property_details']         = $property_array;//$property_details;
        $result['property_rates']           = $property_rates;
        $result['property_gallery']         = $property_gallery;
        $result['property_testimonials']    = $property_testimonials;
        $result['deals']                    = $deals;
        $result['deal_click']               = $deal_click;
        $result['srate_per_week']           = $srate_per_week;

        return $result;     
    }


    public static function getSuperAdminSinglePropertyDetailsById($id, $deal_id){


        $result = array();

        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }
       

        $property_rates     = DB::table('property_rate as pr')
                                ->select(
                                    'pr.*',
                                    DB::raw('DATE_FORMAT(pr.start_date, "%b %d, %Y") as sstart_date'),
                                    DB::raw('DATE_FORMAT(pr.end_date, "%b %d, %Y") as send_date')
                                )
                                ->where('pr.property_id', $id)
                                ->get();
                    
        $property_gallery   = DB::table('property_gallery as pg')
                                ->select('pg.*')
                                ->where('pg.property_id', $id)
                                ->get();

        $dealsQuery              = DB::table('deals as d')
                                ->select('d.*')
                                ->where('d.property_id', $id);
        if($deal_id){

            $dealsQuery->where('d.id', $deal_id);
                                
        }else{

            $dealsQuery->whereRaw('d.to_date >= CURDATE()');
        }                                
        
        $deals = $dealsQuery->get();

        if(count($deals)){

            $deal_click = 'yes';
        }else{
            $deal_click = 'no';
        }                                                               

        $spl_min_week_rate = DB::table('property_rate')->select(DB::raw('min(rate_per_week) as rate_per_week'))->where('property_id', $id)->groupBy(DB::raw('week(CURDATE())'))->first();

        $spl_min_rate = DB::table('property_rate')->select(DB::raw('min(rate_per_week) as rate_per_week'))->where('property_id', $id)->whereRaw('end_date >= CURDATE()')->first();

                
        $property_details_query = DB::table('property_details as pd')
                                ->select(
                                    'u.*',
                                    'pa.*',
                                    'pd.*',
                                    'pd.status as prop_status',
                                    'pd.address as property_address',
                                    'pd.description as property_description',
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id="'.$id.'" group by week(CURDATE())) week_rate')),
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id="'.$id.'" and pr.start_date >= CURDATE() ) min_week_rate')),
                                    DB::raw('DATE_FORMAT(u.created_datetime, "%d/%m/%Y") as user_created_datetime'), 
                                    (DB::raw('(SELECT count(cpd.click_time)+1 FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id='.$id.') last_one_day_record')),

                                    (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                                    (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                                    (DB::raw("(SELECT (CASE 
                                        WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                            CASE 
                                                WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                                        WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                                        WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                            CASE
                                                WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                                        ELSE
                                            CASE
                                                WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                                    END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                                );

        $property_details = $property_details_query->leftJoin('property_amenity as pa', 'pa.property_id','=','pd.property_id')                               
                                ->leftJoin('users as u', 'u.id', '=','pd.user_id')
                                ->where('pd.property_id', $id)
                                ->where('u.status', 'active')                                
                                ->get(); 
        
        $property_testimonials = DB::table('testimonials as t')
                                ->select(
                                    't.*', 
                                    DB::raw('DATE_FORMAT(t.created_at, "%d-%m-%Y") as tcreated_at'),
                                    'pd.property_title')
                                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                                ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                                ->where('u.status', 'active')
                                ->where('t.status', 'publish')
                                ->where('t.admin_status', 'active')
                                ->where('pd.property_id', $id)  
                                ->orderBy('t.created_at', 'desc')
                                ->offset(0)->limit(10)
                                ->get();
                                
        $latitude  = $property_details[0]['latitude'];
        $longitude = $property_details[0]['longitude'];                                
        $near_by               = DB::select("SELECT pd.*, ( 6371 * acos( cos( radians(" . $latitude . ") ) * cos( radians( pd.latitude ) ) * cos( radians( pd.longitude ) - radians(" . $longitude . ") ) + sin( radians(" . $latitude . ") ) * sin( radians( pd.latitude ) ) ) ) AS distance FROM property_details as pd left join users as u on u.id = pd.user_id where u.status='active' and pd.verified='yes' and pd.status='active' group by pd.property_id HAVING distance < 5");         

        $result['near_by']                  = $near_by;
        $result['property_details']         = $property_details;
        $result['property_rates']           = $property_rates;
        $result['property_gallery']         = $property_gallery;
        $result['property_testimonials']    = $property_testimonials;
        $result['deals']                    = $deals;
        $result['deal_click']               = $deal_click;

        return $result;     
    }

    public static function calculatePropertyRates($property_details, $currency_rate){

        $property_array = array();                                
        if($property_details){

            foreach($property_details as $pd){

                $data['access_books']               = $pd['access_books'];
                $data['address']                    = $pd['address'];
                $data['air_conditioning']           = $pd['air_conditioning'];
                $data['area_code']                  = $pd['area_code'];
                $data['arrival_time']               = $pd['arrival_time'];
                $data['barbq_equipment']            = $pd['barbq_equipment'];
                $data['basic_currency']             = $pd['basic_currency'];
                $data['bathroom']                   = $pd['bathroom'];
                $data['beach_access']               = $pd['beach_access'];
                $data['bedroom']                    = $pd['bedroom'];
                $data['bedroom_type']               = $pd['bedroom_type'];
                $data['before_owner_inactive']      = $pd['before_owner_inactive'];
                $data['cable_tv']                   = $pd['cable_tv'];
                $data['car']                        = $pd['car'];
                $data['central_heating']            = $pd['central_heating'];
                $data['city']                       = $pd['city'];
                $data['close_to_public_transport']  = $pd['close_to_public_transport'];
                $data['coffee_maker']               = $pd['coffee_maker'];
                $data['commual_pool']               = $pd['commual_pool'];
                $data['communal_garden']            = $pd['communal_garden'];
                $data['communal_jacuzzi']           = $pd['communal_jacuzzi'];
                $data['conference_centre']          = $pd['conference_centre'];
                $data['cooking_facilities']         = $pd['cooking_facilities'];
                $data['cot_available']              = $pd['cot_available'];
                $data['country']                    = $pd['country'];
                $data['country_club']               = $pd['country_club'];
                $data['couples_preferred']          = $pd['couples_preferred'];
                $data['created_at']                 = $pd['created_at'];
                $data['created_datetime']           = $pd['created_datetime'];
                $data['currency_rate']              = $pd['currency_rate'];
                $data['departure_time']             = $pd['departure_time'];
                $data['description']                = $pd['description'];
                $data['dishwasher']                 = $pd['dishwasher'];
                $data['double_room']                = $pd['double_room'];
                $data['dvd_player']                 = $pd['dvd_player'];
                $data['electricity']                = $pd['electricity'];
                $data['email']                      = $pd['email'];
                $data['email_verification']         = $pd['email_verification'];
                $data['ensuite']                    = $pd['ensuite'];
                $data['european_appliances']        = $pd['european_appliances'];
                $data['expiry_date']                = $pd['expiry_date'];
                $data['facebook_url']               = $pd['facebook_url'];
                $data['favourite_id']               = $pd['favourite_id'];
                $data['favourite_property']         = $pd['favourite_property'];
                $data['fb_id']                      = $pd['fb_id'];
                $data['first_name']                 = $pd['first_name'];
                $data['floor_name']                 = $pd['floor_name'];
                $data['freezer']                    = $pd['freezer'];
                $data['fridge']                     = $pd['fridge'];
                $data['game_console']               = $pd['game_console'];
                $data['games_facilities']           = $pd['games_facilities'];
                $data['garage']                     = $pd['garage'];
                $data['gas']                        = $pd['gas'];
                $data['gated_community']            = $pd['gated_community'];
                $data['golf']                       = $pd['golf'];
                $data['google_id']                  = $pd['google_id'];
                $data['google_plus_url']            = $pd['google_plus_url'];
                $data['guest_limit']                = $pd['guest_limit'];
                $data['gymnasium']                  = $pd['gymnasium'];
                $data['hair_dryer']                 = $pd['hair_dryer'];
                $data['high_chair']                 = $pd['high_chair'];
                $data['horse_riding']               = $pd['horse_riding'];
                $data['house_no']                   = $pd['house_no'];
                $data['house_swap']                 = $pd['house_swap'];
                $data['id']                         = $pd['id'];
                $data['internet_access']            = $pd['internet_access'];
                $data['iron']                       = $pd['iron'];
                $data['landline']                   = $pd['landline'];
                $data['language']                   = $pd['language'];
                $data['last_one_day_record']        = $pd['last_one_day_record'];
                $data['latitude']                   = $pd['latitude'];
                $data['laundry_facilities']         = $pd['laundry_facilities'];
                $data['linkdin_url']                = $pd['linkdin_url'];
                $data['linkedin_id']                = $pd['linkedin_id'];
                $data['local_golf_course']          = $pd['local_golf_course'];
                $data['local_grocery_store']        = $pd['local_grocery_store'];
                $data['login_type']                 = $pd['login_type'];
                $data['longitude']                  = $pd['longitude'];
                $data['maid_service']               = $pd['maid_service'];
                $data['microwave']                  = $pd['microwave'];
                $data['min_week_rate']              = !empty($pd['min_week_rate'])?round(($currency_rate*$pd['min_week_rate']),2):'';
                $data['round_min_week_rate']        = !empty($pd['min_week_rate'])?round(($currency_rate*$pd['min_week_rate'])):'';
                $data['minimum_stay']               = $pd['minimum_stay'];
                $data['mobile_otp']                 = $pd['mobile_otp'];
                $data['mobility_impaired']          = $pd['mobility_impaired'];
                $data['music']                      = $pd['music'];
                $data['nickname']                   = $pd['nickname'];
                $data['other_room']                 = $pd['other_room'];
                $data['oven_hob']                   = $pd['oven_hob'];
                $data['parking']                    = $pd['parking'];
                $data['password']                   = $pd['password'];
                $data['payment_method_token']       = $pd['payment_method_token'];
                $data['paypal_email']               = $pd['paypal_email'];
                $data['pets_welcome']               = $pd['pets_welcome'];
                $data['phone']                      = $pd['phone'];
                $data['phone_verification']         = $pd['phone_verification'];
                $data['pinterest_url']              = $pd['pinterest_url'];
                $data['private_garden']             = $pd['private_garden'];
                $data['private_jacuzzi']            = $pd['private_jacuzzi'];
                $data['private_pool']               = $pd['private_pool'];
                $data['profile_pic']                = $pd['profile_pic'];
                $data['prop_status']                = $pd['prop_status'];
                $data['property_address']           = $pd['property_address'];
                $data['property_amenity_id']        = $pd['property_amenity_id'];
                $data['property_click_time']        = $pd['property_click_time'];
                $data['property_description']       = $pd['property_description'];
                $data['property_id']                = $pd['property_id'];
                $data['property_image']             = $pd['property_image'];
                $data['property_title']             = $pd['property_title'];
                $data['property_view_time']         = $pd['property_view_time'];
                $data['property_views']             = $pd['property_views'];
                $data['restaurant_cafe']            = $pd['restaurant_cafe'];
                $data['room']                       = $pd['room'];
                $data['safe']                       = $pd['safe'];
                $data['security_deposit_amount']    = !empty($pd['security_deposit_amount'])?round(($currency_rate*$pd['security_deposit_amount']),2):'';
                $data['self_introduction']          = $pd['self_introduction'];
                $data['single_room']                = $pd['single_room'];
                $data['skype_url']                  = $pd['skype_url'];
                $data['smoking_allowed']            = $pd['smoking_allowed'];
                $data['snapchat_url']               = $pd['snapchat_url'];
                $data['space_type']                 = $pd['space_type'];
                $data['sports_facilities']          = $pd['sports_facilities'];
                $data['standard_rate_per_day']      = !empty($pd['standard_rate_per_day'])?round(($currency_rate*$pd['standard_rate_per_day']),2):'';
                $data['standard_rate_per_week']     = !empty($pd['standard_rate_per_week'])?round(($currency_rate*$pd['standard_rate_per_week']),2):'';
                $data['round_standard_rate_per_day']      = !empty($pd['standard_rate_per_day'])?round(($currency_rate*$pd['standard_rate_per_day'])):'';
                $data['round_standard_rate_per_week']     = !empty($pd['standard_rate_per_week'])?round(($currency_rate*$pd['standard_rate_per_week'])):'';
                $data['state']                      = $pd['state'];
                $data['status']                     = $pd['status'];
                $data['street_name']                = $pd['street_name'];
                $data['surname']                    = $pd['surname'];
                $data['time_since']                 = $pd['time_since'];
                $data['title']                      = $pd['title'];
                $data['tmt_api_token']              = $pd['tmt_api_token'];
                $data['tmt_password']               = $pd['tmt_password'];
                $data['tmt_username']               = $pd['tmt_username'];
                $data['token']                      = $pd['token'];
                $data['town']                       = $pd['town'];
                $data['tv']                         = $pd['tv'];
                $data['twenty_four_hour_security']  = $pd['twenty_four_hour_security'];
                $data['twin_room']                  = $pd['twin_room'];
                $data['twitter_url']                = $pd['twitter_url'];
                $data['updated_at']                 = $pd['updated_at'];
                $data['user_created_datetime']      = $pd['user_created_datetime'];
                $data['user_id']                    = $pd['user_id'];
                $data['user_type']                  = $pd['user_type'];
                $data['verified']                   = $pd['verified'];
                $data['washing_machine']            = $pd['washing_machine'];
                $data['week_rate']                  = !empty($pd['week_rate'])?round(($currency_rate*$pd['week_rate']),2):'';
                array_push($property_array, $data);
            }

            return $property_array;
        }
    }

    public static function getUserSimilarProperties($request){
        
        $properties = DB::table('property_details as pd')
                     ->select('pd.*', 'pg.image_name as image', 'pg.property_gallery_id as pg_id')
                     ->leftJoin('property_gallery as pg', 'pg.property_id','=','pd.property_id')
                     ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                     ->orderBy('pd.created_at', 'desc')
                     ->where('u.id', $request['owner_id'])
                     ->where('pd.property_id', '!=', $request['property_id'])
                     ->where("pd.verified", 'yes')
                     ->where('u.status', 'active')
                     ->where("pd.status", 'active')
                     ->groupBy('pd.property_id')
                     ->get();
        if($properties){

            return Response::json(array('message'=>'success', 'property_details'=>$properties));

        }else{

            return Response::json(array('message'=>'error', 'property_details'=>'No properties found with this owner, Please try another'));
        }            
    }

    public static function getSimilarPropertiesByLocation($id, $latitude, $longitude, $currency_name, $currency_symbol){
        

        $properties = DB::select("SELECT pd.*, pg.image_name as image, pg.property_gallery_id as pg_id,  ( 6371 * acos( cos( radians(" . $latitude . ") ) * cos( radians( pd.latitude ) ) * cos( radians( pd.longitude ) - radians(" . $longitude . ") ) + sin( radians(" . $latitude . ") ) * sin( radians( pd.latitude ) ) ) ) AS distance, (SELECT CAST(( CAST(sum(t.rating) AS UNSIGNED) / (count(t.rating)*5))* 100 AS UNSIGNED) FROM testimonials as t WHERE t.property_id=pd.property_id and t.status='publish' and t.admin_status='active') testimonial_rating FROM property_details as pd left join property_gallery as pg on pg.property_id=pd.property_id left join users as u on u.id=pd.user_id where u.status='active' and pd.property_id!=".$id." and pd.verified='yes' and pd.status='active' group by pd.property_id HAVING distance < 5");    

        
        $properties_array = array();
        if($properties){

            foreach ($properties as $nb) {
                $currency_rate  = $currency_name=='EUR'?1:PropertyDetails::convertCurrency($currency_name);

                $data['property_id']            = $nb['property_id'];
                $data['property_image']         = $nb['property_image'];
                $data['property_title']         = $nb['property_title'];
                $data['city']                   = $nb['city'];
                $data['country']                = $nb['country'];
                $data['space_type']             = $nb['space_type'];
                $data['guest_limit']            = $nb['guest_limit'];
                $data['testimonial_rating']     = $nb['testimonial_rating'];
                $data['standard_rate_per_week'] = round(($currency_rate*$nb['standard_rate_per_week']));
                $data['distance']               = $nb['distance'];

                array_push($properties_array, $data);
            }
        }
                   
        if($properties_array){

            return Response::json(array('message'=>'success', 'property_details'=>$properties_array));

        }else{

            return Response::json(array('message'=>'error', 'property_details'=>'No properties found!'));
        }                      
    }

   public static function getUserSearchResults($request){

       // print_r($request->all());die();
        $ip_address = $_SERVER['REMOTE_ADDR']; 
        if($ip_address=='::1'){
            $ip = '127.0.0.1';
        }else{
            $ip = $ip_address;
        }

        $id = isset($id)?$id:'';

        $searchPropertiesQuery = DB::table('property_details as pd')
                                 ->select('pd.property_id as main_property_id','pd.property_id', 'pd.property_title','pd.standard_rate_per_week', 'pd.city','pd.country','pd.space_type', 'pd.guest_limit',   'pd.property_id as main_property_id','pd.latitude','pd.longitude','pd.property_image',
                                    'pg.image_name', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date',
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                                    (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate')),
                                    (DB::raw('(SELECT count(cpd.click_time)+1 FROM property_clicks as cpd  WHERE cpd.click_time >= CURDATE() - INTERVAL 1 DAY AND cpd.property_id=pd.property_id) last_one_day_record')),

                                    (DB::raw('(SELECT count(property_id) FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id, fp.ip_address) favourite_property')),

                                    (DB::raw('(SELECT id FROM user_favourite_properties as fp WHERE fp.property_id=pd.property_id and fp.ip_address="'.$ip.'" group by fp.property_id)favourite_id')),

                                    (DB::raw('(SELECT CAST(( CAST(sum(t.rating) AS UNSIGNED) / (count(t.rating)*5))* 100 AS UNSIGNED) FROM testimonials as t WHERE t.property_id=pd.property_id and t.status="publish" and t.admin_status="active") testimonial_rating')),
                                    'd.id as deal_id',
                                    'd.deal_type',                        
                                    'd.amount as deal_amount', 
                                    (DB::raw("(SELECT (CASE 
                                                WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) != 0 THEN 
                                                    CASE 
                                                        WHEN DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) > 1 THEN CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' days ago') ELSE CONCAT(DATEDIFF(UTC_TIMESTAMP, cpd.property_view_time) ,' day ago') END
                                                WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                                    CASE
                                                        WHEN HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hours ago') ELSE CONCAT(HOUR(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' hour ago') END
                                                WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) != 0 THEN 
                                                    CASE
                                                        WHEN MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minutes ago') ELSE CONCAT(MINUTE(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) ,' minute ago') END
                                                ELSE
                                                    CASE
                                                        WHEN SECOND(TIMEDIFF(UTC_TIMESTAMP, cpd.property_view_time)) > 1 THEN CONCAT(SECOND(TIMEDIFF(UTC_TIMESTAMP, pd.property_view_time)) ,' seconds ago') ELSE 'now' END
                                            END ) from property_details as cpd where cpd.property_id = pd.property_id) time_since"))
                                 )
                                 ->leftJoin('deals as d', 'd.property_id', '=', 'pd.property_id')
                                 ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                                 ->leftJoin('booknow_property_details as pbd', 'pbd.property_id', '=', 'pd.property_id')
                                 ->leftJoin('property_amenity as pa', 'pa.property_id', '=', 'pd.property_id')
                                 ->leftJoin('users as u', 'u.id', '=', 'pd.user_id');
                           
        //Log::info(print_r($request->all(), true));
        // if($request->has('country') && $request['country']!='undefined'){

        //     $searchPropertiesQuery->whereRaw("pd.country LIKE '%".$request['country']."%'"); 

        // }



        if($request->has('city')){

            $city = $request['city'];

            $explode = explode(',', $city);

            if(count($explode)>1){

                $searchPropertiesQuery->whereIn("pd.city", $explode); 
                $searchPropertiesQuery->orwhereIn("pd.country", $explode);               
            }else{

                $searchPropertiesQuery->whereraw("(pd.city like '%".$city."%'"); 
                $searchPropertiesQuery->orwhereraw("pd.country like '%".$city."%')");         
            }            

        }

        $min_price  = $request->has('min_price')?$request['min_price']:null;
        $max_price  = $request->has('max_price')?$request['max_price']:null;
       
        if(isset($min_price)){ 
            
                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week >= ".$min_price."");
            
        } 

        if(isset($min_price) && isset($max_price)){ 
            if($min_price<$max_price){    

                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week >= ".$min_price.""); 

                $searchPropertiesQuery->whereRaw("pd.standard_rate_per_week <= ".$max_price."");
            }
            
        } 


        $arrival_time       = $request->has('arrival_time')?$request['arrival_time']:null;
        $departure_time     = $request->has('departure_time')?$request['departure_time']:null;
        
        $preBlockPropQuery = DB::table('booknow_property_details as pbd')
                                     ->select('pbd.property_id', 'pbd.arrival_time', 'pbd.departure_time');                          
        $preBlockPropQuery->where('pbd.payment_status', 'yes');     

       $pre_prop_id = array();
        if(isset($arrival_time) && isset($departure_time)){           
                                 
            $preBlockPropQuery->whereRaw("date(pbd.arrival_time) <= '".$departure_time."'"); 
        }

        if(isset($arrival_time) && isset($departure_time)){           
                                 
            $preBlockPropQuery->whereRaw("date(pbd.departure_time)   >= '".$arrival_time."'");  
        }

        if(isset($arrival_time) && !isset($departure_time)){

            $preBlockPropQuery->whereRaw("date(pbd.arrival_time) <= '".$arrival_time."'");

            $preBlockPropQuery->whereRaw("date(pbd.departure_time)   >= '".$arrival_time."'");  
        }



            if($arrival_time || $departure_time){

                //$preBlockPropQuery->whereRaw("pbd.departure_time   <= '".$departure_time."'")
                $preblockProp = $preBlockPropQuery->get(); 
            }else{
                $preblockProp = array(); 
            }
            if(count($preblockProp)>0){
              foreach ($preblockProp as $pre) {
               $res = array();               
               $res = $pre['property_id'];   
               array_push($pre_prop_id, $res);
              }
            }
              // Log::info(print_r($preBlockPropQuery->toSql(), true));      
             //Log::info(print_r(array_unique($pre_prop_id), true));  
        if($request->has('space_type')){

            if($request['space_type']!='any'){
                $searchPropertiesQuery->whereRaw("pd.space_type LIKE '%".$request['space_type']."%'"); 
            }
        }

        if($request->has('guest_limit')){ //echo $request['guest_limit'];die();

            if($request['guest_limit']=='any'){
                $searchPropertiesQuery->whereRaw("pd.guest_limit >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.guest_limit = ". $request['guest_limit'] .""); 
            }
        }

        if($request->has('single_room')){
            
            if($request['single_room']=='any'){
                $searchPropertiesQuery->whereRaw("pd.single_room >= 1"); 
            }else{

                $searchPropertiesQuery->whereRaw("pd.single_room = ". $request['single_room'] .""); 
            }
            
        }

        if($request->has('double_room')){
            
            if($request['double_room']=='any'){
                $searchPropertiesQuery->whereRaw("pd.double_room >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.double_room = ". $request['double_room'] .""); 
            }
              
        }

        if($request->has('twin_room')){
            
            if($request['twin_room']=='any'){
                $searchPropertiesQuery->whereRaw("pd.twin_room >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.twin_room  = ".$request['twin_room']."");                        
            }
        }

        if($request->has('other_room')){
            
            if($request['other_room']=='any'){
                $searchPropertiesQuery->whereRaw("pd.other_room >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.other_room  = ".$request['other_room']."");                        
            }
        }

        if($request->has('minimum_stay')){
            if($request['minimum_stay']=='Any'){
                $searchPropertiesQuery->whereRaw("pd.minimum_stay >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.minimum_stay >= ". $request['minimum_stay'] .""); 
            }
        }

        
        if($request->has('bathroom')){
            if($request['bathroom']=='Any'){
                $searchPropertiesQuery->whereRaw("pd.bathroom >= 1"); 
            }else{
                $searchPropertiesQuery->whereRaw("pd.bathroom >= ". $request['bathroom'] .""); 
            }
        }

        if($request->has('tv')){

            $searchPropertiesQuery->whereRaw("pa.tv LIKE '%".$request['tv']."%'"); 
        }

        if($request->has('twenty_four_hour_security')){

            $searchPropertiesQuery->whereRaw("pa.twenty_four_hour_security LIKE '%".$request['twenty_four_hour_security']."%'"); 
        }

        if($request->has('air_conditioning')){

            $searchPropertiesQuery->whereRaw("pa.air_conditioning LIKE '%".$request['air_conditioning']."%'"); 
        }

        if($request->has('barbq_equipment')){

            $searchPropertiesQuery->whereRaw("pa.barbq_equipment LIKE '%".$request['barbq_equipment']."%'"); 
        }

        if($request->has('beach_access')){

            $searchPropertiesQuery->whereRaw("pa.beach_access LIKE '%".$request['beach_access']."%'"); 
        }

        if($request->has('access_books')){

            $searchPropertiesQuery->whereRaw("pa.access_books LIKE '%".$request['access_books']."%'"); 
        }

        if($request->has('cable_tv')){

            $searchPropertiesQuery->whereRaw("pa.cable_tv LIKE '%".$request['cable_tv']."%'"); 
        }

        if($request->has('car')){

            $searchPropertiesQuery->whereRaw("pa.car LIKE '%".$request['car']."%'"); 
        }

        if($request->has('central_heating')){

            $searchPropertiesQuery->whereRaw("pa.central_heating LIKE '%".$request['central_heating']."%'"); 
        }

        if($request->has('close_to_public_transport')){

            $searchPropertiesQuery->whereRaw("pa.close_to_public_transport LIKE '%".$request['close_to_public_transport']."%'"); 
        }

        if($request->has('coffee_maker')){

            $searchPropertiesQuery->whereRaw("pa.coffee_maker LIKE '%".$request['coffee_maker']."%'"); 
        }

        if($request->has('conference_centre')){

            $searchPropertiesQuery->whereRaw("pa.conference_centre LIKE '%".$request['conference_centre']."%'"); 
        }

        if($request->has('cooking_facilities')){

            $searchPropertiesQuery->whereRaw("pa.cooking_facilities LIKE '%".$request['cooking_facilities']."%'"); 
        }

        if($request->has('cot_available')){

            $searchPropertiesQuery->whereRaw("pa.cot_available LIKE '%".$request['cot_available']."%'"); 
        }

        if($request->has('country_club')){

            $searchPropertiesQuery->whereRaw("pa.country_club LIKE '%".$request['country_club']."%'"); 
        }
        if($request->has('dishwasher')){

            $searchPropertiesQuery->whereRaw("pa.dishwasher LIKE '%".$request['dishwasher']."%'"); 
        }
        if($request->has('dvd_player')){

            $searchPropertiesQuery->whereRaw("pa.dvd_player LIKE '%".$request['dvd_player']."%'"); 
        }
        if($request->has('electricity')){

            $searchPropertiesQuery->whereRaw("pa.electricity LIKE '%".$request['electricity']."%'"); 
        }
        if($request->has('ensuite')){

            $searchPropertiesQuery->whereRaw("pa.ensuite LIKE '%".$request['ensuite']."%'"); 
        }
        if($request->has('european_appliances')){

            $searchPropertiesQuery->whereRaw("pa.european_appliances LIKE '%".$request['european_appliances']."%'"); 
        }
        if($request->has('couples_preferred')){

            $searchPropertiesQuery->whereRaw("pa.couples_preferred LIKE '%".$request['couples_preferred']."%'"); 
        }
        if($request->has('game_console')){

            $searchPropertiesQuery->whereRaw("pa.game_console LIKE '%".$request['game_console']."%'"); 
        }
        if($request->has('garage')){

            $searchPropertiesQuery->whereRaw("pa.garage LIKE '%".$request['garage']."%'"); 
        }
        if($request->has('gas')){

            $searchPropertiesQuery->whereRaw("pa.gas LIKE '%".$request['gas']."%'"); 
        }
        if($request->has('gated_community')){

            $searchPropertiesQuery->whereRaw("pa.gated_community LIKE '%".$request['gated_community']."%'"); 
        }
        if($request->has('golf')){

            $searchPropertiesQuery->whereRaw("pa.golf LIKE '%".$request['golf']."%'"); 
        }
        if($request->has('gymnasium')){

            $searchPropertiesQuery->whereRaw("pa.gymnasium LIKE '%".$request['gymnasium']."%'"); 
        }
        if($request->has('high_chair')){

            $searchPropertiesQuery->whereRaw("pa.high_chair LIKE '%".$request['high_chair']."%'"); 
        }
        if($request->has('horse_riding')){

            $searchPropertiesQuery->whereRaw("pa.horse_riding LIKE '%".$request['horse_riding']."%'"); 
        }
        if($request->has('house_swap')){

            $searchPropertiesQuery->whereRaw("pa.house_swap LIKE '%".$request['house_swap']."%'"); 
        }
        if($request->has('internet_access')){

            $searchPropertiesQuery->whereRaw("pa.internet_access LIKE '%".$request['internet_access']."%'"); 
        }
        if($request->has('laundry_facilities')){

            $searchPropertiesQuery->whereRaw("pa.laundry_facilities LIKE '%".$request['laundry_facilities']."%'"); 
        }
        if($request->has('local_golf_course')){

            $searchPropertiesQuery->whereRaw("pa.local_golf_course LIKE '%".$request['local_golf_course']."%'"); 
        }
        if($request->has('local_grocery_store')){

            $searchPropertiesQuery->whereRaw("pa.local_grocery_store LIKE '%".$request['local_grocery_store']."%'"); 
        }
        if($request->has('tv')){

            $searchPropertiesQuery->whereRaw("pa.tv LIKE '%".$request['tv']."%'"); 
        }
        if($request->has('music')){

            $searchPropertiesQuery->whereRaw("pa.music LIKE '%".$request['music']."%'"); 
        }
        if($request->has('sports_facilities')){

            $searchPropertiesQuery->whereRaw("pa.sports_facilities LIKE '%".$request['sports_facilities']."%'"); 
        }
        if($request->has('games_facilities')){

            $searchPropertiesQuery->whereRaw("pa.games_facilities LIKE '%".$request['games_facilities']."%'"); 
        }
        if($request->has('microwave')){

            $searchPropertiesQuery->whereRaw("pa.microwave LIKE '%".$request['microwave']."%'"); 
        }
        if($request->has('oven_hob')){

            $searchPropertiesQuery->whereRaw("pa.oven_hob LIKE '%".$request['oven_hob']."%'"); 
        }
        if($request->has('fridge')){

            $searchPropertiesQuery->whereRaw("pa.fridge LIKE '%".$request['fridge']."%'"); 
        }
        if($request->has('freezer')){

            $searchPropertiesQuery->whereRaw("pa.freezer LIKE '%".$request['freezer']."%'"); 
        }
        if($request->has('washing_machine')){

            $searchPropertiesQuery->whereRaw("pa.washing_machine LIKE '%".$request['washing_machine']."%'"); 
        }
        if($request->has('parking')){

            $searchPropertiesQuery->whereRaw("pa.parking LIKE '%".$request['parking']."%'"); 
        }
        if($request->has('safe')){

            $searchPropertiesQuery->whereRaw("pa.safe LIKE '%".$request['safe']."%'"); 
        }
        if($request->has('hair_dryer')){

            $searchPropertiesQuery->whereRaw("pa.hair_dryer LIKE '%".$request['hair_dryer']."%'"); 
        }
        if($request->has('iron')){

            $searchPropertiesQuery->whereRaw("pa.iron LIKE '%".$request['iron']."%'"); 
        }
        if($request->has('restaurant_cafe')){

            $searchPropertiesQuery->whereRaw("pa.restaurant_cafe LIKE '%".$request['restaurant_cafe']."%'"); 
        }
        if($request->has('private_pool')){

            $searchPropertiesQuery->whereRaw("pa.private_pool LIKE '%".$request['private_pool']."%'"); 
        }
        if($request->has('commual_pool')){

            $searchPropertiesQuery->whereRaw("pa.commual_pool LIKE '%".$request['commual_pool']."%'"); 
        }
        if($request->has('private_jacuzzi')){

            $searchPropertiesQuery->whereRaw("pa.private_jacuzzi LIKE '%".$request['private_jacuzzi']."%'"); 
        }
        if($request->has('communal_jacuzzi')){

            $searchPropertiesQuery->whereRaw("pa.communal_jacuzzi LIKE '%".$request['communal_jacuzzi']."%'"); 
        }
        if($request->has('private_garden')){

            $searchPropertiesQuery->whereRaw("pa.private_garden LIKE '%".$request['private_garden']."%'"); 
        }
        if($request->has('communal_garden')){

            $searchPropertiesQuery->whereRaw("pa.communal_garden LIKE '%".$request['communal_garden']."%'"); 
        }
        if($request->has('maid_service')){

            $searchPropertiesQuery->whereRaw("pa.maid_service LIKE '%".$request['maid_service']."%'"); 
        }
        if($request->has('pets_welcome')){

            $searchPropertiesQuery->whereRaw("pa.pets_welcome LIKE '%".$request['pets_welcome']."%'"); 
        }
        if($request->has('smoking_allowed')){

            $searchPropertiesQuery->whereRaw("pa.smoking_allowed LIKE '%".$request['smoking_allowed']."%'"); 
        }
        if($request->has('mobility_impaired')){

            $searchPropertiesQuery->whereRaw("pa.mobility_impaired LIKE '%".$request['mobility_impaired']."%'"); 
        }   
            $searchPropertiesQuery->addSelect(DB::Raw('"'.$request['selected_currency'].'" as currency_name'));
            $searchPropertiesQuery->addSelect(DB::Raw('"'.$request['selected_currency_symbol'].'" as currency_symbol'));
            //Log::info(print_r($pre_prop_id, true));
             $searchPropertiesQuery->where("pd.verified", 'yes');
             $searchPropertiesQuery->where("pd.status", 'active');
             $searchPropertiesQuery->where("u.status", 'active');
             $searchPropertiesQuery->whereNotIn("pd.property_id", array_unique($pre_prop_id));             
             $searchPropertiesQuery->groupBy('pd.property_id');
             $searchPropertiesQuery->orderBy('pd.created_at', 'desc');            
                

             if(isset($request['selected_currency']) && $request['selected_currency']){
                $prop_array     = array();
                $propDetails    = $searchPropertiesQuery->get();
                $currency       = strtoupper($request['selected_currency']); 
                $currency_rate  = $currency=='EUR'?1:PropertyDetails::convertCurrency($currency);

                
                foreach ($propDetails as $k => $prop) {
                    $prop_rate                  = $prop['standard_rate_per_week'];
                    $final_prop_rate            = round(($prop_rate * $currency_rate));
                    $compare_prop_rate          = intval(round(($prop_rate * $currency_rate), 2));
                    $data = array();                    
                    if($min_price && !$max_price && $compare_prop_rate>=$min_price){
                        $data['main_property_id']       = $prop['main_property_id'];
                        $data['property_id']            = $prop['property_id'];
                        $data['property_title']         = $prop['property_title'];
                        $data['standard_rate_per_week'] = $final_prop_rate;
                        $data['city']                   = $prop['city'];
                        $data['country']                = $prop['country'];
                        $data['space_type']             = $prop['space_type'];
                        $data['guest_limit']            = $prop['guest_limit'];
                        $data['latitude']               = $prop['latitude'];
                        $data['longitude']              = $prop['longitude'];
                        $data['property_image']         = $prop['property_image'];
                        $data['image_name']             = $prop['image_name'];
                        $data['start_date']             = $prop['start_date'];
                        $data['end_date']               = $prop['end_date'];
                        $data['week_rate']              = $prop['week_rate'];
                        $data['min_week_rate']          = $prop['min_week_rate'];
                        $data['last_one_day_record']    = $prop['last_one_day_record'];
                        $data['favourite_property']     = $prop['favourite_property'];
                        $data['favourite_id']           = $prop['favourite_id'];
                        $data['testimonial_rating']     = $prop['testimonial_rating'];
                        $data['deal_id']                = $prop['deal_id'];
                        $data['deal_type']              = $prop['deal_type'];
                        $data['deal_amount']            = $prop['deal_amount'];
                        $data['time_since']             = $prop['time_since'];
                        $data['currency_symbol']        = $prop['currency_symbol'];
                        $data['currency_name']          = $prop['currency_name'];
                        
                    } 

                    if($compare_prop_rate>=$min_price  && $compare_prop_rate<=$max_price){
                        $data['main_property_id']       = $prop['main_property_id'];
                        $data['property_id']            = $prop['property_id'];
                        $data['property_title']         = $prop['property_title'];
                        $data['standard_rate_per_week'] = $final_prop_rate;
                        $data['city']                   = $prop['city'];
                        $data['country']                = $prop['country'];
                        $data['space_type']             = $prop['space_type'];
                        $data['guest_limit']            = $prop['guest_limit'];
                        $data['latitude']               = $prop['latitude'];
                        $data['longitude']              = $prop['longitude'];
                        $data['property_image']         = $prop['property_image'];
                        $data['image_name']             = $prop['image_name'];
                        $data['start_date']             = $prop['start_date'];
                        $data['end_date']               = $prop['end_date'];
                        $data['week_rate']              = $prop['week_rate'];
                        $data['min_week_rate']          = $prop['min_week_rate'];
                        $data['last_one_day_record']    = $prop['last_one_day_record'];
                        $data['favourite_property']     = $prop['favourite_property'];
                        $data['favourite_id']           = $prop['favourite_id'];
                        $data['testimonial_rating']     = $prop['testimonial_rating'];
                        $data['deal_id']                = $prop['deal_id'];
                        $data['deal_type']              = $prop['deal_type'];
                        $data['deal_amount']            = $prop['deal_amount'];
                        $data['time_since']             = $prop['time_since'];
                        $data['currency_symbol']        = $prop['currency_symbol'];
                        $data['currency_name']          = $prop['currency_name'];
                    } 

                    if(!$min_price && $max_price && $compare_prop_rate<=$max_price){ 
                        $data['main_property_id']       = $prop['main_property_id'];
                        $data['property_id']            = $prop['property_id'];
                        $data['property_title']         = $prop['property_title'];
                        $data['standard_rate_per_week'] = $final_prop_rate;
                        $data['city']                   = $prop['city'];
                        $data['country']                = $prop['country'];
                        $data['space_type']             = $prop['space_type'];
                        $data['guest_limit']            = $prop['guest_limit'];
                        $data['latitude']               = $prop['latitude'];
                        $data['longitude']              = $prop['longitude'];
                        $data['property_image']         = $prop['property_image'];
                        $data['image_name']             = $prop['image_name'];
                        $data['start_date']             = $prop['start_date'];
                        $data['end_date']               = $prop['end_date'];
                        $data['week_rate']              = $prop['week_rate'];
                        $data['min_week_rate']          = $prop['min_week_rate'];
                        $data['last_one_day_record']    = $prop['last_one_day_record'];
                        $data['favourite_property']     = $prop['favourite_property'];
                        $data['favourite_id']           = $prop['favourite_id'];
                        $data['testimonial_rating']     = $prop['testimonial_rating'];
                        $data['deal_id']                = $prop['deal_id'];
                        $data['deal_type']              = $prop['deal_type'];
                        $data['deal_amount']            = $prop['deal_amount'];
                        $data['time_since']             = $prop['time_since'];
                        $data['currency_symbol']        = $prop['currency_symbol'];
                        $data['currency_name']          = $prop['currency_name'];
                        
                    }
                    
                    if(!$min_price && !$max_price){ 
                        $data['main_property_id']       = $prop['main_property_id'];
                        $data['property_id']            = $prop['property_id'];
                        $data['property_title']         = $prop['property_title'];
                        $data['standard_rate_per_week'] = $final_prop_rate;
                        $data['city']                   = $prop['city'];
                        $data['country']                = $prop['country'];
                        $data['space_type']             = $prop['space_type'];
                        $data['guest_limit']            = $prop['guest_limit'];
                        $data['latitude']               = $prop['latitude'];
                        $data['longitude']              = $prop['longitude'];
                        $data['property_image']         = $prop['property_image'];
                        $data['image_name']             = $prop['image_name'];
                        $data['start_date']             = $prop['start_date'];
                        $data['end_date']               = $prop['end_date'];
                        $data['week_rate']              = $prop['week_rate'];
                        $data['min_week_rate']          = $prop['min_week_rate'];
                        $data['last_one_day_record']    = $prop['last_one_day_record'];
                        $data['favourite_property']     = $prop['favourite_property'];
                        $data['favourite_id']           = $prop['favourite_id'];
                        $data['testimonial_rating']     = $prop['testimonial_rating'];
                        $data['deal_id']                = $prop['deal_id'];
                        $data['deal_type']              = $prop['deal_type'];
                        $data['deal_amount']            = $prop['deal_amount'];
                        $data['time_since']             = $prop['time_since'];
                        $data['currency_symbol']        = $prop['currency_symbol'];
                        $data['currency_name']          = $prop['currency_name'];
                        
                    }
                    if($data){

                        array_push($prop_array, $data);    
                    }   
                    
                }

                $rdata['prop'] =  $prop_array;
             }else{


                $rdata['prop'] = $searchPropertiesQuery->get();
             }
              
            
             if($rdata){            

                return $rdata;

             }else{

                return '';
             }  
              
         
        }

    public static function addPropertyDetails($request){

        $propertyObj = new PropertyDetails;

        //Log::info(print_r($request->all(), true));
        if($request->has('address')){
            $address = isset($request['address'])?$request['address']:'';
            $propertyObj->address = $address;
        }
        if($request->has('user_id')){
            $user_id = isset($request['user_id'])?$request['user_id']:'';
            $propertyObj->user_id = $user_id;
        }
        if($request->has('latitude')){

            $latitude = isset($request['latitude'])?$request['latitude']:'';
            $propertyObj->latitude = $latitude;
        }
        if($request->has('longitude')){

            $longitude = isset($request['longitude'])?$request['longitude']:'';
            $propertyObj->longitude = $longitude;
        }
        if($request->has('house_no')){

            $house_no = isset($request['house_no'])?$request['house_no']:'';
            $propertyObj->house_no = $house_no;
        }
        if($request->has('security_deposit_amount')){

            $security_deposit_amount = isset($request['security_deposit_amount'])?$request['security_deposit_amount']:'';
            $propertyObj->security_deposit_amount = $security_deposit_amount;
        }
        if($request->has('floor_name')){

            $floor_name = isset($request['floor_name'])?$request['floor_name']:'';
            $propertyObj->floor_name = $floor_name;
        }
        if($request->has('street_name')){

            $street_name = isset($request['street_name'])?$request['street_name']:'';
            $propertyObj->street_name = $street_name;
        }
        if($request->has('town')){

            $town = isset($request['town'])?$request['town']:'';
            $propertyObj->town = $town;
        }
        if($request->has('city')){

            $city = isset($request['city'])?$request['city']:'';
            $propertyObj->city = $city;
        }
        if($request->has('area_code')){

            $area_code = isset($request['area_code'])?$request['area_code']:'';
            $propertyObj->area_code = $area_code;
        }
        if($request->has('state')){

            $state = isset($request['state'])?$request['state']:'';
            $propertyObj->state = $state;
        }
        if($request->has('country')){
            $country = isset($request['country'])?$request['country']:'';
            $propertyObj->country = $country;
        }
        if($request->has('property_title')){

            $property_title = isset($request['property_title'])?$request['property_title']
            :'';
            $propertyObj->property_title = $property_title;
        }
        if($request->has('description')){

            $description = isset($request['description'])?$request['description']:'';
            $propertyObj->description = $description;
        }

        if($request->has('space_type')){
            $space_type = isset($request['space_type'])?$request['space_type']:'';
            $propertyObj->space_type = $space_type;
        }
        if($request->has('guest_limit')){

            $guest_limit = isset($request['guest_limit'])?$request['guest_limit']:'';
            $propertyObj->guest_limit = $guest_limit;
        }
        if($request->has('single_room')){

            $single_room = isset($request['single_room'])?$request['single_room']:'';
            $propertyObj->single_room = $single_room;
        }
        if($request->has('double_room')){
            $double_room = isset($request['double_room'])?$request['double_room']:'';
            $propertyObj->double_room = $double_room;
        }
        if($request->has('twin_room')){
            $twin_room = isset($request['twin_room'])?$request['twin_room']:'';
            $propertyObj->twin_room = $twin_room;
        }
        if($request->has('other_room')){
            $other_room = isset($request['other_room'])?$request['other_room']:'';
            $propertyObj->other_room = $other_room;
        }
        if($request->has('bathroom')){

            $bathroom = isset($request['bathroom'])?$request['bathroom']:'';
            $propertyObj->bathroom = $bathroom;
        }   
        if($request->has('standard_rate_per_day')){

            $standard_rate_per_day = isset($request['standard_rate_per_day'])?$request['standard_rate_per_day']:'';
            $propertyObj->standard_rate_per_day = $standard_rate_per_day;
        }
        if($request->has('standard_rate_per_week')){

            $standard_rate_per_week = isset($request['standard_rate_per_week'])?$request['standard_rate_per_week']:'';
            $propertyObj->standard_rate_per_week = $standard_rate_per_week;
        }
        if($request->has('minimum_stay')){

            $minimum_stay = isset($request['minimum_stay'])?$request['minimum_stay']:'';
            $propertyObj->minimum_stay = $minimum_stay;
        }    
        if($request->has('verified')){

            $verified = isset($request['verified'])?$request['verified']:'';
            $propertyObj->verified = $verified;
        }        
            

        if($request->has('status')){

            $status = isset($request['status'])?$request['status']:'';
            $propertyObj->status = $status;
        }
            $propertyObj->created_at  = date('Y-m-d H:i:s');
            $propertyObj->updated_at  = date('Y-m-d H:i:s');
            $propertyObj->property_view_time = date('Y-m-d H:i:s');
            $propertyObj->save();

        $propId = $propertyObj->id;

        if($request->hasfile('main_image_name')){

            $files           = $request->file('main_image_name');   
            $local_directory = public_path().'/uploads/property_images/'.$propId.'/'; 
            $directory       = 'uploads/property_images/'.$propId;
            if (!file_exists($local_directory)) {
                mkdir($local_directory, 0777, true);
            }


           $filename        = 'main_image.'.$files->getClientOriginalExtension(); 
           $local_img       = $files->move($local_directory,$filename);

           $image           = Image::make($local_img);
           $resize_image    = $image->fit(640,427)->stream();
            //Move the uploaded file to temp directory
           $upload_success  = Storage::disk('s3')->put($directory.'/'.$filename, $resize_image->__toString(), 'public');
           
           if($upload_success){
            unlink($local_directory.'/'.$filename);
           }
           

            $gallery = DB::table('property_details')
                      ->where('property_id', $propId)
                      ->update([
                        'property_image' => $filename,
                     ]);         
                
        }

        //$prop_click = DB::table('property_clicks')->insert(array('property_id'=>$propId, 'click_time'=>date('Y-m-d H:i:s')));
        if($request->hasfile('image_name')){ 
            $images= PropertyGallery::savePropertyImages($request, $propId);
        }

        if($request->has('amenities')){

            $amenities = PropertyAmenity::savePropertyAmenities($request, $propId);
        }

        if($request->has('prop_rates')){
           
            $price = PropertyRate::savePropertyRates($request, $propId);

        } 
       // print_r($propertyObj);die();
        if($propertyObj){

            return Response::json(array('success'=>1, 'message'=>'Property added successfully', 'property_details'=>$propertyObj));
        }else{

            return Response::json(array('success'=>0, 'message'=>'Property not added successfully, Please try again'));
        }
       
    }

    /*public static function deletePropertyDetails($request){

       $propId      = isset($request['property_id'])?$request['property_id']:'';

       $property    = DB::table('property_details')->where('property_id', $propId)->delete();

        if($property){

            return Response::json(array('success'=>'1', 'message'=>'Property details deleted successfully!'));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Property details not deleted successfully!'));
        }
             
    }*/ 
    public static function compressImage($source, $destination, $quality) {

        $info = getimagesize($source);

        if ($info['mime'] == 'image/jpeg') 
            $image = imagecreatefromjpeg($source);

        elseif ($info['mime'] == 'image/gif') 
            $image = imagecreatefromgif($source);

        elseif ($info['mime'] == 'image/png') 
            $image = imagecreatefrompng($source);

        imagejpeg($image, $destination, $quality);

        return $destination;
    }

    public static function editPropertyDetails($request){
        Log::info(print_r($request->all(), true));
        //echo "<pre>";
        //print_r($request->all());exit;
        $result = array();
       
        if(isset($request['property_id']) && isset($request['property_id'])){

            $eproperty      = PropertyDetails::getExistingPropertyDetails($request['property_id']);
           
            $address        = isset($request['address'])?$request['address']:$eproperty['address'];           
            $user_id        = isset($request['user_id'])?$request['user_id']:$eproperty['user_id'];  
            
            $user_mail_details = PropertyDetails::getUserDetailsById($user_id);
            $latitude       = isset($request['latitude'])?$request['latitude']:$eproperty['latitude'];            
            $longitude      = isset($request['longitude'])?$request['longitude']:$eproperty['longitude'];   
            $house_no       = isset($request['house_no'])?$request['house_no']:$eproperty['house_no'];
            $floor_name     = isset($request['floor_name'])?$request['floor_name']:$eproperty['floor_name'];
            $street_name    = isset($request['street_name'])?$request['street_name']:$eproperty['street_name'];
            $town           = isset($request['town'])?$request['town']:$eproperty['town'];
            $city           = isset($request['city'])?$request['city']:$eproperty['city'];        
            $area_code      = isset($request['area_code'])?$request['area_code']:$eproperty['area_code'];
            $state          = isset($request['state'])?$request['state']:$eproperty['state'];
            $country        = isset($request['country'])?$request['country']:$eproperty['country'];
            $property_title = isset($request['property_title'])?$request['property_title']
            :$eproperty['property_title'];
            $description    = isset($request['description'])?$request['description']:$eproperty['description'];
            $space_type     = isset($request['space_type'])?$request['space_type']:$eproperty['space_type'];
            $guest_limit    = isset($request['guest_limit'])?$request['guest_limit']:$eproperty['guest_limit'];
            $single_room                = isset($request['single_room'])?$request['single_room']:$eproperty['single_room'];
            $double_room                = isset($request['double_room'])?$request['double_room']:$eproperty['double_room'];
            $twin_room                  = isset($request['twin_room'])?$request['twin_room']:$eproperty['twin_room'];
            $other_room                 = isset($request['other_room'])?$request['other_room']:$eproperty['other_room'];   
            
            $bathroom       = isset($request['bathroom'])?$request['bathroom']:$eproperty['bathroom'];            
            $standard_rate_per_day      = isset($request['standard_rate_per_day'])?$request['standard_rate_per_day']:$eproperty['standard_rate_per_day'];
            $standard_rate_per_week     = isset($request['standard_rate_per_week'])?$request['standard_rate_per_week']:$eproperty['standard_rate_per_week'];
            $minimum_stay               = isset($request['minimum_stay'])?$request['minimum_stay']:$eproperty['minimum_stay'];
            $verified                   = isset($request['verified'])?$request['verified']:$eproperty['verified'];
            $status1                     = isset($request['status'])?$request['status']:$eproperty['status'];
            $security_deposit_amount    = isset($request['security_deposit_amount'])?$request['security_deposit_amount']:$eproperty['security_deposit_amount'];
                         
                    //Log::info(print_r($request->all(), true));
            if(isset($request['property_type_save']) && $request['property_type_save']=="save"){
                $status = '';
            }else if($request['property_type_save']=="publish"){
                if(empty($status1)){ $status = "inactive"; }else{ $status = $status1; }
            }else{
                $status = $status1;
            }             
                         
                $data   = DB::table('property_details as pd')
                            ->where('pd.property_id', $request['property_id'])
                            ->update(array(
                                'address'           => $address,
                                'verified'          => $verified,
                                'status'            => $status,
                                'user_id'           => $user_id,
                                'latitude'          => $latitude,
                                'longitude'         => $longitude,
                                'house_no'          => $house_no,
                                'street_name'       => $street_name,
                                'town'              => $town,
                                'floor_name'        => $floor_name,
                                'city'              => $city,
                                'area_code'         => $area_code,
                                'state'             => $state,
                                'country'           => $country,
                                'property_title'    => $property_title,
                                'description'       => $description,
                                'space_type'        => $space_type,
                                'guest_limit'       => $guest_limit,
                                'single_room'                => $single_room,
                                'double_room'                => $double_room,
                                'twin_room'                  => $twin_room,
                                'other_room'                 => $other_room,
                                'bathroom'                   => $bathroom,
                                'standard_rate_per_day'      => $standard_rate_per_day,
                                'standard_rate_per_week'     => $standard_rate_per_week,
                                'minimum_stay'               => $minimum_stay,
                                'security_deposit_amount'    => $security_deposit_amount
                            ));

                if($verified=='yes' && $request['sentMail']=='yes'){

                    $mail =  Mail::send('emails.property-activate', ['user_mail_details'=>$user_mail_details], function ($m) use ($user_mail_details) {

                                $m->from('info@direct-owners.com', 'Direct Owners');

                                $m->to($user_mail_details['email'])->subject('Property activation mail');
                            });
                           
                }            

               $main_image=''; $propertyRate='';  $propertyGallery = '';    $propertyAmenity='';

                if($request->hasfile('main_image_name')){

                    $files           = $request->file('main_image_name');  
                    $local_directory = public_path().'/uploads/property_images/'.$request['property_id'].'/'; 
                    $directory  = '/uploads/property_images/'.$request['property_id'].'/';
                    if (!file_exists($local_directory)) {
                        mkdir($local_directory, 0777, true);
                    }


                   $filename        = 'main_image.'.$files->getClientOriginalExtension(); 
                   $local_img       = $files->move($local_directory,$filename);

                   $image           = Image::make($local_img);
                   $resize_image    = $image->fit(640,427)->stream();
                    //Move the uploaded file to temp directory
                   $upload_success  = Storage::disk('s3')->put($directory.'/'.$filename, $resize_image->__toString(), 'public');
                   
                   if($upload_success){
                    unlink($local_directory.'/'.$filename);
                   }

                    
                    $main_image1 = DB::table('property_details')
                                  ->where('property_id', $request['property_id'])
                                  ->update([
                                    'property_image' => $filename,
                                 ]);         
                    
                 } 

                $super_admin = isset($request['super_admin'])?$request['super_admin']:''; 
                    
                if(isset($request['property_id']) && !$super_admin){

                    $propertyRate   = PropertyRate::savePropertyRates($request, $request['property_id']);
                }

                if(isset($request['property_id']) && $super_admin){

                    $propertyRate   = PropertyRate::saveSuperAdminPropertyRates($request, $request['property_id']);
                }   

                if(isset($request['property_id']) && $request->hasfile('image_name')){
                   
                    $propertyGallery = PropertyGallery::savePropertyImages($request, $request['property_id']);                            
                } 

                if(isset($request['property_id'])){

                    $propertyAmenity = PropertyAmenity::editPropertyAmenityDetails($request);
                }                   

            
            if($main_image || $data || $propertyRate || $propertyGallery || $propertyAmenity){

                return Response::json(array('success'=>1, 'message'=>'Property details edited successfully!'));
            }else{

                return Response::json(array('success'=>0, 'message'=>'Property details not edited!'));
            }                  

        }

    } 

    public static function getUserDetailsById($id){

        $data = DB::table('users as u')
                ->select('u.id', DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'), 'u.email')
                ->where('u.id', $id)
                ->first();
        return $data;         
    } 

    public static function getExistingPropertyDetails($propId){ 

        $property = DB::table('property_details as pd')
                    ->select('pd.*')
                    ->where('property_id', $propId)
                    //->where("pd.verified", 'yes')
                    //->where("pd.status", 'active')
                    ->first();
        return $property;
    }

    public static function getPropertiesDetails($request){
        $property = '';
        if(isset($request['status']) && $request['verified']){
        if($request['status']=='active' && $request['verified']=='yes') {
                $property = DB::table('property_details as pd')
                    ->select(
                        'pd.*',
                        'pg.image_name',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate'))
                        )
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                    ->groupBy('pd.property_id')
                    ->where('pd.verified', 'yes')
                    ->where('pd.status', 'active')        
                    ->where('u.status', 'active')                
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
            }
        if($request['status']!='active' || $request['status']=='active' && $request['verified']!='yes') { 
                $property = DB::table('property_details as pd')
                    ->select(
                        'pd.*',
                        'pg.image_name',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate'))
                    )
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                    ->groupBy('pd.property_id')
                    ->where("pd.status", '!=', 'active')
                    ->where("pd.verified", '!=' ,'yes')
                    ->where('u.status', 'active')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
        }
       }            
        
            if($property){

                return Response::json(array('success'=>'1', 'properties_details'=>$property));

            }else{

                return Response::json(array('success'=>'0', 'properties_details'=>'No results found'));
            }            
    }

    public static function getMinMaxValues(){

       /* $property =  DB::select('select  min(LEAST(standard_rate_per_day, standard_rate_per_week)) as min_price, max(GREATEST(standard_rate_per_day, standard_rate_per_week)) as max_price from property_details where verified="verified" and status="active"');*/

        $property = DB::table('property_details as pd')
                    ->select(DB::raw('MAX(pd.standard_rate_per_week) AS max_price'))
                    ->leftJoin('users as u', 'u.id', '=', 'pd.user_id')
                    ->where("pd.verified", 'yes')
                    ->where("pd.status", 'active')
                    ->where('u.status', 'active')
                    ->first();
                    
        if($property){

            return Response::json(array('success'=>'1', 'data'=>$property));

        }
    }

    public static function getActivePropertiesDetails(){

        $property = DB::table('property_details as pd')

                    ->select('pd.*')
                    ->where("pd.verified", 'yes')
                    ->where("pd.status", 'active')
                    ->get();
                    
        if($property){

            return Response::json(array('success'=>'1', 'properties_details'=>$property));

        }else{
            
            return Response::json(array('success'=>'0', 'properties_details'=>'No properties are there!'));                                               
        }

    }

    public static function getUserPropertiesDashborad($request){

        $selected_currency  = isset($request['currency_name'])?strtoupper($request['currency_name']):'eur';
        $currency_rate      = $selected_currency=='EUR'?1:PropertyDetails::convertCurrency($selected_currency); 
        if(isset($request['status']) && $request['verified']){
        if($request['status']=='active' && $request['user_id'] && $request['verified']=='yes') {
                $property = DB::table('property_details as pd')
                    ->select(
                        'pd.*',
                        'pg.image_name',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate'))
                    )
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->where('pd.verified', 'yes')
                    ->where('pd.status', 'active')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
            }
        if($request['status']!='active' || $request['status']=='active' && $request['verified']!='yes' && $request['user_id']) { 
                $property = DB::table('property_details as pd')
                    ->select(
                        'pd.*',
                        'pg.image_name',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate'))
                    )
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->where("pd.status", '!=', 'active')
                    ->where("pd.verified", '!=' ,'yes')                        
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
        }
       }
        if($request['user_id'] && !isset($request['verified']) && !isset($request['status'])) {
                $property = DB::table('property_details as pd')
                    ->select(
                        'pd.*',
                        'pg.image_name',
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id group by week(CURDATE())) week_rate')),
                        (DB::raw('(SELECT min(pr.rate_per_week) FROM property_rate as pr WHERE pr.property_id=pd.property_id and pr.start_date >= CURDATE() ) min_week_rate'))
                    )
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->where('user_id', $request['user_id'])
                    ->orderBy('pd.created_at', 'desc')
                    ->get();
                    
        }
        
        $result_array = array();
        if($property){
            
            foreach ($property as $p) {
                
                $prop_rate          = $p['standard_rate_per_week']?$p['standard_rate_per_week']:$p['min_week_rate'];
                $prop_week_rate     = $p['min_week_rate']?$p['min_week_rate']:$p['min_week_rate'];
                $final_prop_rate    = round(($prop_rate * $currency_rate), 2);
                $final_week_rate    = round(($prop_week_rate * $currency_rate), 2);
                $data['property_title']         = $p['property_title'];
                $data['city']                   = $p['city'];
                $data['country']                = $p['country'];
                $data['space_type']             = $p['space_type'];
                $data['standard_rate_per_week'] = $final_prop_rate;
                $data['min_week_rate']          = $final_week_rate;
                $data['status']                 = $p['status'];
                $data['property_image']         = $p['property_image'];
                $data['property_id']            = $p['property_id'];
                $data['guest_limit']            = $p['guest_limit'];
                $data['selected_currency']      = $request['currency_name'];
                array_push($result_array, $data);   
            }
        }
            if($result_array){

                return $result_array;

            }else{

                return '';
            }            
    }      

    public static function getOwnerDashboardStats($input){

        $result = array();

        $allpropertiesCount     = DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])                                
                                  ->count();

        $activePropertiesCount  = DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])
                                  ->where("pd.status", '=', 'active')
                                  ->where("pd.verified", '=' ,'yes')                                
                                  ->count();

        $inactivePropertiesCount= DB::table('property_details as pd')
                                  ->select('pd.*')
                                  ->where('pd.user_id', $input['owner_id'])
                                  ->where("pd.status", '!=', 'active')
                                  ->where("pd.verified", '!=' ,'yes')                               
                                  ->count(); 

        $enquiriesCount        = DB::table('property_enquiry as pe')
                                  ->select('pe.*')
                                  ->where('pe.owner_id', $input['owner_id'])
                                  ->count();

        $notificationsCount    = DB::table('property_notifications as pn')
                                  ->select('pn.*')
                                  //->whereRaw('date(pn.created_at) = CURDATE()')
                                  ->count();                                      

         $result['allpropertiesCount'] = $allpropertiesCount;
         $result['activePropertiesCount'] = $activePropertiesCount;
         $result['inactivePropertiesCount'] = $inactivePropertiesCount;
         $result['enquiriesCount'] = $enquiriesCount;
         $result['notificationsCount'] = $notificationsCount;             

        if($result){

            return Response::json(array('success'=>'1', 'properties_details'=>$result));

        }else{
            
            return Response::json(array('success'=>'0', 'properties_details'=>'No properties are there!'));                                               
        }                                                                   

    }

    public static function getCountriesList(){

        $countries = DB::table('country as c')
                     ->select('c.*')
                     ->get();
        if($countries){

            return Response::json(array('success'=>'1', 'countries'=>$countries));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No countries are there!'));                                               
        }             
    }

    public static function getCitiesByCountry($id){

        $cities = DB::table('city as cs')
                     ->select('cs.*')
                     ->join('country as c', 'c.id', '=', 'cs.countryid')
                     ->where('cs.countryid', $id)
                     ->get();
        if($cities){

            return Response::json(array('success'=>'1', 'cities'=>$cities));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No cities are there!'));                                               
        }             

    }

    public static function getCitiesListToSearch(){

        $cities = DB::select("select distinct pd.city, COUNT(property_id) from property_details as pd left join users as u on u.id=pd.user_id where pd.city != '' and pd.status ='active' and u.status='active' group by pd.city order by count(property_id) DESC, pd.city asc limit 0,10");

        /*$cities = DB::table('property_details as pd')
                      ->select('pd.city')
                      ->groupBy('pd.city')
                      ->distinct('pd.city')
                      ->where('pd.city', '!=', '')
                      ->orderBy('pd.city', 'asc') 
                      ->get();*/  
        if($cities){

            return Response::json(array('success'=>'1', 'cities'=>$cities));

        }else{
            
            return Response::json(array('success'=>'0', 'countries'=>'No cities are there!'));                                               
        }    

    }

    public static function getAllPropertiesDetailsList(){

         $property = DB::table('property_details as pd')
                    ->select('pd.*','pg.image_name')
                    ->leftJoin('property_gallery as pg', 'pg.property_id', '=','pd.property_id')
                    ->groupBy('pd.property_id')
                    ->orderBy('pd.created_at', 'desc')
                    ->get();

        if($property){

            return Response::json(array('success'=>'1', 'property'=>$property));

        }else{
            
            return Response::json(array('success'=>'0', 'property'=>'No properties are there!'));                                               
        } 
    }


    public static function getDeletePropertyDetailsById($ids){

        $prop_images  = PropertyDetails::getDeletePropertyImageDirectory($ids);

        $property_details    = DB::table('property_details')->whereIn('property_id', $ids)->delete();
        $property_amenity    = DB::table('property_amenity')->whereIn('property_id', $ids)->delete();
        $property_gallery    = DB::table('property_gallery')->whereIn('property_id', $ids)->delete();
        $property_preblock_details    = DB::table('property_preblock_details')->whereIn('property_id', $ids)->delete();
        $property_rate       = DB::table('property_rate')->whereIn('property_id', $ids)->delete();   

        if($property_details){

            return Response::json(array('success'=>'1', 'message'=>'Property details deleted successfully!'));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Property details not deleted successfully!'));
        }     
    }

    public static function getDeletePropertyImageDirectory($ids){
        foreach($ids as $id){
          $dir = public_path().'/uploads/property_images/'.$id.'/';  
          if(is_dir($dir)){
            foreach(glob($dir . '/*') as $file) { 
              if(is_dir($file)) delete_files($file); else unlink($file); 
            } rmdir($dir); 
          }
        }
    }
}
