<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use Response;

use App\User;

use Mail;

use DB;

class PropertyEnquiry extends Model
{
   protected $table = "property_enquiry";

   public static function getPropertyEnquiries($request){   		
      
    	$enquiriesQuery = DB::table('property_enquiry as pe')
    				 ->select('pe.*', 'pd.*')
    				 ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
    				 ->orderBy('pe.created_at', 'desc');
             

      if(isset($request['owner_id'])){

          $enquiriesQuery->where('pe.owner_id', $request['owner_id']);
      }       

      if(isset($request['property_id'])){

          $enquiriesQuery->where('pe.property_id', $request['property_id']);
      }                                       			 
    	
      $enquiries = $enquiriesQuery->get();

    	if($enquiries){			 

    		return Response::json(array('message'=>'success', 'enquiry_details'=>$enquiries));

    	}else{

    		return Response::json(array('message'=>'error', 'enquiry_details'=>'There are no enquiries.'));
    	}  
	}

  public static function getAllEnquiriesList(){

    $enquiries = DB::table('property_enquiry as pe')
             ->select('pe.*','pe.arrival_time as at', 'pe.departure_time as dt', 'pd.*')
             ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
             ->orderBy('pe.created_at', 'desc')
             ->get();

    if($enquiries){      

        return Response::json(array('message'=>'success', 'enquiry_details'=>$enquiries));

      }else{

        return Response::json(array('message'=>'error', 'enquiry_details'=>'There are no enquiries.'));
      }
  }

  public static function savePropertyEnquiryDetails($input){
Log::info(print_r('$input', true));
    Log::info(print_r($input, true));
      $enquiry    = new PropertyEnquiry();

      $booknowObj = new PropertyBooknow();

      $checkDates = PropertyBooknow::checkPropertyPreblockDetails($input);
        
      if($checkDates){

          return Response::json(array('success'=>'2', 'message'=>'You cannot add property some dates are blocked'));
          
      }else{

        if(isset($input['arrival_time'])){
          $enquiry->arrival_time      = $input['arrival_time'];
        }
        if(isset($input['departure_time'])){
          $enquiry->departure_time    = $input['departure_time'];
        }
        if(isset($input['guest_limit'])){
          $enquiry->guest_limit       = $input['guest_limit'];
        }
        if(isset($input['first_name'])){
          $enquiry->first_name        = $input['first_name'];
        }
        if(isset($input['surname'])){
          $enquiry->surname           = $input['surname'];
        }
        if(isset($input['phone'])){
          $enquiry->phone             = $input['phone'];
        }
        if(isset($input['email'])){
          $enquiry->email             = $input['email'];
        }
        if(isset($input['message'])){
          $enquiry->message           = $input['message'];
        }
        if(isset($input['property_id'])){
          $enquiry->property_id       = $input['property_id'];
        }
        if(isset($input['paid_amount'])){
          $enquiry->paid_amount       = $input['paid_amount'];
        }
        if(isset($input['security_deposit'])){
          $enquiry->security_deposit       = $input['security_deposit'];
        }
        if(isset($input['booking_amount'])){
          $enquiry->booking_amount       = $input['booking_amount'];
        }
        if(isset($input['owner_id'])){
          $enquiry->owner_id          = $input['owner_id'];        
          $owner = PropertyEnquiry::getOwnerDetailsById($input['owner_id']);        
        }

        if(isset($input['owner_security_deposit'])){
          $enquiry->owner_security_deposit       = $input['owner_security_deposit'];
        }

        if(isset($input['coupon'])){
          $enquiry->coupon                       = $input['coupon'];
        }
        if(isset($input['owner_deal_amount'])){
          $enquiry->deal_discount                = $input['owner_deal_amount'];
        }

        $enquiry->enq_status = 1;
        $enquiry->save();
        //print_r($enquiry->id);die();
        $enq = PropertyEnquiry::getPropertyEnquiryDetails($enquiry->id);
        //print_r($enq);die();
       // $emails = array($input['email'], $owner['email']);
       
        if($enquiry){

          //$omail = array($owner['email']);

          $mail =  Mail::send('emails.enquiry-client', ['enq'=>$enq], function ($m) use ($enq) {

              $m->from('info@direct-owners.com', 'Direct Owners');

              $m->to($enq['email'])->subject('Confirmation of your Enquiry from Direct-Owners');
          });

          $mail =  Mail::send('emails.enquiry-owner', ['enq'=>$enq], function ($m) use ($enq) {

              $m->from('info@direct-owners.com', 'Direct Owners');

              $m->to($enq['owner_mail'])->subject('New Guest Enquiry from Direct-Owners');
          });

          return Response::json(array('message'=>'success', 'enquiry_details'=>$enquiry, 'status'=>'Your enquiry has been sent successfully. The owner will contact you soon.'));
          

        }else{

          return Response::json(array('message'=>'error', 'enquiry_details'=>'Enquiry not saved successfully, Please try again.'));
        } 
    }

  }

  public static function getPropertyEnquiryDetails($enqId){

    $data = DB::table('property_enquiry as pe')
            ->select(
              'pe.*',
              'pe.id as enq_id',
              'pe.guest_limit as guest',
              DB::raw('DATE_FORMAT(pe.arrival_time, "%d %b %Y") as earrival_time'),
              DB::raw('DATE_FORMAT(pe.departure_time, "%d %b %Y") as edeparture_time'),
              'pd.*', 
              DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
              DB::raw('CONCAT(pe.first_name, " ", pe.surname) AS customer_name'), 
              'u.email as owner_mail'
            )
            ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
            ->leftJoin('users as u', 'u.id', '=', 'pe.owner_id')
            ->where('pe.id', $enqId)
            ->first();
    return $data;
  }

  public static function getEnquiriesById($id){

      // $data = DB::table('property_enquiry as pe')
      //       ->select('pe.*')
      //       ->where('pe.id', $id)
      //       ->first();

      $data = DB::table('property_enquiry as pe')
            ->select(
              'pe.*',
              'pe.id as enq_id',
              'pe.guest_limit as guest',
              DB::raw('DATE_FORMAT(pe.arrival_time, "%d %b %Y") as earrival_time'),
              DB::raw('DATE_FORMAT(pe.departure_time, "%d %b %Y") as edeparture_time'),
              'pd.*', 
              DB::raw('CONCAT(u.first_name, " ", u.surname) AS name'),
              DB::raw('CONCAT(pe.first_name, " ", pe.surname) AS customer_name'), 
              'u.email as owner_mail',
              'pd.property_title',
              'pd.property_id'
            )
            ->leftJoin('property_details as pd', 'pd.property_id','=','pe.property_id')
            ->leftJoin('users as u', 'u.id', '=', 'pe.owner_id')
            ->where('pe.id', $id)
            ->first();

      if($data){

          return Response::json(array('success'=>'1', 'enquiry_details'=>$data));
      }else{

          return Response::json(array('success'=>'0', 'enquiry_details'=>'No details found'));
      }      

  }

  public static function getOwnerDetailsById($id){

      $data = DB::table('users as u')
                ->select('u.*')
                ->where('u.id', $id)
                ->first();
      return $data;                
  }

  public static function deletePropertyEnquiryDetails($id){

    $data    = DB::table('property_enquiry')->where('id', $id)->delete();

            if($data){

                return Response::json(array('success'=>'1', 'message'=>'Property enquiry details deleted successfully!'));
            }else{

                return Response::json(array('success'=>'0', 'message'=>'Property enquiry details not deleted successfully!'));
            }
  }
}
