<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use App\PropertyNotifications;

use Response;

use DB;

class PropertyNotifications extends Model
{
    protected $table = 'property_notifications';

    public static function getNotificationsList(){
    		$notifications = DB::table('property_notifications as pn')
    						->select('pn.*')
    						->orderBy('pn.created_at', 'desc')
                            //->whereRaw('date(pn.created_at) = CURDATE()')
    						->get();
    		if($notifications){

                return Response::json(array('success'=>'1', 'notifications'=>$notifications));

            }else{
                
                return Response::json(array('success'=>'0', 'notifications'=>'No notifications are there!'));                                               
            } 
    }

    public static function saveNotificationsDetails($request){

        $notification = new PropertyNotifications();
        $notification->title        = $request['title'];
        $notification->description  = $request['description'];
        $notification->save();
        return $notification;
    }   

    public static function getNotificationDetails($id){

        $data = DB::table('property_notifications')
                ->select('*')
                ->where('id', $id)
                ->first();
        return $data;
    }

    public static function deleteNotification($id){

        $data = DB::table('property_notifications')->where('id', $id)->delete();

        return $data;
    }

    public static function getUserNotificationsList($ownerId, $propId){

        $ownerId = isset($ownerId)?$ownerId:'0';
        $propId = isset($propId)?$propId:'0';

        if($ownerId){
            $data = DB::table('property_notifications as n')
                    ->select('n.*')
                    ->where('n.owner_id', $ownerId)
                    ->get();
        }

        if($data){

            return Response::json(array('success'=>'1', 'notifications'=>$data));

        }else{
            
            return Response::json(array('success'=>'0', 'notifications'=>'No notifications found!'));                                               
        }  

    }
}
