<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use DB;

use DateTime;

use DatePeriod;

use DateInterval;

use Response;

class PropertyPreblockDetails extends Model
{
    protected $table = 'property_preblock_details';

    public static function savePreblockProperty($request){
        
    	$preblock_property = new PropertyPreblockDetails;    	

        $checkDates = PropertyPreblockDetails::checkPropertyPreblockDetails($request);
        
        if($checkDates){

            return Response::json(array('success'=>'2', 'message'=>'You cannot add property some dates are blocked already'));
            
        }else{

            if(isset($request['property_id'])){

                $property_id = $request['property_id'];
            }

            if(isset($request['start_date'])){

                $start_date = $request['start_date'];
            }

            if(isset($request['end_date'])){

                $end_date = $request['end_date'];
            }

            if(isset($request['preblock_comment'])){

                $preblock_comment = $request['preblock_comment'];
            }           

            $rate = isset($request['rate'])?$request['rate']:'';            
            
            $preblock_property = DB::table('property_preblock_details')->insertGetId([
                                'property_id'=>$property_id,
                                'start_date' =>$start_date,
                                'end_date'   =>$end_date,
                                'rate'       =>$rate,
                                'comment'    =>$preblock_comment
                                ]);

            $book_property    = DB::table('booknow_property_details')->insertGetId([
                                'property_id'       =>$property_id,
                                'arrival_time'      =>$start_date,
                                'departure_time'    =>$end_date,
                                'payment_status'    =>'yes',
                                'preblock_id'       =>$preblock_property,
                                'block_type'        =>'preblock',
                                'preblock_comment'  =>$preblock_comment
                                ]);
            Log::info(print_r('pre block', true));
            Log::info(print_r($book_property, true));
            if($preblock_property){

                $details = PropertyPreblockDetails::getPreblockPropertyDetailsById($preblock_property);
                return Response::json(array('success'=>'1', 'message'=>'Reserved dates details saved successfully!', 'details'=>$details));
            }else{

                return Response::json(array('success'=>'0', 'message'=>'Reserved dates details not saved!'));
            } 
        }
    	
    }

    public static function checkPropertyPreblockDetails($request){
        
        $existingDates = PropertyPreblockDetails::getExistingPropertyDetails($request['property_id']);
        
        $start  = new DateTime($request['start_date']);
        $end    = new DateTime($request['end_date']);

        $daterange = new DatePeriod($start, new DateInterval('P1D'), $end);
        $data = array();

        foreach($daterange as $date){
            array_push($data, $date->format("Y-m-d"));
        }
        
        if($existingDates){ 

            $result = count(array_intersect($data, $existingDates));

            return $result;
        }else{
            return 0;
        }
        
    }

    public static function getExistingPropertyDetails($id){

        /*$dates = DB::table('property_preblock_details as ppd')
            ->select('ppd.id', 'ppd.property_id', 'ppd.start_date', 'ppd.end_date', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date')
            ->leftJoin('booknow_property_details as pbd', 'pbd.property_id', '=', 'ppd.property_id')
            ->where('ppd.property_id', $id)
            ->where('pbd.payment_status', 'yes')
            ->get();*/

         $dates =  DB::table('booknow_property_details as pbd')
                ->select('ppd.id', 'ppd.property_id', 'ppd.start_date', 'ppd.end_date', 'pbd.arrival_time as start_date', 'pbd.departure_time as end_date')
                ->leftJoin('property_preblock_details as ppd', 'ppd.property_id', '=', 'pbd.property_id')
                ->where('pbd.property_id', $id)
                ->where('pbd.payment_status', 'yes')
                ->where('pbd.owner_cancel_request','!=', 'no')
                ->where('pbd.admin_cancel_status','!=', 'yes')
                ->get();
                              
        if(count($dates)){
            $data = array();
            $dates_arr      = array();
            foreach ($dates as $d) {
                
                
                $current        = strtotime($d['start_date']);
                $last           = strtotime($d['end_date']);
                $output_format  = 'Y-m-d';
                $step           = "+1 day";
                while( $current <= $last ) {

                    $dates_arr[] = date($output_format, $current);
                    $current = strtotime($step, $current);
                }              
                
            }   

            return $dates_arr;
        }else{                
            return 0;
        }               

    }

    public static function getPreblockPropertyDetailsById($id){

    	$data = DB::table('property_preblock_details as ppd')
    			->select('ppd.*', 'pd.property_title')
    			->join('property_details as pd', 'pd.property_id', '=', 'ppd.property_id')
    			->where('ppd.id', $id)
    			->get();

    	return $data;
    }

    public static function getAllOwnerPreblockPropertyDetails($id){

        $data = DB::table('property_preblock_details as ppd')
                ->select(
                    'ppd.*', 
                    DB::raw('DATE_FORMAT(ppd.start_date, "%b %d, %Y") as start_date'), 
                    DB::raw('DATE_FORMAT(ppd.end_date, "%b %d, %Y") as end_date'),
                    'pd.property_title'
                )
                ->join('property_details as pd', 'pd.property_id', '=', 'ppd.property_id')
                ->where('pd.user_id', $id)
                ->orderBy('created_at', 'desc')
                ->get();

        if($data){

            return Response::json(array('success'=>'1', 'message'=>'Reserved dates details', 'details'=>$data));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'No details found'));
        }
    }

    public static function getAllPreblockPropertyDetails(){

    	$data = DB::table('property_preblock_details as ppd')
    			->select('ppd.*', 'pd.property_title')
    			->join('property_details as pd', 'pd.property_id', '=', 'ppd.property_id')
    			->get();

    	if($data){

            return Response::json(array('success'=>'1', 'message'=>'Reserved dates details', 'details'=>$data));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'No details found'));
        }
    }

    public static function deletePreblockPropertyDetails($id){

    	$data       = DB::table('property_preblock_details')->where('id', $id)->delete();
        Log::info(print_r($data.' preblock', true));
        $preblock   = DB::table('booknow_property_details')->where('preblock_id', $id)->delete();
        Log::info(print_r($preblock.' book niw preblock', true));
    	if($data){

            return Response::json(array('success'=>'1', 'message'=>'Reserved dates details deleted'));
        }else{

            return Response::json(array('success'=>'0', 'message'=>'Reserved dates details not deleted!'));
        }

    }
}
