<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use App\SignupBenifits;

use Response;

use DB;

class SignupBenifits extends Model
{
    
    protected $table = "signup_benifits" ;

    public static function saveBenifits($data){

    	$result = DB::table('signup_benifits')
    			  ->insertGetId(array('benifits'=>$data['description']));

    	if($result){

    		$data = SignupBenifits::getBenifitsById($result);

    		return Response::json(array('success'=>'1', 'result'=>$data, 'message'=>'Benifts added successfully!'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Benifts not added, please try again'));
    	}		  
    }

    public static function getBenifitsById($id){

    	$data = DB::table('signup_benifits')
                ->select('*')
                ->where('id', $id)
                ->first();
        return $data;
    }

    public static function deleteBenifitsById($data){

    	$result = DB::table('signup_benifits')->where('id', $data['id'])->delete();

    	if($result){

    		return Response::json(array('success'=>'1', 'message'=>'Benifits deleted successfully!'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Benifits not deleted, please try again'));
    	}
    }

    public static function updateBenifits($request){

    	$update = DB::table('signup_benifits')
    			  ->where('id', $request['id'])
    			  ->update(array('benifits'=>$request['description']));

    	if($update){

    		return Response::json(array('success'=>'1', 'message'=>'Benifits updated successfully!'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Benifits not updated, please try again'));
    	}		  
    }

    public static function getBenifitsListToDisplay(){

        $data = DB::table('signup_benifits')
                ->select('*')
                ->orderBy('created_at', 'desc')
                ->offset(0)->limit(1)
                ->get();

        if($data){

            return Response::json(array('success'=>1, 'result'=>$data));
        }else{

            return Response::json(array('success'=>0, 'message'=>'No testimonials found!'));
        }
    }
}
