<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use App\Testimonials;

use DB;

use Response;

class Testimonials extends Model
{
    protected $table = 'testimonials';

    public static function saveTestimonials($request){

    	$name = $request['name'];
    	$rating = $request['rating'];
    	$testimonial = $request['testimonial'];
    	$designation = isset($request['designation'])?$request['designation']:'';
        $property_id = $request['property_id'];
    	$owner_id = $request['owner_id'];
    	$priority = isset($request['priority'])?$request['priority']:0;
        //$status = isset($request['status'])?$request['status']:0;
    	$testimonial_id = DB::table('testimonials')
    			->insertGetId(array(
    				'name'=>$name,
    				'property_id'=>$property_id,
    				'rating'=>$rating,
                    'designation'=>$designation,
    				'testimonial'=>$testimonial,
    				'owner_id'   =>$owner_id,
    				'priority'	 =>$priority
    			));

    	if($testimonial_id){

    		$data = Testimonials::getTestimonialById($testimonial_id);

    		return Response::json(array('success'=>'1', 'result'=>$data, 'message'=>'Thank you for sharing your experience with us'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Review not added, please try again'));
    	}		
    }

    public static function getTestimonialById($id){

    	$data = DB::table('testimonials as t')
                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                ->select('t.*', 'pd.property_title')
                ->where('t.id', $id)
                ->first();
        return $data;
    }

    public static function updateTestimonials($request){

    	$id 		 = $request['id'];
    	$edata 		 = Testimonials::getTestimonialById($id);


    	$name 		 = isset($request['name'])?$request['name']:$edata['name'];
        $designation        = isset($request['designation'])?$request['designation']:$edata['designation'];
    	$rating      = isset($request['rating'])?$request['rating']:$edata['rating'];
        $status = '';
        if($request['status']=='on' && $request['status1']=='no'){

            $status = 'publish';
        }else if($request['status1']=='no'){
            $status = '';
        }else{
            $status = $edata['status'];
        }

        $admin_status = '';
        if($request['admin_status']=='on' && $request['admin_status1']=='no'){

            $admin_status = 'active';
        }else if($request['admin_status1']=='no'){
            $admin_status = '';
        }else{
            $admin_status = $edata['admin_status'];
        }
        
    	$testimonial = isset($request['testimonial'])?$request['testimonial']:$edata['testimonial'];
    	$property_id = isset($request['property_id'])?$request['property_id']:$edata['property_id'];
    	$owner_id 	 = isset($request['owner_id'])?$request['owner_id']:$edata['owner_id'];
    	$priority 	 = isset($request['priority'])?$request['priority']:$edata['priority'];

    	$data = DB::table('testimonials')
    			->where('id', $id)
    			->update(array(
    				'name'		 =>$name,
                    'designation'=>$designation,
    				'rating'     =>$rating,
                    'status'     =>$status,
                    'admin_status'=>$admin_status,
    				'testimonial'=>$testimonial,
    				'property_id'=>$property_id,
    				'owner_id'   =>$owner_id,
    				'priority'	 =>$priority
    			));

    	if($data){

    		$result = Testimonials::getTestimonialById($id);

    		return Response::json(array('success'=>'1', 'result'=>$result, 'message'=>'Review updated successfully'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Review not updated, please try again'));
    	}
    }

    public static function deleteTestimonial($id){

    	$data = DB::table('testimonials')->where('id', $id)->delete();

    	if($data){

    		return Response::json(array('success'=>'1', 'message'=>'Review deleted successfully!'));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'Review not deleted, please try again'));
    	}

    }

    public static function getTestimonials(){

    	$data = DB::table('testimonials')
    			->select('*')
    			->get();

   		if($data){

   			return Response::json(array('success'=>'1', 'result'=>$data));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'No testimonials found'));
    	}
   		
    }

    public static function getOwnerTestimonials($uid){

    	$data = DB::table('testimonials as t')
    			->leftJoin('property_details as pd','pd.property_id','=','t.property_id')
    			->select('t.*', 'pd.property_title')
    			->where('owner_id', $uid)
                ->orderBy('created_at', 'desc')
    			->get();

   		if($data){

   			return Response::json(array('success'=>'1', 'result'=>$data));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'No testimonials found for this user'));
    	}
    }

    public static function getTestimonialByIdJsonResult($id){

        $data = DB::table('testimonials as t')
                ->leftJoin('property_details as pd', 'pd.property_id', '=', 't.property_id')
                ->select('t.*', 'pd.property_title')
                ->where('t.id', $id)
                ->first();
                
   		if($data){

   			return Response::json(array('success'=>'1', 'result'=>$data));
    	}else{

    		return Response::json(array('error'=>'0', 'message'=>'No testimonials found for this user'));
    	}
    }
}
