(function() {

 
'use strict';

    var serviceId = 'remoteServices';
    

    var app = angular.module('directOwnersApp', ['ui.router', 'satellizer','angular-flexslider', 'ui.bootstrap', 'ui.tinymce']);
    
    app.filter('unsafe', function($sce) { return $sce.trustAsHtml; });
    console.log('jjjjj');

    angular.module('ui.tinymce', [])
        .value('uiTinymceConfig', {})
        .directive('uiTinymce', ['uiTinymceConfig', function(uiTinymceConfig) {
        uiTinymceConfig = uiTinymceConfig || {};
        var generatedIds = 0;
        return {
            require: 'ngModel',
            link: function(scope, elm, attrs, ngModel) {
                var expression, options, tinyInstance;
                // generate an ID if not present
                if (!attrs.id) {
                    attrs.$set('id', 'uiTinymce' + generatedIds++);
                }
                options = {
                    // Update model when calling setContent (such as from the source editor popup)
                    setup: function(ed) {
                        ed.on('init', function(args) {
                            ngModel.$render();
                        });
                        // Update model on button click
                        ed.on('ExecCommand', function(e) {
                            ed.save();
                            ngModel.$setViewValue(elm.val());
                            if (!scope.$$phase) {
                                scope.$apply();
                            }
                        });
                        // Update model on keypress
                        ed.on('KeyUp', function(e) {
                            console.log(ed.isDirty());
                            ed.save();
                            ngModel.$setViewValue(elm.val());
                            if (!scope.$$phase) {
                                scope.$apply();
                            }
                        });
                    },
                    mode: 'exact',
                    elements: attrs.id,
                    browser_spellcheck : true,
                    branding: false,
                    content_css: ['//fonts.googleapis.com/css?family=Indie+Flower'],
                    font_formats: 'Arial Black=arial black,avant garde;Indie Flower=indie flower, cursive;Times New Roman=times new roman,times;',
                    theme: 'modern',
                    plugins: ['searchreplace wordcount visualblocks visualchars code fullscreen',
                            'emoticons template paste textcolor colorpicker textpattern imagetools'
                            ],
                    toolbar1: 'insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image | fontsizeselect fontselect',
                    toolbar2: 'print preview media | forecolor backcolor emoticons', 
                    font_formats: 'Andale Mono=andale mono,times;' + 'Arial=arial,helvetica,sans-serif;' + 'Arial Black=arial black,avant garde;' + 'Book Antiqua=book antiqua,palatino;' + 'Comic Sans MS=comic sans ms,sans-serif;' + 'Courier New=courier new,courier;' + 'Georgia=georgia,palatino;' + 'Helvetica=helvetica;' + 'Impact=impact,chicago;' + 'Symbol=symbol;' + 'Tahoma=tahoma,arial,helvetica,sans-serif;' + 'Terminal=terminal,monaco;' + 'Times New Roman=times new roman,times;' + 'Trebuchet MS=trebuchet ms,geneva;' + 'Verdana=verdana,geneva;' + 'Webdings=webdings;' + 'Wingdings=wingdings,zapf dingbats',
                    fontsize_formats: "8pt 9pt 10pt 11pt 12pt 14pt 16pt 18pt 20pt 22pt 24pt 26pt 28pt 36pt 48pt 72pt"                   
                };
                if (attrs.uiTinymce) {
                    expression = scope.$eval(attrs.uiTinymce);
                } else {
                    expression = {};
                }
                angular.extend(options, uiTinymceConfig, expression);
                setTimeout(function() {
                    tinymce.init(options);
                });


                ngModel.$render = function() {
                    if (!tinyInstance) {
                        tinyInstance = tinymce.get(attrs.id);
                    }
                    if (tinyInstance) {
                        tinyInstance.setContent(ngModel.$viewValue || '');
                    }
                };
            }
        };
    }]); 

    

    //notificationService.success('Successing text')
    app.filter('capitalize', function() {
        return function(input) {
          return (!!input) ? input.charAt(0).toUpperCase() + input.substr(1).toLowerCase() : '';
        }
    });

    app.filter('removeSpacesWithHypenThenLowercase', function () {
          return function (text) {
            var str = text.replace(/\s+/g, '-');
            return str.toLowerCase();
          };
    });

    app.directive('dateNow', ['$filter', function($filter) {
      return {
        link: function( $scope, $element, $attrs) {
          $element.text($filter('date')(new Date(), $attrs.dateNow));
        }
      };
    }])
    app.directive('myModal', function() {
       return {
         restrict: 'A',
         link: function(scope, element, attr) {
           scope.dismiss = function() {
               element.modal('hide');
           };
         }
       } 
    });



    app.directive('loading',   ['$http' ,function ($http)
    {
        return {
            restrict: 'A',
            link: function (scope, elm, attrs)
            {
                scope.isLoading = function () {
                    return $http.pendingRequests.length > 0;
                };

                scope.$watch(scope.isLoading, function (v)
                {
                    if(v){
                        elm.show();
                    }else{
                        elm.hide();
                    }
                });
            }
        };

    }])

    app.directive('formAutofillFix', function() {
      return function(scope, elem, attrs) {
        // Fixes Chrome bug: https://groups.google.com/forum/#!topic/angular/6NlucSskQjY
        elem.prop('method', 'POST');

        // Fix autofill issues where Angular doesn't know about auto-filled inputs
        if(attrs.ngSubmit) {
          setTimeout(function() {
            elem.unbind('submit').submit(function(e) {
              e.preventDefault();
              elem.find('input, textarea, select').trigger('input').trigger('change').trigger('keydown');
              scope.$apply(attrs.ngSubmit);
            });
          }, 0);
        }
      };
    });

    app.factory('httpPreConfig', ['$http', '$rootScope', function ($http, $rootScope) {
	    $http.defaults.transformRequest.push(function () {
	        console.log('Started');
	        //Show your loader here
	        $rootScope.$broadcast('AjaxProgress');
	    });
	    $http.defaults.transformResponse.push(function () {
	        console.log('Stopped');
	        //Hide your loader here
	        $rootScope.$broadcast('AjaxFinished');
	    })
	    return $http;
	}]);
    
    app.directive('ngEnter', function() {
        return function(scope, element, attrs) {
            element.bind("keydown keypress", function(event) {
                if(event.which === 13) {
                    scope.$apply(function(){
                        scope.$eval(attrs.ngEnter, {'event': event});
                    });

                    event.preventDefault();
                }
            });
        };
    });

    app.config(function($stateProvider, $urlRouterProvider, $authProvider) {

                    // Satellizer configuration that specifies which API
                    // route the JWT should be retrieved from
                    if(window.location.hostname=='localhost'){
                        $authProvider.loginUrl = 'direct_owners/public/api/v1/signin';
                        //$redirectUri = 'http://localhost/direct_owners/public';
                    }else{
                        $authProvider.loginUrl = 'direct_owners/public/api/v1/signin';
                    }

                    $authProvider.facebook({
                      clientId: '1804317573123021',
                    });

                    $authProvider.google({
                      clientId: '57322318994-120n3vookko7k5ldrgt7rgfl6h2fog7c.apps.googleusercontent.com'
                    });

                    $authProvider.linkedin({
                      clientId: '86vsugahsmlj4g',
                    });

                    //console.log($authProvider);

                    // Redirect to the auth state if any other states
                    // are requested other than users
                    $urlRouterProvider.otherwise('/');
                    var header = {
                           templateUrl: './layouts/header.html',
                           controller: function($scope, $rootScope,$window, $http,$sce, $state, $location, AuthFactory) {
                                //alert($location.search(''));
                                var _s3_path = '';
                                var url = 'api/v1/get-aws-link';
                                $http.get(url).success(function(data) {
                                    console.log(data, 's4 data');
                                  if(data.success==1){
                                    $scope._s3_path = data._s3_path;    
                                    _s3_path        = data._s3_path;                                 
                                  }
                                }).error(function(error) {
                                    $scope.error = error;            
                                }); 
                                
                                setTimeout(function(){

                                    $scope.token        = localStorage.token;
                                    $scope.name         = localStorage.name;
                                    $scope.id           = localStorage.id;
                                    $scope.emailv       = localStorage.emailv;
                                    $scope.phonev       = localStorage.phonev;
                                    $scope.access_token = localStorage.access_token;
                                    $scope.tun          = localStorage.tmt_username;
                                    $scope.tpd          = localStorage.tmt_password;
                                    $scope.basic_currency = localStorage.basic_currency;
                                    $scope.pemail       = localStorage.paypal_email;
                                    $scope.auth_token   = localStorage.auth_token;

                                    var img             = localStorage.image;
                                    console.log(_s3_path, '_s3_path');
                                    if(img){
                                        $scope.image    = _s3_path+'/profile_pics/'+img;
                                    }else{
                                        $scope.image    = _s3_path+'/profile_pics/default.jpg';
                                    }
                                }, 550);
                                
                                
                                $scope.logout = function () {                

                                    localStorage.clear();
                                    var pnotify = new PNotify({
                                    title: 'Success',
                                    text: 'Successfully Logged Out!',
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    //delay:100
                                });
                                    $window.location.href = '#/';
                                    $window.location.reload();                                                                        
                                };

                                $scope.clickOnLogin = function($window){
                                    
                                    var width = $(window).width();
                                    if(width<1024){
                                       var url = '#/signin'; 
                                       $('.login-popup-cls').attr('data-target', '');
                                       $('a.login-popup-cls').attr('href', url)
                                    }
                                }  

                                $scope.clickOnSignup = function(){

                                    var width = $(window).width();
                                    if(width<1024){
                                       var url = '#/signup'; 
                                       $('.signup-popup-cls').attr('data-target', '');
                                       $('a.signup-popup-cls').attr('href', url)
                                    }
                                }

                                $scope.checkPassword = function(){

                                	$('#forgot_password_error').text("");
                                }

                                $scope.forgotPassword = function(){

                                	var url = 'api/v1/forgot-password-request?email='+$scope.email;

	                                $http.get(url).success(function(data) {
	                                  		console.log(data);
	                                  if(data.success=='1'){
	                                  	$('#forgotPasswordRequest')[0].reset();
	                                  	$('#forget-Modal').modal('hide');
	                                  	var pnotify = new PNotify({
					                                    title: 'Success',
					                                    text: data.message,
					                                    type: 'success',
					                                    styling: 'bootstrap3',				                                    
		                                });

	                                    $('#forgot_password_error').text(""); 
	                                    
	                                  }else{

	                                  	$('#forgot_password_error').text(data.message);
	                                  }
	                                }).error(function(error) {
	                                    $scope.error = error;            
	                                });
                                }  

                                var url = 'api/v1/benifits-to-display';

                                $http.get(url).success(function(data) {
                                  if(data.success=='1'){                                    
                                    $scope.benifits = $sce.trustAsHtml(data.result[0].benifits);
                                  }
                                }).error(function(error) {
                                    $scope.error = error;            
                                });   

                                var url = 'super-admin/register-json-list';

                                $http.get(url).success(function(data) {
                                  if(data.success==1){
                                    $scope.register_name = data.cms['name'];                                     
                                  }
                                }).error(function(error) {
                                    $scope.error = error;            
                                }); 

                                $('#required_base_currency').change(function(e){
                                    var selected_currency = $(this).val()?$(this).val():'';
                                    var selected_symbol   = $(this).val()?$('#required_base_currency option:selected').attr('data-symbol'):'';
                                    $window.localStorage.currency_value = selected_currency;
                                    $window.localStorage.currency_symbol = selected_symbol;                                    
                                });                                             

                                $scope.selected_currency = localStorage.currency_value;              
                            } 
                    }

                   
                    var footer = {
                       templateUrl: './layouts/footer1.html',
                       controller: function($scope, $http) {

                           $scope.emailv       = localStorage.emailv;
                           $scope.phonev       = localStorage.phonev;   

                           var url = 'super-admin/register-json-list';

                            $http.get(url).success(function(data) {
                              if(data.success==1){
                                $scope.register_name = data.cms['name'];                                     
                              }
                            }).error(function(error) {
                                $scope.error = error;            
                            });  
                       }                  
                    }

                    var sidediv = {
                       templateUrl: './layouts/adminsidebar.html',
                       controller: function($scope) {
                        console.log('$scope');
                       }                  
                    }

                    $stateProvider                                             
                        .state('/', {
                            url: '/',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/homePageView1.html',
                                    controller: 'HomePageController',
                                },
                                footer:footer
                            }
                        })
                        .state('about-us', {
                            url: '/about-us',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/about.html',
                                    controller: function AboutPageController($scope, $http, $sce){
                                        var api = 'https://api.getAddress.io/v2/uk/e2 6dr/100';
                                        $http.get(api).success(function(data) {console.log(data);

                                        });
                                        
                                        var url = 'super-admin/cms-json-list/1';

                                        $http.get(url).success(function(data) {console.log(data);
                                          if(data.success=='1'){
                                            $scope.title = data.cms.title;
                                            $scope.description = $sce.trustAsHtml(data.cms.description);
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });

                                    }
                                },
                                footer:footer
                            }
                        })
                        .state('contact', {
                            url: '/contact',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/contact.html',
                                    controller: 'ContactPageCtrl'
                                },
                                footer:footer
                            }
                        })
                        .state('testimonials', {
                            url: '/testimonials',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/testimonials.html',
                                    controller: 'TestimonialsPageCtrl'
                                },
                                footer:footer
                            }
                        })
                        .state('client-testimonial', {
                            url: '/client-testimonial',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/client-testimonial.html',
                                    controller: 'TestimoanialsSaveController'
                                },
                                footer:footer
                            }
                        })
                        .state('add-testimonial', {
                            url: '/add-testimonial',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/add-testimonial.html',
                                    controller: 'TestimonialsPageCtrl'
                                },
                                footer:footer
                            }
                        })
                        .state('edit-testimonial/:id', {
                            url: '/edit-testimonial/:id',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/edit-testimonial.html',
                                    controller: 'EditTestimonialsPageCtrl'
                                },
                                footer:footer
                            }
                        })
                        .state('faq_owners', {
                            url: '/faq_owners',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/faq_owners.html',
                                    controller: function FAQPageController($scope, $http, $sce){

                                        var url = 'super-admin/cms-json-list/4';

                                        $http.get(url).success(function(data) {console.log(data.cms);
                                          if(data.success=='1'){
                                            $scope.data = data.cms;
                                            $scope.title = data.cms.title;
                                            $scope.description = $sce.trustAsHtml(data.cms.description);
                                            if($('.container-fluid').hasClass('privacy-policy-cls')){
                                        		$('.container-fluid').removeClass('privacy-policy-cls').addClass('privacy-policy-nw-cls')
                                        	}
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });    
                                    }
                                },
                                footer:footer
                            }
                        })
                        .state('gdpr_policy', {
                            url: '/gdpr_policy',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/gdpr_policy1.html',
                                    controller: function FAQPageController($scope, $http, $sce){

                                        var url = 'super-admin/cms-json-list/7';

                                        $http.get(url).success(function(data) {console.log(data.cms);
                                          if(data.success=='1'){
                                            $scope.data = data.cms;
                                            $scope.title = data.cms.title;
                                            $scope.description = $sce.trustAsHtml(data.cms.description);
                                            if($('.container-fluid').hasClass('privacy-policy-cls')){
                                                $('.container-fluid').removeClass('privacy-policy-cls').addClass('privacy-policy-nw-cls')
                                            }
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });    
                                    }
                                },
                                footer:footer
                            }
                        })
                        .state('faq_holidaymakers', {
                            url: '/faq_holidaymakers',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/faq_holidaymakers.html',
                                    controller: function FAQPageController($scope, $http, $sce){

                                        var url = 'super-admin/cms-json-list/6';

                                        $http.get(url).success(function(data) {console.log(data.cms);
                                          if(data.success=='1'){
                                            $scope.data = data.cms;
                                            $scope.title = data.cms.title;
                                            $scope.description = $sce.trustAsHtml(data.cms.description);
                                            if($('.container-fluid').hasClass('privacy-policy-cls')){
                                                $('.container-fluid').removeClass('privacy-policy-cls').addClass('privacy-policy-nw-cls')
                                            }
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });    
                                    }
                                },
                                footer:footer
                            }
                        })
                         .state('privacy-policy', {
                            url: '/privacy-policy',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/privacypolicy.html',
                                    controller: function PrivacyPolicyPageController($scope, $http, $sce){

                                        var url = 'super-admin/cms-json-list/2';

                                        $http.get(url).success(function(data) {
                                          if(data.success=='1'){
                                            $scope.title = data.cms.title; 
                                            //setTimeout(function(){

                                            	$scope.description = $sce.trustAsHtml(data.cms.description);		
                                            	if($('.container-fluid').hasClass('privacy-policy-cls')){
                                            		$('.container-fluid').removeClass('privacy-policy-cls').addClass('privacy-policy-nw-cls')
                                            	}
                                            //},500);
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });   
                                    }
                                },
                                footer:footer
                            }
                        })
                          .state('terms-conditions', {
                            url: '/terms-conditions',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/termsofuse.html',
                                    controller: function TermsConditionsPageController($scope, $http, $sce){

                                        var url = 'super-admin/cms-json-list/3';

                                        $http.get(url).success(function(data) {
                                          if(data.success=='1'){
                                            $scope.title = data.cms.title;
                                            $scope.description = $sce.trustAsHtml(data.cms.description);
                                            if($('.container-fluid').hasClass('terms-cls')){
                                        		$('.container-fluid').removeClass('terms-cls').addClass('terms-nw-cls')
                                        	}
                                          }
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });
                                    }
                                },
                                footer:footer
                            }
                        })
                        .state('property-details/:id', {
                            url: '/property-details/:id',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/singlePageView.html',
                                    controller: 'SinglePropertyDetails',                                    
                                },
                                footer:footer
                            }                            
                        }).state('property-search', {
                            url: '/property-search',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/listPage.html',
                                    controller: 'PropertiesController',                                    
                                }
                            },
                            //params: {reload: false}                           
                        }).state('dashboard', {
                            url: '/dashboard',
                            views:{
                                header: header, 
                                content:{                                    
                                    templateUrl: './views/adminDashboard.html',
                                    controller: 'AdminDashBoardCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('owner-profile', {
                            url: '/owner-profile',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/ownerProfile.html',
                                    controller: 'OwnerProfileCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('add-property', {
                            url: '/add-property',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/add-property.html',
                                    controller: 'AddPropertyCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('edit-property/:id', {
                            url: '/edit-property/:id',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/edit-property.html',
                                    controller: 'EditPropertyCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('owner-properties', {
                            url: '/owner-properties',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/ownerPropertyListView.html',
                                    controller: 'OwnerPropertyListCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('properties-availability', {
                            url: '/properties-availability',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/owner-property-availability.html',
                                    controller: 'OwnerPropertyAvailabilityCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('property-enquiries', {
                            url: '/property-enquiries',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/ownerPropertyEnquiries.html',
                                    controller: 'PropertyEnquiriesCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('property-bookings', {
                            url: '/property-bookings',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/property-bookings.html',
                                    controller: 'PropertyBookingsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('cancel-bookings', {
                            url: '/cancel-bookings',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/cancel-bookings.html',
                                    controller: 'CancelPropertyBookingsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('preblock-property', {
                            url: '/preblock-property',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/preblock-date.html',
                                    controller: 'PreBlockPropertyCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('change-password', {
                            url: '/change-password',
                            views:{
                                header: header,
                                sidediv:sidediv,
                                content:{
                                    templateUrl: './views/change-password.html',
                                    controller: 'changePassword',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('notifications', {
                            url: '/notifications',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/notifications.html',
                                    controller: 'NotificationsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('email-verification', {
                            url: '/email-verification',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/signup-email-verification.html',
                                    controller: 'EmailVerificationCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('confirm-email-verification', {
                            url: '/confirm-email-verification',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/confirm-email-verification.html',
                                    controller: 'ConfirmEmailVerificationCtrl',                                    
                                },
                                footer:footer
                            }                            
                        }).state('mobile-verification', {
                            url: '/mobile-verification',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/mobile-verification-code.html',
                                    controller: 'MobileVerificationCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('invoices', {
                            url: '/invoices',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/invoices_latest.html',
                                    controller: 'InvoicesPageCtrl'                                                                      
                                },
                                footer:footer
                            }                            
                        })
                        .state('invoice-status', {
                            url: '/invoice-status',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/invoice-status.html',
                                    controller: function InvoicesPageController(){
                                        
                                    }                                                                      
                                },
                                footer:footer
                            }                            
                        })
                        .state('destinations', {
                            url: '/destinations',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/destinations.html',
                                    controller: 'destinationsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('holiday-essentials', {
                            url: '/holiday-essentials',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/holiday-essentials-latest.html',
                                    controller: 'holidayEssentialsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('deals', {
                            url: '/deals',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/deals.html',
                                    controller: 'dealsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('owner-deals', {
                            url: '/owner-deals',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/ownerDeals.html',
                                    controller: 'ownerDealsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('add-deal', {
                            url: '/add-deal',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/add-deal.html',
                                    controller: 'addOwnerDealsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('edit-deal/:id', {
                            url: '/edit-deal/:id',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/edit-deal.html',
                                    controller: 'editOwnerDealsCtrl',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('signin', {
                            url: '/signin',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/login.html',
                                    controller: 'LoginController',                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('book-now', {
                            url: '/book-now',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/book-now.html',
                                    controller: 'PropertyBooknowController',                                    
                                },
                                footer:footer
                            }                            
                        })                       
                        .state('signup', {
                            url: '/signup',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/signup.html',
                                    controller: function($http, $scope, $sce){

                                    	var url = 'api/v1/benifits-to-display';

		                                $http.get(url).success(function(data) {
		                                  if(data.success=='1'){                                    
		                                    $scope.benifits = $sce.trustAsHtml(data.result[0].benifits);
		                                  }
		                                }).error(function(error) {
		                                    $scope.error = error;            
		                                });
                                    },                                    
                                },
                                footer:footer
                            }                            
                        })
                        .state('booking-confirmation', {
                            url: '/booking-confirmation',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/booking-confirmation.html',
                                    controller: function BookingConfirmationPageController($scope,$stateParams, $location){
                                        //$scope.amount = $stateParams.amount;
                                        $scope.amount = $location.search().amount;
                                    }                                                                      
                                },
                                footer:footer
                            }                            
                        }).state('tmt-token', {
                            url: '/tmt-token',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/tmt-token.html',
                                    controller: 'accessTokenController',                                   
                                },
                                footer:footer
                            }                            
                        })
                        .state('view-email-confirmation', {
                            url: '/view-email-confirmation',
                            views:{
                                
                                content:{
                                    templateUrl: './views/view-client-enquiry-email.html',
                                    controller: function viewEnquiredEmail($scope,$stateParams, $location, $http){
                                        //$scope.amount = $stateParams.amount;
                                        var enq_id = $location.search().enq_id;
                                        var url = 'api/v1/view-email-enquiry-details?enq_id='+enq_id;

                                        $http.get(url).success(function(result) {
                                            
                                            $scope.enq  = result.data;
                                            $scope.src  = result.img_src;
                                            $scope.year = result.date;
                                             
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });
                                    }                                                                      
                                },
                                
                            }                            
                        })
                        .state('view-booking-email-details', {
                            url: '/view-booking-email-details',
                            views:{
                                
                                content:{
                                    templateUrl: './views/view-client-booking-email.html',
                                    controller: function viewEnquiredEmail($scope,$stateParams, $location, $http){
                                        //$scope.amount = $stateParams.amount;
                                        var booking_id = $location.search().booking_id;
                                        var url = 'api/v1/view-email-booking-details?booking_id='+booking_id;

                                        $http.get(url).success(function(result) {
                                            
                                            $scope.booking  = result.data;
                                            $scope.src  = result.img_src;
                                            $scope.year = result.date;
                                             
                                        }).error(function(error) {
                                            $scope.error = error;            
                                        });
                                    }                                                                      
                                },
                                
                            }                            
                        })
                        .state('forgot-password', {
                            url: '/forgot-password',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/forgot-password.html',
                                    controller: function forgotPasswordCtrl($http, $state, $scope, $location){

                                    	$scope.saveNewPassword = function(){
                                    		var user_id = $location.search().id
                                    		var params 	= {
                                    						'new_password':$scope.new_password, 
                                    						'confirm_password':$scope.confirm_password, 
                                    						'user_id':user_id};
                                    		console.log(user_id);
                                    		var url 	= 'api/v1/reset-owner-password';
                                    		$http.post(url, params).success(function(data) {
                                    		  console.log(data)			
			                                  if(data.success=='1'){                                    
			                                    $('#resetOwnerPassword')[0].reset();
			                                    $state.go('/', {}, { reload: true });
			                                    var pnotify = new PNotify({
				                                    title: 'Success',
				                                    text: data.message,
				                                    type: 'success',
				                                    styling: 'bootstrap3',				                                    
				                                });
			                                    $('#forgot_page_password_error').text("");
			                                  }else{
			                                  	
			                                  	$('#forgot_page_password_error').text(data.message);
			                                  	//$scope.error = data.message;
			                                  }
			                                }).error(function(error) {
			                                    $('#forgot_page_password_error').text("");
			                                });
                                    	}	
                                    },                                    
                                },
                                footer:footer
                            }                            
                        }).state('google-map', {
                            url: '/google-map',
                            views:{
                                header: header,
                                content:{
                                    templateUrl: './views/google-map.html',
                                    controller: function GoogleMapPageController($scope,$stateParams, $location){
                                          var myLatLng = {lat: -25.363, lng: 131.044};

                                          var map = new google.maps.Map(document.getElementById('property_details_map'), {
                                            zoom: 4,
                                            center: myLatLng
                                          });

                                          var marker = new google.maps.Marker({
                                            position: myLatLng,
                                            map: map,
                                            title: 'Hello World!'
                                          });
                                    }                                                                      
                                },
                                footer:footer
                            }                            
                        });
               
            });


 
        
})();