(function() {

    'use strict';

    var app = angular.module('directOwnersApp');

    if(localStorage.id){

        app.directive('uiTinymce', ['uiTinymceConfig', function (uiTinymceConfig) {
                uiTinymceConfig = uiTinymceConfig || {};
                var generatedIds = 0;
                return {
                    require: 'ngModel',
                    link: function (scope, elm, attrs, ngModel) {
                        var expression, options, tinyInstance,
                        updateView = function () {
                            ngModel.$setViewValue(elm.val());
                            if (!scope.$$phase) {
                                scope.$apply();
                            }
                        };
                        // generate an ID if not present
                        if (!attrs.id) {
                            attrs.$set('id', 'uiTinymce' + generatedIds++);
                        }

                        if (attrs.uiTinymce) {
                            expression = scope.$eval(attrs.uiTinymce);
                        } else {
                            expression = {};
                        }
                        options = {
                            // Update model when calling setContent (such as from the source editor popup)
                            setup: function (ed) {
                                var args;
                                ed.on('init', function (args) {
                                    ngModel.$render();
                                });
                                // Update model on button click
                                ed.on('ExecCommand', function (e) {
                                    ed.save();
                                    updateView();
                                });
                                // Update model on keypress
                                ed.on('KeyUp', function (e) {
                                    ed.save();
                                    updateView();
                                });
                                // Update model on change, i.e. copy/pasted text, plugins altering content
                                ed.on('SetContent', function (e) {
                                    if (!e.initial) {
                                        ed.save();
                                        updateView();
                                    }
                                });
                                if (expression.setup) {
                                    scope.$eval(expression.setup);
                                    delete expression.setup;
                                }
                            },
                            mode: 'exact',
                            elements: attrs.id,
                            browser_spellcheck : true,
                            branding: false,
                            plugins: [
                                'advlist autolink lists link image charmap print preview hr anchor pagebreak',
                                'searchreplace wordcount visualblocks visualchars code fullscreen',
                                'insertdatetime media nonbreaking save table contextmenu directionality',
                                'emoticons template paste textcolor colorpicker textpattern imagetools codesample toc help'
                            ],
                            toolbar1: 'undo redo | insert | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image',
                            toolbar2: 'print preview media | forecolor backcolor emoticons | codesample help',
                            image_advtab: true,
                            font_formats: 'Arial=arial,helvetica,sans-serif; Courier New=courier new,courier,monospace'
                        };
                        // extend options with initial uiTinymceConfig and options from directive attribute value
                        angular.extend(options, uiTinymceConfig, expression);
                        setTimeout(function () {
                            tinymce.init(options);
                        });


                        ngModel.$render = function () {
                            if (!tinyInstance) {
                                tinyInstance = tinymce.get(attrs.id);
                            }
                            if (tinyInstance) {
                                tinyInstance.setContent(ngModel.$viewValue || '');
                            }
                        };
                    }
                };
            }]);

        app.directive('fileModel', ['$parse', function ($parse) {
        return {
            restrict: 'A',
            
            link: function (scope, element, attrs) {
                var model = $parse(attrs.fileModel);
                var modelSetter = model.assign;
                element.bind('change', function () {
                    console.log('test img');
                    console.log(element[0].files);
                    angular.forEach(element[0].files, function (item) { 
                       // if(element[0].files[0].size < 50000){
                        modelSetter(scope, element[0].files[0]);
                        //}else{
                           // alert('image size is more');
                       // }
                    });
                });
                    }
                };
        }]);
        app.directive('ngFileModel', ['$parse', '$http',function ($parse, $http) {
        return {
            restrict: 'A',
            
            link: function (scope, element, attrs) {
                var model = $parse(attrs.ngFileModel);
                var isMultiple = attrs.multiple;
                var modelSetter = model.assign;
                element.bind('change', function () {
                    var values = [];
                    var formData = new FormData();
                    angular.forEach(element[0].files, function (item, i) {    
                    //console.log(item, 'item');  
                              
                        if(item.size<3000000){
                            values.push(item);    
                            formData.append('image_name['+i+']', item);
                            //values.push(item);
                            //scope.fileContainer.push(item);
                        }
                    });
                    
                    var url = 'api/v1/scan-multiple-files-virus';
                    $http({
                        method: 'POST', 
                        data: formData,
                        url: url,
                        enctype: 'multipart/form-data',
                        headers: {'Content-Type': undefined},
                        cache: false,
                        contentType: false,
                        processData: false,
                    })
                    .success(function(data) {
                        console.log(data, 'multiple scan result');
                       if(data.success==0){

                            $scope.myFile = '';
                            var pnotify1 = new PNotify({
                                                title: 'Error',
                                                text:  data.message,
                                                type: 'error',
                                                styling: 'bootstrap3',
                                                delay: 2000
                                            });
                       }else if(data.success==1){

                            var read_files = data.cleared_count;
                            
                            
                            for(var i=0; i<values.length;i++){ 
                                console.log(values[i], 'iiiii');                                
                                for(var j=0; j<data.cleared_count.length;j++){   

                                    console.log(data.cleared_count[j], 'jjjjj');
                                    if(data.cleared_count[j]==i){
                                        console.log(values[i], 'in side of if');
                                        scope.fileContainer.push(values[i]);
                                    }
                                    //$scope.fileContainer.splice(str,1);
                                }
                            }
                            var pnotify1 = new PNotify({
                                                title: 'Success',
                                                text:  data.message,
                                                type: 'success',
                                                styling: 'bootstrap3',
                                                delay: 2000
                                            });
                       }
                    })
                    .error(function(data) {
                        var pnotify1 =  new PNotify({
                                            title: 'Error',
                                            text:  data.message,
                                            type: 'error',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                        });
                    });
                    scope.$apply(function () {
                        if (isMultiple) {
                            modelSetter(scope, values);
                        } else {
                            modelSetter(scope, values[0]);
                        }
                    });
                });
                    }
                };
        }]);

        app.directive('customOnChange', ['$parse','$http', function ($parse, $http) {
            return {
                restrict: 'A',
                
                link: function (scope, element, attrs) {
                    var model = $parse(attrs.ngFileModel);
                    var isMultiple = attrs.multiple;
                    var modelSetter = model.assign;
                    element.bind('change', function () {
                        console.log('scan file image');

                        var values = [];
                        angular.forEach(element[0].files, function (item) {    
                                  
                        
                        console.log(item, ' scan file image');
                        var formData = new FormData();
                        formData.append('image_file', item);
                        var url = 'api/v1/scan-file-virus';
                            $http({
                                method: 'POST', 
                                data: formData,
                                url: url,
                                enctype: 'multipart/form-data',
                                headers: {'Content-Type': undefined},
                                cache: false,
                                contentType: false,
                                processData: false,
                            })
                            .success(function(data) {
                                console.log(data, 'scan result');
                               if(data.success==0){

                                    $scope.myFile = '';
                                    var pnotify1 = new PNotify({
                                                        title: 'Error',
                                                        text:  data.message,
                                                        type: 'error',
                                                        styling: 'bootstrap3',
                                                        delay: 2000
                                                    });
                               }else{
                                    var pnotify1 = new PNotify({
                                                        title: 'Success',
                                                        text:  data.message,
                                                        type: 'success',
                                                        styling: 'bootstrap3',
                                                        delay: 2000
                                                    });
                               }
                            })
                            .error(function(data) {
                                var pnotify1 =  new PNotify({
                                                    title: 'Error',
                                                    text:  data.message,
                                                    type: 'error',
                                                    styling: 'bootstrap3',
                                                    delay: 2000
                                                });
                            }); 

                        });
                    });
                }
            };
        }]);

        app.directive("initDealForm", function ($parse, $location) {
            return {
              link: function (scope, element, attrs) {
                
                console.log(scope);               
                
                setTimeout(function(){
                    console.log($('#deal_from_date').val());
                    scope.from_date1    = new Date($('#deal_from_date').val());
                    scope.to_date1      = new Date($('#deal_to_date').val());
                    scope.from_time     = $('#deal_from_time').val();
                    scope.to_time       = $('#deal_to_time').val();                
                },200);
                
              }
            };
        });

        app.directive('onlyDigits', function () {
            return {
            require: 'ngModel',
            restrict: 'A',
            link: function (scope, element, attr, ctrl) {
                function inputValue(val) {
                  if (val) {
                    var digits = val.replace(/[^0-9]/g, '');

                    if (digits !== val) {
                      ctrl.$setViewValue(digits);
                      ctrl.$render();
                    }
                    return parseInt(digits,10);
                  }
                  return undefined;
                }            
                ctrl.$parsers.push(inputValue);
              }
        };
    });

    }  

    app.controller('UserProfileCtrl', function($scope, $http, $location){
     if(localStorage.id){
        $http.post('api/v1/user-details?user_id='+localStorage.id).success(function(data){


            $scope.user            = data.user_details;
            $scope.s3_path         = data._s3_path;
            if(data.user_details.profile_pic){
                $scope.profile_pic = data.user_details.profile_pic;
            }else{
                $scope.profile_pic = 'default.jpg';
            }
                
            // if(!data.user_details.tmt_api_token){

            //     $('.add-property-cls').click(false);
            //     $('.add-property-cls').click(function (){
            //     var pnotify1 = new PNotify({
            //                             title: 'Error',
            //                             text:  'Please add TMT Payment Token in My Profile to continue',
            //                             type: 'error',
            //                             styling: 'bootstrap3',
            //                             delay: 2000
            //                         });
            //     });
            // }else if(!data.user_details.tmt_api_token && !data.user_details.paypal_email){
            //     $('.add-property-cls').click(false);
            //     $('.add-property-cls').click(function (){
            //     var pnotify1 = new PNotify({
            //                             title: 'Error',
            //                             text:  'Please add Paypal business email in My Profile to continue',
            //                             type: 'error',
            //                             styling: 'bootstrap3',
            //                             delay: 2000
            //                         });
            //     });
            // }

            
        }).error(function(error){

            console.log(error);
        });

        $scope.status = localStorage.status;

        
            if(localStorage.status=='inactive'){           
                $('.add-property-cls').click(false);                        
                $('.add-property-cls').click(function (){                         
                    var url = 'api/v1/invoice-renewal/'+localStorage.id;
                    $http({method : 'get',url:url})
                    .success(function(data, status) {
                        var status = data.user_details.status;
                        if(status=='inactive'){
                            var pnotify1 = new PNotify({
                                        title: 'Error',
                                        text:  'Your account is expired, Please renewal your account and continue!',
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                        }
                    })
                    .error(function(data, status) {
                        
                    });                    
                });
            }
    }else{
        $location.url('/');
    }
               
    });

    app.controller('AdminDashBoardCtrl', function($http, $scope, $location) {

      if(localStorage.id){  
        var owner_id = localStorage.id;       
        var url = 'api/v1/onwer-dashboard-stats?owner_id='+owner_id;
            $http({method : 'post',url:url})
            .success(function(data, status) {console.log(data.properties_details);
            	$scope.result = data.properties_details;
            })
            .error(function(data, status) {
                console.log(data+' : '+status);
            });
        
      }else{
        $location.url('/');
      }

    });

    app.controller('OwnerProfileCtrl', function($scope, $http, $location, $window, $state) {
     if(localStorage.id){
        $scope.formatDate = function(date){ 
            var dateOut = new Date(date.replace(/-/g, "/"));
            return dateOut;
        };
        
        $scope.ph_numbr = /^(\+?(\d{1}|\d{2}|\d{3})[- ]?)?\d{3}[- ]?\d{3}[- ]?\d{4}$/;
            
        var user_id = localStorage.getItem("id");
        var url = 'api/v1/user-details?user_id='+user_id;
        $http.post(url).success(function(data) {
            if(data.user_details){
                
                $scope.user_details   = data.user_details;
                $scope.s3_path        = data._s3_path;
                $('#prof_phone').trigger('keyup');
                $('#prof_phone').val(data.user_details.phone); 
                $('#prof_landline').trigger('keyup');
                $('#prof_landline').val(data.user_details.landline);                
                if(data.user_details.profile_pic){
                    $scope.profile_pic = data.user_details.profile_pic;
                }else{
                    $scope.profile_pic = 'default.jpg';
                }
            }


        }).error(function(error) {
            $scope.error = error;
        });
        $scope.submitted = true;
        $scope.myFunc = function () {

            var url = 'api/v1/update-user?'+$('#profile-form').serialize();
            var formData = new FormData();

            $.each(jQuery('#filer_input2')[0].files, function(i, file) {
                formData.append('profile_pic', file);
            });            
            
            $http({
                method : 'post',
                url:url,
                headers: {
                    "Content-Type": undefined
                },
                cache: false,
                contentType: false,
                processData: false,
                data:formData,
            }).success(function(data, status) {

                $state.go($state.current, {}, { reload: true });
                var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',                                    
                                });
                //$window.location.reload();
            }).error(function(data, status) {
                var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',                                    
                                });
            }); 
        }
      }else{
        $location.url('/');
      }   

    });

    app.controller('OwnerPropertyListCtrl', function($scope, $http, $location, $window, $stateParams, $sce, $state, $filter) {
       if(localStorage.id){ 
        
        $scope.prop_status = $location.search().status; 
        var url;     
        var user_id                  = localStorage.getItem("id");
        var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
        var selected_currency_symbol = selected_currency_name?localStorage.currency_symbol:'€';
        if($location.search().status =='active'){
             url = 'api/v1/all-user-properties?user_id='+user_id+'&status='+$location.search().status+'&verified=yes'+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        }else if($location.search().status=='inactive'){
             url = 'api/v1/all-user-properties?user_id='+user_id+'&status='+$location.search().status+'&verified=no'+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        }else{
             url = 'api/v1/all-user-properties?user_id='+user_id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        }

        $scope.closePropertyPreviewModal = function(){

            $('#propertyPriviewModal').modal('hide');
            $state.go($state.current, {}, { reload: true });
        }       
        
        $http.post(url).success(function(data) {
            if(data.properties_details){                
                $scope.prop_details   = data.properties_details;
                $scope._s3_path       = data._s3_path;
            }
        }).error(function(error) {
                $scope.error = error;
        });

        $('#required_base_currency').change(function(e){
            url = 'api/v1/all-user-properties?user_id='+user_id+'&currency_name='+$(this).val()+'&currency_symbol='+$('#required_base_currency option:selected').attr('data-symbol');
            $http.post(url).success(function(data) {
                if(data.properties_details){                
                    $scope.prop_details   = data.properties_details;
                    $scope._s3_path       = data._s3_path;
                }
            }).error(function(error) {
                    $scope.error = error;
            });
        });

        $scope.myFunc = function () {
            if($location.search().status){
                $location.search('status', null);
            }
            var prop_status = $scope.myValue;
            var url;
            if(prop_status == ''){
                url = 'api/v1/all-user-properties?user_id='+user_id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            }else if(prop_status=='active'){

                url = 'api/v1/all-user-properties?user_id='+user_id+'&status='+prop_status+'&verified=yes'+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            }else if(prop_status=='inactive'){

                url = 'api/v1/all-user-properties?user_id='+user_id+'&status='+prop_status+'&verified=no'+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            }            
            $http.post(url).success(function(data) {console.log(data.properties_details);
                if(data.success=='1'){
                    $scope.prop_details   = data.properties_details;
                    $scope._s3_path       = data._s3_path;
                }else{
                    $scope.prop_details = '';
                }
            }).error(function(error) {
                $scope.error = error;
            });
        }

        $scope.status = localStorage.status;
            
        $scope.deleteProperty = function(id){
            var url = 'api/v1/delete-property?property_id='+id;
            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {

                $http.post(url).success(function(data) {
                //console.log(data);
                    if(data.success=='1'){

                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: 'Property Deleted Successfully',
                                        type: 'success',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                        
                    }else{
                        var pnotify = new PNotify({
                                        title: 'Property not deleted',
                                        text: 'Property not deleted please try again!',
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                    }
                    $state.go('owner-properties', {}, {reload: true});
                    $(".ui-pnotify-modal-overlay").remove();
                }).error(function(error) {
                    $scope.error = error;
                });

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });   
        }

        $scope.previewProperty = function(id) {

            var url = 'api/v1/property-details/'+id;
            $http.get(url).success(function(data) {

                $scope.property                       = data.property;
                $scope._s3_path                       = data._s3_path;
                $scope.security_deposit_amount        = data.property.property_details[0].security_deposit_amount?data.property.property_details[0].security_deposit_amount:0;
                $scope.owner_security_deposit_amount  = data.property.property_details[0].security_deposit_amount;
                $scope.prop_description               = $sce.trustAsHtml(data.property.property_details[0].description);
                $scope.paypal_booking_amount          = '';
                  if(data.property.property_details[0].profile_pic){
                    $scope.owner_pic = 'uploads/profile_pics/'+data.property.property_details[0].profile_pic; 
                  }else{
                    $scope.owner_pic = 'uploads/profile_pics/default.jpg';
                  }
                $scope.igallery = [];
                $scope.igallery = data.property.property_gallery;                      
                $scope.igallery.push({'image_name': data.property.property_details[0].property_image});
                  if($scope.igallery.length){
                    var img = [];
                    for(var i=0; i<$scope.igallery.length;i++){            
                     
                      var title = data.property.property_details[0].property_title;
                      var str = title.replace(/\s+/g, '-').toLowerCase();
                      var url;
                                         
                        if($scope.igallery[i].image_name){
                            url = {'image':'uploads/property_images/'+data.property.property_details[0].property_id+'/'+$scope.igallery[i].image_name, 'thumb':'uploads/property_images/'+data.property.property_details[0].property_id+'/'+$scope.igallery[i].image_name};                                    
                        }else{
                            url = {'image':'uploads/property_images/default.jpg', 'thumb':'uploads/property_images/default.jpg'};
                        }
                      img.push(url);
                    }
                  }else{
                    var img = [];

                    var url = {'image':'uploads/property_images/default.jpg', 'thumb':'uploads/property_images/default.jpg'};
                    
                    img.push(url);
                  }                    
                $scope.owner_id                     = data.property.property_details[0].id;
                $scope.owner_paypal_email           = data.property.property_details[0].paypal_email;
                $scope.gallery                      = img;
                $scope.rates                        = data.property.property_rates;
                $scope.property_testimonials        = data.property.property_testimonials;
                $scope.deals                        = data.property.deals;

                if(data.property.property_details[0].email!=""){
                    $scope.email1 = data.property.property_details[0].email;
                    var email = $scope.email1;
                    $scope.mask_email = email.replace(/.+(?=@)/g, '*'.repeat(email.replace(/@.+/g, '').length));
                }else{
                    $scope.mask_email = "";
                }

                var initialize = function(){
                    var map = new google.maps.Map(document.getElementById('map'), {
                      zoom: 13,
                      center: new google.maps.LatLng(data.property.property_details[0].latitude, data.property.property_details[0].longitude),
                    });

                    var latitude  = data.property.property_details[0].latitude;
                    var longitude = data.property.property_details[0].longitude;
                    
                    createMarker(data.property.near_by, map, data.property.property_details[0].property_id, latitude, longitude);      
                     
                }            

            var pblockeDatesUrl = 'api/v1/blocked-dates/'+id;
            $http.get(pblockeDatesUrl).success(function(result){                  
                var datesArray  = [];             
                for(var i=0; i<result.details.length; i++){                                          
                    
                    var startDate   = new Date(result.details[i].start_date);
                    var endDate     = new Date(result.details[i].end_date);                        

                    while (startDate <= endDate) {
                        datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/d'));
                        startDate.setDate(startDate.getDate() + 1);
                    }
                }
                $("#availability_datepicker").datepicker({ 
                      firstDay: 1,
                      todayHighlight: true,
                      beforeShowDay: highlightDays,
                      numberOfMonths: 2,
                      minDate: 0,
                      setDate: new Date()
                });
                function highlightDays(date) {
                  for (var i = 0; i < datesArray.length; i++) {
                      if (new Date(datesArray[i]).toString() == date.toString()) {
                          return [true, 'ui-state-holiday'];
                      }
                  }
                  return [true];
               }
              
            }).error(function(error){
              console.log(error);
            });        


        var createMarker = function(markerData, map, property_id, nlat, nlng){                 

            var markerLength = markerData.length;
            
            if(markerLength){

                for(var i=0; i<markerLength; i++){

                    var markerIcon = '';
                    
                    if(markerData[i].property_id==property_id){

                      markerIcon = 'uploads/location-ping.png';
                    }else{
                      markerIcon = 'uploads/location-ping-orange.png';
                    }
                    
                    var image = markerData[i].property_image;
                    if(image){
                      var img_path = "uploads/property_images/"+markerData[i].property_id+"/"+image;
                    }else{
                      var img_path = "uploads/property_images/default.jpg";
                    }

                    var markerContent = '<div class="col-md-12 col-sm-12 map-property single-property-map-icon" ng-repeat="prop in properties" ng-if="properties!=0">'+ 
                            '<a ng:href="#/property-details/'+markerData[i].property_id+'">'+
                           '<div class="vp-pd-side-product">'+
                            '<div class="vp-pd-side-product-inner">'+
                                '<img src='+img_path+' default-img>'+
                                '<div class="vp-pd-side-product-inner-content">'+
                                '<div class="vp-pd-side-product-inner-details">'+
                                    '<h3 class="vp-caption-heading">'+markerData[i].property_title+'</h3>'+
                                '</div>'+   
                                '<div class="col-md-8 col-xs-8">'+
                                    '<p class="vp-para-book">'+markerData[i].space_type+'</p>'+   
                                '</div>'+
                                '<div class="col-md-4 col-xs-4 text-center">'+
                                    '<p class="vp-para-book"><span>'+markerData[i].guest_limit+'</span>guests</p>'+ 
                                '</div>'+
                                '<div class="col-md-12 col-xs-12 vp-pd-verified">'+
                                    '<p class=""><span>Verified</span> <label><i class="fa fa-eur" aria-hidden="true"></i><b>'+markerData[i].standard_rate_per_week+'</b>/Week</label></p>'+
                                '</div></div></div></div></a></div>';
                    if(markerData[i].latitude && markerData[i].longitude){

                        var near_by_lat = markerData[i].latitude;
                        var near_by_lng = markerData[i].longitude;
                    }else{

                        var near_by_lat = nlat;
                        var near_by_lng = nlng;
                    }            
                                                
                    var marker = new google.maps.Marker({
                      position: new google.maps.LatLng(near_by_lat, near_by_lng),
                      map: map,
                      icon:markerIcon,
                      content:markerContent
                    });
                                 

                    var infowindow = new google.maps.InfoWindow();

                    google.maps.event.addListener(marker, 'click', function(){                     
                            
                        infowindow.setContent(this.content);                    
                        infowindow.open(map, this);
                        
                    });             
                    
                }
            }else{
                var markerIcon = 'uploads/location-ping.png';
                var marker = new google.maps.Marker({
                  position: new google.maps.LatLng(nlat, nlng),
                  map: map,
                  icon:markerIcon                  
                });
                    
            }  
             
        }

        $('#loadMap').click(function(){
            $("#map").animate({"height" : "380px"}, 10,function(){
                initialize();
            });
        });

        });     

       }         

     }else{
        $location.url('/');
     }
        
    });


    app.controller('AddPropertyCtrl', function($scope, $http, $location, $window, $state){
    $scope.fileContainer = [];
    console.log($('.required_base_currency option:selected').val(), 'add prop selected currency');
    $scope.currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
   if(localStorage.id && localStorage.status=='active'){

        if(document.URL.indexOf("reloaded")==-1)
        {
            var url = document.URL+"?reloaded";
            location = url;
            location.reload(true);
        }

        $('.prop_standard_rate').keyup(function(){

            var standard_rate_per_day  = $('#standard_rate_per_day').val();
            var standard_rate_per_week = $('#standard_rate_per_week').val();
            if(standard_rate_per_day){
                $('.standard_day_rate').show();
            }

            if(standard_rate_per_week){
                $('.standard_week_rate').show();
            }
            $http.get('api/v1/get-currency-rate?currency_name=usd', {cache:true})
            .success(function(data){
                var currency_rate                 = data.currency_rate;
                var standard_rate_per_day_span    = standard_rate_per_day*currency_rate;
                $('.standard_rate_per_day_usd').text(standard_rate_per_day_span.toFixed(2));

              
                var standard_rate_per_week_span    = standard_rate_per_week*currency_rate;
                $('.standard_rate_per_week_usd').text(standard_rate_per_week_span.toFixed(2));
            }).error(function(){

            });

            $http.get('api/v1/get-currency-rate?currency_name=gbp', {cache:true})
            .success(function(data){
                var currency_rate                  = data.currency_rate;
                var standard_rate_per_week_span    = standard_rate_per_week*currency_rate;
                $('.standard_rate_per_week_gbp').text(standard_rate_per_week_span.toFixed(2));

                var standard_rate_per_day_span    = standard_rate_per_day*currency_rate;
                $('.standard_rate_per_day_gbp').text(standard_rate_per_day_span.toFixed(2));
            }).error(function(){

            });
            $('#before_standard_rate_per_day').val(standard_rate_per_day);
            $('#before_standard_rate_per_week').val(standard_rate_per_week);
        });

        $('.prop_specific_rate').keyup(function(){

            var specific_rate_per_day  = $('#rate_per_day').val();
            var specific_rate_per_week = $('#rate_per_week').val();
            if(specific_rate_per_day){
                $('.specific_day_rate').show();
            }

            if(specific_rate_per_week){
                $('.specific_week_rate').show();
            }
            $http.get('api/v1/get-currency-rate?currency_name=usd', {cache:true})
            .success(function(data){
                var currency_rate                 = data.currency_rate;
                var specific_rate_per_day_span    = specific_rate_per_day*currency_rate;
                $('.specific_rate_per_day_usd').text(specific_rate_per_day_span.toFixed(2));

              
                var specific_rate_per_week_span    = specific_rate_per_week*currency_rate;
                $('.specific_rate_per_week_usd').text(specific_rate_per_week_span.toFixed(2));
            }).error(function(){

            });

            $http.get('api/v1/get-currency-rate?currency_name=gbp', {cache:true})
            .success(function(data){
                var currency_rate                  = data.currency_rate;
                var specific_rate_per_day_span    = specific_rate_per_day*currency_rate;
                $('.specific_rate_per_day_gbp').text(specific_rate_per_day_span.toFixed(2));

                var specific_rate_per_week_span    = specific_rate_per_week*currency_rate;
                $('.specific_rate_per_week_gbp').text(specific_rate_per_week_span.toFixed(2));
            }).error(function(){

            });
            $('#before_rate_per_day').val(specific_rate_per_day);
            $('#before_rate_per_week').val(specific_rate_per_week);
        });
        
        $(document).on('change','#required_base_currency', function(){
            
            var selected_currency   = $(this).val()?$(this).val():'eur';
            var selected_symbol     = selected_currency?$('#required_base_currency option:selected').attr('data-symbol'):'';
            var standard_rate_per_day  = $('#before_standard_rate_per_day').val();
            var standard_rate_per_week = $('#before_standard_rate_per_week').val();
            
            var specific_rate_per_day  = $('#before_rate_per_day').val();
            var specific_rate_per_week = $('#before_rate_per_week').val();
            var security_deposit       = $('#security_deposit_amount').val();
            $scope.currency_name    = selected_currency;
            $scope.currency_symbol  = selected_symbol;
            var data = 'currency_name='+selected_currency+'&currency_symbol='+selected_symbol;//{'currency_name': selected_currency, 'currency_symbol': selected_symbol};
            $http.get('api/v1/get-currency-rate?'+data).success(function(result){
                var currency_rate   = result.currency_rate?result.currency_rate:'';
                var rate_per_day    = standard_rate_per_day*currency_rate;
                var rate_per_week   = standard_rate_per_week*currency_rate;

                var srate_per_day               = specific_rate_per_day*currency_rate;
                var srate_per_week              = specific_rate_per_week*currency_rate;
                var sdeposit                    = security_deposit*currency_rate;
                $scope.standard_rate_per_day    = rate_per_day.toFixed(2);
                $scope.standard_rate_per_week   = rate_per_week.toFixed(2);

                $scope.rate_per_day             = srate_per_day.toFixed(2);
                $scope.rate_per_week            = srate_per_week.toFixed(2);
                $scope.security_deposit_amount  = sdeposit.toFixed(2);

            }).error(function(currency_error){

            });
        });

        $http.post('api/v1/user-details?user_id='+localStorage.id, {cache:true})
        .success(function(data){
        
            var today = new Date();
            $scope.arrival_time = new Date();
            $scope.departure_time = new Date();
            $scope.propDateFormat = 'yyyy-MM-dd';
            $scope.availableDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: today,
                maxDate: new Date(2030, 5, 22)
            };
            $scope.expireDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: today,
                maxDate: new Date(2030, 5, 22)
            };
            $scope.availableDatePopup = {
                opened: false
            };
            $scope.expireDatePopup = {
                opened: false
            };
            $scope.ChangeExpiryMinDate = function(availableDate) {
                if (availableDate != null) {
                    var expiryMinDate = new Date(availableDate);
                    $scope.expireDateOptions.minDate = expiryMinDate;
                    $scope.end_date = expiryMinDate;
                    setTimeout(function(){
                      if($scope.end_date){
                        $('#end_date').val('');
                      }
                    },0);
                }
            };
            $scope.ChangeExpiryMinDate();
            $scope.OpenAvailableDate = function() {
                $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
            };
            $scope.OpenExpireDate = function() {
                $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
            };     

            var checkboxes = $("input[type='checkbox']"),
                    submitButt = $("button[name='amenityBtn']");

            checkboxes.click(function() {
                console.log('checkboxes click test');
                if($("input[type='checkbox']:checked").length>0){
                    $scope.amenityErr = '';
                    submitButt.prop("disabled", false);
                }else{
                    $scope.amenityErr = 'Select any 1 amenity';
                    submitButt.prop("disabled", true);
                }
            });    
            
            $scope.space_type        = ['Apartment','Chalet','Cottage','Villa'];
            $scope.sts               = $scope.space_type[0];
            $scope.guest_limit       = ['1','2', '3', '4', '5', '6', '7', '8'];
            $scope.single_room       = ['1','2','3','4','5','6','7','8'];
            $scope.double_room       = ['1','2','3','4','5','6','7','8']; 
            $scope.twin_room         = ['1','2','3','4','5','6','7','8']; 
            $scope.other_room        = ['1','2','3','4','5','6','7','8']; 
            $scope.bathroom          = ['Any','1','2','3','4','5','6','7','8'];
            $scope.minimum_stay      = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];
            $scope.prop_minimum_stay = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];
            $('.property-back').click(function(){
               
                var indexval = $("div.bhoechie-tab-content.active").attr('data-index');                
                var input_lat = $('#latitude').val();
                var input_lng = $('#longitude').val();
                var lat = input_lat?input_lat:'37.090906';
                var lng = input_lng?input_lng:'-8.7591310999'; 

                if(indexval==1){
                    
                    adminPropertyMap(lat, lng);    
                }               
                
            });

            $('.property-continue').click(function(){

                var index       = parseInt($(this).attr('data-btn-index'))+1;
                console.log(index+' index');                 
                var input_lat   = $('#latitude').val();
                var input_lng   = $('#longitude').val();
                var lat         = input_lat?input_lat:'37.090906';
                var lng         = input_lng?input_lng:'-8.7591310999';

                if(index==1){
                    
                    adminPropertyMap(lat, lng);    
                }                

            });

            var adminPropertyMap = function(klat, klng){

                
                var mapOptions = {
                    zoom: 10,
                    center: new google.maps.LatLng(klat, klng),
                    mapTypeId: google.maps.MapTypeId.TERRAIN
                }

                $scope.map = new google.maps.Map(document.getElementById('map'), mapOptions);
                
                var infoWindow = new google.maps.InfoWindow();
                 
                var autocomplete = new google.maps.places.Autocomplete((document.getElementById('address')), {
                        types: ['geocode']
                });

                  

                google.maps.event.addListener(autocomplete, 'place_changed', function () {
             
                 var place = autocomplete.getPlace();
                 var latlng = place.geometry.location;
                 if (place.geometry.viewport) {
                    $scope.map.fitBounds(place.geometry.viewport);
                 }else {
                    $scope.map.setCenter(place.geometry.location);
                    $scope.map.setZoom(17);  
                }

                 geocodePosition(latlng);

                 document.getElementById("latitude").value = place.geometry.location.lat();
                 document.getElementById("longitude").value = place.geometry.location.lng();
                 marker.setPosition(latlng);
                 $scope.map.setCenter(place.geometry.location);         
                });

                var marker = new google.maps.Marker({
                    map: $scope.map,
                    icon:'uploads/location-ping.png',
                    position: new google.maps.LatLng(klat, klng),
                    draggable:true,
                });

                google.maps.event.addListener(marker, 'dragend', function (event) {//alert(this.getPosition().lat());
                    document.getElementById("latitude").value = event.latLng.lat();
                    document.getElementById("longitude").value = event.latLng.lng();
                    $scope.map.setCenter(marker.getPosition());
                    geocodePosition(marker.getPosition());
                });           
                            

                var country1, city1, state1;
                var geocodePosition = function(pos) 
                {  
                   //var firstResult = $(".pac-container .pac-item:first").text();  
                   var geocoder = new google.maps.Geocoder();
                   geocoder.geocode
                    (
                        {latLng: pos },
                        //latLng: pos
                     
                        function(results, status) 
                        {
                            if (status == google.maps.GeocoderStatus.OK) 
                            {   
                                var placeName = results[0].address_components[0].long_name;                     

                                if(results[0]) {

                                    for(var i = 0; i < results[0].address_components.length; i++) {
                                      
                                      if(results[0].address_components[i].types[0] == "country") {
                                            
                                            var country = results[0].address_components[i].long_name;                                                                    
                                            
                                            $('#city').focus();
                                            $('#state').focus();
                                            $('#town').focus();
                                            $('#street_name').focus();
                                            $('#area_code').focus();
                                            $('#floor_name').focus();
                                            $('#house_no').focus();
                                            $('#country').val(country);
                                            $scope.country = country;

                                      }
                                        if(results[0].address_components[i].types[0] == "locality") {
                                            var city= results[0].address_components[i].long_name;                                     
                                            $scope.city = city;
                                            $('#city').val(city);
                                        }
                                        if(results[0].address_components[i].types[0] == "postal_code") {
                                            var postal_code= results[0].address_components[i].long_name;//console.log(postal_code);                                        
                                            $('#area_code').val(postal_code);
                                        }
                                        if(results[0].address_components[i].types[0] == "administrative_area_level_1") {
                                            var state= results[0].address_components[i].long_name;                                        
                                            $scope.state = state;
                                            $('#state').val(state);
                                        }                         
                                    
                                    }
                                }
                                
                            }                     
                        }
                    );
                }
            }

            
                   
	        $scope.onChangeAddress = function(){

	            console.log(country1+' : '+city1+' : '+state1);
	        }  
	        
	        $scope.openInfoWindow = function(e, selectedMarker){
	            e.preventDefault();
	            google.maps.event.trigger(selectedMarker, 'click');
	        }

            var countryUrl = 'api/v1/all-countries';
            $http.get(countryUrl).success(function(data) {
                $scope.countries = data.countries;
                $scope.selectedCtry = $scope.countries[0].country;
            }).error(function(error) {
                $scope.error = error;
            });
            
            
            $(document).on('click','.delete_gallery_img',function(){

                var li_str = $(this).parents("li");
                (new PNotify({
                    title: 'Are you sure to want to delete?',
                    icon: 'glyphicon glyphicon-question-sign',
                    hide: false,
                    confirm: {
                      confirm: true
                    },
                    buttons: {
                      closer: false,
                      sticker: false
                    },
                    history: {
                      history: false
                    },
                    addclass: 'stack-modal',
                    stack: {
                      'dir1': 'down',
                      'dir2': 'right',
                      'modal': true
                    }
                })).get().on('pnotify.confirm', function() {                    
                    var str = li_str.index();                  
                    $scope.fileContainer.splice(str,1);
                    li_str.remove();

                }).on('pnotify.cancel', function() {
                    $(".ui-pnotify-modal-overlay").remove();
                });
                
            });

            $('.property-continue').click(function(){   
                var index  = parseInt($(this).attr('data-btn-index'))+1;  
                
                if(index==1){

                    $( "#loading-image" ).removeProp("display");
                    $( ".step_one_c" ).prop( "disabled", true );
                    
                    var data;
                    var formFileData = new FormData($('#addProperty1')[0]);                    
                    
                    formFileData.append("step1",1);                    
                
                    
                    if($scope.myFile){

                        formFileData.append('main_image_name', $scope.myFile);
                    }

                   
                    if($scope.fileContainer) {   
                        for(var i=0; i<$scope.fileContainer.length; i++){
                            if($scope.fileContainer[i].size < 3000000){

                                formFileData.append('image_name['+i+']', $scope.fileContainer[i]);    
                            }                        
                        }
                    }
                    
                    var formSerializedData = 'user_id='+localStorage.id+'&'+$('#addProperty1').serialize()+'&';        
                    
                    var propertyUrl = 'api/v1/add-propery-step-one';

                    $http({
                        method: 'POST', 
                        data: formFileData,
                        url: propertyUrl,
                        enctype: 'multipart/form-data',
                        headers: {'Content-Type': undefined},
                        cache: false,
                        contentType: false,
                        processData: false,                           
                    }).success(function(data) {
                        $('#loading-image').hide();
                        //alert(data.success);
                        if(data.success==0){
                            var pnotify = new PNotify({
                                      title: 'Error',
                                      text: data.message,
                                      type: 'error',
                                      styling: 'bootstrap3',
                                      delay: 4000
                                  });
                            return false;
                        }else if(data.success==1){
                            $(".property_id").val(data.property_id);
                            $( ".step_one_c" ).prop( "disabled", false );
                            
                            $('.property_rate_btn').attr('disable', false);
                            $('div.bhoechie-tab-menu>div.list-group>a').siblings('a.active').removeClass("active");
                            $('div.bhoechie-tab-menu>div.list-group>a').eq(index).addClass("active");     
                            $("div.bhoechie-tab-content").removeClass("active");
                            $("div.bhoechie-tab-content").eq(index).addClass("active").attr('data-index', index);
                            $("html, body").animate({ scrollTop: 0 }, "slow");   
                        }else{
                            $(".property_id").val(data.property_id);
                            $( ".step_one_c" ).prop( "disabled", false );
                        }
                        
                    }).error(function(error) {console.log(error);
                        var pnotify = new PNotify({
                                            title: 'Property not added',
                                            text: 'Property not added please try again!',
                                            type: 'error',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                          });

                    });                   
                }
             });
            $scope.addProperty = function(){

                var formFileData = new FormData();

                if($scope.myFile){

                    formFileData.append('main_image_name', $scope.myFile);
                }

                
                if($scope.fileContainer) {   
                    for(var i=0; i<$scope.fileContainer.length; i++){
                        if($scope.fileContainer[i].size < 3000000){

                            formFileData.append('image_name['+i+']', $scope.fileContainer[i]);    
                        }                        
                    }
                }

                //formFileData.append('main_image_name', $scope.fileContainer[0]);

                var formSerializedData = 'user_id='+localStorage.id+'&'+$('#addProperty1').serialize()+'&'+$('#addProperty2').serialize()+'&'+$('#addProperty3').serialize()+'&'+$('#addProperty4').serialize()+'&verified=no&status=inactive';        
                var input_data = $("#addProperty5").serialize();
                var url_root = 'api/v1/add-propery-step-five';
                $.post(url_root,input_data,function(response){
                    if(response.success==0){
                            var pnotify = new PNotify({
                                            title: 'Property not added',
                                            text: 'Property not added please try again!',
                                            type: 'error',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                          });
                        }else if(response.success==1){
                            var pnotify = new PNotify({
                                            title: 'Property added',
                                            text: 'Property added successfully!',
                                            type: 'success',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                          });    
                            $location.url('owner-properties');
                            window.location.href = "#/owner-properties";
                        }
                });
            }
        //}
     });
    }else{

        $location.url('/');
    }

    });

    app.controller('EditPropertyCtrl', function($scope, $http, $stateParams, $window, $location, $filter){
      if(localStorage.id && localStorage.status=='active'){

        var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
        var selected_currency_symbol = localStorage.currency_symbol?localStorage.currency_symbol:'€';
        $scope.currency_name         = selected_currency_name;
        

        $('.prop_standard_rate').keyup(function(){
            console.log('here in edit prop');
            var standard_rate_per_day  = $('#standard_rate_per_day').val();
            var standard_rate_per_week = $('#standard_rate_per_week').val();
            if(standard_rate_per_day){
                $('.standard_day_rate').show();
            }

            if(standard_rate_per_week){
                $('.standard_week_rate').show();
            }
            $http.get('api/v1/get-currency-rate?currency_name=usd', {cache:true})
            .success(function(data){
                var currency_rate                 = data.currency_rate;
                var standard_rate_per_day_span    = standard_rate_per_day*currency_rate;
                $('.standard_rate_per_day_usd').text(standard_rate_per_day_span.toFixed(2));

              
                var standard_rate_per_week_span    = standard_rate_per_week*currency_rate;
                $('.standard_rate_per_week_usd').text(standard_rate_per_week_span.toFixed(2));
            }).error(function(){

            });

            $http.get('api/v1/get-currency-rate?currency_name=gbp', {cache:true})
            .success(function(data){
                var currency_rate                  = data.currency_rate;
                var standard_rate_per_week_span    = standard_rate_per_week*currency_rate;
                $('.standard_rate_per_week_gbp').text(standard_rate_per_week_span.toFixed(2));

                var standard_rate_per_day_span    = standard_rate_per_day*currency_rate;
                $('.standard_rate_per_day_gbp').text(standard_rate_per_day_span.toFixed(2));
            }).error(function(){

            });
            $('#before_standard_rate_per_day').val(standard_rate_per_day);
            $('#before_standard_rate_per_week').val(standard_rate_per_week);
        });

        $('.prop_specific_rate').keyup(function(){

            var specific_rate_per_day  = $('#rate_per_day').val();
            var specific_rate_per_week = $('#rate_per_week').val();
            if(specific_rate_per_day){
                $('.specific_day_rate').show();
            }

            if(specific_rate_per_week){
                $('.specific_week_rate').show();
            }
            $http.get('api/v1/get-currency-rate?currency_name=usd', {cache:true})
            .success(function(data){
                var currency_rate                 = data.currency_rate;
                var specific_rate_per_day_span    = specific_rate_per_day*currency_rate;
                $('.specific_rate_per_day_usd').text(specific_rate_per_day_span.toFixed(2));

              
                var specific_rate_per_week_span    = specific_rate_per_week*currency_rate;
                $('.specific_rate_per_week_usd').text(specific_rate_per_week_span.toFixed(2));
            }).error(function(){

            });

            $http.get('api/v1/get-currency-rate?currency_name=gbp', {cache:true})
            .success(function(data){
                var currency_rate                  = data.currency_rate;
                var specific_rate_per_day_span    = specific_rate_per_day*currency_rate;
                $('.specific_rate_per_day_gbp').text(specific_rate_per_day_span.toFixed(2));

                var specific_rate_per_week_span    = specific_rate_per_week*currency_rate;
                $('.specific_rate_per_week_gbp').text(specific_rate_per_week_span.toFixed(2));
            }).error(function(){

            });
            $('#before_rate_per_day').val(specific_rate_per_day);
            $('#before_rate_per_week').val(specific_rate_per_week);
        });

        var countryUrl = 'api/v1/all-countries';
        $http.get(countryUrl).success(function(data) {
            $scope.countries = data.countries;
            $scope.selectedCtry = $scope.countries[0].country;
        }).error(function(error) {
            $scope.error = error;            
        });

        var today = new Date();
        $scope.arrival_time = new Date();
        $scope.departure_time = new Date();
        $scope.propDateFormat = 'yyyy-MM-dd';
        $scope.availableDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: today,
            maxDate: new Date(2030, 5, 22)
        };
        $scope.expireDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: today,
            maxDate: new Date(2030, 5, 22)
        };
        $scope.availableDatePopup = {
            opened: false
        };
        $scope.expireDatePopup = {
            opened: false
        };
        $scope.ChangeExpiryMinDate = function(availableDate) {
            if (availableDate != null) {
                var expiryMinDate = new Date(availableDate);
                $scope.expireDateOptions.minDate = expiryMinDate;
                $scope.end_date = expiryMinDate;
                setTimeout(function(){
                  if($scope.end_date){
                    $('#end_date').val('');
                  }
                },0);
            }
        };
        $scope.ChangeExpiryMinDate();
        $scope.OpenAvailableDate = function() {
            $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
        };
        $scope.OpenExpireDate = function() {
            $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
        };  

                      
        $scope.removeSpecRate = function(id){
            var rateUrl = 'api/v1/delete-property-rate?property_rate_id='+id;
            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {
                $(document).on('click', 'td.removeSpecRate',function(){
                    $(this).parent('tr:first').remove();
                });
                $http.get(rateUrl).success(function(data) {
                    console.log(data);
                    if(data.success=='1'){
                        console.log('rate deleted');
                    }
                }).error(function(error) {console.log(error);
                    $scope.error = error;            
                });

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });                
                          
        }

        var checkboxes = $("input[type='checkbox']"),
                submitButt = $("button[name='editPropertySubmitBtn']");
        var datesArray  = [];                   
        $http.get('api/v1/property-rate-blocked-dates/'+$stateParams.id).success(function(data){ console.log(data);                                     
        for(var i=0; i<data.details.length; i++){                                       
            var startDate   = new Date(data.details[i].start_date);
            var endDate     = new Date(data.details[i].end_date);
            while (startDate <= endDate) {
                datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                startDate.setDate(startDate.getDate() + 1);
            }                                                   
        }
        $scope.dates = datesArray;
        $scope.availableDateOptions = {
          //dateDisabled:bookedPropDates,
          customClass: bookedPropDates,
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
        };

        $scope.expireDateOptions = {
            customClass: bookedPropDates,
            formatYear: 'yy',
            startingDay: 1,
            minDate: new Date(),
            maxDate: new Date(2030, 5, 22)
        };
        
        var dayDuration = 60 * 60 * 24 * 1000;
        function areDatesEqual(date1, date2) {

            return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

        }

        function bookedPropDates(data) {
          var date = data.date,
              mode = data.mode;

          if (mode === 'day') {    
            //var isRealDate = true;
            for (var i = 0; i < $scope.dates.length; i++) {    
              var changedDate     = new Date($scope.dates[i]);
              if (areDatesEqual(changedDate, date)) {    
                 return 'appointment';                  
              }
            }
          }

          return '';
          //return mode === 'day' && !isRealDate;
        }  
          
        
    }).error(function(error){

    });

        $scope.removeImgFromGallery = function(id){
            if (confirm("Are you sure to want to delete from database?")){
                $('li.jFiler-item-li-to-del').on('click', function() {
                    $(this).parent().children('li:eq(' + $(this).index() + ')').remove();
                });
                var imageUrl = 'api/v1/delete-property-image?property_gallery_id='+id;
                $http
                .get(imageUrl)
                .success(function(data) {
                    console.log(data);
                })
                .error(function(error){
                    console.log(error);
                });
            }else{

                return false;
            }
        }           
        

        $scope.space_type        = ['Apartment','Chalet','Cottage','Villa'];
        $scope.guest_limit       = ['1','2', '3', '4', '5', '6', '7', '8'];
        $scope.single_room       = ['1','2','3','4','5','6','7','8'];
        $scope.double_room       = ['1','2','3','4','5','6','7','8']; 
        $scope.twin_room         = ['1','2','3','4','5','6','7','8']; 
        $scope.other_room        = ['1','2','3','4','5','6','7','8'];        
        $scope.bathroom          = ['Any','1','2','3','4','5','6','7','8'];
        $scope.minimum_stay      = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];
        $scope.prop_minimum_stay = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];

        $scope.getCities = function(id){
            var cityUrl = 'api/v1/city-by-country?country_id='+id;
            $http.post(cityUrl).success(function(data) {
                console.log(data.cities);
                $scope.citiesList = data.cities;
                
            }).error(function(error) {
                $scope.error = error;
            });
        }        

        $('#required_base_currency').change(function(e){

            var selected_currency_name = $(this).val();
            var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'';
            $scope.currency_name         = selected_currency_name;

            var url = 'api/v1/property-details/'+$stateParams.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            $http.get(url).success(function(data) {
                if(data.message=='success'){
                    $scope.prop                    = data.property;
                    $scope._s3_path                = data._s3_path;
                    $scope.country                 = data.property.property_details[0].country;
                    $scope.city                    = data.property.property_details[0].city;
                    $scope.state                   = data.property.property_details[0].state;
                    $scope.town                    = data.property.property_details[0].town;
                    $scope.property_title          = data.property.property_details[0].property_title;
                    $scope.description             = data.property.property_details[0].description;
                    $scope.tinymceModel            = data.property.property_details[0].description;
                    $scope.standard_rate_per_week  = data.property.property_details[0].standard_rate_per_week;
                    $scope.standard_rate_per_day   = data.property.property_details[0].standard_rate_per_day;
                    $scope.rates                   = data.property.property_rates;
                    $scope.gallery                 = data.property.property_gallery;
                var lat, lng; console.log(data.property);   
                if(data.property.property_details[0].latitude){
                    lat = data.property.property_details[0].latitude;
                }else{
                    lat="37.090906";
                }
                if(data.property.property_details[0].longitude){
                    lng = data.property.property_details[0].longitude;
                }else{
                    lng = "-8.7591310999";
                }   
                var mapOptions = {
                    zoom: 11,
                    center: new google.maps.LatLng(lat, lng),
                    mapTypeId: google.maps.MapTypeId.TERRAIN
                }

                $scope.map = new google.maps.Map(document.getElementById('map'), mapOptions);
                
                var infoWindow = new google.maps.InfoWindow();
            
                var autocomplete = new google.maps.places.Autocomplete((document.getElementById('address')), {
                        types: ['geocode']
                });

                

                google.maps.event.addListener(autocomplete, 'place_changed', function() {
                 
                 var place = autocomplete.getPlace();                 
                 var latlng = place.geometry.location;
                 geocodePosition(latlng);
                 document.getElementById("latitude").value = place.geometry.location.lat();
                 document.getElementById("longitude").value = place.geometry.location.lng();
                 marker.setPosition(latlng);
                 $scope.map.setCenter(place.geometry.location);

                });
                

                var marker = new google.maps.Marker({
                    map: $scope.map,
                    icon:'uploads/location-ping.png',
                    position: new google.maps.LatLng(lat, lng),
                    draggable:true,
                });

                google.maps.event.addListener(marker, 'dragend', function (event) {//alert(this.getPosition().lat());
                    document.getElementById("latitude").value = event.latLng.lat();
                    document.getElementById("longitude").value = event.latLng.lng();
                    
                    geocodePosition(marker.getPosition());
                });              
                              

                var geocodePosition = function(pos) 
                {  
                   $scope.map.setCenter(pos); 
                   var geocoder = new google.maps.Geocoder();
                   geocoder.geocode
                    ({
                        latLng: pos
                    }, 
                        function(results, status) 
                        {
                            if (status == google.maps.GeocoderStatus.OK) 
                            {
                                if(results[0]) {
                                    for(var i = 0; i < results[0].address_components.length; i++) {

                                       if(results[0].address_components[i].types[0] == "locality") {
                                            var city= results[0].address_components[i].long_name;                                     
                                            $scope.city = city;
                                            $('#city').val(city);
                                        }
                                        if(results[0].address_components[i].types[0] == "postal_code") {
                                            var postal_code= results[0].address_components[i].long_name;//console.log(postal_code);                                        
                                            $('#area_code').val(postal_code);
                                        }
                                        if(results[0].address_components[i].types[0] == "administrative_area_level_1") {
                                            var state= results[0].address_components[i].long_name;                                        
                                            $scope.state = state;
                                            $('#state').val(state);
                                        }  

                                        if(results[0].address_components[i].types[0] == "country") {
                                            var country = results[0].address_components[i].long_name;
                                            $scope.country = country; 
                                            $("#country").val(country);                                           
                                        }
                                    }
                                }                                
                            }                     
                        }
                    );
                } 
                }

            }).error(function(error) {
                $scope.error = error;
            });
        });
        var url = 'api/v1/property-details/'+$stateParams.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        $http.get(url).success(function(data) {
            if(data.message=='success'){
                $scope.prop                    = data.property;
                $scope._s3_path                = data._s3_path;
                $scope.country                 = data.property.property_details[0].country;
                $scope.city                    = data.property.property_details[0].city;
                $scope.state                   = data.property.property_details[0].state;
                $scope.town                    = data.property.property_details[0].town;
                $scope.property_title          = data.property.property_details[0].property_title;
                $scope.description             = data.property.property_details[0].description;
                $scope.tinymceModel            = data.property.property_details[0].description;
                $scope.standard_rate_per_week  = data.property.property_details[0].standard_rate_per_week;
                $scope.standard_rate_per_day   = data.property.property_details[0].standard_rate_per_day;
                $scope.rates                   = data.property.property_rates;
                $scope.gallery                 = data.property.property_gallery;
                var lat, lng; 
            if(data.property.property_details[0].latitude){
                lat = data.property.property_details[0].latitude;
            }else{
                lat="37.090906";
            }
            if(data.property.property_details[0].longitude){
                lng = data.property.property_details[0].longitude;
            }else{
                lng = "-8.7591310999";
            }   
            var mapOptions = {
                zoom: 11,
                center: new google.maps.LatLng(lat, lng),
                mapTypeId: google.maps.MapTypeId.TERRAIN
            }

            $scope.map = new google.maps.Map(document.getElementById('map'), mapOptions);
            
            var infoWindow = new google.maps.InfoWindow();
        
            var autocomplete = new google.maps.places.Autocomplete((document.getElementById('address')), {
                    types: ['geocode']
            });

            

            google.maps.event.addListener(autocomplete, 'place_changed', function() {
             
             var place = autocomplete.getPlace();                 
             var latlng = place.geometry.location;
             geocodePosition(latlng);
             document.getElementById("latitude").value = place.geometry.location.lat();
             document.getElementById("longitude").value = place.geometry.location.lng();
             marker.setPosition(latlng);
             $scope.map.setCenter(place.geometry.location);

            });
            

            var marker = new google.maps.Marker({
                map: $scope.map,
                icon:'uploads/location-ping.png',
                position: new google.maps.LatLng(lat, lng),
                draggable:true,
            });

            google.maps.event.addListener(marker, 'dragend', function (event) {//alert(this.getPosition().lat());
                document.getElementById("latitude").value = event.latLng.lat();
                document.getElementById("longitude").value = event.latLng.lng();
                
                geocodePosition(marker.getPosition());
            });              
                          

            var geocodePosition = function(pos) 
            {  
               $scope.map.setCenter(pos); 
               var geocoder = new google.maps.Geocoder();
               geocoder.geocode
                ({
                    latLng: pos
                }, 
                    function(results, status) 
                    {
                        if (status == google.maps.GeocoderStatus.OK) 
                        {
                            if(results[0]) {
                                for(var i = 0; i < results[0].address_components.length; i++) {

                                   if(results[0].address_components[i].types[0] == "locality") {
                                        var city= results[0].address_components[i].long_name;                                     
                                        $scope.city = city;
                                        $('#city').val(city);
                                    }
                                    if(results[0].address_components[i].types[0] == "postal_code") {
                                        var postal_code= results[0].address_components[i].long_name;//console.log(postal_code);                                        
                                        $('#area_code').val(postal_code);
                                    }
                                    if(results[0].address_components[i].types[0] == "administrative_area_level_1") {
                                        var state= results[0].address_components[i].long_name;                                        
                                        $scope.state = state;
                                        $('#state').val(state);
                                    }  

                                    if(results[0].address_components[i].types[0] == "country") {
                                        var country = results[0].address_components[i].long_name;
                                        $scope.country = country; 
                                        $("#country").val(country);                                           
                                    }
                                }
                            }                                
                        }                     
                    }
                );
            } 
            }

        }).error(function(error) {
            $scope.error = error;
        });

        $(document).on('click','.delete_gallery_img',function(){

            var li_str = $(this).parents("li");
            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {                    
                var str = li_str.index();                  
                $scope.fileContainer.splice(str,1);
                li_str.remove();

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });
            
        });
        
        $scope.fileContainer = [];
        $scope.updateProperty = function(){            

            $scope.formatDate = function(date){ 
              var dateOut = new Date(date.replace(/-/g, "/"));
              return dateOut;
            };

            var formFileData = new FormData($('#editProperty')[0]);

             if($scope.myFile){
                console.log($scope.myFile);
                formFileData.append('main_image_name', $scope.myFile);
             }   
             
             if($scope.fileContainer) {   
                for(var i=0; i<$scope.fileContainer.length; i++){
                    console.log($scope.fileContainer[i]);

                    if($scope.fileContainer[i].size < 3000000){
                        formFileData.append('image_name['+i+']', $scope.fileContainer[i]);
                    }
                }
            }
                        
            var editPropertyUrl = 'api/v1/edit-property';
            console.log('editProperty');
            console.log(editPropertyUrl);    
            $http({
                method: 'POST', 
                data: formFileData,
                url: editPropertyUrl,
                enctype: 'multipart/form-data',
                headers: {'Content-Type': undefined},
                cache: false,
                contentType: false,
                processData: false,                
                
            }).success(function(data) {
                console.log(data);
                if(data.success==1){
                    var pnotify = new PNotify({
                                    title:'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    $window.location.reload();
                }else{
                    var pnotify = new PNotify({
                                    title:'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    //alert('Property not edited please try again');
                }               
                
            }).error(function(error) {console.log(error);
                    $scope.error = error;
            });
        }
      }else{
        $location.url('/');
      }    
    });

    app.controller('PreBlockPropertyCtrl', function($scope, $http, $state, $window, $filter, $location){
      if(localStorage.id){
        $scope.formatDate = function(date){ 
              var dateOut = new Date(date.replace(/-/g, "/"));
              return dateOut;
        };     
        
        $scope.getBlockedDates = function(id){
             var datesArray  = [];     
            $http.get('api/v1/blocked-dates/'+id).success(function(data){console.log(data);
                for(var i=0; i<data.details.length; i++){                                       
                    var startDate   = new Date(data.details[i].start_date);
                    var endDate     = new Date(data.details[i].end_date);
                    while (startDate <= endDate) {
                        datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                        startDate.setDate(startDate.getDate() + 1);
                    }                                                   
                }
                $scope.dates = datesArray;
                $scope.availableDateOptions = {
                  customClass: bookedPropAvailDates,
                  startingDay: 1,
                  minDate: new Date(),
                  maxDate: new Date(2030, 5, 22)
                };

                $scope.expireDateOptions = {
                    customClass: bookedPropDates,
                    startingDay: 1,
                    minDate: new Date(),
                    maxDate: new Date(2030, 5, 22)
                };

                var dayDuration = 60 * 60 * 24 * 1000;
                
                function areDatesEqual(date1, date2) {

                    return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

                }

                function bookedPropAvailDates(data){

                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#start_date').attr('data-key');
                      var eclick_count      = $('#end_date').attr('data-key');                        
                      var start_date        = $('#start_date').val();
                      var end_date          = $('#end_date').val();                     

                      var changedDate     = new Date($scope.dates[i]);                        
                        
                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }

                function bookedPropDates(data) {
                    console.log(data);
                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#start_date').attr('data-key');
                      var eclick_count      = $('#end_date').attr('data-key');                        
                      var start_date        = $('#start_date').val();
                      var end_date          = $('#end_date').val();
                        
                      var changedDate     = new Date($scope.dates[i]);                      
                        
                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }  
                  
                
            }).error(function(error){

            });
        }  

        var today = new Date();
        $scope.start_date = new Date();
        $scope.end_date = new Date();
        $scope.propDateFormat = 'yyyy-MM-dd';
        $scope.availableDateOptions = {
            formatYear: 'yy',
            minDate: today,
            maxDate: new Date(2050, 5, 22)
        };
        $scope.expireDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: today,
            maxDate: new Date(2050, 5, 22)
        };
        $scope.availableDatePopup = {
            opened: false
        };
        $scope.expireDatePopup = {
            opened: false
        };
        $scope.ChangeExpiryMinDate = function(availableDate) {

            if (availableDate != null) {
                var expiryMinDate = new Date(availableDate);
                $scope.expireDateOptions.minDate = expiryMinDate;
                $scope.end_date1 = expiryMinDate;
                setTimeout(function(){
                  if($scope.end_date1){
                    $('#end_date').val('');
                  }
                },0);
            }
        };
        $scope.ChangeExpiryMinDate();
        var i = 0;
        $scope.OpenAvailableDate = function() {
            
            $('#start_date').attr('data-key', i);
            i++;
            $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
        };
        $scope.OpenExpireDate = function() {

            $('#end_date').attr('data-key', i);
            i++;
            $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
        };
        /*$scope.ChangeExpiryMinDate();
        var i = 0;
        $scope.OpenAvailableDate = function() {
            
            $('#start_date').attr('data-key', i);
            i++;
            $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
        };
        $scope.OpenExpireDate = function() {
            $('#end_date').attr('data-key', i);
            i++;
            $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
        };*/

        var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
        var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

        var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        $http.post(propertyDetails).success(function(data){console.log(data);
            $scope.properties       = data.properties_details;
            $scope._s3_path         = data._s3_path;
        }).error(function(error){
            console.log(error);
        });

        $scope.getProblockComment = function(comment){
            
            if(comment){

                $('#view_preblock_comment').text(comment);    
            }else{
                $('#view_preblock_comment').text('No comments found');
            }
            
        }   

        $scope.getUpdateOwnerPreblockComment = function(){
            
            var preblock_id         = $('#preblock_id').val();
            var preblock_comment    = $('#preblock_comment').val();
            //console.log(preblock_id+'__'+preblock_comment);            
            var url = 'api/v1/update-preblock-comment?preblock_id='+preblock_id+'&comment='+preblock_comment;
            $http.get(url).success(function(data){console.log(data);
               
                if(data.success==1){
                    var pnotify = new PNotify({
                                title: 'Success',
                                text: data.message,
                                type: 'success',
                                styling: 'bootstrap3',
                                delay: 2000
                            });
                  $('#preblock-property-comment-modal').modal('hide');
                  $('.modal-backdrop').remove();
                  $state.go($state.current, {}, {reload: true});
                }else if(data.success==0){
                    var pnotify = new PNotify({
                                title: 'Error',
                                text: data.message,
                                type: 'error',
                                styling: 'bootstrap3',
                                delay: 2000
                            });
                  $('#preblock-property-comment-modal').modal('hide');  
                  $('.modal-backdrop').remove();
                  $state.go($state.current, {}, {reload: true});  
                }     
            }).error(function(error){
                
            });

        }

        $scope.blockProperty    = function(){
            var slectedRate     = $('#property_id option:selected').attr('data-rate');  
                    
            var date2           = new Date($('#end_date').val());console.log(date2);
            var date1           = new Date($('#start_date').val());
            var timeDiff        = Math.abs(date2.getTime() - date1.getTime());
            var diffDays        = Math.ceil(timeDiff / (1000 * 3600 * 24));
            var calcRate        = slectedRate*diffDays;  
            $('#rate').val(calcRate);
            if($('#end_date').val()){
            if($('#property_id').val()){

                if(!$('#preblock_comment').val())
                    return pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please add comment',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                else


                var formData        = $('#blockPropertyForm').serialize();

                var bookProperty    = 'api/v1/save-preblock-property?'+formData;
                
                $http.post(bookProperty).success(function(data){console.log(data);
                    $('#blockPropertyForm')[0].reset();
                    if(data.success=='1'){
                        var pnotify = new PNotify({
                                    title: 'Success',
                                    text: 'Successfully blocked the dates of property',
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                      $state.go($state.current, {}, {reload: true});
                    }else if(data.success=='2'){
                        var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Some dates are already blocked please try again!',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    }
                }).error(function(error){
                    console.log(error);
                }); 
            }else{
                var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please select the property to preblock it',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
            }
          }else{

            var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please select the End Date to preblock it',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
          }           
        }
        if(localStorage.id){
            var owner_id = localStorage.id;
        }else{
            var owner_id = '0';
        }
        var preblockUrl = 'api/v1/all-owner-preblock-properties/'+owner_id;
        $http.get(preblockUrl).success(function(data){
            if(data.success=='1'){

                    $scope.preblock = data.details;
            }
        }).error(function(error){
            console.log(error);
        });

        $scope.deletePreblockDate = function(id){console.log(id);
            if (confirm("Are you sure to want to delete from database?")){

                $('td.deletePreblockDate').closest('tr:first').remove();                    
                $http.get('api/v1/all-preblock-properties/delete/'+id).success(function(data){
                    if(data.success=='1'){                   
                       $window.location.reload(); 
                    }
                }).error(function(error){
                    console.log(error);
                });
            }else{

                return false;
            }
        }
      }else{
        $location.url('/');
      }
    });

    app.controller('PropertyEnquiriesCtrl', function($http, $scope, $location, $state, $window){
       if(localStorage.id){
        var ownerId = localStorage.id;
        $scope.orderByField = 'date';
        $scope.reverseSort = '';
        var propertiesUrl = 'api/v1/user-enquiries?list=1&ownerId='+ownerId;
        $http.post(propertiesUrl).success(function(result){//console.log(result);
            if(result.message=='success'){
                $scope.prop_list = result.enquiry_details;
            }
        }).error(function(error){
            console.log(error);
        });

        $scope.enqSort = function(){
            console.log('enqsort');
        }
        var enquiriesUrl = 'api/v1/user-enquiries?list=0&ownerId='+ownerId;
        $http.post(enquiriesUrl, {cache:true}).success(function(result){console.log(result);
            if(result.message=='success'){
                $scope.enq_list 	= result.enquiry_details;
                console.log(result.enquiry_details, 'enquiry_details');
                $scope.totalItems 	= result.enquiry_details.length;
				$scope.currentPage 	= 1;
				$scope.numPerPage 	= 10;
				  
				$scope.paginate = function(value) {
				    
				    var begin, end, index;
				    begin 	= ($scope.currentPage - 1) * $scope.numPerPage;
				    end 	= begin + $scope.numPerPage;
				    index 	= result.enquiry_details.indexOf(value);
				    console.log(index);
				    return (begin <= index && index < end);
				};
            }
        }).error(function(error){
            console.log(error);
        });

        $scope.getEnquiryDetails = function(id){

            var url = 'api/v1/enquiries/'+id;
            $http.get(url).success(function(result){
                console.log(result, 'enq result');

                if(result.reload==1){

                    $('#review_status_enq').val(1);      
                } 
               if(result.success=='1'){
                $scope.name 		= result.enquiry_details.first_name+' '+result.enquiry_details.surname;
                $scope.arrival 		= result.enquiry_details.earrival_time;
                $scope.departure 	= result.enquiry_details.edeparture_time;
                $scope.guest_limit 	= result.enquiry_details.guest;
                $scope.message 		= result.enquiry_details.message;
                $scope.customer_name = result.enquiry_details.customer_name;
                $scope.property_title = result.enquiry_details.property_title;
                $scope.property_id = result.enquiry_details.property_id;
                $scope.booking_amount = result.enquiry_details.booking_amount;
                $scope.deal_discount = result.enquiry_details.deal_discount;
                $scope.coupon = result.enquiry_details.coupon;
                $scope.security_deposit = result.enquiry_details.security_deposit;
                $scope.paid_amount = result.enquiry_details.paid_amount;
                $scope.phone = result.enquiry_details.phone;
                $scope.email = result.enquiry_details.email;
                $scope.currency_symbol = result.enquiry_details.selected_currency_symbol?result.enquiry_details.selected_currency_symbol:'€';
               }
            }).error(function(error){

            });
        }

        $scope.getEnquiryDetailsByPropId = function(id){

            var propertiesUrl = 'api/v1/user-enquiries?ownerId='+ownerId+'&propId='+id; 

            $http.post(propertiesUrl).success(function(result){console.log(result);
                if(result.message=='success'){
                    $scope.enq_list 	= result.enquiry_details;
                    $scope.totalItems 	= result.enquiry_details.length;
					$scope.currentPage 	= 1;
					$scope.numPerPage 	= 10;
					  
					$scope.paginate = function(value) {
					    
					    var begin, end, index;
					    begin 	= ($scope.currentPage - 1) * $scope.numPerPage;
					    end 	= begin + $scope.numPerPage;
					    index 	= result.enquiry_details.indexOf(value);
					    console.log(index);
					    return (begin <= index && index < end);
					};
                }else{
                    $scope.enq_list = '';
                }
            }).error(function(error){
                console.log(error);
            });    
        }

        $scope.getConvertBooking = function(enq_id){

            var convertUrl = 'api/v1/convert-enquiry-as-booking?enq_id='+enq_id;
            (new PNotify({
                title: 'Are you sure to want to convert as booking?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {
                 //$(this).parent("tr:first").remove();
               // if (confirm("Are you sure to want to delete from database?")){
                    console.log(convertUrl, 'convertUrl');
                    $http.post(convertUrl).success(function(result){                    

                        console.log(result, 'convert result');
                        if(result.success==1){

                            var pnotify = new PNotify({
                                        title: 'Success',
                                        text: result.message,
                                        type: 'success',
                                        delay: 2000,
                                        styling: 'bootstrap3'
                                    });
                        }else{
                            var pnotify = new PNotify({
                                        title: 'Error',
                                        text: result.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                        }                        
                        $(".ui-pnotify-modal-overlay").remove();
                        $window.location.reload();
                        //$state.go('property-enquiries', {}, {reload: true});
                    }).error(function(error){
                        console.log(error);
                    });

                //}
                }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });
        }

        $(document).on('click','span.deleteEnquiryDetails', function(){
           
            var enqId = $(this).attr('data-enquiry-id');
            var deleteUrl = 'api/v1/delete-property-enquiry/'+enqId;
            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {
                 //$(this).parent("tr:first").remove();
               // if (confirm("Are you sure to want to delete from database?")){
                    console.log(deleteUrl, 'deleteUrl');
                    $http.get(deleteUrl).success(function(result){                    
                        if(result.success=='1'){

                            var pnotify = new PNotify({
                                        title: 'Enquiry deleted successfully',
                                        text: 'Enquiry deleted successfully!',
                                        type: 'success',
                                        delay: 2000,
                                        styling: 'bootstrap3'
                                    });
                        }else{
                            var pnotify = new PNotify({
                                        title: 'Enquiry not deleted successfully',
                                        text: 'Enquiry not deleted please try again!',
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                        }
                        $(".ui-pnotify-modal-overlay").remove();
                        $window.location.reload();
                        //$state.go('property-enquiries', {}, {reload: true});
                        
                    }).error(function(error){
                        console.log(error);
                    });

                //}
                }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });
        });
       }else{
            $location.url('/');
       }
        
    });

    app.controller('NotificationsCtrl', function($scope, $http, $location, $sce){
      if(localStorage.id){
        var ownerId = localStorage.id;
        var url = 'api/v1/notifications';
        $scope.orderByField = 'date';
        $scope.reverseSort = false;   
        $http.get(url).success(function(result){
           if(result.success=='1'){
          	
                $scope.notif 		= result.notifications;
                $scope.totalItems 	= result.notifications.length;
				$scope.currentPage 	= 1;
				$scope.numPerPage 	= 10;
				  
				$scope.paginate = function(value) {
				    
				    var begin, end, index;
				    begin = ($scope.currentPage - 1) * $scope.numPerPage;
				    end = begin + $scope.numPerPage;
				    index = result.notifications.indexOf(value);
				    console.log(index);
				    return (begin <= index && index < end);
				};
           }     
        }).error(function(error){
            console.log(error);
        });

        $scope.getNotificationDetails = function(id){

            var url = 'api/v1/notification/'+id;
            $http.get(url).success(function(result){
                $scope.subject = result.title;
                $scope.description = $sce.trustAsHtml(result.description);
            }).error(function(error){

            });
        }
      }else{

        $location.url('/');
      }
    });

    app.controller('InvoicesPageCtrl', function($scope, $http, $window, $location){
        
        $scope.onPayClick   = function(price,id){

            console.log(id, 'id');
            $('#paypal_invoice_amount').val(price);
            $('#paypal_invoice_id').val(id);
        }
        if(localStorage.id){
            var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
            var selected_currency_symbol = localStorage.currency_symbol?localStorage.currency_symbol:'€';
            $scope.currency_name         = selected_currency_name;
            
            $('#required_base_currency').change(function(e){

                var selected_currency_name = $(this).val();
                var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'';
                $scope.currency_name         = selected_currency_name;
                if (null == this.ran || this.symb!=$(this).val()) {
                    e.preventDefault();
                    $scope.orderByField = 'cmdate1';
                    $scope.reverseSort = false;    
                    var url = 'api/v1/invoices/'+localStorage.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
                    $http.get(url).success(function(result){
                       if(result.success=='1'){
                            $scope.invoices     = result.invoice_details;
                            $scope.totalItems   = result.invoice_details.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = result.invoice_details.indexOf(value);
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       }     
                    }).error(function(error){
                        console.log(error);
                    });

                    var url = 'api/v1/invoices/'+localStorage.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
                    $http.get(url).success(function(result){
                       if(result.success=='1'){
                            $scope.invoices     = result.invoice_details;
                            $scope.totalItems   = result.invoice_details.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = result.invoice_details.indexOf(value);
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       }     
                    }).error(function(error){
                        console.log(error);
                    });

                    if($location.search().op=='success'){
                        
                        var invoice_id = localStorage.ivktid;    
                        var url = 'api/v1/invoice-renewal/'+localStorage.id+'/'+invoice_id;
                        $http.get(url).success(function(result){console.log(result);
                           $window.localStorage.status = result.user_details.status; 
                           if(result.success=='1'){                        
                                $location.search('');
                                $window.location.reload();  
                                var pnotify = new PNotify({
                                            title: 'Success',
                                            text: 'Account renewal success!',
                                            type: 'success',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                        });                        
                           }     
                        }).error(function(error){
                              
                        });    

                    }else if($location.search().op=='cancel'){
                        $location.search('');
                        var pnotify = new PNotify({
                                            title: 'Error',
                                            text: 'Payment process declined, please try again!',
                                            type: 'error',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                        });
                    }

                    $('#Model-paynow').on('shown.bs.modal', function (e) {       
                

                        $('.selected_invoice_payment_method_type').on('change', function(){
                            console.log('cccccc');
                            var selected_value = $(this).val();
                            console.log(selected_value, 'selected_card57');
                            if(selected_value=='paypal'){
                                $('.credit_card_inputs').hide();
                                $('.credit_card_submit').text('Pay Now');
                                $('.credit_card_submit').attr('id', 'paypal-submit-button');
                                $('.credit_card_submit').attr('onclick', 'submitPaypalPaymentForm(); return false;');
                            }else{
                                $('.credit_card_inputs').show();
                                $('.credit_card_submit').text('Make Payment');
                                $('.credit_card_submit').attr('id', 'submit-button');
                                $('.credit_card_submit').attr('onclick', 'submitPaymentForm(); return false;');
                            }
                                       
                        });

                        $window.submitPaymentForm = function () {
                          var requiredFields            = {};
                          requiredFields["full_name"]   = document.getElementById("full_name").value;
                          requiredFields["month"]       = document.getElementById("month").value;
                          requiredFields["year"]        = document.getElementById("year").value;

                          var result = Spreedly.tokenizeCreditCard(requiredFields);
                          console.log(result, 'result');
                        }
                        
                        $window.submitPaypalPaymentForm = function(){

                            //$scope.onPayClick   = function(price,id){
                            var amount = $('#paypal_invoice_amount').val();
                            var id  = $('#paypal_invoice_id').val();
                            var url =  'paypal/renew/'+amount+'?amount='+amount+'&invoice_id='+id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol; 
                            console.log('paypal submit url', url);
                            $window.open(url, "_self");
                        }

                        var access_token = '2VliQoIvXLLyW2vTn7kPWotrMId';  
                        console.log(access_token, 'access_token122');
                        
                        
                        Spreedly.init(access_token, {
                          "numberEl": "spreedly-number",
                          "cvvEl": "spreedly-cvv"
                        });

                        Spreedly.on("ready", function () {
                          var submitButton = document.getElementById('submit-button');
                          submitButton.disabled = false;
                        });

                        

                        Spreedly.on('errors', function(errors) {
                          for (var i=0; i < errors.length; i++) {
                            var error = errors[i];
                            var msg = error.message;
                            console.log(msg, 'error message');
                            if(msg){

                                $('.payment_error_validation').text(msg);    
                            }else{
                                $('.payment_error_validation').text('');
                            }
                            
                          };
                        });

                        Spreedly.on('paymentMethod', function(token, pmData) {
                          var tokenField = document.getElementById("payment_method_token");
                          $('.payment_error_validation').text('');
                          var pnotify = new PNotify({
                                                title: 'Info',
                                                text: 'Please wait, while your payment is being processed.',
                                                type: 'info',
                                                styling: 'bootstrap3',                                        
                                                delay:5000
                                              });
                          tokenField.setAttribute("value", token);
                          console.log(token, 'token');
                          var url            = 'tmt-owner-payment-response';
                          var paymentBooking = $('.paymentBookingId').text();
                          var full_name      = $('#full_name').val();
                          var month          = $('#month').val();
                          var year           = $('#year').val();
                          var cvv            = $('#cvv').val()!='undefined'?$('#cvv').val():'';
                          var amount         = $('#paypal_invoice_amount').val();
                          var id             = $('#paypal_invoice_id').val();        
                          var data                            = {'currency_name':selected_currency_name,'currency_symbol':selected_currency_symbol,'paymentBooking':paymentBooking, 'payment_method_token':token, 'full_name':full_name, 'month':month, 'year':year, 'amount':amount,'cvv':'cvv', 'selected_card':'Credit / Debit', 'id':id};
                          console.log(data, 'dddd loading start before');
                          $('.credit_card_submit').prop('disabled', true);
                          $http({
                                  method  : 'post',
                                  url     : url,
                                  params  : data
                          }).success(function(result){

                            console.log('dddd loading close before');
                            $scope.showLoader = false;
                            console.log('dddd loading close after');            
                            if(result.success==1){
                                $('#book-now-model').modal('hide');    
                                var pnotify = new PNotify({
                                                title: 'Success',
                                                text: result.message,
                                                type: 'success',
                                                styling: 'bootstrap3',                                        
                                                delay:60000
                                              });
                                setTimeout(function(){ location.reload() }, 2000);

                            }else{

                                var pnotify = new PNotify({
                                                title: 'Error',
                                                text: result.message,
                                                type: 'error',
                                                styling: 'bootstrap3',                                        
                                                delay:60000
                                              });
                            }
                          }).error(function(error){
                            $scope.showLoader = false;
                            console.log(error, 'error message');
                            var pnotify = new PNotify({
                                            title: 'Error',
                                            text: '',
                                            type: 'error',
                                            styling: 'bootstrap3',                                        
                                            delay:60000
                                          });
                          });
                      });
                    });

                    this.ran = true;
                    this.symb = selected_currency_name;
                }
            });
            var invoicePaypalFunction = function(selected_currency_name, selected_currency_symbol){
                console.log(localStorage.currency_value, 'localStorage.currency_value');
                console.log(selected_currency_name, 'localStorage.currency_value');
                if(localStorage.currency_value==selected_currency_name){
                    $scope.orderByField = 'cmdate1';
                    $scope.reverseSort = false;    
                    var url = 'api/v1/invoices/'+localStorage.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
                    $http.get(url).success(function(result){
                       if(result.success=='1'){
                            $scope.invoices     = result.invoice_details;
                            $scope.totalItems   = result.invoice_details.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = result.invoice_details.indexOf(value);
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       }     
                    }).error(function(error){
                        console.log(error);
                    });

                    var url = 'api/v1/invoices/'+localStorage.id+'?currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
                    $http.get(url).success(function(result){
                       if(result.success=='1'){
                            $scope.invoices     = result.invoice_details;
                            $scope.totalItems   = result.invoice_details.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = result.invoice_details.indexOf(value);
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       }     
                    }).error(function(error){
                        console.log(error);
                    });

                    if($location.search().op=='success'){
                        
                        var invoice_id = localStorage.ivktid;    
                        var url = 'api/v1/invoice-renewal/'+localStorage.id+'/'+invoice_id;
                        $http.get(url).success(function(result){console.log(result);
                           $window.localStorage.status = result.user_details.status; 
                           if(result.success=='1'){                        
                                $location.search('');
                                $window.location.reload();  
                                var pnotify = new PNotify({
                                            title: 'Success',
                                            text: 'Account renewal success!',
                                            type: 'success',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                        });                        
                           }     
                        }).error(function(error){
                              
                        });    

                    }else if($location.search().op=='cancel'){
                        $location.search('');
                        var pnotify = new PNotify({
                                            title: 'Error',
                                            text: 'Payment process declined, please try again!',
                                            type: 'error',
                                            styling: 'bootstrap3',
                                            delay: 2000
                                        });
                    }

                    $('#Model-paynow').on('shown.bs.modal', function (e) {       
                

                        $('.selected_invoice_payment_method_type').on('change', function(){
                            console.log('cccccc');
                            var selected_value = $(this).val();
                            console.log(selected_value, 'selected_card57');
                            if(selected_value=='paypal'){
                                $('.credit_card_inputs').hide();
                                $('.credit_card_submit').text('Pay Now');
                                $('.credit_card_submit').attr('id', 'paypal-submit-button');
                                $('.credit_card_submit').attr('onclick', 'submitPaypalPaymentForm(); return false;');
                            }else{
                                $('.credit_card_inputs').show();
                                $('.credit_card_submit').text('Make Payment');
                                $('.credit_card_submit').attr('id', 'submit-button');
                                $('.credit_card_submit').attr('onclick', 'submitPaymentForm(); return false;');
                            }
                                       
                        });

                        $window.submitPaymentForm = function () {
                          var requiredFields            = {};
                          requiredFields["full_name"]   = document.getElementById("full_name").value;
                          requiredFields["month"]       = document.getElementById("month").value;
                          requiredFields["year"]        = document.getElementById("year").value;

                          var result = Spreedly.tokenizeCreditCard(requiredFields);
                          console.log(result, 'result');
                        }
                        
                        $window.submitPaypalPaymentForm = function(){

                            //$scope.onPayClick   = function(price,id){
                            var amount = $('#paypal_invoice_amount').val();
                            var id  = $('#paypal_invoice_id').val();
                            var url =  'paypal/renew/'+amount+'?amount='+amount+'&invoice_id='+id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol; 
                            console.log('paypal submit url', url);
                            $window.open(url, "_self");
                        }

                        var access_token = '2VliQoIvXLLyW2vTn7kPWotrMId';  
                        console.log(access_token, 'access_token122');
                        
                        
                        Spreedly.init(access_token, {
                          "numberEl": "spreedly-number",
                          "cvvEl": "spreedly-cvv"
                        });

                        Spreedly.on("ready", function () {
                          var submitButton = document.getElementById('submit-button');
                          submitButton.disabled = false;
                        });

                        

                        Spreedly.on('errors', function(errors) {
                          for (var i=0; i < errors.length; i++) {
                            var error = errors[i];
                            var msg = error.message;
                            console.log(msg, 'error message');
                            if(msg){

                                $('.payment_error_validation').text(msg);    
                            }else{
                                $('.payment_error_validation').text('');
                            }
                            
                          };
                        });

                        Spreedly.on('paymentMethod', function(token, pmData) {
                          var tokenField = document.getElementById("payment_method_token");
                          
                          var pnotify = new PNotify({
                                                title: 'Info',
                                                text: 'Please wait, while your payment is being processed.',
                                                type: 'info',
                                                styling: 'bootstrap3',                                        
                                                delay:5000
                                              });
                          tokenField.setAttribute("value", token);
                          console.log(token, 'token');
                          var url            = 'tmt-owner-payment-response';
                          var paymentBooking = $('.paymentBookingId').text();
                          var full_name      = $('#full_name').val();
                          var month          = $('#month').val();
                          var year           = $('#year').val();
                          var cvv            = $('#cvv').val()!='undefined'?$('#cvv').val():'';
                          var amount         = $('#paypal_invoice_amount').val();
                          var id             = $('#paypal_invoice_id').val();        
                          var data                            = {'currency_name':selected_currency_name,'currency_symbol':selected_currency_symbol,'paymentBooking':paymentBooking, 'payment_method_token':token, 'full_name':full_name, 'month':month, 'year':year, 'amount':amount,'cvv':'cvv', 'selected_card':'Credit / Debit', 'id':id};
                          console.log(data, 'dddd loading start before');
                          $('.credit_card_submit').prop('disabled', true);
                          $http({
                                  method  : 'post',
                                  url     : url,
                                  params  : data
                          }).success(function(result){

                            console.log('dddd loading close before');
                            $scope.showLoader = false;
                            console.log('dddd loading close after');            
                            if(result.success==1){
                                $('#book-now-model').modal('hide');    
                                var pnotify = new PNotify({
                                                title: 'Success',
                                                text: result.message,
                                                type: 'success',
                                                styling: 'bootstrap3',                                        
                                                delay:60000
                                              });
                                setTimeout(function(){ location.reload() }, 2000);

                            }else{

                                var pnotify = new PNotify({
                                                title: 'Error',
                                                text: result.message,
                                                type: 'error',
                                                styling: 'bootstrap3',                                        
                                                delay:60000
                                              });
                            }
                          }).error(function(error){
                            $scope.showLoader = false;
                            console.log(error, 'error message');
                            var pnotify = new PNotify({
                                            title: 'Error',
                                            text: '',
                                            type: 'error',
                                            styling: 'bootstrap3',                                        
                                            delay:60000
                                          });
                          });
                      });
                    });
                }
            }

            invoicePaypalFunction(selected_currency_name, selected_currency_symbol);
        }else{

            $location.url('/');
        }

    });
    
    app.controller('TestimonialsPageCtrl', function($scope, $http, $state, $stateParams, $location, $window){
        
      if(localStorage.id){
        $scope.owner_id = localStorage.id;
        
        var url = 'api/v1/owner-testimonials-list?owner_id='+localStorage.id;
        $scope.orderByField = 'name';
        $scope.reverseSort = false; 
          $http.get(url)
          .success(function(data) {
                
               if(data.success=='1'){console.log(data.result);
                $scope.testimonials = data.result;
                $scope.totalItems 	= data.result.length;
				$scope.currentPage 	= 1;
				$scope.numPerPage 	= 10;
				  
				$scope.paginate = function(value) {
				    
				    var begin, end, index;
				    begin = ($scope.currentPage - 1) * $scope.numPerPage;
				    end = begin + $scope.numPerPage;
				    index = data.result.indexOf(value);
				    console.log(index);
				    return (begin <= index && index < end);
				};
               } 
          })
          .error(function(error) {
                $scope.error = error;
        });

        var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
        var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

        var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        $http.post(propertyDetails).success(function(data){console.log(data);
            $scope.properties       = data.properties_details;
            $scope._s3_path         = data._s3_path;
        }).error(function(error){
            console.log(error);
        }); 

        $scope.submitTestimonialForm = function(){
            
            var form = $('#testimonial_form').serialize();
            
            var url = 'api/v1/save-testimonials?owner_id='+localStorage.id+'&'+form;
            $http.post(url).success(function(data){console.log(data);
                if(data.success=='1'){
                    $state.go('testimonials', {}, {reload: true});
                    var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });  
                }
            }).error(function(error){
                if(error.success=='0'){
                    $scope.errorMessage = error.message;
                }
            });
        }            

        $scope.deleteTestimonial = function(id){

            var url = 'api/v1/delete-testimonial?id='+id;

            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {

                $http.get(url).success(function(data){

                if(data.success=='1'){
                    $state.go($state.current, {}, {reload: true});
                    var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                }); 
                }
               
                }).error(function(error){
                    if(error.data=='0'){
                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: data.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                    }   
               });

                $state.go('testimonials', {}, {reload: true});
                $(".ui-pnotify-modal-overlay").remove();

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });        
            
        }       
        
      }else{

        $location.url('/');
      }         

    
    });

    app.controller('PropertyBookingsCtrl', function($scope, $http){

        if(localStorage.id){
            $scope.formatDate = function(date){ 
              var dateOut = new Date(date.replace(/-/g, "/"));
              return dateOut;
            }; 

            $scope.getPropertyDetails = function(id){

                var url = 'api/v1/booked-property-details?booking_id='+id;
                $http.get(url)
                  .success(function(obj) {
                            console.log(obj);
                       if(obj.success=='1'){
                            $scope.property_data = obj.data;
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                });
            }


            $scope.getPropertyBookingDetails = function(id){

                var url = 'api/v1/property-booking-details?booking_id='+id;
                $http.get(url)
                  .success(function(obj) {
                       
                       if(obj.reload==1){

                            $('#review_status').val(1);      
                       }

                       if(obj.success=='1'){
                            $scope.booked_data = obj.data;
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                });
            }
            
            $scope.owner_id = localStorage.id;            

            var propertiesUrl = 'api/v1/owner-property-bookings?owner_id='+localStorage.id+'&list=1'+'&propId=0';
            $http.get(propertiesUrl).success(function(data){//console.log(result);
                if(data.success=='1'){
                    $scope.prop_list = data.result;
                }
            }).error(function(error){
                console.log(error);
            });

            $scope.getBookingDetailsByPropId = function(id){

                var url = 'api/v1/owner-property-bookings?owner_id='+localStorage.id+'&list=0'+'&propId='+id;            
                //$scope.orderByField = 'property_title';
                //$scope.reverseSort = false;       
                  $http.get(url, {cache:true})
                  .success(function(data) {
                            console.log(data.result, 'bookings');
                       if(data.success=='1'){
                            $scope.bookings     = data.result;
                            $scope.totalItems   = data.result.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = data.result.indexOf(value);
                                $scope.bookings_index  = index;
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       }else{
                            $scope.bookings = '';
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 0;
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                  });  
            }

            var ownerId = localStorage.id;
            var propertiesUrl = 'api/v1/owner-property-bookings?owner_id='+localStorage.id+'&list=0'+'&propId=0';
            $http.get(propertiesUrl).success(function(result){
                console.log(result);
                $http.get(propertiesUrl, {cache:true})
                  .success(function(data) {
                            console.log(data.result, 'bookings');
                       if(data.success=='1'){
                            $scope.bookings     = data.result;
                            $scope.totalItems   = data.result.length;
                            $scope.currentPage  = 1;
                            $scope.numPerPage   = 10;
                              
                            $scope.paginate = function(value) {
                                
                                var begin, end, index;
                                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                                end     = begin + $scope.numPerPage;
                                index   = data.result.indexOf(value);
                                $scope.bookings_index  = index;
                                console.log(index);
                                return (begin <= index && index < end);
                            };
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                  });
            }).error(function(error){
                console.log(error);
            });

            $scope.enqSort = function(){
                console.log('enqsort');
            }

            
        }
        else{

            $location.url('/');
        }

    });

    app.controller('CancelPropertyBookingsCtrl', function($scope, $http, $window, $state){
        if(localStorage.id){
            $scope.formatDate = function(date){ 
              var dateOut = new Date(date.replace(/-/g, "/"));
              return dateOut;
            }; 

            $scope.getPropertyDetails = function(id){
                
                var url = 'api/v1/booked-property-details?booking_id='+id;
                $http.get(url)
                  .success(function(obj) {
                            console.log(obj);
                       if(obj.success=='1'){
                            $scope.property_data = obj.data;
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                });
            }


            $scope.getPropertyBookingDetails = function(id){

                var url = 'api/v1/property-booking-details?booking_id='+id;
                $http.get(url)
                  .success(function(obj) {
                    console.log(obj.reload, 'reload tstaus');
                       if(obj.reload==1){

                            $('#review_status').val(1);      
                       }
                       
                       if(obj.success=='1'){
                            $scope.booked_data = obj.data;
                       } 
                  })
                  .error(function(error) {
                        $scope.error = error;
                });
            }
            $scope.owner_id = localStorage.id;            
            var url = 'api/v1/upcoming-cancel-property-bookings?owner_id='+localStorage.id;
            $scope.orderByField = 'property_title';
            $scope.reverseSort = true;
            $http.get(url, {cache:true})
              .success(function(data) {
                        console.log(data);
                   if(data.success=='1'){
                        $scope.bookings = data.result;
                   } 
              })
              .error(function(error) {
                    $scope.error = error;
            });

            $scope.getPropertyBookingId = function(id){

                $('#property_booking_id').val(id);
            }

            $scope.cancelPropertyBooking = function(){

                var formData = $('#cancelPropertyBookingForm').serialize();
                if($('#property_cancel_comment').val()){

                    var url = 'api/v1/cancel-property-bookings-request?'+formData;
                    $http.get(url)
                      .success(function(data) {
                               console.log(data);
                           if(data.success=='1'){
                                var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                                $('.modal-backdrop').remove();
                                $state.go($state.current, {}, {reload: true});
                           }else{

                                var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                           } 
                      })
                      .error(function(error) {
                            $scope.error = error;
                    });
                }else{

                    var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please add comments',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                }
            }  
        }
        else{

            $location.url('/');
        }

    });

    app.controller('EditTestimonialsPageCtrl', function($scope, $http, $state, $stateParams){
        var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
        var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

        var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
        $http.post(propertyDetails).success(function(data){console.log(data);
            $scope.properties       = data.properties_details;
            $scope._s3_path         = data._s3_path;
        }).error(function(error){
            console.log(error);
        });

        
        var edit_url = 'api/v1/testimonial-by-id?id='+$stateParams.id;
        $http.get(edit_url).success(function(data){console.log(data);
           
           if(data.success=='1'){
            $scope.testimonial = data.result;
           }
        }).error(function(error){
            console.log(error);
        });
        $scope.rating = ['1','2','3','4','5'];  
        $scope.submitEditTestimonialForm = function(){          

            var form = $('#edit_testimonial_form').serialize();
            
            var url = 'api/v1/update-testimonial?'+form;
            console.log(url);
            $http.post(url).success(function(data){console.log(data);
                if(data.success=='1'){
                    $state.go($state.current, {}, {reload: true});
                    var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });  
                }
            }).error(function(error){
                if(error.success=='0'){
                    $scope.errorMessage = error.message;
                }
            });
        }
    });

    app.controller('accessTokenController', function($scope, $http, $location, $window){
        
        console.log(localStorage, 'sdsdsdsd');
        if(localStorage.id){
                       
            $scope.basic_currency = localStorage.basic_currency && localStorage.basic_currency!='null'?localStorage.basic_currency:'';
            $scope.ttoken = localStorage.ttoken && localStorage.ttoken!='null'?localStorage.ttoken:''; 
            $scope.pemail = localStorage.pemail && localStorage.pemail!='null'?localStorage.pemail:''; 
            $scope.submitTokenDetailsForm = function(){
                var access_token = $('#add_token_form').serialize();          
                var url = 'api/v1/update-tmt-token?'+access_token+'&user_id='+localStorage.id;
                 $http.post(url, {cache:true}).success(function(data){console.log(data);
                    if(data.success==1){
                        
                        localStorage.setItem("basic_currency", data.details.basic_currency); 
                        sessionStorage.setItem("basic_currency", data.details.basic_currency);

                        localStorage.setItem("ttoken", data.details.tmt_api_token); 
                        sessionStorage.setItem("ttoken", data.details.tmt_api_token);

                        localStorage.setItem("pemail", data.details.paypal_email); 
                        sessionStorage.setItem("pemail", data.details.paypal_email);
                    
                        var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                }); 
                    }else{
                        var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                }); 
                    }
                }).error(function(error){
                    console.log(error);
                });
            }

        }else{

            $location.url('/');
        }
    });

    app.controller('ownerDealsCtrl', function($scope, $http, $location, $window, $state){

        if(localStorage.id){
            var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
            var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

            var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            $http.post(propertyDetails).success(function(data){console.log(data);
                $scope.properties       = data.properties_details;
                $scope._s3_path         = data._s3_path;
            }).error(function(error){
                console.log(error);
            });
            $scope.orderByField = 'property_title';
            $scope.reverseSort = false;   
            $scope.$watch('formData', function() {
               
               var deal_property_id = $scope.formData.property_id;
               var deal_deals_date  = $scope.formData.deals_date;
               var url = 'api/v1/filter-deals?property_id='+deal_property_id+'&date='+deal_deals_date+'&owner_id='+localStorage.id;

               $http.get(url).success(function(result){console.log(result);

                    if(result.success=='1'){
                    
                        $scope.deals 		= result.data;
                        $scope.totalItems 	= result.data.length;
						$scope.currentPage 	= 1;
						$scope.numPerPage 	= 10;
						  
						$scope.paginate = function(value) {
						    
						    var begin, end, index;
						    begin 	= ($scope.currentPage - 1) * $scope.numPerPage;
						    end 	= begin + $scope.numPerPage;
						    index 	= result.data.indexOf(value);
						    console.log(index);
						    return (begin <= index && index < end);
						}; 
                    }else{

                        $scope.deals = ''; 
                    }
               }).error(function(error){

                    
               });
            }, true);

            var url = 'api/v1/owner-deals-list?owner_id='+localStorage.id;
            
            $http.get(url).success(function(result){console.log(result);

                if(result.success=='1'){
                    
                    $scope.deals = result.data;
                    $scope.totalItems 	= result.data.length;
					$scope.currentPage 	= 1;
					$scope.numPerPage 	= 10;
					  
					$scope.paginate = function(value) {
					    
					    var begin, end, index;
					    begin 	= ($scope.currentPage - 1) * $scope.numPerPage;
					    end 	= begin + $scope.numPerPage;
					    index 	= result.data.indexOf(value);
					    console.log(index);
					    return (begin <= index && index < end);
					}; 
                }
            }).error(function(error){

                if(error.success=='0'){

                    $scope.errorMessage = error.message;
                }
            });

            $scope.deleteOwnerDeal = function(id){
                var url = 'api/v1/delete-deal?id='+id;
                (new PNotify({
                    title: 'Are you sure to want to delete?',
                    icon: 'glyphicon glyphicon-question-sign',
                    hide: false,
                    confirm: {
                      confirm: true
                    },
                    buttons: {
                      closer: false,
                      sticker: false
                    },
                    history: {
                      history: false
                    },
                    addclass: 'stack-modal',
                    stack: {
                      'dir1': 'down',
                      'dir2': 'right',
                      'modal': true
                    }
                })).get().on('pnotify.confirm', function() {

                    $http.get(url).success(function(result){console.log(result);

                        if(result.success=='1'){
                            
                            var pnotify = new PNotify({
                                        title: 'Success',
                                        text: result.message,
                                        type: 'success',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });

                            $window.location.reload(); 
                        }else{

                            var pnotify = new PNotify({
                                        title: 'Error',
                                        text: result.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                            
                        }
                    }).error(function(error){

                        if(error.success=='0'){

                            $scope.errorMessage = error.message;
                        }
                    });

                    $state.go('owner-deals', {}, {reload: true});

                    $(".ui-pnotify-modal-overlay").remove();

                }).on('pnotify.cancel', function() {
                    $(".ui-pnotify-modal-overlay").remove();
                });          
            
            }            

        }else{

            $location.url('/');
        }
        
    });

    app.controller('addOwnerDealsCtrl', function($scope, $http, $location, $state, $filter){

        if(localStorage.id && localStorage.status=='active'){

            var deal_exists_url = 'api/v1/check-deal-help-file';

            $http.get(deal_exists_url).success(function(result){

                $scope.existency = result.success;

            }).error(function(){});

            var url = 'super-admin/deal-name';

            $http.get(url).success(function(data) {
              if(data.success==1){
                $scope.deal_name = data.cms['name'];                                     
              }
            }).error(function(error) {
                $scope.error = error;            
            }); 


        	$scope.getBlockedDealDates = function(prop_id){

        		var datesArray  = [];     
            	$http.get('api/v1/property-deal-dates?property_id='+prop_id).success(function(data){console.log(data);
                for(var i=0; i<data.details.length; i++){                                       
                    var startDate   = new Date(data.details[i].from_date);
                    var endDate     = new Date(data.details[i].to_date);
                    while (startDate <= endDate) {
                        datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                        startDate.setDate(startDate.getDate() + 1);
                    }                                                   
                }
                $scope.dates = datesArray;
                $scope.availableDateOptions = {
                  customClass: bookedPropAvailDates,
                  startingDay: 1,
                  minDate: new Date(),
                  maxDate: new Date(2030, 5, 22)
                };

                $scope.expireDateOptions = {
                    customClass: bookedPropDates,
                    startingDay: 1,
                    minDate: new Date(),
                    maxDate: new Date(2030, 5, 22)
                };

                var dayDuration = 60 * 60 * 24 * 1000;
                function areDatesEqual(date1, date2) {

                    return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

                }

                function bookedPropAvailDates(data){

                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#from_date').attr('data-key');
                      var eclick_count      = $('#to_date').attr('data-key');                        
                      var start_date        = $('#from_date').val();
                      var end_date          = $('#to_date').val();
                      
                    

                      var changedDate     = new Date($scope.dates[i]);

                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }

                $scope.getArrivalDate = function(arrival_time){    
                console.log(arrival_time, 'deal arrival_time');       
                   enq_arrival_time = arrival_time;
                   
                    var from_date    = $('#from_date').val();
                    var to_date  = $('#to_date').val();
                    if(to_date<from_date){
                     $('#to_date').val('');
                    }      
                }  

                function bookedPropDates(data) {
                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#from_date').attr('data-key');
                      var eclick_count      = $('#to_date').attr('data-key');                        
                      var start_date        = $('#from_date').val();
                      var end_date          = $('#to_date').val();
                      
                      
                        
                      var changedDate     = new Date($scope.dates[i]);
                      
                        
                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }  
                  
                
            }).error(function(error){

            });
        	}

            //var today = new Date();
            $scope.from_date = '';//new Date();
            $scope.to_date = '';//new Date();
            $scope.propDateFormat = 'yyyy-MM-dd';
            $scope.availableDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: new Date(),
                maxDate: new Date(2030, 5, 22)
            };
            $scope.expireDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: new Date(),
                maxDate: new Date(2030, 5, 22)
            };
            $scope.availableDatePopup = {
                opened: false
            };
            $scope.expireDatePopup = {
                opened: false
            };
            $scope.ChangeExpiryMinDate = function(availableDate) {
                //console.log(availableDate, 'availableDate');
                if (availableDate != null) {
                    var expiryMinDate = new Date(availableDate);
                    $scope.expireDateOptions.minDate = expiryMinDate;
                    //$scope.ExpireDate = expiryMinDate;
                    $scope.to_date = expiryMinDate;
                    setTimeout(function(){
                    if($scope.to_date){
                        $('#to_date').val('');
                      }
                    },0); 
                }
            };
            $scope.ChangeExpiryMinDate();
            $scope.OpenAvailableDate = function() {
                $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
            };
            $scope.OpenExpireDate = function() {
                $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
            };

            var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
            var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

            var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            $http.post(propertyDetails).success(function(data){console.log(data);
                $scope.properties       = data.properties_details;
                $scope._s3_path         = data._s3_path;
            }).error(function(error){
                console.log(error);
            });
            $scope.max_price_limit  = 75;
            $scope.checkDealMaxPrice = function(val){

                var max_price = $('.max_price_num').val();
                var deal_type = $('#deal_type').val();
                console.log(max_price+'__'+deal_type);
                setTimeout(function(){

                    if(parseInt(val)>parseInt(max_price) && deal_type=='percentage'){          

                        $('.deal_amount').val('');  

                        var pnotify = new PNotify({
                                              title: 'Error',
                                              text: 'Maximum discount '+max_price+' %',
                                              type: 'error',
                                              styling: 'bootstrap3',
                                            });        
                      
                    }else if(parseInt(val)==0 && deal_type=='percentage'){

                        $('.deal_amount').val('');  

                        var pnotify = new PNotify({
                                              title: 'Error',
                                              text: "Discount must be greater than '0'",
                                              type: 'error',
                                              styling: 'bootstrap3',
                                            });  
                    }
                }, 300);
            }

            $scope.submitAddDealsForm = function(){

                var formData = $('#add_deals_form').serialize();
                var url = 'api/v1/add-deals?'+formData+'&owner_id='+localStorage.id;
                $http.post(url).success(function(data){

                    if(data.success==0){

                        var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    }else{

                        var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });

                        $state.go('owner-deals');
                    }
                    
                }).error(function(error){
                    
                    
                });
            }

            $scope.submitTokenDetailsForm = function(){

            }
        
        }else{

            $location.url('/');
        }    
    });

    app.controller('editOwnerDealsCtrl', function($scope, $filter, $http, $location, $state, $stateParams){

        if(localStorage.id && localStorage.status=='active'){				      	


            var today = new Date();
            $scope.arrival_time = new Date();
            $scope.departure_time = new Date();
            $scope.propDateFormat = 'yyyy-MM-dd';
            $scope.availableDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: today,
                maxDate: new Date(2030, 5, 22)
            };
            $scope.expireDateOptions = {
                formatYear: 'yy',
                startingDay: 1,
                minDate: today,
                maxDate: new Date(2030, 5, 22)
            };
            $scope.availableDatePopup = {
                opened: false
            };
            $scope.expireDatePopup = {
                opened: false
            };
            $scope.ChangeExpiryMinDate = function(availableDate) {
                if (availableDate != null) {
                    var expiryMinDate = new Date(availableDate);
                    $scope.expireDateOptions.minDate = expiryMinDate;
                    $scope.ExpireDate = expiryMinDate;
                }
            };
            $scope.ChangeExpiryMinDate();
            $scope.OpenAvailableDate = function() {
                $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
            };
            $scope.OpenExpireDate = function() {
                $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
            };

            var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
            var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';

            var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            $http.post(propertyDetails).success(function(data){console.log(data);
                $scope.properties       = data.properties_details;
                $scope._s3_path         = data._s3_path;
            }).error(function(error){
                console.log(error);
            });

            var url = 'api/v1/deals-by-id/'+$stateParams.id;
            var deal_from_date = '';
            $http.get(url).success(function(result){

                $scope.deal = result.data;

                $scope.dealObj              = result.data;
                $scope.deal_id              = result.data.id;
                $scope.property_id          = result.data.property_id;
                $scope.from_date1           = new Date(result.data.from_date);
                $scope.to_date1             = new Date(result.data.to_date);
                $scope.from_time            = result.data.from_time;
                $scope.to_time              = result.data.to_time;
                $scope.amount               = result.data.amount;
                $scope.max_price_limit      = 75;
            }).error(function(error){
                console.log(error);
            });

            setTimeout(function(){

                console.log($('#deal_from_date').val()+' deal from date');

            }, 100);

            $('#property_id').change(function(){
       		
        		var prop_id = $(this).val();
        		getDealDatesFunction(prop_id);
        	});

            var getDealDatesFunction = function(prop_id){

            	var datesArray  = [];  
            	
            	$http.get('api/v1/property-deal-dates?property_id='+prop_id).success(function(data){console.log(data);
                for(var i=0; i<data.details.length; i++){                                       
                    var startDate   = new Date(data.details[i].from_date);
                    var endDate     = new Date(data.details[i].to_date);
                    while (startDate <= endDate) {
                        datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                        startDate.setDate(startDate.getDate() + 1);
                    }                                                   
                }
                $scope.dates = datesArray;
                $scope.availableDateOptions = {
                  customClass: bookedPropAvailDates,
                  startingDay: 1,
                  minDate: new Date(),
                  maxDate: new Date(2030, 5, 22)
                };

                $scope.expireDateOptions = {
                    customClass: bookedPropDates,
                    startingDay: 1,
                    minDate: new Date(),
                    maxDate: new Date(2030, 5, 22)
                };

                var dayDuration = 60 * 60 * 24 * 1000;
                function areDatesEqual(date1, date2) {

                    return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

                }

                function bookedPropAvailDates(data){

                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#from_date').attr('data-key');
                      var eclick_count      = $('#to_date').attr('data-key');                        
                      var start_date        = $('#from_date').val();
                      var end_date          = $('#to_date').val();
                      
                                          
                       

                      var changedDate     = new Date($scope.dates[i]);
                        
                        
                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }

                function bookedPropDates(data) {
                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    //var isRealDate = true;
                    for (var i = 0; i < $scope.dates.length; i++) {
                      var click_count       = $('#from_date').attr('data-key');
                      var eclick_count      = $('#to_date').attr('data-key');                        
                      var start_date        = $('#from_date').val();
                      var end_date          = $('#to_date').val();
                      
                      
                        
                      var changedDate     = new Date($scope.dates[i]);
                      
                        
                        if (areDatesEqual(changedDate, date)) {    
                             return 'appointment';                  
                        }                          
                    }
                  }

                  return '';
                  //return mode === 'day' && !isRealDate;
                }  
                  
                
            }).error(function(error){

            });		
            }	
            	
            

            setTimeout(function(){
            	var property_id = $('#property_id option:selected').val();
            	getDealDatesFunction(property_id);

            }, 500);	
            

            
            $scope.checkDealMaxPrice = function(val){

                var max_price = $('.max_price_num').val();
                var deal_type = $('#deal_type').val();
                console.log(max_price+'__'+deal_type);
                setTimeout(function(){

                    if(parseInt(val)>parseInt(max_price) && deal_type=='percentage'){          

                        $('.deal_amount').val('');  

                        var pnotify = new PNotify({
                                              title: 'Error',
                                              text: 'Maximum discount '+max_price+' %',
                                              type: 'error',
                                              styling: 'bootstrap3',
                                            });        
                      
                    }else if(parseInt(val)==0 && deal_type=='percentage'){

                        $('.deal_amount').val('');  

                        var pnotify = new PNotify({
                                              title: 'Error',
                                              text: "Discount must be greater than '0'",
                                              type: 'error',
                                              styling: 'bootstrap3',
                                            });  
                    }
                }, 300);
            }   

            $scope.submitEditDealsForm = function(){

                var formData = $('#edit_deals_form').serialize();
                var url = 'api/v1/update-deals?'+formData+'&owner_id='+localStorage.id;
                $http.post(url).success(function(data){

                    if(data.success==0){

                        var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    }else{

                        var pnotify = new PNotify({
                                    title: 'Success',
                                    text: data.message,
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });

                        $state.go('owner-deals');
                    }
                    
                }).error(function(error){
                    
                    
                });
            }
        
        }else{

            $location.url('/');
        }    
    });

    
    app.controller('OwnerPropertyAvailabilityCtrl', function($scope, $http, $state, $window, $filter, $location){

        if(localStorage.id){
            var selected_currency_name   = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
            var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';
            var propertyDetails         = 'api/v1/all-user-properties?status=active&verified=yes&user_id='+localStorage.id+'&currency_name='+selected_currency_name+'&currency_symbol='+selected_currency_symbol;
            
            $http.post(propertyDetails).success(function(data){
                $scope.properties       = data.properties_details;  
                $scope._s3_path         = data._s3_path;              
                var query_prop_id = $location.search().id;                
                if(query_prop_id){

                    var url = 'api/v1/property-details/'+query_prop_id;
                    $http.get(url, {cache: true}).success(function(data) {
                        if(data.message=='success'){
                            $scope._s3_path                                 = data._s3_path;
                            $scope.prop                                     = data.property;
                            $window.localStorage.calendar_first_prop_title  = data.property.property_details[0].property_title;//$('#property_id option:selected').text();
                            $scope.selected_prop_title                      = data.property.property_details[0].property_title;//$('#property_id option:selected').text();
                        }
                    }).error(function(){

                    });
                    $scope.first_property                           = query_prop_id;
                    $window.localStorage.calendar_first_option      = query_prop_id;  
                    
                }else{
                    $scope._s3_path                                 = data._s3_path;
                    $scope.first_property                           = data.properties_details[0].property_id;
                    $window.localStorage.calendar_first_option      = data.properties_details[0].property_id;
                    $window.localStorage.calendar_first_prop_title  = data.properties_details[0].property_title;
                    $window.localStorage.calendar_first_prop_rate   = data.properties_details[0].standard_rate_per_week;
                    $scope.selected_prop_title                      = data.properties_details[0].property_title;
                    
                }
                                          
            }).error(function(error){
                console.log(error);
            });

            //$scope.getBlockedDates = function(id){
            setTimeout(function(){

                get_property_blocked_dates(localStorage.calendar_first_option);

            }, 100);    
            
                
            var get_property_blocked_dates = function(id){

                var datesArray  = []; 
                var startDatesArray  = [];
                var endDatesArray  = [];  
                var combinesArray = []; 
                var temp  = [];
                var dup   = [];     
            $http.get('api/v1/blocked-dates/'+id, {cache: true}).success(function(data){                                      
                for(var i=0; i<data.details.length; i++){    

                //console.log(data.details[i].start_date, 'start_date');
                //console.log(data.details[i].end_date, 'end_date');                                   
                    var startDate   = new Date(data.details[i].start_date);
                    var endDate     = new Date(data.details[i].end_date);

                    endDate.setDate(endDate.getDate() + 1);
                  
                    startDatesArray.push(startDate);
                    endDatesArray.push($filter('date')(new Date(endDate), 'yyyy/MM/dd'));

                    var sDate       = new Date(data.details[i].start_date);
                    sDate.setDate(sDate.getDate() + 1);
                    var eDate       = new Date(data.details[i].end_date);

                    /*var sDate = data.details[i].start_date;
                    var eDate = data.details[i].end_date; */
                                                         
                    var startDate1   = new Date(sDate);
                    var endDate1     = new Date(eDate);

                    while (startDate1 <= endDate1) {
                        datesArray.push($filter('date')(new Date(startDate1), 'yyyy/MM/dd'));                        
                        startDate1.setDate(startDate1.getDate() + 1);                        
                    }                                                   
                }

                combinesArray = startDatesArray.concat(endDatesArray);
                   
                $.each(combinesArray, function (key, value) {

                   if($.inArray(value, temp) === -1) {
                       temp.push(value);

                    }else{
                       dup.push(value);
                    }
                });
                $scope.dates = datesArray;

                $scope.availableDateOptions = {
                  //dateDisabled:bookedPropDates,
                  customClass: bookedPropDates,
                  startingDay: 1,
                  minDate: new Date(),
                  maxDate: new Date(2030, 5, 22)
                };

                $scope.expireDateOptions = {
                    customClass: bookedPropDates,
                    formatYear: 'yy',
                    startingDay: 1,
                    minDate: new Date(),
                    maxDate: new Date(2030, 5, 22)
                };
                
                var dayDuration = 60 * 60 * 24 * 1000;
                function areDatesEqual(date1, date2) {

                    return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

                }

                function bookedPropDates(data) {console.log(data);
                  var date = data.date,
                      mode = data.mode;

                  if (mode === 'day') {    
                    
                    for (var i = 0; i < $scope.dates.length; i++) {
                        
                      var click_count       = $('#start_date').attr('data-key');
                      var dclick_count      = $('#end_date').attr('data-key');
                      var barrival_time     = $('#start_date').val();
                      var bdeparture_time   = $('#end_date').val();

                      var changedDate       = new Date($scope.dates[i]);
                                           
                      if (areDatesEqual(changedDate, date)) {   
                       
                        return 'appointment';                  
                      }
                    }

                    for (var i = 0; i < startDatesArray.length; i++) {
                      if($.inArray(startDatesArray[i], dup) == -1){                        
                        var changedDate     = new Date(startDatesArray[i]);                      
                        if (areDatesEqual(changedDate, date)) {    
                           return 'start_appointment';                  
                        }
                      }
                    }

                    for (var i = 0; i < endDatesArray.length; i++) {
                      if($.inArray(endDatesArray[i], dup) == -1){                        
                        var changedDate     = new Date(endDatesArray[i]);                      
                        if (areDatesEqual(changedDate, date)) {    
                           return 'end_appointment';                  
                        }
                      }
                    }

                    for (var i = 0; i < dup.length; i++) {
                      var changedDate     = new Date(dup[i]);                      
                      if (areDatesEqual(changedDate, date)) {    
                         return 'combine_appointment appointment';                  
                      }                      
                    }

                  }

                 // return '';
                  return mode === 'day';
                }  
                  
                
            }).error(function(error){

            });
            }    
            $('#property_id').change(function(){    
                
                var property_id = $(this).val();
                console.log();
                $scope.selected_prop_title  = $('#property_id option:selected').text()
                get_property_blocked_dates(property_id);
            });

        var today = new Date();
        $scope.start_date   = new Date();
        if($('#start_date').val()){

            $scope.end_date     = new Date();    
        }        
        $scope.propDateFormat = 'yyyy-MM-dd';
        $scope.availableDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: new Date(),
            maxDate: new Date(2030, 5, 22)
        };
        $scope.expireDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: new Date(),
            maxDate: new Date(2030, 5, 22)
        };
        $scope.availableDatePopup = {
            opened: false
        };
        $scope.expireDatePopup = {
            opened: false
        };
             
        $scope.ChangeExpiryMinDate = function(availableDate) {

            if (availableDate != null) {
                var expiryMinDate = new Date(availableDate);
                $scope.expireDateOptions.minDate = expiryMinDate;
                $scope.end_date = expiryMinDate;                                
            }            
        };
        $scope.ChangeExpiryMinDate();
        var i = 0;
        $scope.OpenAvailableDate = function() {
            
            $('#start_date').attr('data-key', i);
            i++;
            $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
        };
        $scope.OpenExpireDate = function() {
          $('#end_date').attr('data-key', i);
            i++;
            $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
        };

        $scope.getProblockComment = function(comment){
            
            if(comment){

                $('#view_preblock_comment').text(comment);    
            }else{
                $('#view_preblock_comment').text('No comments found');
            }
            
        }   

        $scope.getUpdateOwnerPreblockComment = function(){
            
            var preblock_id         = $('#preblock_id').val();
            var preblock_comment    = $('#preblock_comment').val();
            //console.log(preblock_id+'__'+preblock_comment);            
            var url = 'api/v1/update-preblock-comment?preblock_id='+preblock_id+'&comment='+preblock_comment;
            $http.get(url, {cache: true}).success(function(data){console.log(data);
               
                if(data.success==1){
                    var pnotify = new PNotify({
                                title: 'Success',
                                text: data.message,
                                type: 'success',
                                styling: 'bootstrap3',
                                delay: 2000
                            });
                  $('#preblock-property-comment-modal').modal('hide');
                  $('.modal-backdrop').remove();
                  $state.go($state.current, {}, {reload: true});
                }else if(data.success==0){
                    var pnotify = new PNotify({
                                title: 'Error',
                                text: data.message,
                                type: 'error',
                                styling: 'bootstrap3',
                                delay: 2000
                            });
                  $('#preblock-property-comment-modal').modal('hide');  
                  $('.modal-backdrop').remove();
                  $state.go($state.current, {}, {reload: true});  
                }     
            }).error(function(error){
                
            });

        }

        $scope.blockProperty    = function(){
            console.log('pre block');
            var slectedRate         = $('#rate').val();//$('#property_id option:selected').attr('data-rate');  
            var date2               = new Date($('#end_date').val());console.log(date2);
            var date1               = new Date($('#start_date').val());

            var prop_day_rate       = (slectedRate/7).toFixed(2);
            var timeDiff            = Math.abs(date2.getTime() - date1.getTime());
            var diffDays            = Math.ceil(timeDiff / (60 * 60 * 24 * 1000))+1;            
            var calcRate            = Math.round(prop_day_rate*diffDays);
            var selected_prop_id    = $('#selected_property_id').val(); 
            $('#rate').val(calcRate);
            if($('#end_date').val() && selected_prop_id){
            //if($('#preblock_property_id').val()){

                if(!$('#preblock_comment').val())
                    return pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please add comment',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                else


                var formData        = $('#blockPropertyForm').serialize();
                console.log(formData, 'formData');
                var bookProperty    = 'api/v1/save-preblock-property?'+formData;
                
                $http.post(bookProperty).success(function(data){console.log(data);
                    $('#blockPropertyForm')[0].reset();
                    if(data.success=='1'){
                        var pnotify = new PNotify({
                                    title: 'Success',
                                    text: 'Successfully blocked the dates of property',
                                    type: 'success',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                      $('#pre-block-modal').modal('hide');
                      $('.modal-backdrop').remove();  
                      
                      var url = window.location.href;    
                      if (url.indexOf('?') > -1){
                        
                        
                        var curl = url.substring(0, url.indexOf('?'));
                        url = curl+'?id='+selected_prop_id;
                      }else{
                        url += '?id='+selected_prop_id;
                      }
                      
                      window.location.href = url;
                      
                      $window.location.reload();
                    }else if(data.success=='2'){
                        var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Some dates are already blocked please try again!',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    }
                }).error(function(error){
                    console.log(error);
                }); 
            /*}else{
                var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please select the property to preblock it',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
            }*/
          }else{ 

            var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please fill the required fields',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
          }           
        }

        if(localStorage.id){
            var owner_id = localStorage.id;
        }else{
            var owner_id = '0';
        }

        $('.reserve_preblock_date').click(function(){
            setTimeout(function(){

                var sid = $('#sid').val(); 
                $scope.orderByField = 'property_id';
                $scope.sortOrder = false;        
                var propertyDetails = 'api/v1/all-owner-preblock-properties-by-id?owner_id='+owner_id+'&property_id='+sid;
                $http.get(propertyDetails).success(function(data){console.log(data);
                    
                    if(data.success=='1'){
                        console.log(data);
                        $scope.preblock         = data.details;
                        $scope.totalItems       = data.details.length;
                        $scope.currentPage      = 1;
                        $scope.itemsPerPage     = 6;
                          
                        $scope.paginate = function(value) {
                            
                            var begin, end, index;
                            begin   = ($scope.currentPage - 1) * $scope.itemsPerPage;
                            end     = begin + $scope.itemsPerPage;
                            index   = data.details.indexOf(value);                    
                            return (begin <= index && index < end);
                        };
                    }
                                              
                }).error(function(error){
                    console.log(error);
                });
            }, 500);            
        });
        /*var preblockUrl = 'api/v1/all-owner-preblock-properties/'+owner_id;
        $http.get(preblockUrl).success(function(data){
            if(data.success=='1'){
                console.log(data);
                $scope.preblock         = data.details;
                $scope.totalItems       = data.details.length;
                $scope.currentPage      = 1;
                $scope.itemsPerPage     = 6;
                  
                $scope.paginate = function(value) {
                    
                    var begin, end, index;
                    begin   = ($scope.currentPage - 1) * $scope.itemsPerPage;
                    end     = begin + $scope.itemsPerPage;
                    index   = data.details.indexOf(value);                    
                    return (begin <= index && index < end);
                };
            }
        }).error(function(error){
            console.log(error);
        });*/

        $scope.deletePreblockDate = function(id){console.log(id);

            (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {

                                   
                $http.get('api/v1/all-preblock-properties/delete/'+id).success(function(data){
                    if(data.success=='1'){       
                      var pnotify = new PNotify({
                                        title: 'Success',
                                        text: 'Reserved Dates Deleted Successfully!',
                                        type: 'success',
                                        delay: 2000,
                                        styling: 'bootstrap3'
                                    });            
                      $('#pre-block-modal').modal('hide');
                      $('.modal-backdrop').remove();  
                      $state.go($state.current, {}, {reload: true}); 
                    }else{

                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: 'Reserved Dates Not Deleted, Try Again',
                                        type: 'error',
                                        delay: 2000,
                                        styling: 'bootstrap3'
                                    });
                    }
                }).error(function(error){
                    console.log(error);
                });
                $(".ui-pnotify-modal-overlay").remove();
                $state.go('properties-availability', {}, {reload: true});
            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });
            
        }
        }else{

            $location.url('/');
        }
         
    });    

    app.controller('OwnerSidebarCtrl', function($scope){

        /*$scope.status = localStorage.status;

        if(localStorage.status=='inactive'){
                
            $('li.add-property-cls').click(false);                        
            $('li.add-property-cls').click(function (){
                var pnotify = new PNotify({
                                    title: 'Error',
                                    text:  'Your account is expired, Please renewal your account and continue our services!',
                                    type: 'error',
                                    styling: 'bootstrap3'
                                });
            });
        }*/
    });


    app.filter('cmdate', [
        '$filter', function($filter) {
            return function(input, format) {
                return $filter('date')(new Date(input.replace(/-/g, "/")), format);
            };
        }
    ]);
    app.filter('cmdate1', [
        '$filter', function($filter) {
            return function(input, format) {
                return $filter('date')(new Date(input.replace(/-/g, "/")), format);
            };
        }
    ]);

})();