(function() {

    'use strict';

  var app = angular.module('directOwnersApp'); 
  app.directive("limitTo", [function() {
      return {
          restrict: "A",
          link: function(scope, elem, attrs) {              

              elem.bind('change keydown keyup', function (event) {
                var limit = parseInt(attrs.limitTo);
               // console.log(this.value+'__'+limit);
                if (this.value > limit) event.preventDefault();
              }); 
              
          }
      }
  }]);

 app.factory('Scopes', function($rootScope, $http, $location, $stateParams){
   return {
       
       hfn: function(searchData){        
                
              //var map;
              var markers = [];
              var mapOptions = {
                zoom:1,
                minZoom: 2,                
                panControl : false,                
                center: new google.maps.LatLng('20.5937', '78.9629'),  
                mapTypeId: google.maps.MapTypeId.ROADMAP
              };

              var map = new google.maps.Map(document.getElementById('map'), mapOptions);
              $rootScope.map = map;
              
              var bounds = new google.maps.LatLngBounds();
              var infoWindow = new google.maps.InfoWindow;
              var lastOpenedInfoWindow;
              var createMarker = function(_s3_path, markerData){
                for (var i=0; i<markerData.length; i++) {

                  var position = new google.maps.LatLng(markerData[i].lat, markerData[i].lng);
                  
                  if(markerData[i].image){ 
                    var img_path = _s3_path+"/holiday_essentials/"+markerData[i].image;
                  }else{
                    var img_path = _s3_path+"/property_images/default.jpg";
                  } 

                  var markerContent = '<div class="col-md-12 col-sm-12 map-property" >'+ 
                         '<a ng:href="#/property-details/'+markerData[i].web_link+'">'+
                         '<div class="vp-pd-side-product">'+
                          '<div class="vp-pd-side-product-inner">'+
                              '<img src='+img_path+' default-img>'+
                              '<div class="vp-pd-side-product-inner-content">'+
                              '<div class="vp-pd-side-product-inner-details">'+
                                  '<h3 class="vp-caption-heading">'+markerData[i].name+'</h3>'+
                              '</div>';                             
                              
                    markerContent+= '</div></div></div></a></div>';           
                  var marker = new google.maps.Marker({
                                    position: position,
                                    content: markerContent,
                                    map: $rootScope.map,
                                    icon: normalIcon(),
                                    index: i
                               });

                  markers.push(marker);    
                  bounds.extend(position);                   
                  map.fitBounds(bounds); 
                  google.maps.event.addListener(marker, 'click', function(){     
                    closeLastOpenedInfoWindo();         
                    $('.the_list').find('.he_list').eq(this.index).addClass('vp-pd-side-product-hover');

                    var $selectedLocation = $('div[class*=vp-pd-side-product-hover' );  
                    var $container = $('.vp-ps-left');

                    var scroll_div = $selectedLocation.offset().top - $container.offset().top + $container.scrollTop();                    
                    $container.animate({
                      scrollTop: scroll_div
                    }); 


                    infoWindow.setContent(this.content);                    
                    infoWindow.open($rootScope.map, this);
                    lastOpenedInfoWindow = infoWindow;
                  }); 

                  // google.maps.event.addListener(marker, 'mouseout', function(){    
                  //   $('.the_list').find('.he_list').eq(this.index).removeClass('vp-pd-side-product-hover');                 
                  //   closeLastOpenedInfoWindo();
                  // }); 

                  google.maps.event.addListenerOnce(map, 'bounds_changed', function(event) {
                    
                    if(this.getZoom() > 15) {
                      this.setZoom(15);
                      this.setCenter(marker.getPosition());
                    }else{
                      this.setCenter(marker.getPosition());
                    }

                  });        

                  google.maps.event.addDomListener(window, 'resize', function() {
                    
                  });                          
                }                                
              }

              var  closeLastOpenedInfoWindo = function() {
                if (lastOpenedInfoWindow) {
                    lastOpenedInfoWindow.close();
                }
              }             

              $rootScope.hoverIn = function(i){
                   closeLastOpenedInfoWindo();
                 if(i>=0){//console.log('not equal');
                   closeLastOpenedInfoWindo();
                   google.maps.event.trigger(markers[i],'click');                                            
                 }

              }

              $rootScope.hoverOut = function(i){ 
                infoWindow.close();
              }

              
              // functions that return icons.  Make or find your own markers.
              function normalIcon() {
                return {
                  url: 'uploads/location-ping.png'
                };
              }
              function highlightedIcon() {
                return {
                  url: 'uploads/location-ping-hover.png'
                };
              }
                                
                var searchRequest             = '', city = $location.search().city, activity = $location.search().activity;   

                var searchUrl                 = $('.he-search-filters').serialize();
                var selected_currency_name    = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'';
                var selected_currency_symbol  = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'';
                 
                if(city){
                    
                  searchUrl = 'city='+city+'&';
                }
                 
                if(activity){// console.log('here123');
                  searchUrl+= searchRequest+'&activities_list='+activity;
                } 
                             
                var url = 'api/v1/he-search-results?'+searchUrl;
                $http({method : 'get',url:url}).success(function(data, status) {//console.log(data);
                    if(data.success==1){
                      $rootScope.he_details = data.he_details;
                      $rootScope._s3_path   = data._s3_path;
                    }else{
                      $rootScope.he_details = 0;
                    }
                    if(data.success==1){
                        var len = data.he_details.length;
                        if(len>0){
                          var result = [];
                            for (var i=0;i<len;i++){                                
                                result.push(data.he_details[i]);
                            }

                            createMarker(data._s3_path, result);
                        }               
                    }
                }).error(function(data, status) {

                }); 

              
            google.maps.event.addDomListener(document.getElementById("map"), 'load');      
        } 
   }
  }).controller('HeMapController',function(Scopes,$scope, $http, $timeout, $location) {
               
    Scopes.hfn(); 

  }).controller('holidayEssentialsCtrl', function(Scopes, $scope, $http, $timeout, $location, $window) {     
           
      $scope.activities_list        = ['Restaurants & Bars','Car / Bike Rental','Shopping','Day Trips & Tours','Concerts & Shows','Sports Facilities','Other'];        
      $scope.formData = {};
      $scope.$watch('formData', function() {
          Scopes.hfn(); 
      }, true);


      $scope.formData.city =  $location.search().city;
      $scope.formData.activities_list =  $location.search().activity;
      //$scope.activity1 =  $location.search().activity;
      // $scope.onCountryChange = function(date){
                
      //   $location.search('country', $scope.formData.country);
      //   $location.search('city', '');
      // }

      var autocomplete;
      autocompleteInitialize();
      function autocompleteInitialize() {
        autocomplete = new google.maps.places.Autocomplete(
            /** @type {HTMLInputElement} */(document.getElementById('list_city')),
            { types: ['geocode'] });

       
        google.maps.event.addListener(autocomplete, 'place_changed', function(results, status) {                          //$scope.formData.city = '';
              
           $scope.formData.city = $('#list_city').val();
           
        });                      
      }
      $scope.onCityChange = function(){   
        $location.search({'city':$scope.formData.city, 'activity':$scope.formData.activities_list});  
      }
      $scope.onActivityChange = function(){   
        $location.search({'activity':$scope.formData.activities_list, 'city':$scope.formData.city});  
      }

  }).controller('heListCtrl', function(Scopes, $http, $scope, $location, $window, $state){ 
         
     $scope.countClicks = function(id){

        var url = 'api/v1/count-he-clicks?id='+id;

        $http({
          url: url,
          method: "get"
        }).success(function(data) {

            $window.location.reload();
        }).error(function(error){

        }); 
     }    
    Scopes.hfn();       
      
  });  
    
})();