//(function() {

    'use strict';

    var app = angular.module('directOwnersApp');
//console.log('home page');
    app.filter('removeSpacesWithHypenThenLowercase', function () {
          return function (text) {
            var str = text.replace(/\s+/g, '-');
            return str.toLowerCase();
          };
    });
    
    app.controller('HomePageController', function($scope, $http, $filter, $state, $window) {      

      $(document).on('change','#required_base_currency', function(){
          var selected_currency       = $(this).val();
          var selected_currency_name  = $('#required_base_currency option:selected').val();
          var selected_symbol         = $('#required_base_currency option:selected').attr('data-symbol');
          $scope.currency_symbol      = selected_currency;
          $http.get('api/v1/recent-properties-list/0?selected_currency='+selected_currency_name+'&page=home').success(function(properties) {
            if(properties.properties_details){
              $scope.properties       = properties.properties_details;
              $scope._s3_path         = properties._s3_path;
            }else{
            $scope.properties         = '';
            }
          }).error(function(error) {
               $scope.error = error;
          });
      });
      
      var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
    	$http.get('api/v1/recent-properties-list/0?selected_currency='+selected_currency_name+'&page=home').success(function(properties) {
       if(properties.properties_details){
          $scope.currency_symbol  = localStorage.currency_value?localStorage.currency_value:'eur';
          $scope.properties       = properties.properties_details;
          $scope._s3_path         = properties._s3_path;
       }else{
        $scope.properties = '';
       }
      }).error(function(error) {
               $scope.error = error;
      });
    });

    app.controller('SinglePropertySearchCtrl', function($scope, $location, $http){

       $scope.getPropertySearchResult = function(){

          var val = $('#propertyId').val();
          $http.post('api/v1/search-record?property_id='+val).success(function(data){
            if(data=='1'){

                $location.url('property-details/'+val);
            }else{
                var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'No property found with that property id!',
                                    type: 'error',
                                    //styling: 'bootstrap3',
                                    //delay:100
                                });
                $location.url('/');
            }
          }).error(function(){

          });
       } 

       $scope.searchProperty = function(id){
          var val = $('#propertyId').val();
          $http.post('api/v1/search-record?property_id='+val).success(function(data){
            if(data=='1'){

                $location.url('property-details/'+val);
            }else{

                 var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'No property found with that property id!',
                                    type: 'error',
                                    styling: 'bootstrap3',
                                    sticker: false
                                    //delay:100
                                });
                //alert('No property found with that property id');
                $location.url('/');
            }
          }).error(function(){

          });
       }
              
    });

    app.controller('HomePageSearchResultsCtrl', function($scope, $location, $http){

	    var pl_country_url = 'api/v1/cproperty-country-list';
	    $http.get(pl_country_url).success(function(result){
	        $scope.country = result.data;
	    }).error(function(){

	    });

	    
      	$scope.guest_limit = ['1','2', '3', '4', '5', '6', '7', '8'];
      	var today = new Date();
        $scope.arrival_time = new Date();
        $scope.departure_time = new Date();
        $scope.propDateFormat = 'yyyy-MM-dd';
        $scope.availableDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: today,
            maxDate: new Date(2030, 5, 22)
        };
        $scope.expireDateOptions = {
            formatYear: 'yy',
            startingDay: 1,
            minDate: today,
            maxDate: new Date(2030, 5, 22)
        };
        $scope.availableDatePopup = {
            opened: false
        };
        $scope.expireDatePopup = {
            opened: false
        };
        $scope.ChangeExpiryMinDate = function(availableDate) {
            if (availableDate != null) {
                var expiryMinDate = new Date(availableDate.setDate(availableDate.getDate() + 1));
                $scope.expireDateOptions.minDate = expiryMinDate;
                $scope.ExpireDate = expiryMinDate;
                $scope.end_date  = expiryMinDate;
                setTimeout(function(){
                  if($scope.end_date){
                    $('#departure_time').val('');
                  }
                },0);

            }
        };
        $scope.ChangeExpiryMinDate();
        $scope.OpenAvailableDate = function() {
            $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
        };
        $scope.OpenExpireDate = function() {
            $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
        }; 

       	$scope.disabled = function(date, mode) {
            return (mode === 'day' && (date.getDay() === 0 || date.getDay() === 6));
       	};    

      	$scope.toggleMin = function() {
          $scope.minDate = $scope.minDate ? null : new Date();
        };
      	$scope.toggleMin();
      	$scope.homePageSearchResults = function(){

          var city 				= $('#home_city').val();
          var arrival_time 		= $('#arrival_time').val();
          var departure_time 	= $('#departure_time').val();
          var guest_limit 		= $('#guest_limit').val();
          var country 			= $('#country').val();
          $location.path('/property-search').search({'country': country,'city': city, 'arrival_time':arrival_time, 'departure_time':departure_time, 'guest_limit':guest_limit});
      	}

      

    });

    app.controller('TestimonialsCtrl', function($scope, $location, $http){

      $http.get('api/v1/testimonial-by-priority').success(function(data) {
               if(data.success=='1'){
                //console.log(data.result);
                  $scope.testimonial = data.result;
                  
               }else{
                  $scope.testimonial = '';
               }
      }).error(function(error) {
               $scope.error = error;
      });
    });

    app.controller('destinationsCtrl', function($scope, $location, $http, $window, $state){
      
      $scope.saveFavourite = function(property_id,fprop_status,f_id){

       
            if(fprop_status && f_id){//console.log('if');
              //if (confirm("Are you sure to want to delete favourite?")){
                
                var data = {'f_id': f_id};
                  var url  = 'api/v1/delete-favourite-property?f_id='+f_id; 
                  $http({method : 'get',url:url})
                   .success(function(data, status) {//console.log(data);
                    if(data.success=='1'){
                      var pnotify = new PNotify({
                                      title: 'Success',
                                      text: data.message,
                                      type: 'success',
                                      styling: 'bootstrap3',
                                    });
                       $state.go($state.current, {}, { reload: true });
                    }
                   })                             
              //}          

            }else{//console.log('else');
              //if (confirm("Are you sure to want to add favourite?")){
                $.getJSON("https://jsonip.com?callback=?", function (data1) {
                  var data = {'property_id': property_id, 'status':'1', 'ip_address':data1.ip};
                  var url  = 'api/v1/save-favourite-property'; 
                  $http({method : 'post',url:url, data:data})
                   .success(function(data, status) {
                    if(data.success=='1'){
                      var pnotify = new PNotify({
                                      title: 'Success',
                                      text: data.message,
                                      type: 'success',
                                      styling: 'bootstrap3',
                                    });
                       $state.go($state.current, {}, { reload: true });
                    }
                   })
                   .error(function(error){
                      var pnotify = new PNotify({
                                      title: 'Error',
                                      text: 'Favourite not added!',
                                      type: 'error',
                                      styling: 'bootstrap3',
                                    });
                   });
                });
              //}
            }
            
          }   
            
      var url  = 'api/v1/get-user-favourites'; 
        $http({method : 'get',url:url})
         .success(function(data, status) {//console.log(data);
          if(data.properties_details){

              $scope.properties = data.properties_details;
              $scope._s3_path   = data._s3_path;
              $scope.ip_address = data.ip_address;
          }else{
            $scope.properties = '';
          }
        })                             
          

      /*$http.get('api/v1/recent-properties-list/0').success(function(properties) {console.log(properties);
               if(properties.properties_details){

                  $scope.properties = properties.properties_details;
                  $scope.ip_address = properties.ip_address;
               }else{
                $scope.properties = '';
               }
      }).error(function(error) {
               $scope.error = error;
      });*/

    });
    app.controller('holiday-essentialsCtrl', function($scope, $location, $http){});
    app.controller('dealsCtrl', function($scope, $location, $http, $state){
        
      $scope.saveFavourite = function(property_id,fprop_status,f_id){
       
        if(fprop_status && f_id){
          //if (confirm("Are you sure to want to delete favourite?")){
            
            var data = {'f_id': f_id};
              var url  = 'api/v1/delete-favourite-property?f_id='+f_id; 
              $http({method : 'get',url:url})
               .success(function(data, status) {//console.log(data);
                if(data.success=='1'){
                  var pnotify = new PNotify({
                                  title: 'Success',
                                  text: data.message,
                                  type: 'success',
                                  styling: 'bootstrap3',
                                });
                   $state.go($state.current, {}, { reload: true });
                }
               })                             
          //}          

        }else{
          //if (confirm("Are you sure to want to add favourite?")){
            $.getJSON("https://jsonip.com?callback=?", function (data1) {
              var data = {'property_id': property_id, 'status':'1', 'ip_address':data1.ip};
              var url  = 'api/v1/save-favourite-property'; 
              $http({method : 'post',url:url, data:data})
               .success(function(data, status) {
                if(data.success=='1'){
                  var pnotify = new PNotify({
                                  title: 'Success',
                                  text: data.message,
                                  type: 'success',
                                  styling: 'bootstrap3',
                                });
                   $state.go($state.current, {}, { reload: true });
                }
               })
               .error(function(error){
                  var pnotify = new PNotify({
                                  title: 'Error',
                                  text: 'Favourite not added!',
                                  type: 'error',
                                  styling: 'bootstrap3',
                                });
               });
            });
          //}
        }            
      }  

        $scope.redirectToPropertyDetails = function(){

          $('#property_deals_modal').modal('hide');
          //console.log('tets test ');
        }

        $scope.getDealsBetweenDates = function(){

          console.log($('#deals_datepicker').val());
        } 

        $scope.getPropertyMoreDeals = function(prop_id){

          var url = 'api/v1/get-property-deals?prop_id='+prop_id;
          $http({
            method:'get',
            url:url
          }).success(function(dealsObj){
            //console.log(dealsObj);
              $scope.deals = dealsObj.data;  
          }).error(function(){

          });
        }

        var url = 'api/v1/get-deal-properties';
        $http({
          method:'get',
          url:url
        }).success(function(result){

          if(result.success==1){

            $scope.properties   = result.data;
            $scope._s3_path     = result._s3_path;
            $scope.totalItems   = result.data.length;
            $scope.currentPage  = 1;
            $scope.numPerPage   = 9;
              
            $scope.paginate = function(value) {
                
                var begin, end, index;
                begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                end   = begin + $scope.numPerPage;
                index   = result.data.indexOf(value);
               // console.log(index);
                return (begin <= index && index < end);
            };  

            /*if(result.data[0].deals_count>1){

              $('#show_more_details').show();
            }*/          
            
          }else{

            $scope.properties = 0;
          }  
            

        }).error(function(error){

            //console.log(error);

        });

        var url = 'api/v1/get-countries-list';
        $http({
          method:'get',
          url:url
        }).success(function(result){

          $scope.country = result.data;

        }).error(function(error){

           // console.log(error);

        });

        $('.deal_filter_request').change(function(){            
            $scope.properties = [];
            var filter_type = $('.deals-filter a.active').attr('data-filter');
            
            var formData    = $('#deals_filter_form').serialize()+'&filter_type='+filter_type;
            var url         = 'api/v1/get-filter-deal-request?'+formData;
            
            $http({
              method:'get',              
              url:url              
            }).success(function(result){
                //console.log(result);
                if(result.success==1){

                  $scope.properties   = result.data;
                  
                  $scope.totalItems   = result.data.length;
                  $scope.currentPage  = 1;
                  $scope.numPerPage   = 9;
                    
                  $scope.paginate = function(value) {
                      
                      var begin, end, index;
                      begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                      end     = begin + $scope.numPerPage;
                      //console.log(result.data);
                      index   = result.data.indexOf(value);
                      //console.log(index);
                      return (begin <= index && index < end);
                  }; 
                }else{

                  $scope.properties = [];
                }

            }).error(function(error){

                console.log(error);

            });
            
        });

        /*var i=1;
        $('#show_more_details').click(function(){

            i++;
            $(this).attr('data-load-val', i);
            var page_count    = $(this).attr('data-load-val');
            var filter_type   = $('.deals-filter a.active').attr('data-filter');
            var deals_url     = 'api/v1/load-more-deals?page_count='+page_count+'&filter_type='+filter_type;
            $http({
              method:'get',              
              url:deals_url,
            }).success(function(deals_obj){

              console.log(deals_obj);

            }).error(function(){

            });
        });*/

        $('#country').change(function(){
          
          var selected_country = $(this).val();
          var url = 'api/v1/get-cities-by-country';
          var data = {'country':selected_country};
          $http({
            method:'get',
            params:data,
            url:url              
          }).success(function(result){

            $scope.city = result.data;

          }).error(function(error){

              console.log(error);

          });
        });

        $scope.getDealFilters = function(item){

          console.log(item);
        }

        $scope.getDealPropertiesByCategory = function(type){
            $scope.properties = [];
            var url = 'api/v1/get-filetered-deals'
            var data = {'filter_type':type};              
            $http({
              method:'get',
              params:data,
              url:url              
            })
            .success(function(result) {
                
                console.log(result);
                if(result.success==1){

                  $scope.properties = result.data;
                  $scope.totalItems   = result.data.length;
                  $scope.currentPage  = 1;
                  $scope.numPerPage   = 9;
                    
                  $scope.paginate = function(value) {
                      
                      var begin, end, index;
                      begin   = ($scope.currentPage - 1) * $scope.numPerPage;
                      end     = begin + $scope.numPerPage;
                      console.log(result.data);
                      index   = result.data.indexOf(value);
                      console.log(index);
                      return (begin <= index && index < end);
                  }; 
                }else{

                  $scope.properties = 0;
                }
            })
            .error(function(error){

            });
        }
    });
    app.controller('ContactPageCtrl', function($scope, $http){

      $scope.saveContactDetails = function(){
        
          var url = 'api/v1/save-contact-details?'+$('#contactForm').serialize();
          $http.post(url).success(function(result) {
                 $('#contactForm')[0].reset(); 
                 if(result.success=='1'){
                    var pnotify = new PNotify({
                                    title: 'Success',
                                    text: 'Contact details saved successfully!',
                                    type: 'success',
                                    styling: 'bootstrap3',                                    
                                });
                 }
        }).error(function(error) {
                 $scope.error = error;
        });
      }
    });

    app.controller('TestimoanialsSaveController', function($scope, $http, $state, $stateParams, $location){       
              
        $scope.cname        = $location.search().name;

        $scope.owner_id     = $location.search().owner;
        $scope.property_id  = $location.search().property_id;

        var url = 'api/v1/property-details-by-id?property_id='+$scope.property_id;
        $http.get(url).success(function(result){
            
          if(result.success==1){

            $scope.data           = result.data;
            $scope.img            = result.img_src;
            $scope.prop_title     = result.prop_title;
          }

        }).error(function(error){
            if(error.success=='0'){
                $scope.errorMessage = error.message;
            }
        });

        $scope.submitTestimonialForm = function(){
            
            var form = $('#testimonial_form').serialize();
            var crating = $('input:radio.crating:checked').val();
            var testimonial_comment = $('.testimonial_comment').val();
            console.log(crating, 'crating');
            console.log(testimonial_comment, 'testimonial_comment');

            if(!crating){

              var pnotify = new PNotify({
                                    title: 'Error',
                                    text: 'Please, rate',
                                    type: 'error',
                                    styling: 'bootstrap3',                                    
                                });
            }else{

              if(!testimonial_comment){

                var pnotify = new PNotify({
                                      title: 'Error',
                                      text: 'Please, write a comment',
                                      type: 'error',
                                      styling: 'bootstrap3',                                    
                                  });
              }else{

                var url = 'api/v1/save-testimonials?'+form;
                $http.post(url).success(function(data){console.log(data);
                    if(data.success=='1'){
                        $state.go('/', {}, {reload: true});
                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: data.message,
                                        type: 'success',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });  
                    }
                }).error(function(error){
                    if(error.success=='0'){
                        $scope.errorMessage = error.message;
                    }
                });
              }              
            }
            
            console.log('after conditions');
            
        }
      });   
        