(function() {

    'use strict';

 var app = angular.module('directOwnersApp');
 
  
  app.directive("initFromForm", function ($parse, $location) {
    return {
      link: function (scope, element, attrs) {
        var attr = attrs.initFromForm || attrs.ngModel || element.attrs('name'),
        val = attrs.value;

        if($location.search().arrival_time){

          if (attrs.ngModel === "formData.arrival_time") {val = new Date($location.search().arrival_time)}
        }
        if($location.search().departure_time){
          if (attrs.ngModel === "formData.departure_time") {val = new Date($location.search().departure_time)}
        }        
        scope.formData.country      = $location.search().country;
        scope.formData.city         = $location.search().city;
        scope.formData.guest_limit  = $location.search().guest_limit;
        $parse(attr).assign(scope, val);
      }
    };
  });

  app.directive("limitTo", [function() {
      return {
          restrict: "A",
          link: function(scope, elem, attrs) {              

              elem.bind('change keydown keyup', function (event) {
                var limit = parseInt(attrs.limitTo);
               // console.log(this.value+'__'+limit);
                if (this.value > limit) event.preventDefault();
              }); 
              
          }
      }
  }]);


  app.directive("regExInput", function(){
  "use strict";
    return {
        restrict: "A",
        require: "?regEx",
        scope: {},
        replace: false,
        link: function(scope, element, attrs, ctrl){
          element.bind('keypress', function (event) {
            var regex = new RegExp(attrs.regEx);
            var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
            if (!regex.test(key)) {
               event.preventDefault();
               return false;
            }
          });
        }
    };
  });


 app.factory('ScopesFunc', function($rootScope, $http,$window, $location, $stateParams){
   return {
      fn: function(searchData){        
                
              //var map;
              var markers = [];
              var mapOptions = {
                zoom:1,
                minZoom: 2,                
                panControl : false,                
                center: new google.maps.LatLng('20.5937', '78.9629'),  
                mapTypeId: google.maps.MapTypeId.ROADMAP
              };

              var map = new google.maps.Map(document.getElementById('map'), mapOptions);
              $rootScope.map = map;
              
              var bounds = new google.maps.LatLngBounds();
              var infoWindow = new google.maps.InfoWindow;
              var lastOpenedInfoWindow;
              var createMarker = function(_s3_path, markerData){
                console.log(markerData, 'markerData');
                for (var i=0; i<markerData.length; i++) {

                  var position = new google.maps.LatLng(markerData[i].latitude, markerData[i].longitude);
                  
                  if(markerData[i].property_image){ 
                    var img_path = _s3_path+"/property_images/"+markerData[i].property_id+"/"+markerData[i].property_image;
                  }else{
                    var img_path = _s3_path+"/property_images/default.jpg";
                  } 

                  var markerContent = '<div class="col-md-12 col-sm-12 map-property" ng-repeat="prop in properties" ng-if="properties!=0">'+ 
                         '<a ng:href="#/property-details/'+markerData[i].property_id+'">'+
                         '<div class="vp-pd-side-product">'+
                          '<div class="vp-pd-side-product-inner">'+
                              '<img src='+img_path+' default-img>'+
                              '<div class="vp-pd-side-product-inner-content">'+
                              '<div class="vp-pd-side-product-inner-details">'+
                                  '<h3 class="vp-caption-heading">'+markerData[i].property_title+'</h3>'+
                              '</div>'+   
                              '<div class="col-md-8 col-xs-8">'+
                                  '<p class="vp-para-book">'+markerData[i].space_type+'</p>'+   
                              '</div>'+
                              '<div class="col-md-4 col-xs-4 text-center">'+
                                  '<p class="vp-para-book"><span>'+markerData[i].guest_limit+'</span>guests</p>'+ 
                              '</div>';
                  if(markerData[i].testimonial_rating){
                    markerContent+='<div class="col-md-12 col-xs-12 vp-pd-rating">'+
                                      '<span> <b>'+markerData[i].testimonial_rating+'%</b> Positive Reviews </span>'+
                                    '</div>';
                  }            
                              
                    markerContent+= '</div></div></div></a></div>';           
                  var marker = new google.maps.Marker({
                                    position: position,
                                    content: markerContent,
                                    map: $rootScope.map,
                                    icon: normalIcon(),
                                    index: i,
                                    prop_id: markerData[i].main_property_id
                               });

                  markers.push(marker);                    

                  bounds.extend(position); 
                  /*if (bounds.getNorthEast().equals(bounds.getSouthWest())) {
                     var extendPoint = new google.maps.LatLng(bounds.getNorthEast().lat() + 0.01, bounds.getNorthEast().lng() + 0.01);
                     bounds.extend(extendPoint);                     

                  }*/ 
                  map.fitBounds(bounds);
                  var x = 0, y = 0;
                  google.maps.event.addListener(marker, 'mouseover', function(e){      
                    closeLastOpenedInfoWindo();
                    console.log('mouse over event');
                    $('.prop_main_div').find('.prop_inner_div').eq(this.index).addClass('vp-pd-side-product-hover');    

                    

                    setTimeout(function(){

                      var $selectedLocation = $('div[class*=vp-pd-side-product-hover' );  
                      var $container = $('.vp-ps-left');

                      var scroll_div = $selectedLocation.offset().top - $container.offset().top + $container.scrollTop();                    
                      $container.animate({
                        scrollTop: scroll_div
                      }); 
                    }, 2000); 



                    infoWindow.setContent(this.content);                    
                    infoWindow.open($rootScope.map, this);
                    lastOpenedInfoWindow = infoWindow;
                  });

                  google.maps.event.addListener(marker, 'mouseout', function(){      
                    $('.prop_main_div').find('.prop_inner_div').eq(this.index).removeClass('vp-pd-side-product-hover');               
                    closeLastOpenedInfoWindo();
                  }); 


                  google.maps.event.addListenerOnce(map, 'bounds_changed', function(event) {
                    
                    if(this.getZoom() > 15) {
                      this.setZoom(15);
                      this.setCenter(marker.getPosition());
                    }else{
                      this.setCenter(marker.getPosition());
                    }

                  });        

                  google.maps.event.addDomListener(window, 'resize', function() {
                    
                  });                          
                }                                
              }

              var  closeLastOpenedInfoWindo = function() {
                if (lastOpenedInfoWindow) {
                    lastOpenedInfoWindow.close();
                }
              }             

              $rootScope.hoverIn = function(i){
                  closeLastOpenedInfoWindo();
                  
                 if(i>=0){//console.log('not equal');
                   closeLastOpenedInfoWindo();
                   google.maps.event.trigger(markers[i],'mouseover');                                            
                 }

              }

              $rootScope.hoverOut = function(i){ 
                infoWindow.close();
              }

              // functions that return icons.  Make or find your own markers.
              function normalIcon() {
                return {
                  url: 'uploads/location-ping.png'
                };
              }
              function highlightedIcon() {
                return {
                  url: 'uploads/location-ping-hover.png'
                };
              }

              
                                
                var searchRequest   = '', city = $location.search().city, arrival_time1 = $location.search().arrival_time;
                var departure_time1 = $location.search().departure_time, guest_limit = $location.search().guest_limit;

               
               
                if(city){
                    
                    searchRequest+= 'city='+city+'&';
                }
                 
                if(arrival_time1){// console.log('here123');
                    searchRequest+= 'city='+city+'&arrival_time='+arrival_time1+'&';
                } 
                if(departure_time1){                    
                    
                    searchRequest+=  'city='+city+'&arrival_time='+arrival_time1+'&departure_time='+departure_time1+'&';
                }
                if(guest_limit){
                    searchRequest+= 'city='+city+'&arrival_time='+arrival_time1+'&departure_time='+departure_time1+'&guest_limit='+guest_limit+'&';
                } 

                if(!city && !arrival_time1 && departure_time1){

                    searchRequest+=  'city='+city+'&arrival_time='+arrival_time1+'&departure_time='+departure_time1+'&';
                }

                if(!city && !arrival_time1 && departure_time1){

                    searchRequest+=  'city='+city+'&arrival_time='+arrival_time1+'&departure_time='+departure_time1+'&';
                }

                //console.log(searchRequest, 'searchRequest');
                
                var width = $(window).width();
                if(width<991){
                 // console.log(searchRequest, 'searchRequest22');
                  if(city && arrival_time1 && departure_time1 && guest_limit){             
                                    
                    var searchUrl = $('.search-mob-filters').serialize()+'&'+searchRequest;
                  }else if(guest_limit){

                    $rootScope.guest_limit1 = guest_limit;
                    var searchUrl = $('.search-mob-filters').serialize()+'&'+searchRequest;

                  }else if(arrival_time1 && departure_time1){
                    
                    var searchUrl = $('.search-mob-filters').serialize()+'&'+searchRequest;

                  }else if(!arrival_time1 && !departure_time1){
                    
                    var searchUrl = $('.search-mob-filters').serialize()+'&'+searchRequest;
                  }else if(!arrival_time1 && !departure_time1){
                    
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && !departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else{
                  	var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }
                }else{
                 // console.log(searchRequest, 'searchRequest11');
                  if(city && arrival_time1 && departure_time1 && guest_limit){             
                                    
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(city){
                    
                    $rootScope.guest_limit1 = guest_limit;
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;

                  }else if(guest_limit){

                    $rootScope.guest_limit1 = guest_limit;
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;

                  }else if(arrival_time1 && departure_time1){
                    
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;

                  }else if(!arrival_time1 && !departure_time1){
                    
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && !departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else if(!city && arrival_time1 && departure_time1){
                    var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }else{
                  	var searchUrl = $('.search-filters').serialize()+'&'+searchRequest;
                  }
                }
                
                var min = $('#min_price').val() || 0;
                var max = $('#max_price').val() || 0;
                
                var selected_currency_name = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'';
                var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'';

                $('#btnResetPropType').click(function(){
                 
                  $('.property_type_cls').val('');
                  $('#search-filters')[0].reset();                   
                                   
                  $('#departure_time1').val('');
                  $('#arrival_time1').val('');
                  $('#guest_limit').prop("selected", false);
                  $("#guest_limit").val('').find("option[value='']").attr('selected', true);
                  $('#min_price').val('');
                  $('#max_price').val('');
                  $('#list_city').val('');
                  $location.search('city', '');
                  searchUrl = '';
                  var selected_currency_name = $('#required_base_currency option:selected').val()?$('#required_base_currency option:selected').val():'eur';
                  var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'€';
                  var url = 'api/v1/search-results?'+searchUrl+'&selected_currency='+selected_currency_name+'&selected_currency_symbol='+selected_currency_symbol;console.log(url,'ttt');
                  $http({method : 'get',url:url}).success(function(data, status) {//console.log(data);
                      if(data.properties_details){
                        //console.log('iffff');
                         $rootScope.properties = data.properties_details.prop;
                         $rootScope._s3_path   = data._s3_path;
                         /*$rootScope.one_day = data.properties_details.one_day_record;
                         $rootScope.minute_record = data.properties_details.minute_record;
                         $rootScope.minute_record = data.properties_details.minute_record;*/
                      }else{

                     // console.log('elseeee'); 
                         $rootScope.properties = 0;
                      }
                      if(data.properties_details){
                          var len = data.properties_details.prop.length;
                          if(len>0){
                            var result = [];
                              for (var i=0;i<len;i++){                                
                                  result.push(data.properties_details.prop[i]);
                              }
                              console(result, 'result');
                              createMarker(data._s3_path, result);
                          }               
                      }
                  }).error(function(data, status) {

                  }); 
                });

                $('#required_base_currency').change(function(e){

                  if (null == this.ran || this.symb!=$(this).val()) {
                    e.preventDefault();
                    var selected_currency_name = $(this).val();
                    var selected_currency_symbol = selected_currency_name?$('#required_base_currency option:selected').attr('data-symbol'):'';
                    console.log('selected_currency_symbol', selected_currency_symbol);
                    var url = 'api/v1/search-results?'+searchUrl+'&selected_currency='+selected_currency_name+'&selected_currency_symbol='+selected_currency_symbol+'&'+$('#search-filters1').serialize();console.log(url, 'pppp');
                    $http({method : 'get',url:url}).success(function(data, status) {//console.log(data);
                        if(data.properties_details){
                          $rootScope.properties = data.properties_details.prop;
                          $rootScope._s3_path   = data._s3_path;
                        }else{

                          $rootScope.properties = 0;
                        }
                        if(data.properties_details){
                            var len = data.properties_details.prop.length;
                            if(len>0){
                              var result = [];
                                for (var i=0;i<len;i++){                                
                                    result.push(data.properties_details.prop[i]);
                                }

                                createMarker(data._s3_path, result);
                            }               
                        }
                    }).error(function(data, status) {

                    }); 
                    this.ran = true;
                    this.symb = selected_currency_name;
                  }
                });
             
                var url = 'api/v1/search-results?'+searchUrl+'&selected_currency='+selected_currency_name+'&selected_currency_symbol='+selected_currency_symbol;console.log(url,'iiii');
                $http({method : 'get',url:url}).success(function(data, status) {//console.log(data);
                    if(data.properties_details){
                      $rootScope.properties = data.properties_details.prop;
                      $rootScope._s3_path   = data._s3_path;
                    }else{
                      $rootScope.properties = 0;
                    }
                    if(data.properties_details){
                        var len = data.properties_details.prop.length;
                        if(len>0){
                          var result = [];
                            for (var i=0;i<len;i++){                                
                                result.push(data.properties_details.prop[i]);
                            }

                            createMarker(data._s3_path, result);
                        }               
                    }
                }).error(function(data, status) {

                }); 

              
            google.maps.event.addDomListener(document.getElementById("map"), 'load');      
        }          
    }
 }).controller('MapController',function(ScopesFunc,$scope, $http, $timeout, $location) {
               
    ScopesFunc.fn(); 


 }).controller('PropertiesController', function(ScopesFunc, $scope, $http, $timeout, $location, $window) {
      
      $scope.currency_name = 'eur';

      var pl_country_url = 'api/v1/cproperty-country-list';
  	  $http.get(pl_country_url).success(function(result){
  	        $scope.country = result.data;
  	        if($location.search().country!=''){
  	            $scope.sCountry = $location.search().country;           
  	        }
  	  }).error(function(){

  	  });
       
      $scope.compareMaxPrice = function(price){

          var max_price = $('#max_price_num').val();
          
          setTimeout(function(){

            if(parseInt(price)>parseInt(max_price)){          

                $('#max_price').val('');  

                var pnotify = new PNotify({
                                      title: 'Error',
                                      text: 'You can\'t enter more than '+max_price+', it is the maximum price.',
                                      type: 'error',
                                      styling: 'bootstrap3',
                                    });        
              
            }
          }, 300); 
      } 

      var url = 'api/v1/property-minmax-rates';
      $http
      .get(url)
      .success(function(result){

       if(result.success==1){

          $scope.max_price_limit = result.data.max_price;
       } 
        

      }).error(function(error){

      });

      
      $scope.guest_limit          = ['1','2', '3', '4', '5', '6', '7', '8'];
      $scope.space_type           = ['Apartment','Chalet','Cottage','Villa'];
      $scope.single_room          = ['1','2','3','4','5','6','7','8'];
      $scope.double_room          = ['1','2','3','4','5','6','7','8']; 
      $scope.twin_room            = ['1','2','3','4','5','6','7','8']; 
      $scope.other_room           = ['1','2','3','4','5','6','7','8']; 
      $scope.bedroom              = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];    
      $scope.bedroom_type         = ['Single','Double','Twin','Other'];
      $scope.bathroom             = ['Any','1','2','3','4','5','6','7','8'];
      $scope.minimum_stay         = ['Any','1','2','3','4','5','6','7','8','9','10','11','12','13','14'];
        
      
      $scope.ChangeExpiryMinDate  = function(availableDate) {
          if (availableDate != null) {

            var dtime = new Date($('#arrival_time').val());            
            var ddtime = $('#departure_time').val()?new Date(dtime.setDate(dtime.getDate() + 1)):new Date();
            var expiryMinDate = new Date(availableDate.setDate(availableDate.getDate() + 1));  
            $scope.expireDateOptions.minDate = availableDate;
            $scope.formData.departure_time = availableDate;
            $scope.ExpireDate = expiryMinDate;                
            setTimeout(function(){
              if($scope.formData.departure_time){

                $scope.formData.departure_time = '';
                $('#departure_time1').val('');
              }
            },0);
          }
      };
      var i = 0;
      $scope.ChangeExpiryMinDate();
      $scope.OpenAvailableDate = function() {
        $('#arrival_time').attr('data-key', i);
            i++;
          $scope.availableDatePopup.opened      = !$scope.availableDatePopup.opened;
      };
      $scope.OpenExpireDate = function() {
        $('#departure_time').attr('data-key', i);
            i++;
          $scope.expireDatePopup.opened         = !$scope.expireDatePopup.opened;
      }; 

      $scope.arrival_time         = new Date();
      
      $scope.propDateFormat       = 'yyyy-MM-dd';
      $scope.availableDateOptions = {
          formatYear: 'yy',
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
      };
      $scope.expireDateOptions    = {
          formatYear: 'yy',
          maxDate: new Date(2030, 5, 22)
      };
      $scope.availableDatePopup   = {
          opened: false
      };
      $scope.expireDatePopup      = {
          opened: false
      };

      $scope.checkPriceRange = function() {
        var min = $scope.formData.min_price || 0;
        var max = $scope.formData.max_price || 0;        
        if (min > max) 
          $scope.formData.max_price = null;
          $('#max_price').css('border-color', 'red');

      }
      


      $scope.formData = {};

           $scope.$watch('formData', function() {
                ScopesFunc.fn(); 
           }, true);

           $scope.onCountryChange = function(date){
              	
          	$location.search('country', $scope.formData.country);
            $location.search('city', '');
           }

           var autocomplete;
              autocompleteInitialize();
              function autocompleteInitialize() {
                autocomplete = new google.maps.places.Autocomplete(
                    /** @type {HTMLInputElement} */(document.getElementById('list_city')),
                    { types: ['geocode'] });

               
                google.maps.event.addListener(autocomplete, 'place_changed', function(results, status) {                          //$scope.formData.city = '';
                      
                   $scope.formData.city = $('#list_city').val();
                   
                });                      
              }
           $scope.onCityChange = function(){   
              $location.search({'city':$scope.formData.city});  
           }


           $('#btnResetPropType').click(function(){
              console.log('prop type click');
              $scope.formData.space_type = '';
              $('.property_type_cls').val('');

           });

           $scope.onGuestLimitChange = function(date){
              $location.search('guest_limit', $scope.formData.guest_limit);
           }        

           $scope.getArrivalDate  = function(date){
              var formattedDate   = new Date($scope.formData.arrival_time);
              
              var d               = formattedDate.getDate()-1;
              
              var month           = formattedDate.getMonth();
              
              month += 1;
              var m               = month < 10 ? '0' + month : '' + month;
              var y               = formattedDate.getFullYear();
              var day = (d < 9?'0':'')+d;
              
              var arrival_time    = y+'-'+m+'-'+day;
              
              if(arrival_time=='1970-01-0'){

              	$location.search('arrival_time','');

              }else{

              	$location.search('arrival_time',arrival_time);	
              }
              
           }

           $scope.getDepartureTime  = function(date){ 
              var formattedDate     = new Date($scope.formData.departure_time);
              var d                 = formattedDate.getDate();
              var month =  formattedDate.getMonth();
              month += 1;  
              var m                 = month < 10 ? '0' + month : '' + month;
              var y                 = formattedDate.getFullYear();
              var departure_time    = y+'-'+m+'-'+d;

              if(departure_time=='NaN-NaN-NaN'){

              	$location.search('departure_time','');

              }else{

              	$location.search('departure_time',departure_time);	
              }
              
           }
           
  }).controller('propertiesList', function(ScopesFunc, $http, $scope, $location, $window, $state){ 
         
            ScopesFunc.fn();  

            $scope.saveFavourite = function(property_id,fprop_status,f_id){
              
            $scope.fav_class = '';
            if(property_id){
              if(fprop_status && f_id){
                //if (confirm("Are you sure to want to delete favourite?")){
                  
                  var data          = {'f_id': f_id};
                  var url           = 'api/v1/delete-favourite-property?f_id='+f_id; 
                    $http({method : 'get',url:url, cache:true})
                     .success(function(data, status) {//console.log(data);
                      if(data.success=='1'){

                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: data.message,
                                        type: 'success',
                                        styling: 'bootstrap3',
                                      });
                        
                       
                        
                        $window.location.reload();
                        
                        if($('.user_favourite'+property_id).hasClass('fa-heart')){
                          
                          $('.user_favourite'+property_id).removeClass('fa-heart');
                          
                          
                          $('.user_favourite'+property_id).addClass('fa-heart-o deleted_fav');
                        }else if($('.user_favourite'+property_id).hasClass('fa-heart-o')){
                          
                          $('.user_favourite'+property_id).removeClass('fa-heart-o');
                          
                          $('.user_favourite'+property_id).addClass('fa-heart added_fav');
                        }
                         
                      }
                     });       

              }else{
                ///if (confirm("Are you sure to want to add favourite?")){
                  $.getJSON("https://jsonip.com?callback=?", function (data1) {
                    var data = {'property_id': property_id, 'status':'1', 'ip_address':data1.ip};
                    var url  = 'api/v1/save-favourite-property'; 
                    $http({method : 'post',url:url, data:data, cache:true})
                     .success(function(data, status) {
                      if(data.success=='1'){
                      
                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: data.message,
                                        type: 'success',
                                        styling: 'bootstrap3',
                                      });

                                                
                        $window.location.reload();
                         
                          if($('.user_favourite'+property_id).hasClass('fa-heart')){
                          
                          $('.user_favourite'+property_id).removeClass('fa-heart');
                          
                          $('.user_favourite'+property_id).addClass('fa-heart-o deleted_fav');
                        }else if($('.user_favourite'+property_id).hasClass('fa-heart-o')){
                          
                          $('.user_favourite'+property_id).removeClass('fa-heart-o');
                          
                          $('.user_favourite'+property_id).addClass('fa-heart added_fav');
                        }
                      }
                     })
                     .error(function(error){
                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: 'Favourite not added!',
                                        type: 'error',
                                        styling: 'bootstrap3',
                                      });
                     });
                  });
              }
            }
            
          }       
      
  });

  
    
})();