
  var app = angular.module('directOwnersApp');

  app.directive('stopEvent', function () {
    return {
      restrict: 'A',
      link: function (scope, element, attr) {
        element.on(attr.stopEvent, function (e) {
          e.stopPropagation();
        });
      }
    };
  });	 

  app.filter('capitalize', function() {
    return function(input) {
      return (angular.isString(input) && input.length > 0) ? input.charAt(0).toUpperCase() + input.substr(1).toLowerCase() : input;
    }
  });

  app.controller('SinglePropertyDetails',function($state, $sce,$scope,$http, $stateParams, $filter, $window, $location) {
    
    var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
    var selected_currency_symbol = localStorage.currency_symbol?localStorage.currency_symbol:'€';
    
    $('#required_base_currency').change(function(e){
      var selected_currency = $(this).val()?$(this).val():'';
      var selected_currency_symbol = $(this).val()?$('#required_base_currency option:selected').attr('data-symbol'):'';
      propdetyDetails(selected_currency, selected_currency_symbol); 
    });
    var propdetyDetails = function(currency_name, currency_symbol){

      $scope.currency_name = currency_name;
      $scope.currency_symbol = currency_symbol;
      console.log('selected currency in property details page', currency_name);
      console.log('selected currency symbol in property details page', currency_symbol);
      $scope.property_id = $stateParams.id;

      var prop_deal_id = $location.search().deal_id?$location.search().deal_id:'';

      var url = 'api/v1/property-details/'+$scope.property_id+'?deal_id='+prop_deal_id+'&currency_name='+currency_name+'&currency_symbol='+currency_symbol;
      $scope.ownerId;

      $http({
        method:'get',
        url: url, 
        cache:true, 
        headers: {
        'Content-Type': 'application/json', 
        'Accept': 'application/json' }
      }).success(function(data) {
         // Data success start         
          $('#loadMap').click(function(){
            $("#property_details_map").animate({"height" : "380px"}, 10,function(){
              initialize();
            });
          });

          var width = $(window).width();
           if(width<1024){
            $('#loadMap').trigger('click');
          }

          $scope.getOpenBookNow = function($window){                                    
            var width = $(window).width();
            if(width<1024){
               var url = '#/book-now'; 
               $('.login-popup-cls').attr('data-target', '');
               $('a.login-popup-cls').attr('href', url)
            }        
            // kk guest limit function//
            $(".guest_limit_option").empty();
            var guest_value = parseInt($(".guestlimitVal").text());
            var opt = '<option value="" disabled="" selected="">No. of guests * </option>';
            for(var k=1;k<=guest_value; k++){
              opt += '<option value="'+k+'">'+k+'</option>';
            }
            $(".guest_limit_option").append(opt);
             
            $("#barrival_time").val("");
            $("#bdeparture_time").val("");
            $(".booknow_fname").val("");
            $(".booknow_sname").val("");
            $("#prop_book_phone").val("");
            $(".email_input_box").val("");
            $(".text_box").html("");
            $(".text_box").val("").change();
           
            $(".AmountDetailsShow").html("");
            var html = '<div class="row para">\
                                    <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount </div>\
                                        <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount"></span></div>\
                                </div>\
                                <div class="row para">\
                                    <div class="col-md-12"><small>Deal Period ()</small> </div>\
                                </div>';
            $(".calculated_paypal_amount").html("0");   
            $(".AmountDetailsShow").html(html);
            $(".calculated_booking_amount_main").html("");        
            // kk guest limit function//       
          }
      
      
          $scope.enquire_click = function($window){   
            $("#arrival_time").val("");
            $("#departure_time").val("");
            $(".booknow_snam").val("");
            $(".booknow_name").val("");
            $(".phone_num_enq").val("");  
            $(".email_input_box").val("");
            $(".text_box").html("");
            $(".text_box").val("").change();    
            
            $(".guest_limit_option").empty();
            var guest_value = parseInt($(".guestlimitVal").text());
            var opt = '<option value="" disabled="" selected="">No. of guests * </option>';
            for(var k=1;k<=guest_value; k++){
              opt += '<option value="'+k+'">'+k+'</option>';
            }
            $(".guest_limit_option").append(opt);
            $(".AmountDetailsShow").html("");
            var html = '<div class="row para">\
                                        <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount </div>\
                                            <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount"></span></div>\
                                    </div>\
                                    <div class="row para">\
                                        <div class="col-md-12"><small>Deal Period ()</small> </div>\
                                    </div>';
            $(".calculated_paypal_amount").html("0");         
              
            $(".AmountDetailsShow").html(html);
            $(".calculated_booking_amount_main").html("");        
          }  
          // kk guest limit function//

          var createMarker = function(_s3_path, markerData, map, property_id, latitude, longitude)
          {   
            var markerLength = markerData.length;
            var marker1;
            if(markerLength){

                for(var i=0; i<markerLength; i++){
                  console.log(markerLength, 'markerLength');
                    var markerIcon = '';
                    
                    if(markerData[i].property_id==property_id){

                      markerIcon = 'uploads/location-ping.png';
                    }else{
                      markerIcon = 'uploads/location-ping-orange.png';
                    }
                    
                    var image = markerData[i].property_image;
                    if(image){
                      var img_path = _s3_path+"/property_images/"+markerData[i].property_id+"/"+image;
                    }else{
                      var img_path = _s3_path+"/property_images/default.jpg";
                    }

                    var markerContent = '<div class="col-md-12 col-sm-12 map-property single-property-map-icon" ng-repeat="prop in properties" ng-if="properties!=0">'+ 
                            '<a ng:href="#/property-details/'+markerData[i].property_id+'">'+
                           '<div class="vp-pd-side-product">'+
                            '<div class="vp-pd-side-product-inner">'+
                                '<img src='+img_path+' default-img>'+
                                '<div class="vp-pd-side-product-inner-content">'+
                                '<div class="vp-pd-side-product-inner-details">'+
                                    '<h3 class="vp-caption-heading">'+markerData[i].property_title+'</h3>'+
                                '</div>'+   
                                '<div class="col-md-8 col-xs-8">'+
                                    '<p class="vp-para-book">'+markerData[i].space_type+'</p>'+   
                                '</div>'+
                                '<div class="col-md-4 col-xs-4 text-center">'+
                                    '<p class="vp-para-book"><span>'+markerData[i].guest_limit+'</span>guests</p>'+ 
                                '</div>'+
                                '<div class="col-md-12 col-xs-12 vp-pd-verified">'+
                                    '<p class=""><span>Verified</span> <label><i class="fa fa-eur" aria-hidden="true"></i><b>'+markerData[i].standard_rate_per_week+'</b>/Week</label></p>'+
                                '</div></div></div></div></a></div>';
                              
                         //console.log(near_by_lat+','+near_by_lng, 'ddddddd ,markers');                       
                    marker1 = new google.maps.Marker({
                      position: new google.maps.LatLng(latitude, longitude),
                      map: map,
                      //geocode:false,
                      icon:markerIcon,
                      content:markerContent
                    });
                                 
                    console.log(marker1, 'marker content');
                    var infowindow = new google.maps.InfoWindow();

                    google.maps.event.addListener(marker1, 'click', function(){                     
                            
                        infowindow.setContent(this.content);                    
                        infowindow.open(map, this);
                        
                    });             
                    
                }
            }else{
              console.log('1wedrf');
              //console.log(nlat+','+nlng, 'else ddddddd ,markers');       
                var markerIcon = 'uploads/location-ping.png';
                var marker = new google.maps.Marker({
                  position: new google.maps.LatLng(latitude, longitude),
                  map: map,
                  icon:markerIcon                  
                });
                    
            } 
          }     
      
          var initialize = function(){
            // console.log('map test');
            var map = new google.maps.Map(document.getElementById('property_details_map'), {
              zoom: 13,
              center: new google.maps.LatLng(data.property.property_details[0].latitude, data.property.property_details[0].longitude),
            });
            var latitude  = data.property.property_details[0].latitude;
            var longitude = data.property.property_details[0].longitude;   
            $scope._s3_path = data._s3_path;
            var _s3_path  = data._s3_path;       
            createMarker(_s3_path, data.property.near_by, map, data.property.property_details[0].property_id, latitude, longitude);                    
          }              

          $scope.property                       = data.property;
          $scope._s3_path                       = data._s3_path;
          var _s3_path                          = data._s3_path; 
          $scope.security_deposit_amount        = data.property.property_details[0].security_deposit_amount?data.property.property_details[0].security_deposit_amount:0;
          $scope.owner_security_deposit_amount  = data.property.property_details[0].security_deposit_amount;
          $scope.prop_description               = $sce.trustAsHtml(data.property.property_details[0].description);
          $scope.paypal_booking_amount          = '';
          if(data.property.property_details[0].profile_pic){
            $scope.owner_pic = _s3_path+'/profile_pics/'+data.property.property_details[0].profile_pic; 
          }else{
            $scope.owner_pic = _s3_path+'/profile_pics/default.jpg';
          }
          $scope.igallery = [];
          $scope.igallery = data.property.property_gallery;                      
          $scope.igallery.push({'image_name': data.property.property_details[0].property_image});
          if($scope.igallery.length){
            var img = [];
            for(var i=0; i<$scope.igallery.length;i++){            
             
              var title = data.property.property_details[0].property_title;
              var str = title.replace(/\s+/g, '-').toLowerCase();
              var url;
                                 
                if($scope.igallery[i].image_name){
                    url = {'image':_s3_path+'/property_images/'+data.property.property_details[0].property_id+'/'+$scope.igallery[i].image_name, 'thumb':_s3_path+'/property_images/'+data.property.property_details[0].property_id+'/'+$scope.igallery[i].image_name};                                    
                }else{
                    url = {'image':_s3_path+'/property_images/default.jpg', 'thumb':_s3_path+'/property_images/default.jpg'};
                }
              img.push(url);
            }
          }else{
            var img = [];

            var url = {'image':_s3_path+'/property_images/default.jpg', 'thumb':_s3_path+'/property_images/default.jpg'};
            
            img.push(url);
          }                    
          $scope.owner_id                     = data.property.property_details[0].id;
          $scope.owner_paypal_email           = data.property.property_details[0].paypal_email;
          $scope.gallery                      = img;
          $scope.rates                        = data.property.property_rates;
          $scope.property_testimonials        = data.property.property_testimonials;
          $scope.deals                        = data.property.deals;

          var propId;
          setTimeout(function(){
            if($scope.gallery.length<8){                                 
              $('.flex-prev').css('display', 'none');
              $('.flex-next').css('display', 'none');
            }
          }, 500);
                 
          var ipAddress;
          $scope.cprops = [];
          var lcprop_id = data.property.property_details[0].property_id;
          
          var lcdeal_id = data.property.deals.length?data.property.deals[0].id:'';     
          var lcdeal_click_count = data.property.deal_click;

          var enq_arrival_time;  

          $scope.getArrivalDate = function(arrival_time, type){           
            enq_arrival_time = arrival_time;
            if(type=='booknow'){
              var arrival_date    = $('#barrival_time').val();
              var departure_date  = $('#bdeparture_time').val();
              var click_count     = $('#barrival_time').attr('data-key');
              if(departure_date<arrival_date){
                $('#bdeparture_time').val('');
              }

            }else if(type=='enquirenow'){
              var arrival_date    = $('#arrival_time').val();
              var departure_date  = $('#departure_time').val();
              var click_count     = $('#arrival_time').attr('data-key');
              if(departure_date<arrival_date){
                $('#departure_time').val('');
              }                                    
            }
            var coupon_code = $('.property_coupon_code').val();
             
            if(click_count>0){

              checkMinimumDatesRequirement(arrival_time, type, arrival_date, departure_date); 
            }           
          }                
        
          var checkAndApplyPropertyCoupon = function(coupon, property_id, from_date, to_date){

           
            var coupon_url  = 'api/v1/check-property-coupons-availability';
            var params = {'from_date':from_date,'to_date':to_date, 'coupon':coupon, 'property_id':property_id, 'currency_name':currency_name, 'currency_symbol':currency_symbol};
              $http({
                    method  : 'get',
                    url     : coupon_url,
                    params  : params
              })
              .success(function(coupon_obj){
                  
                  var security_deposit_amount       = ''; 

                  setTimeout(function(){

                      var owner_deal_amount_check = $('.owner_deal_amount').val();

                      if(owner_deal_amount_check!=0 && owner_deal_amount_check){

                        var apply_owner_deal = owner_deal_amount_check;                 
                      }else{

                        var apply_owner_deal = 0;
                      }                   
                      
                  }, 200);  

                  var changedSecurityDeposit        = $('.keyChangeSecurityDeposit').val();
                      
                  if(changedSecurityDeposit){

                    security_deposit_amount       = changedSecurityDeposit;
                  }else{

                    security_deposit_amount       = $('.property_security_deposit_amt').val();  
                  }              

                  
                  if(coupon_obj.success==3){
                    
                    $('.property_coupon_code').prop('readonly', true);
                    $('.property_coupon_code').val('');
                    $('.coupon_error_span').text(coupon_obj.message);
                    $scope.coupon_discount_amount = '';
                    $('.coupon_discount_amount').text('');
                    $('.coupon_amount').val(0); 
                    $scope.applied_coupon         = '';


                  }else{

                    $('.property_coupon_code').prop('readonly', false);
                  }                                  

                  if(coupon_obj.success==1){
                    
                    $('#check_coupon_btn').prop('disabled', false);                    
                    $('.coupon_error_span').text("");
                      if(coupon_obj.data.type=='flat'){
                        
                        if(parseFloat($scope.booking_amount)>parseFloat(coupon_obj.data.min_amount) || parseFloat(coupon_obj.data.min_amount)==parseFloat($scope.booking_amount)){

                          var coupon_amount             = coupon_obj.data.amount;
                          $('.coupon_amount').val(coupon_amount); 
                          $scope.applied_coupon         = coupon_amount;
                          var fix_coupon_amout          = parseFloat($scope.booking_amount)-parseFloat(coupon_amount)+parseFloat(security_deposit_amount); 
                          var apply_coupon              = fix_coupon_amout.toFixed(2);
                          $scope.coupon_amount_valid    = apply_coupon;
                          $scope.paypal_booking_amount  = apply_coupon;

                          $('.total_amount_for_booking').val(apply_coupon);
                          console.log($scope.paypal_booking_amount, 'kv1');
                          $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
                          $('.coupon_val_cls').text(coupon_amount);
                        }else{

                          $('.coupon_error_span').text("Need minimum "+coupon_obj.data.min_amount);
                           //$scope.coupon_error  = "Need minimum "+coupon_obj.data.min_amount;
                        }  
                          
                      }else if(coupon_obj.data.type=='percentage'){
                        
                        if(parseFloat($scope.booking_amount)>parseFloat(coupon_obj.data.min_amount) || parseFloat(coupon_obj.data.min_amount)==parseFloat($scope.booking_amount)){  
                          
                          var coupon_amount                 = coupon_obj.data.amount;
                          $('.coupon_amount').val(coupon_amount);                        
                          var calculated_amount             = (parseFloat($scope.booking_amount)*parseFloat(coupon_amount)/100).toFixed(2);
                          $('.coupon_val_cls').text(calculated_amount);                        
                          $scope.applied_coupon             = calculated_amount;                                                
                          var fix_coupon_amout              = parseFloat($scope.booking_amount)-parseFloat(calculated_amount)+parseFloat(security_deposit_amount); 
                          var apply_coupon                  = fix_coupon_amout.toFixed(2);
                          $scope.coupon_amount_valid        = apply_coupon; 
                          $scope.paypal_booking_amount      = apply_coupon;
                          $('.total_amount_for_booking').val(apply_coupon); 
                          console.log($scope.paypal_booking_amount, 'kv2');                     
                          $('.calculated_paypal_amount').text($scope.paypal_booking_amount); 
                        }else{

                          $('.coupon_error_span').text("Need minimum "+coupon_obj.data.min_amount);
                           //$scope.coupon_error  = "Need minimum "+coupon_obj.data.min_amount;
                        }                        
                      }
                  }else if(coupon_obj.success==3){
                    
                    $('.coupon_error_span').text(coupon_obj.message);
                    $scope.coupon_discount_amount = '';
                    $('.coupon_discount_amount').text('');
                    $('.coupon_amount').val(0); 
                    $scope.applied_coupon         = '';

                  }
                  else{
                    

                    $('.coupon_val_cls').text(0);
                    
                    if(!$scope.amount && $scope.amount!='undefined'){
                      $('.coupon_amount').val('');
                      var calculated_amount = parseFloat($scope.booking_amount)+parseFloat(security_deposit_amount)                    
                      $scope.paypal_booking_amount  = calculated_amount.toFixed(2);                      
                      $('.total_amount_for_booking').val($scope.paypal_booking_amount);
                      console.log($scope.paypal_booking_amount, 'kv3');                    
                      $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
                    }else{
                      $('.coupon_amount').val('');
                      var calculated_amount = parseFloat($scope.booking_amount)+parseFloat(security_deposit_amount)                    
                      $scope.paypal_booking_amount  = calculated_amount.toFixed(2);
                      $('.total_amount_for_booking').val($scope.paypal_booking_amount); 
                      console.log($scope.paypal_booking_amount, 'kv4');                   
                      $('.calculated_paypal_amount').text($scope.paypal_booking_amount);  
                    }                

                    if($('.property_coupon_code').val()){

                      $('.coupon_error_span').text(coupon_obj.message);
                    }else{
                      $('.coupon_error_span').text('');
                    }
                    
                    $scope.coupon_amount_valid    = 0;    
                  }
              })
              .error(function(coupon_error){

              });
          }        

          // MinimumDatesRequirement Start  
          var checkMinimumDatesRequirement = function(departure, type, arrival_date, departure_date){
                    
            var params          = {'currency_name':currency_name, 'arrival_time':arrival_date, 'departure_time':departure_date, 'property_id':$stateParams.id};                        
            $http({
              method  : 'get',
              url     : 'api/v1/check-special-property-rate-dates',
              params  : params
            })
            .success(function(obj){

              var deal_url = 'api/v1/check-property-coupons';
              $http({
                method  : 'get',
                url     : deal_url,
                params  : params
              })
              .success(function(deal_obj){
                var coupon_val = $('.property_coupon_code').val();
                checkAndApplyPropertyCoupon(coupon_val, $stateParams.id, arrival_date, departure_date);  
                
                if(obj.success==1){

                  enq_departure_time  = departure;
                  var prop_wek_rate   = typeof obj.data.rate!=="undefined"?obj.data.rate:0;
                  
                  var prop_min_stay   = obj.data.minimum_stay;
                  var timeDiff        = Math.abs(enq_departure_time.getTime() - enq_arrival_time.getTime());
                  var diffDays        = Math.ceil(timeDiff / (60 * 60 * 24 * 1000));
                  var no_of_days      = Number.isInteger(diffDays)?diffDays:0;
                  console.log(no_of_days, 'no of days');
                  console.log(diffDays, 'diffDaysdays');
                  var calculate_type  = obj.data.type=='week'?'week':'day';
                  var prop_day_rate   = calculate_type=='week'?(prop_wek_rate/7).toFixed(2):prop_wek_rate;
                  if(prop_min_stay!='any' && diffDays>=prop_min_stay){                            
                    
                    if(type=='booknow'){

                      $('#book_now_property').prop('disabled', false);  
                    }else{

                      $('#enq_nw_btn').prop('disabled', false);
                    } 

                  }else if(obj.data.minimum_stay!='any'){
                    
                    if(type=='booknow'){

                      $('#book_now_property').prop('disabled', true);  
                    }else{
                      $('#enq_nw_btn').prop('disabled', true);
                      
                    }
                    
                    if(departure_date!=''){
                      
                      if(prop_min_stay==1){
                        var day_text = 'day';
                      }else{
                        var day_text = 'days';
                      }
                      var pnotify = new PNotify({
                                    title  :'Error',
                                    text   : 'Minimum stay is '+prop_min_stay+' '+day_text,//'Required more than '+prop_min_stay+' days to stay',
                                    type   : 'error',
                                    styling: 'bootstrap3',
                                    delay: 2000
                                });
                    }
                  }  
                  var rateForBookedDates            = Math.round(prop_day_rate*diffDays); 
                  $scope.booking_amount             = rateForBookedDates;                 
                  $scope.total_booking_amount       = rateForBookedDates;                 
                  var security_deposit_amount       = ''; 
                  var changedSecurityDeposit        = $('.keyChangeSecurityDeposit').val();
                                  
                  if(changedSecurityDeposit){

                    security_deposit_amount       = changedSecurityDeposit;
                  }else{

                    security_deposit_amount       = $('.property_security_deposit_amt').val();  
                  }
                  
                  
                  var check_coupon_val              = $('.coupon_amount').val()?$('.coupon_amount').val():0;
                  if(check_coupon_val){

                    var apply_coupon_on_date_change   = check_coupon_val;
                  }else{

                    var apply_coupon_on_date_change   = 0;
                  }

                  var owner_deal_amount_check     = $('.owner_deal_amount').val();
                  if(owner_deal_amount_check!=0 && owner_deal_amount_check){

                    var apply_owner_deal = owner_deal_amount_check;                 
                  }else{

                    var apply_owner_deal = 0;
                  }
                       
                  if(deal_obj.data){
                  
                    var html = '';
                    var sum = 0;
                    $(".AmountDetailsShow").html("");
                    var total_booking_amount = 0;                                 
                    $.each(deal_obj.data,function(k,v){
                      total_booking_amount += parseFloat(v.rate);
                      if(v.deal_type=='flat'){
                            
                        html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                      <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                          <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                  </div>\
                                  <div class="row para">\
                                      <div class="col-md-12"><small>Deal Period ('+v.deal_apply_dates+')</small> </div>\
                                  </div></div>';
                  
                      }else if(v.deal_type=='percentage'){
                        html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                      <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                          <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                  </div>\
                                  <div class="row para">\
                                      <div class="col-md-12"><small>Deal Period ('+v.deal_apply_dates+')</small> </div>\
                                  </div></div>';
                      }else{
                        html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                      <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                          <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                  </div>\
                                  <div class="row para">\
                                      <div class="col-md-12"><small>Deal Period (NO DEAL)</small> </div>\
                                  </div></div>';
                      }
                      sum += parseFloat(v.rate) - parseFloat(v.discount_amount);          
                    });
                      $(".calculated_booking_amount_main").html(total_booking_amount.toFixed(2));
                      $(".AmountDetailsShow").html(html);
                      $(".calculated_paypal_amount").html((parseFloat(parseFloat(sum) + parseFloat(security_deposit_amount) - parseFloat(apply_coupon_on_date_change))).toFixed(2));
                      $(".total_amount_for_booking").val(parseFloat(parseFloat(sum) + parseFloat(security_deposit_amount) - parseFloat(apply_coupon_on_date_change)));
                  
                  }else{                        

                      $('.owner_deal_amount').val(0);
                      $scope.deal_discount_amount     = '';
                      $scope.deal_period              = '';
                      $scope.applied_deal_amount      = '';
                      if(security_deposit_amount){
                        
                        var calculated_amount    = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);                                                                  
                        console.log(parseFloat(rateForBookedDates),'bookedDates');
                        console.log(parseFloat(security_deposit_amount),'security_deposit_amount');
                        console.log(parseFloat(apply_coupon_on_date_change),'apply_coupon_on_date_change');
                        $scope.total_cal_amount  = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);
                        $('.total_amount_for_booking').val(calculated_amount);   
                        console.log(calculated_amount, 'kv7');                   
                        $('.calculated_paypal_amount').text(calculated_amount);

                      }else{  
                        
                        $scope.paypal_booking_amount    = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);                      
                        $scope.total_cal_amount         = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);
                        $('.total_amount_for_booking').val($scope.paypal_booking_amount); 
                        console.log($scope.paypal_booking_amount, 'kv8');                     
                        $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
                        
                      }

                  }
                      

                }else if(obj.success==0 || !obj){                

                  enq_departure_time  = departure;
                  var prop_wek_rate   = data.property.property_details[0].standard_rate_per_week?data.property.property_details[0].standard_rate_per_week:data.property.property_details[0].min_week_rate//data.property.srate_per_week;//data.property.property_details[0].standard_rate_per_week;                
                  var check_week_rate_exists = prop_wek_rate !== undefined && prop_wek_rate ? prop_wek_rate : '';
                  var prop_day_rate   = check_week_rate_exists?(prop_wek_rate/7).toFixed(2):data.property.property_details[0].standard_rate_per_day;
                  var timeDiff        = Math.abs(enq_departure_time.getTime() - enq_arrival_time.getTime());
                  var diffDays        = Math.ceil(timeDiff / (60 * 60 * 24 * 1000)); 
                  if(data.property.property_details[0].minimum_stay!='any' && diffDays>=data.property.property_details[0].minimum_stay){
                    
                    if(type=='booknow'){

                      $('#book_now_property').prop('disabled', false);  
                    }else{

                      $('#enq_nw_btn').prop('disabled', false);
                    }                   

                  }else if(data.property.property_details[0].minimum_stay!='any'){
                            
                    if(type=='booknow'){

                      $('#book_now_property').prop('disabled', true);  
                    }else{
                      $('#enq_nw_btn').prop('disabled', true);
                      
                    }if(data.property.property_details[0].minimum_stay==1){
                      var day_text = 'day';
                    }else{
                      var day_text = 'days';
                    }
                    
                    if(departure_date!=''){                      
                        var pnotify = new PNotify({
                                      title  :'Error',
                                      text   : 'Minimum stay is '+data.property.property_details[0].minimum_stay+' '+day_text,//'Required more than '+data.property.property_details[0].minimum_stay+' days to stay',
                                      type   : 'error',
                                      styling: 'bootstrap3',
                                      delay: 2000
                                  });
                    }                              
                  }          
                  var rateForBookedDates        = Math.round(prop_day_rate*diffDays);                  
                  $scope.booking_amount         = rateForBookedDates;
                  $scope.total_booking_amount   = rateForBookedDates;
                  var changedSecurityDeposit    = $('.keyChangeSecurityDeposit').val(); 
                  var security_deposit_amount   = '';
                  if(changedSecurityDeposit){

                    security_deposit_amount     = changedSecurityDeposit;
                  }else{

                    security_deposit_amount     = $('.property_security_deposit_amt').val();  
                  }
                  
                  var check_coupon_val          = $('.coupon_amount').val()?$('.coupon_amount').val():0;

                  if(check_coupon_val){

                    var apply_coupon_on_date_change = check_coupon_val;
                  }else{

                    var apply_coupon_on_date_change = 0;
                  }
                                     
                    
                  if(deal_obj.data){  
                    var sum = 0;  
                    var html = '';
                    $(".AmountDetailsShow").html("");
                    var total_booking_amount = 0;
                    $.each(deal_obj.data,function(k,v){
                      total_booking_amount += parseFloat(v.rate);
                      if(v.deal_type=='flat'){                      
                        html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                    <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                        <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                </div>\
                                <div class="row para">\
                                    <div class="col-md-12"><small>Deal Period ('+v.deal_apply_dates+')</small> </div>\
                                </div></div>';
                
                      }else if(v.deal_type=='percentage'){
                          html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                    <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                        <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                </div>\
                                <div class="row para">\
                                    <div class="col-md-12"><small>Deal Period ('+v.deal_apply_dates+')</small> </div>\
                                </div></div>';
                      }else{
                        html += '<div class="samp" style="margin-bottom:10px;"><div class="row para">\
                                    <div class="col-md-8 col-sm-8 col-xs-8">Deal Discount</div>\
                                        <div class="col-md-4 col-sm-4 col-xs-4 text-right">- <i class="fa fa-'+currency_name+'" aria-hidden="true"></i><span id="calculated_booking_amount" class="calculated_booking_amount">'+v.discount_amount+'</span></div>\
                                </div>\
                                <div class="row para">\
                                    <div class="col-md-12"><small>Deal Period (NO DEAL)</small> </div>\
                                </div></div>';
                
                      }
                      sum += parseFloat(v.rate) - parseFloat(v.discount_amount);
                    });
                    $(".calculated_booking_amount_main").html(total_booking_amount.toFixed(2));
                    $(".AmountDetailsShow").html(html);       
                    $(".calculated_paypal_amount").html((parseFloat(parseFloat(sum) + parseFloat(security_deposit_amount) - parseFloat(apply_coupon_on_date_change))).toFixed(2));
                    $(".total_amount_for_booking").val(parseFloat(parseFloat(sum) + parseFloat(security_deposit_amount) - parseFloat(apply_coupon_on_date_change)));
                      
                  }else{                   
                    $('.owner_deal_amount').val(0);
                    $scope.deal_discount_amount         = '';
                    $scope.deal_period                  = '';
                    $scope.applied_deal_amount          = '';
                    var owner_deal_amount_check         = $('.owner_deal_amount').val();

                    if(owner_deal_amount_check!=0 && owner_deal_amount_check){
                      var apply_owner_deal              = owner_deal_amount_check;                 
                    }else{

                      var apply_owner_deal = 0;
                    }
                    
                    $scope.paypal_booking_amount        = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);
                    $('.total_amount_for_booking').val($scope.paypal_booking_amount);   
                    console.log($scope.paypal_booking_amount, 'kv11');                 
                    $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
                    $scope.total_cal_amount             = (parseFloat(rateForBookedDates)+parseFloat(security_deposit_amount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);                      

                  }
                }
              }).error(function(deal_error){

              });                   
                      
            }).error(function(error){
              console.log(error);
            });  
          }                 
          // MinimumDatesRequirement End

          // DepartureTimeChange Start
          $scope.getDepartureTimeChange = function(departure, type){    
          console.log(currency_name, 'currency_name123');  
          console.log(currency_symbol, 'currency_symbol123');  
            if(type=='booknow'){
              var arrival_time    = $('#barrival_time').val();
              var departure_time  = $('#bdeparture_time').val();  
              checkMinimumDatesRequirement(departure, type, arrival_time, departure_time); 
              setTimeout(function(){                                            
                var pamount = $('.total_amount_for_booking').val();
                console.log(pamount, 'kv12');
                $('.calculated_paypal_amount').text(pamount);
                var coupon_amt = $('.coupon_amount').val();
                if(coupon_amt==0){                                                
                  $('.coupon_val_cls').text('');
                  $scope.coupon_discount_amount = "";
                  $('.coupon_discount_amount').text('');
                }
              }, 700);

              if(departure_time<arrival_time){
                $('#bdeparture_time').val('');
              }

              var params          = {'arrival_time':arrival_time, 'departure_time':departure_time, 'property_id':$stateParams.id};
              
              $http({
                    method  : 'get',
                    url     : 'api/v1/property-availability',
                    params  : params
              })
              .success(function(data) {
                console.log('kjuhy');
                console.log(data);
                if(data.success==1){

                  if(type=='booknow'){

                  $('#book_now_property').prop('disabled', true);  
                }else{

                  $('#enq_nw_btn').prop('disabled', true);
                  
                }
                  var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                });
                }else{

                  if(type=='booknow'){

                  $('#book_now_property').prop('disabled', false);  
                }else{
                  $('#enq_nw_btn').prop('disabled', false);
                  
                } 
                }
              })
              .error(function(error){
                console.log(error);
              });    
            }else{
              var arrival_time    = $('#arrival_time').val();
              var departure_time  = $('#departure_time').val();

              checkMinimumDatesRequirement(departure, type, arrival_time, departure_time);                      

              if(departure_time<arrival_time){
                $('#departure_time').val('');
              }
              var params          = {'arrival_time':arrival_time, 'departure_time':departure_time, 'property_id':$stateParams.id};
                  
              $http({
                    method  : 'get',
                    url     : 'api/v1/property-availability',
                    params  : params
              })
              .success(function(data) {

                if(data.success==1){

                  if(type=='booknow'){

                  $('#book_now_property').prop('disabled', true);  
                }else{
                  $('#enq_nw_btn').prop('disabled', true);
                  
                }
                  var pnotify = new PNotify({
                                    title: 'Error',
                                    text: data.message,
                                    type: 'error',
                                    styling: 'bootstrap3',
                                });
                }else{

                  if(type=='booknow'){

                  $('#book_now_property').prop('disabled', false);  
                }else{
                  $('#enq_nw_btn').prop('disabled', false);
                  
                } 
                }
              })
              .error(function(error){
                console.log(error);
              });
            }
          }              
          // DepartureTimeChange End    
              
          /*Save property click for time_since*/ 
            var tim_since_data = {'property_id': lcprop_id};
            var url  = 'api/v1/save-last-property-clicks';
            $http({method : 'post',url:url, data:tim_since_data})
            .success(function(data, status) {
              console.log(data);
            })
            .error(function(){});
          /*End time_since save*/             
              
                              
          /* Total property clicks*/
            var a = []; 
            var timer;
            var key = 'cprops';
            appendItem('cprops', lcprop_id);
            function appendItem(key, data) {
            var t = data.constructor, tmp;
              switch(t) {
               case Number:                      
                   tmp = sessionStorage.getItem(key);   
                   var listIds = JSON.parse(tmp);
                    if($.inArray(lcprop_id, listIds) == -1){
                      
                      $.getJSON("https://jsonip.com?callback=?", function (data1) { 
                        var data = {'property_id': lcprop_id, 'num':1};
                        var url  = 'api/v1/save-property-clicks'; 
                        $http({method : 'post',url:url, data:data})
                         .success(function(data, status) {
                          
                         })
                         .error(function(){});
                      });
                    }
                   tmp = (tmp === null) ? [] : JSON.parse(tmp);
                   tmp.push(data);

                   sessionStorage.setItem(key, JSON.stringify(tmp));
                   break;                       
              }
            }
          /*End total property click*/  

          if(lcdeal_click_count=='yes'){
            /*Save deal count*/  
            var deal_a = []; 
            var deal_timer;
            var deal_key = 'cprops_deal';  
            appendItem('cprops_deal', lcdeal_id);
            function appendItem(key, data) {
            var t = data.constructor, tmp;
              switch(t) {
               case Number:                      
                   tmp = sessionStorage.getItem(key); 
                   var listIds = JSON.parse(tmp);
                    if($.inArray(lcdeal_id, listIds) == -1){  

                      $.getJSON("https://jsonip.com?callback=?", function (data1) { 
                        var data = {'property_id': lcprop_id, 'deal_id':lcdeal_id,'num':1};
                        var url  = 'api/v1/save-property-deal-clicks'; 
                        $http({method : 'post',url:url, data:data})
                         .success(function(data, status) {
                          
                         })
                         .error(function(){});
                      });
                    }else{

                        console.log('else deal first click');    
                    }
                   tmp = (tmp === null) ? [] : JSON.parse(tmp);
                   tmp.push(data);

                   sessionStorage.setItem(key, JSON.stringify(tmp));
                   break;                       
              }
            }
            /* End deal count*/
          }     
                
          var sarray = [];  
          if(data.property.property_details[0].email!=""){
            $scope.email1 = data.property.property_details[0].email;
            var email = $scope.email1;
            $scope.mask_email = email.replace(/.+(?=@)/g, '*'.repeat(email.replace(/@.+/g, '').length));
          }else{
            $scope.mask_email = "";
          }
          
          if(data.property.property_details[0].property_id){
            propId = data.property.property_details[0].property_id
          }else{
            propId = '0';
          }
          var pblockeDatesUrl = 'api/v1/blocked-dates/'+propId;
          $http({
            method:'get',
            url: pblockeDatesUrl, 
            cache:true, 
            headers: {
            'Content-Type': 'application/json', 
            'Accept': 'application/json' }
          }).success(function(result){                  
            var datesArray  = [];
            var startDatesArray  = [];
            var endDatesArray  = [];  
            var combinesArray = []; 
            var temp  = [];
            var dup   = [];             
            for(var i=0; i<result.details.length; i++){        
              var arrival_date    = result.details[i].start_date;
              var departure_date  = new Date(result.details[i].send_date);                        
              departure_date.setDate(departure_date.getDate() + 1);
              
              startDatesArray.push(arrival_date);
              //console.log(startDatesArray,'startDatesArray');
              endDatesArray.push($filter('date')(new Date(departure_date), 'yyyy/MM/dd'));

              var startDate       = new Date(result.details[i].start_date);
              startDate.setDate(startDate.getDate() + 1);
              var endDate         = new Date(result.details[i].send_date);

              while (startDate <= endDate) {
                  datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/d'));
                  startDate.setDate(startDate.getDate() + 1);
              }
            }
            combinesArray = startDatesArray.concat(endDatesArray);
           
            $.each(combinesArray, function (key, value) {

               if($.inArray(value, temp) === -1) {
                   temp.push(value);

                }else{
                   dup.push(value);
                }
            });

            $("#availability_datepicker").datepicker({ 
                  firstDay: 1,
                  todayHighlight: true,
                  beforeShowDay: highlightDays,
                  numberOfMonths: 2,
                  minDate: 0,
                  setDate: new Date()
            });
            function highlightDays(date) {
              var today_date = new Date();

              var yesterday = new Date(today_date.setUTCDate(today_date.getUTCDate() - 1));
              if(date<yesterday){

                  var past = 'past';

                  return [true, ('past', past)];
              }
              
              for (var i = 0; i < datesArray.length; i++) {
                
                if (new Date(datesArray[i]).toString() == date.toString()) {
                  return [false, 'ui-state-holiday'];
                }
              }

              for (var i = 0; i < startDatesArray.length; i++) {  
                if($.inArray(startDatesArray[i], dup) == -1){
                  if (new Date(startDatesArray[i]).toString() == date.toString()) {
                    return [true, 'ui-start-date'];
                  }                                                                                             
                }                                            
              }

              for (var i = 0; i < endDatesArray.length; i++) {                         
                if($.inArray(endDatesArray[i], dup) == -1){ 
                  if (new Date(endDatesArray[i]).toString() == date.toString()) {
                    return [true, 'ui-end-date'];
                  }                        
                }
              }
              
              for (var i = 0; i < dup.length; i++) {                        
                if (new Date(dup[i]).toString() == date.toString()) {
                  return [true, 'ui-combine-date ui-state-holiday'];
                }
              }

              return [true];
            }                  
          }).error(function(error){
            console.log(error);
          });  
          displaySimilarPropertiesByLocation($stateParams.id, data.property.property_details[0].latitude, data.property.property_details[0].longitude, currency_name, currency_symbol);
      }).error(function(error) {
            $scope.error = error;
      }); 
      
      function displaySimilarPropertiesByLocation(id, latitude, longitude, currency_name, currency_symbol){      

          var data = {'id':id, 'latitude':latitude, 'longitude':longitude, 'currency_name':currency_name, 'currency_symbol':currency_symbol};
         
          $http({
            method:'get',
            url: 'api/v1/property-similar-properties', 
            params:data,
            cache:true, 
            headers: {
            'Content-Type': 'application/json', 
            'Accept': 'application/json' }
          }).success(function(properties) {
            
              if(properties.message=='success'){
                 if(properties.property_details){
                  $scope.similar_property = properties.property_details;
                 }else{
                  $scope.similar_property = '';
                 }
               }
          }).error(function(error) {
                   $scope.error = error;
          });
      }

      $http({
        method:'get',
        url: 'api/v1/recent-properties-list/'+$stateParams.id, 
        cache:true, 
        headers: {
        'Content-Type': 'application/json', 
        'Accept': 'application/json' }
      }).success(function(properties) {
               if(properties.properties_details){
                $scope.rproperties = properties.properties_details;
               }else{
                $scope.rproperties = '0';
               }
      }).error(function(error) {
               $scope.error = error;
      });
      
      $scope.saveFavourite = function(property_id,fprop_status,f_id){
        if(fprop_status && f_id){            
            var data          = {'f_id': f_id};
            var url           = 'api/v1/delete-favourite-property?f_id='+f_id; 
              $http({method : 'get',url:url})
               .success(function(data, status) {
                if(data.success=='1'){
                  var pnotify = new PNotify({
                                  title: 'Success',
                                  text: data.message,
                                  type: 'success',
                                  styling: 'bootstrap3',
                                });
                  $window.location.reload();
                   //$state.go($state.current, {}, { reload: true });
                }
               });                                          

        }else{
          
            $.getJSON("https://jsonip.com?callback=?", function (data1) {
              var data = {'property_id': property_id, 'status':'1', 'ip_address':data1.ip};
              var url  = 'api/v1/save-favourite-property'; 
              $http({method : 'post',url:url, data:data})
               .success(function(data, status) {
                if(data.success=='1'){
                  var pnotify = new PNotify({
                                  title: 'Success',
                                  text: data.message,
                                  type: 'success',
                                  styling: 'bootstrap3',
                                });
                  $window.location.reload();
                   //$state.go($state.current, {}, { reload: true });
                }
               })
               .error(function(error){
                  var pnotify = new PNotify({
                                  title: 'Error',
                                  text: 'Favourite not added!',
                                  type: 'error',
                                  styling: 'bootstrap3',
                                });
               });
            });              
        }            
      }
    };  

    propdetyDetails(selected_currency_name, selected_currency_symbol);    
  });

  app.controller('PropertyEnquiryController', function($scope, $http, $stateParams, $location, $filter){
    var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
    var selected_currency_symbol = localStorage.currency_symbol?localStorage.currency_symbol:'€';
    
    $('#required_base_currency').change(function(e){
      var selected_currency = $(this).val()?$(this).val():'';
      var selected_currency_symbol = $(this).val()?$('#required_base_currency option:selected').attr('data-symbol'):'';
      property_enq_detaits_func(selected_currency_name, selected_currency_symbol);
    });
    var property_enq_detaits_func = function(currency_name, currency_symbol){

      var datesArray  = [];
      var startDatesArray  = [];
      var endDatesArray  = [];  
      var combinesArray = []; 
      var temp  = [];
      var dup   = [];     

      $http({
        method:'get',
        url: 'api/v1/blocked-dates/'+$stateParams.id, 
        cache:true, 
        headers: {
        'Content-Type': 'application/json', 
        'Accept': 'application/json' }
      }).success(function(data){  
                                         
        for(var i=0; i<data.details.length; i++){                                       

            var arrival_date    = data.details[i].start_date;
            var departure_date  = new Date(data.details[i].send_date);                        
            departure_date.setDate(departure_date.getDate() + 1);
            
            startDatesArray.push(arrival_date);
            endDatesArray.push($filter('date')(new Date(departure_date), 'yyyy/MM/dd'));

            var startDate       = new Date(data.details[i].start_date);
            startDate.setDate(startDate.getDate() + 1);
            var endDate         = new Date(data.details[i].send_date);

            /*var startDate   = new Date(data.details[i].start_date);
            var endDate     = new Date(data.details[i].end_date);*/
            while (startDate <= endDate) {
                datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                startDate.setDate(startDate.getDate() + 1);
            }                                                   
        }
        //console.log(datesArray, 'datesArray/');
        combinesArray = startDatesArray.concat(endDatesArray);
           
        $.each(combinesArray, function (key, value) {

           if($.inArray(value, temp) === -1) {
               temp.push(value);

            }else{
               dup.push(value);
            }
        });

        $scope.dates = datesArray;
        $scope.availableDateOptions = {
          //dateDisabled:bookedPropDates,
          customClass: bookedPropDates,
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
        };

        $scope.expireDateOptions = {
            customClass: bookedPropDates,
            formatYear: 'yy',
            startingDay: 1,
            minDate: new Date(),
            maxDate: new Date(2030, 5, 22)
        };
        
        var dayDuration = 60 * 60 * 24 * 1000;
        function areDatesEqual(date1, date2) {

            return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

        }

        function bookedPropDates(data) {
          var date = data.date,
              mode = data.mode;                  
          if (mode === 'day') {    
            //var isRealDate = true;
            for (var i = 0; i < $scope.dates.length; i++) {
              var click_count       = $('#arrival_time').attr('data-key');
              var dclick_count      = $('#departure_time').attr('data-key');
              var barrival_time     = $('#arrival_time').val();
              var bdeparture_time   = $('#departure_time').val();
              
                
              var changedDate     = new Date($scope.dates[i]);
              
              if (areDatesEqual(changedDate, date)) {    
                 return 'appointment';                  
              }
            }

            for (var i = 0; i < startDatesArray.length; i++) {
              if($.inArray(startDatesArray[i], dup) == -1){                        
                var changedDate     = new Date(startDatesArray[i]);                      
                if (areDatesEqual(changedDate, date)) {    
                   return 'start_appointment';                  
                }
              }
            }

            for (var i = 0; i < endDatesArray.length; i++) {
              if($.inArray(endDatesArray[i], dup) == -1){                        
                var changedDate     = new Date(endDatesArray[i]);                      
                if (areDatesEqual(changedDate, date)) {    
                   return 'end_appointment';                  
                }
              }
            }

            for (var i = 0; i < dup.length; i++) {
              var changedDate     = new Date(dup[i]);                      
              if (areDatesEqual(changedDate, date)) {    
                 return 'combine_appointment appointment';                  
              }                      
            }

          }

          return '';
          //return mode === 'day' && !isRealDate;
        }                    
          
      }).error(function(error){

      });          
 
      $scope.arrival_time   = new Date();
      $scope.departure_time = new Date();
      $scope.propDateFormat = 'yyyy-MM-dd';
      $scope.availableDateOptions = {
          formatYear: 'yy',
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
      };
      $scope.expireDateOptions = {
          formatYear: 'yy',
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
      };
      $scope.availableDatePopup = {
          opened: false
      };
      $scope.expireDatePopup = {
          opened: false
      };  
  
      $scope.ChangeExpiryMinDate = function(availableDate) {

          if (availableDate != null) {
              var expiryMinDate = new Date(availableDate);
              $scope.expireDateOptions.minDate = expiryMinDate;
              $scope.departure = expiryMinDate;                
              setTimeout(function(){
                if($scope.departure){
                  $('#departure_time').val('');
                }
              },0);               
          }            
      };
      $scope.ChangeExpiryMinDate();
      var i = 0;
      $scope.OpenAvailableDate = function() {
          
          $('#arrival_time').attr('data-key', i);
          i++;
          $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
      };
      $scope.OpenExpireDate = function() {
        $('#departure_time').attr('data-key', i);
          i++;
          $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
      };

      $scope.submitted = true; 
      $scope.propEnquiry = function(){

        var deal_sum = 0;
        var deal_count = 0;
        $(".calculated_booking_amount").each(function(){
            deal_sum += +$(this).text();
            deal_count++;
        });

        if(deal_count>1){
          var deal_total = deal_sum/2;
        }else{
          var deal_total = deal_sum;
        }
          
        var total_booking_amount = $('.total_amount_for_booking').val();
          
        var paypal_booking_amount = $('.calculated_paypal_amount').text();
        
        //var security_deposit_amount = $('.property_security_deposit_amt').text();  

        var arrival_time    = $('#arrival_time').val();
        var departure_time  = $('#departure_time').val();

        var owner_deal_amount     = deal_total;
        var coupon                = $('.coupon_amount').val();
        var paypal_booking_amount = $('#calculated_paypal_amount').text();              
        var selected_cardtype     = $('.selected_payment_method_type').val();
        var total_booking_amount = $('#calculated_booking_amount_main').text();
        if(arrival_time==departure_time){
            
          var pnotify = new PNotify({
                          title: 'Error',
                          text: 'Entry and Exit on same day not allowed, please change the departure',
                          type: 'error',
                          styling: 'bootstrap3'                              
                        }); 

        }else{
            
          var params = {
                      'owner_paypal_email':$scope.owner_paypal_email,
                      'owner_id':$scope.owner_id, 
                      'property_id':$stateParams.id,
                      'arrival_time':arrival_time, 
                      'departure_time':departure_time, 
                      'guest_limit':$scope.guest_limit, 
                      'first_name':$scope.first_name, 
                      'surname':$scope.surname, 
                      'phone':'+'+$("#prop_phone").intlTelInput("getSelectedCountryData").dialCode+$scope.phone, 
                      'email':$scope.email, 
                      'message':$scope.message,
                      'paid_amount':paypal_booking_amount,
                      'owner_security_deposit':$scope.owner_security_deposit_amount, 
                      'security_deposit':$scope.security_deposit_amount,
                      'coupon':coupon,
                      'owner_deal_amount':owner_deal_amount,    
                      'booking_amount':total_booking_amount,
                      'selected_currency_symbol' : currency_symbol,
                      'selected_currency_name'  : currency_name,
                    };
                   
          $http({
                method  : 'post',
                url     : 'api/v1/save-property-enquiry',
                params    : params, 
          })
          .success(function(data) {
            $('#Model-enquire').modal('hide');
            if(data.message=='success') {  
              $("#property_enquiry")[0].reset();
              var pnotify = new PNotify({
                                title: 'Enquiry sent',
                                text: data.status,
                                type: 'success',
                                styling: 'bootstrap3',
                                ////delay:2000
                            });                                             

            }else{
              var pnotify = new PNotify({
                                title: 'Enquiry not sent',
                                text: 'Something went wrong, enquiry not sent. Please try again!',
                                type: 'error',
                                styling: 'bootstrap3',
                              //  //delay:2000
                            });
            }

          })
          .error(function(data){console.log(data);
             if(data.success=='0') {
              $scope.errorMessage = data.message;
              //alert(data.message+' Please try again!');             
             }

          });
        }   
      }
    };       
    property_enq_detaits_func(selected_currency_name, selected_currency_symbol);
  });
 
  
  app.controller('PropertyBooknowController', function($window, $scope, $http, $stateParams, $location, $filter){
    
    var selected_currency_name   = localStorage.currency_value?localStorage.currency_value:'eur';
    var selected_currency_symbol = localStorage.currency_symbol?localStorage.currency_symbol:'€';

    $('#required_base_currency').change(function(e){
      var selected_currency           = $(this).val()?$(this).val():'';
      var selected_currency_symbol    = $(this).val()?$('#required_base_currency option:selected').attr('data-symbol'):'';
      property_booking_detaits_func(selected_currency, selected_currency_symbol);
    });
    var property_booking_detaits_func = function(currency_name, currency_symbol){

      var datesArray  = []; 
      var startDatesArray  = [];
      var endDatesArray  = [];  
      var combinesArray = []; 
      var temp  = [];
      var dup   = [];   

      $http({
        method:'get',
        url: 'api/v1/blocked-dates/'+$stateParams.id, 
        cache:true, 
        headers: {
        'Content-Type': 'application/json', 
        'Accept': 'application/json' }
      }).success(function(data){
        for(var i=0; i<data.details.length; i++){ 

          var arrival_date    = data.details[i].start_date;
          var departure_date  = new Date(data.details[i].send_date);    
          var block_type      = data.details[i].block_type;
          //if(block_type!='banking'){

            departure_date.setDate(departure_date.getDate() + 1);  
         // }                    
          
          
          startDatesArray.push(arrival_date);
          endDatesArray.push($filter('date')(new Date(departure_date), 'yyyy/MM/dd'));

          var sDate       = new Date(data.details[i].start_date);
          sDate.setDate(sDate.getDate() + 1);
          var eDate       = new Date(data.details[i].send_date);

        	/*var sDate = data.details[i].start_date;
        	var eDate = data.details[i].end_date; */
        	                                     
            var startDate   = new Date(sDate);
            var endDate     = new Date(eDate);
            while (startDate <= endDate) {
                datesArray.push($filter('date')(new Date(startDate), 'yyyy/MM/dd'));
                startDate.setDate(startDate.getDate() + 1);
            }                                                   
        }
        
        combinesArray = startDatesArray.concat(endDatesArray);
           
        $.each(combinesArray, function (key, value) {

           if($.inArray(value, temp) === -1) {
               temp.push(value);

            }else{
               dup.push(value);
            }
        });

        $scope.dates = datesArray;
        $scope.availableDateOptions = {
          customClass: bookedPropDates,
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
        };

        $scope.expireDateOptions = {
            customClass: bookedPropDates,
            startingDay: 1,
            minDate: new Date(),
            maxDate: new Date(2030, 5, 22)
        };

        var dayDuration = 60 * 60 * 24 * 1000;
        function areDatesEqual(date1, date2) {

            return date1.setHours(0,0,0,0) === date2.setHours(0,0,0,0)

        }

        function bookedPropDates(data) {
          var date = data.date,
              mode = data.mode;

          if (mode === 'day') {    
            //var isRealDate = true;
            for (var i = 0; i < $scope.dates.length; i++) {
              var click_count       = $('#barrival_time').attr('data-key');
              var dclick_count      = $('#bdeparture_time').attr('data-key');
              var barrival_time     = $('#barrival_time').val();
              var bdeparture_time   = $('#bdeparture_time').val();
              
              var changedDate     = new Date($scope.dates[i]);
                                    
              if (areDatesEqual(changedDate, date)) {    
                 return 'appointment';                  
              }
            }
          

            for (var i = 0; i < startDatesArray.length; i++) {
              if($.inArray(startDatesArray[i], dup) == -1){                        
                var changedDate     = new Date(startDatesArray[i]);                      
                if (areDatesEqual(changedDate, date)) {    
                   return 'start_appointment';                  
                }
              }
            }
                    

            for (var i = 0; i < endDatesArray.length; i++) {

             
                if($.inArray(endDatesArray[i], dup) == -1){                        
                  var changedDate     = new Date(endDatesArray[i]);                      
                  if (areDatesEqual(changedDate, date)) { 
                     return 'end_appointment';                  
                  }
                }
              
              
            }

            for (var i = 0; i < dup.length; i++) {
              var changedDate     = new Date(dup[i]);                      
              if (areDatesEqual(changedDate, date)) {    
                 return 'combine_appointment appointment';                  
              }                      
            }
          }

          return '';
          //return mode === 'day' && !isRealDate;
        } 
      }).error(function(error){

      }); 


        
      $scope.arrival_time   = new Date();
      $scope.departure_time = new Date();
      $scope.propDateFormat = 'yyyy-MM-dd';
      $scope.availableDateOptions = {
          formatYear: 'yy',
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
      };
      $scope.expireDateOptions = {
          formatYear: 'yy',
          startingDay: 1,
          minDate: new Date(),
          maxDate: new Date(2030, 5, 22)
      };
      $scope.availableDatePopup = {
          opened: false
      };
      $scope.expireDatePopup = {
          opened: false
      };
      $scope.ChangeExpiryMinDate = function(availableDate) {
          if (availableDate != null) {
              var expiryMinDate = new Date(availableDate);
              $scope.expireDateOptions.minDate = expiryMinDate;
              $scope.bdeparture = expiryMinDate;
              setTimeout(function(){
                if($scope.bdeparture){
                  $('#bdeparture_time').val('');
                }
              },0);                
          }
      };
      $scope.ChangeExpiryMinDate();
      var i = 0;
      $scope.OpenAvailableDate = function() {
          
          $('#barrival_time').attr('data-key', i);
          i++;
          $scope.availableDatePopup.opened = !$scope.availableDatePopup.opened;
      };
      $scope.OpenExpireDate = function() {

          $('#bdeparture_time').attr('data-key', i);
          i++;
          $scope.expireDatePopup.opened = !$scope.expireDatePopup.opened;
      };

      $scope.filterValue = function($event){
        if(isNaN(String.fromCharCode($event.keyCode)) || $event.keyCode === 32){
            $event.preventDefault();
        }
      };


      $scope.getSecurityDepositAmount = function(amount){
    
        $('.keyChangeSecurityDeposit').val();

        var check_coupon_val = $('.coupon_amount').val();

        if(check_coupon_val){

          var apply_coupon_on_date_change = check_coupon_val;
        }else{

          var apply_coupon_on_date_change = 0;
        }

        var owner_deal_amount_check = $('.owner_deal_amount').val();

        if(owner_deal_amount_check!=0 && owner_deal_amount_check){

          var apply_owner_deal = owner_deal_amount_check;                 
        }else{

          var apply_owner_deal = 0;
        }

        if(amount){

          var samount = amount;
          $scope.amount = samount;
          $scope.security_amount = samount;

        }else{
          var samount = 0;
          $scope.amount = samount;
          $scope.security_amount = samount;
        }
        
        if($scope.booking_amount){
          
          var bamount = $scope.booking_amount;
        }else{
          var bamount = 0;
        }   


        if(!samount){
          
          $scope.paypal_booking_amount = (parseFloat($scope.booking_amount)-parseFloat(apply_coupon_on_date_change)+0).toFixed(2);
          $('.total_amount_for_booking').val($scope.paypal_booking_amount);
          console.log($scope.paypal_booking_amount, 'kv13');
          $('.calculated_paypal_amount').text($scope.paypal_booking_amount); 
          
        }else{
         
          if($scope.coupon_amount_valid){              
            $scope.paypal_booking_amount = (parseFloat($scope.booking_amount)+parseFloat(samount)-parseFloat(apply_coupon_on_date_change)).toFixed(2);   
            $('.total_amount_for_booking').val($scope.paypal_booking_amount);
            console.log($scope.paypal_booking_amount, 'kv14');
            $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
          }else{              

            $scope.paypal_booking_amount = (parseFloat($scope.booking_amount)+parseFloat(samount)-parseFloat(apply_coupon_on_date_change)).toFixed(2); 
            $('.total_amount_for_booking').val($scope.paypal_booking_amount);
            console.log($scope.paypal_booking_amount, 'kv15');
            $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
            
          }
          
        }          

      }

      

      $scope.getCheckCouponCode = function(coupon, property_id){          

        var from_date   = $('#barrival_time').val();
        var to_date     = $('#bdeparture_time').val();
        checkAndApplyPropertyCoupon(coupon, property_id, from_date, to_date);  
                  
      }

      var submitPaymentForm = function(){

          console.log('spreedly form submission');
      }
      var checkAndApplyPropertyCoupon = function(coupon, property_id, from_date, to_date){
        
        var coupon_url  = 'api/v1/check-property-coupons-availability';
        var params = {'currency_name':currency_name, 'from_date':from_date,'to_date':to_date, 'coupon':coupon, 'property_id':property_id};
        $http({
              method  : 'get',
              url     : coupon_url,
              params  : params
        })
        .success(function(coupon_obj){
          
           
          var owner_deal_amount_check = $('.owner_deal_amount').val();

          if(owner_deal_amount_check!=0 && owner_deal_amount_check){

            var apply_owner_deal = owner_deal_amount_check;                 
          }else{

            var apply_owner_deal = 0;
          }

          var changedSecurityDeposit = $('.keyChangeSecurityDeposit').val();                  
      
          var security_deposit_amount = '';

          if(changedSecurityDeposit){

            security_deposit_amount       = changedSecurityDeposit;
          }else{

            security_deposit_amount       = $('.property_security_deposit_amt').val();  
          }                      

          if(coupon_obj.success==3){
              console.log('3 c');
              $('.property_coupon_code').prop('readonly', true);
              $('.property_coupon_code').val('');

              $('.coupon_error_span').text(coupon_obj.message); 
              console.log('2 ccc');
              $scope.coupon_discount_amount = '';
              $('.coupon_discount_amount').text('');
              $('.coupon_amount').val(0); 
              $scope.applied_coupon         = '';                         

          }else{

              $('.property_coupon_code').prop('readonly', false);
          }
          
          if(coupon_obj.success==1){                         

              $('.coupon_error_span').text("");
              $('#check_coupon_btn').prop('disabled', false);
              //$('.property_coupon_code').removeAttr('readonly');
              if(coupon_obj.data.type=='flat'){
                if(parseFloat($scope.booking_amount)>parseFloat(coupon_obj.data.min_amount) || parseFloat(coupon_obj.data.min_amount)==parseFloat($scope.booking_amount)){
                  
                  var coupon_amount             = coupon_obj.data.amount;
                  $scope.coupon_discount_amount = currency_symbol+' '+coupon_amount;
                  $('.coupon_amount').val(coupon_amount); 
                  $scope.applied_coupon         = coupon_amount;
                  var apply_coupon              = parseFloat($scope.booking_amount)-parseFloat(coupon_amount)+parseFloat(security_deposit_amount);                                 
                  $scope.coupon_amount_valid    = apply_coupon;
                  $scope.paypal_booking_amount  = apply_coupon;
                  console.log($scope.paypal_booking_amount, 'kv16');
                  $('.calculated_paypal_amount').text($scope.paypal_booking_amount);

                }else{

                  $('.coupon_error_span').text("Need minimum "+coupon_obj.data.min_amount);
                   //$scope.coupon_error  = "Need minimum "+coupon_obj.data.min_amount;
                }  
                  
              }else if(coupon_obj.data.type=='percentage'){
                
                if(parseFloat($scope.booking_amount)>parseFloat(coupon_obj.data.min_amount) || parseFloat(coupon_obj.data.min_amount)==parseFloat($scope.booking_amount)){  
                  
                  var coupon_amount             = coupon_obj.data.amount;
                  $scope.coupon_discount_amount = coupon_amount+'%';                                
                  var calculated_amount         = (parseFloat($scope.booking_amount)*parseFloat(coupon_amount)/100).toFixed(2);
                  $('.coupon_amount').val(calculated_amount);
                  $scope.applied_coupon         = calculated_amount;
                  var apply_coupon              = parseFloat($scope.booking_amount)-parseFloat(calculated_amount)+parseFloat(security_deposit_amount); 
                  $scope.coupon_amount_valid    = apply_coupon; 
                  $scope.paypal_booking_amount  = apply_coupon.toFixed(2);
                  console.log($scope.paypal_booking_amount, 'kv17');
                  $('.calculated_paypal_amount').text($scope.paypal_booking_amount); 
                }else{

                  $('.coupon_error_span').text("Need minimum "+coupon_obj.data.min_amount);
                   //$scope.coupon_error  = "Need minimum "+coupon_obj.data.min_amount;
                }                        
              }
          }else if(coupon_obj.success==3){
            console.log('1 c');
            $('.coupon_error_span').text(coupon_obj.message);
            $scope.coupon_discount_amount = '';
            $('.coupon_discount_amount').text('');
            $('.coupon_amount').val(0); 
            $scope.applied_coupon         = '';


          }else{
            
            //$('.property_coupon_code').val('');
            $('#check_coupon_btn').prop('disabled', true);
            //$('.property_coupon_code').prop('readonly', true);
            
            if(!$scope.amount && $scope.amount!='undefined'){
              $('.coupon_amount').val('');
              $scope.paypal_booking_amount  = (parseFloat($scope.booking_amount)+parseFloat(security_deposit_amount)).toFixed(2);  
              console.log($scope.paypal_booking_amount, 'kv18');
              $('.calculated_paypal_amount').text($scope.paypal_booking_amount);
              //$('.calculated_paypal_amount').text($scope.paypal_booking_amount);
            }else{
              $('.coupon_amount').val('');
              $scope.paypal_booking_amount  = (parseFloat($scope.booking_amount)+parseFloat($scope.amount)).toFixed(2);
              console.log($scope.paypal_booking_amount, 'kv19');
              $('.calculated_paypal_amount').text($scope.paypal_booking_amount);  
            }
            

            if($('.property_coupon_code').val()){

              $('.coupon_error_span').text(coupon_obj.message);
              
            }else{

              $('.coupon_error_span').text('');
            }                          
            
            $scope.coupon_amount_valid    = 0;
            $scope.coupon_discount_amount = '';
            $('.coupon_discount_amount').text('');
            $('.coupon_amount').val(0); 
            $scope.applied_coupon         = '';    
          }
        })
        .error(function(coupon_error){

        });
      }

      $scope.submitted = true; 
      if(localStorage.currency_value==currency_name){       
        $scope.booknowProperty = function(e){          
          console.log('property book now controller');
          var arrival_time    = $('#barrival_time').val();
          var departure_time  = $('#bdeparture_time').val();

          if(arrival_time==departure_time){
              
            var pnotify = new PNotify({
                            title: 'Error',
                            text: 'Entry and Exit on same day not allowed, please change the departure',
                            type: 'error',
                            styling: 'bootstrap3'                              
                          }); 

          }else{
            var total_booking_amount = $('.total_amount_for_booking').val();
            if(total_booking_amount!=0 && total_booking_amount>0){ 
            
              var deal_sum = 0;
              var deal_count = 0;
              $(".calculated_booking_amount").each(function(){
                  deal_sum += +$(this).text();
                  deal_count++;
              });

              if(deal_count>1){
                var deal_total = deal_sum/2;
              }else{
                var deal_total = deal_sum;
              }
              var arrival_time          = $('#barrival_time').val();
              var departure_time        = $('#bdeparture_time').val();
              var owner_deal_amount     = deal_total;//$('#calculated_booking_amount').text();
              console.log(owner_deal_amount, 'owner_deal_amount');
              var coupon                = $('.coupon_amount').val();
              var paypal_booking_amount = $('#calculated_paypal_amount').text();              
              var selected_cardtype     = $('.selected_payment_method_type').val();
              var params = {
                            'owner_id':$scope.owner_id,
                            'security_deposit':$scope.security_deposit_amount, 
                            'owner_paypal_email':$scope.owner_paypal_email,
                            'paid_amount':paypal_booking_amount, 
                            'property_id':$stateParams.id ,
                            'arrival_time':arrival_time, 
                            'departure_time':departure_time, 
                            'guest_limit':$scope.guest_limit, 
                            'first_name':$scope.first_name, 
                            'surname':$scope.surname, 
                            'phone':'+'+$("#prop_book_phone").intlTelInput("getSelectedCountryData").dialCode+$scope.phone, 
                            'email':$scope.email, 
                            'message':$scope.message, 
                            'owner_security_deposit':$scope.owner_security_deposit_amount, 
                            'booking_amount':$scope.booking_amount,
                            'coupon':coupon,
                            'owner_deal_amount':owner_deal_amount,                            
                            'selected_cardtype':selected_cardtype,
                            'selected_currency_symbol' : currency_symbol,
                            'selected_currency_name'  : currency_name,
                          };
                $('#loading-image').show();
                $http({
                      method  : 'post',
                      url     : 'api/v1/save-property-booking',
                      params  : params
                })
                .success(function(data) {
                  //$('#book-now-model').modal('hide');
                  $('#loading-image').hide();
                  if(data.success=='2'){

                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: data.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        //timer:null
                                        delay:60000
                                      });

                  }else{
                      if(data.message=='success') {      
                        $scope.paymentBookingId       = data.booknow_details.id;
                        $scope.bookingArrivalTime     = data.booknow_details.arrival_time;
                        $scope.bookingDepartureTime   = data.booknow_details.departure_time;
                        $scope.bookingDepartureTime   = data.booknow_details.departure_time;
                        $scope.stateParamsId          = $stateParams.id;
                        $scope.ownerPaypalEmailId     = $scope.owner_paypal_email;
                        sendEvent('#book-now-model', 2);
                        $('.payment_details_process_step').attr( 'checked', true );
                        $scope.errorMessage = "";       
                      }else{
                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: 'Something went wrong, Booking not done. Please try again!',
                                        type: 'error',
                                        styling: 'bootstrap3',                                        
                                        delay:60000
                                      });
                      }
                  }
                })
                .error(function(data){console.log(data);
                   if(data.success=='0') {
                      
                      var pnotify = new PNotify({
                                        title: 'Error',
                                        text: data.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay:60000
                                    });
                    //$scope.errorMessage = data.message;
                   }

                });

              }else{

                var pnotify = new PNotify({
                                  title: 'Error',
                                  text: 'Amount should not be zero',
                                  type: 'error',
                                  styling: 'bootstrap3',
                                  //delay:2000
                              });
            } 
          }
        }  


        $('#book-now-model').on('shown.bs.modal', function (e) { 
          $('.selected_payment_method_type').on('change', function(){

              var selected_value = $(this).val();
              console.log(selected_value, 'selected_card57');
              if(selected_value=='paypal'){
                  $('.credit_card_inputs').hide();
                  $('.credit_card_submit').text('Pay Now');
                  $('.credit_card_submit').attr('id', 'paypal-submit-button');
                  $('.credit_card_submit').attr('onclick', 'submitPaypalPaymentForm(); return false;');
              }else{
                  $('.credit_card_inputs').show();
                  $('.credit_card_submit').text('Make Payment');
                  $('.credit_card_submit').attr('id', 'submit-button');
                  $('.credit_card_submit').attr('onclick', 'submitPaymentForm(); return false;');
              }

              console.log('inside modalwwwww');
              
          });

          $window.submitPaymentForm = function () {
            var requiredFields            = {};
            requiredFields["full_name"]   = document.getElementById("full_name").value;
            requiredFields["month"]       = document.getElementById("month").value;
            requiredFields["year"]        = document.getElementById("year").value;

            var result = Spreedly.tokenizeCreditCard(requiredFields);
            console.log(result, 'result');
          }
          
          $window.submitPaypalPaymentForm = function(){

              var paymentBooking                = $('.paymentBookingId').text();
              var amount                        = $('#calculated_paypal_amount').text();
              var stateParamsId                 = $('.stateParamsId').text();
              var ownerPaypalEmailId            = $('.ownerPaypalEmailId').text();

              var url =  'book-property-paypal/booking/'+amount+'/'+stateParamsId+'?paypal_email='+ownerPaypalEmailId+'&book_id='+paymentBooking+'&currency_name='+currency_name;
              window.location.href = url;//'book-property-paypal/booking/'+amount+'/'+stateParamsId+'?paypal_email='+ownerPaypalEmailId+'&book_id='+paymentBooking;
          }

          var access_token = '2VliQoIvXLLyW2vTn7kPWotrMId';  
          console.log(access_token, 'access_token122');
          
          
          Spreedly.init(access_token, {
            "numberEl": "spreedly-number",
            "cvvEl": "spreedly-cvv"
          });

          Spreedly.on("ready", function () {
            var submitButton = document.getElementById('submit-button');
            submitButton.disabled = false;
          });

          

          Spreedly.on('errors', function(errors) {
            for (var i=0; i < errors.length; i++) {
              var error = errors[i];
              var msg = error.message;
              console.log(msg, 'error message');
              if(msg){

                  $('.payment_error_validation').text(msg);    
              }else{
                  $('.payment_error_validation').text('');
              }
              
            };
          });

          Spreedly.on('paymentMethod', function(token, pmData) {
            var tokenField = document.getElementById("payment_method_token");
            
            var pnotify = new PNotify({
                                  title: 'Info',
                                  text: 'Please wait, while your payment is being processed.',
                                  type: 'info',
                                  styling: 'bootstrap3',                                        
                                  delay:5000
                                });
            //console.log(tokenField, 'dddd123456789');
            tokenField.setAttribute("value", token);
            console.log(token, 'token');
            var url            = 'api/v1/booking-payment';
            var paymentBooking = $('.paymentBookingId').text();
            var full_name      = $('#full_name').val();
            var month          = $('#month').val();
            var year           = $('#year').val();
            var cvv            = $('#cvv').val()!='undefined'?$('#cvv').val():'';
            var amount         = $('#calculated_paypal_amount').text();
            var selected_card  = $('.selected_payment_method_type').val();
            var bookingDepartureTime          = $('.bookingDepartureTime').text();
            var bookingArrivalTime            = $('.bookingArrivalTime').text();
            //var data                          = 'paymentBooking='+paymentBooking+'&payment_method_token='+token+'&full_name='+full_name+'&month='+month+'&year='+year+'&amount='+amount+'&bookingDepartureTime='+bookingDepartureTime+'&bookingArrivalTime='+bookingArrivalTime+'&cvv='+cvv+'&selected_card='+selected_card;
            var data                            = {'currency_name':currency_name,'paymentBooking':paymentBooking, 'payment_method_token':token, 'full_name':full_name, 'month':month, 'year':year, 'amount':amount,'bookingDepartureTime':bookingDepartureTime,'bookingArrivalTime':bookingArrivalTime,'cvv':'cvv', 'selected_card':selected_card};
            console.log(data, 'dddd loading start before');
            $('.credit_card_submit').prop('disabled', true);
            //console.log('dddd loading start after111123');
            
            //console.log('loader here');
            $http({
                    method  : 'post',
                    url     : url,
                    params  : data
            }).success(function(result){

              console.log('dddd loading close before');
              $scope.showLoader = false;
              console.log('dddd loading close after');            
              if(result.success==1){
                  $('#book-now-model').modal('hide');    
                  var pnotify = new PNotify({
                                  title: 'Success',
                                  text: result.message,
                                  type: 'success',
                                  styling: 'bootstrap3',                                        
                                  delay:60000
                                });
                  setTimeout(function(){ location.reload() }, 2000);

              }else{

                  var pnotify = new PNotify({
                                  title: 'Error',
                                  text: result.message,
                                  type: 'error',
                                  styling: 'bootstrap3',                                        
                                  delay:60000
                                });
              }
            }).error(function(error){
              $scope.showLoader = false;
              console.log(error, 'error message');
              var pnotify = new PNotify({
                              title: 'Error',
                              text: '',
                              type: 'error',
                              styling: 'bootstrap3',                                        
                              delay:60000
                            });
            }); 
          });
        });
      }
    } 
      property_booking_detaits_func(selected_currency_name, selected_currency_symbol);
  });    
