$(document).ready(function() {

    if(window.location.hostname=='localhost'){

    	var public_path = '/direct_owners/public/'	
    }else{

    	var public_path = '/';
    }
    console.log(public_path, 'public_path');
    
   /* ----- Owners Data table start-----*/ 
    var ownersListTable = $('#ownersListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/owners-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     "owner_name": $('#owner_name').val() || '',
                     "email": $('#email').val() || '',
                     'owner_status': $('#owner_status').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Property Owners- Directowners'
            },            
            {
                extend: 'csv',
                filename: 'Property Owners- Directowners'
            },
            ],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "name",
             "name": "name",
             "defaultContent": '-'
         }, {
             "data": "email",
             "name": "email",
             "defaultContent": '-'
         }, {
             "data": "no_of_properties",
             "name": "no_of_properties",
             render:function(data, type, full, index){
                
                var prop_count = '<a href="javascript:void(0)" class="owner_prop_cls" data-target="#owner_properties_Modal" data-toggle="modal" data-owner-id="'+full['id']+'">'+full['no_of_properties']+'</a>';

                return prop_count;
             },
             "defaultContent": '-'
         }, {
             "data": "phone",
             "name": "phone",
             "defaultContent": '-'
         }, {
             "data": "id",
             render:function(data, type, full, index){

                var action = '<td class="admin-center editUserDetails" data-user-id="'+full['id']+'">';            
                action += '<a href="edit-owner/'+full['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
                action += '</td>';            

                return action;
             },
             "defaultContent": '-'
         }, {
             "data": "id",
             render:function(data, type, full, index){
                if(full['status']=='active'){

                    var img = '<img style="width:20px; height:20px;" src="'+public_path+'img/active-user.png"/>';
                }else{
                    var img = '<img style="width:20px; height:20px;" src="'+public_path+'img/inactive-user.png"/>';
                }

                var action1 = '<a href="javascript:void(0)" class="admin-center deleteUserDetails" data-user-status="'+full['status']+'" data-user-id="'+full['id']+'">'+img+'</a>';
                

                return action1;
             },
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {          

             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);   

         },

    });
    

     $('#email').on('change', function () {
        ownersListTable.draw();
     });

     $('#owner_name').on('change', function () {
        ownersListTable.draw();
     });

     $('#owner_status').on('change', function () {
        ownersListTable.draw();
     });

     $(document).on('click','.deleteUserDetails', function(e){
        //console.log('new2');
        var userId = $(this).attr('data-user-id');
        var userStatus = $(this).attr('data-user-status');

            if(userStatus=='active'){

                var confirm_msg = 'Are you sure you want to InActivate the Owner?';
                var success_msg = 'Owner Inactivation done successfully!';
                var error_msg   = 'Owner Inactivation not done!';
            }else{

                var confirm_msg = 'Are you sure you want to Activate the Owner?';
                var success_msg = 'Owner Activation done successfully!';
                var error_msg   = 'Owner Activation not done!';
            }
            e.preventDefault();
            //var targetUrl = $(this).attr("href");
            (new PNotify({
                title: confirm_msg,
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {
                var params = {'user_id':userId, 'user_status':userStatus};
                var deleteUrl = super_admin_api_public_path+'/api/v1/delete-user';
                $.ajax({                    
                    url:deleteUrl,
                    method:'post',
                    data:params,
                    success:function(result){

                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: success_msg,
                                        type: 'success',
                                        styling: 'bootstrap3'
                                    });                     
                        ownersListTable.draw();
                        $(".ui-pnotify-modal-overlay").remove();
                    },
                    error:function(error){

                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: error_msg,
                                        type: 'error',
                                        styling: 'bootstrap3'
                                    });
                        ownersListTable.draw();
                        $(".ui-pnotify-modal-overlay").remove();
                    }
                });
            }).on('pnotify.cancel', function() {
                ownersListTable.draw();
                $(".ui-pnotify-modal-overlay").remove();
            });
            
        });
    /* ----- Owners Data table end-----*/ 

    /*----- Enquiries Data table start -----*/

    var enquiriesListTable = $('#enquiriesListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/enquiries-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     "email": $('#email').val() || '',
                     "arrival_time": $('#arrival_time').val() || '',
                     "departure_time": $('#departure_time').val() || '',
                     "property_title": $('#property_title').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Enquiries- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Enquiries- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "name",
             "name": "name",
             "defaultContent": '-'
         }, {
             "data": "email",
             "name": "email",
             "defaultContent": '-'
         }, {
             "data": "at",
             "name": "at",
             "defaultContent": '-'
         }, {
             "data": "dt",
             "name":"dt",
             "defaultContent": '-'
         }, {
             "data": "property_title",
             "name": "property_title",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
            // var page = this.fnPagingInfo().iPage;
             //var length = this.fnPagingInfo().iLength;
             //var index  = (page * length + (iDisplayIndex +1));
            // $('td:eq(0)', nRow).html(index); 

             var action1 = '<td align="center" class="enquiry-more-details enquiry-more-details-btn"><a href="javascript:void(0)" class="enquiry_anchor_tag" data-enquiry-id="'+aData['id']+'" data-toggle="modal" data-target="#owner-enuqiry-dash-Modal"';
             action1 += 'title="View" style="color:#337ab7;">View</a>';
             action1 += '</td>';

             $('td:eq(6)', nRow).html(action1);            

             var action = '<td align="center" class="deleteEnquiryDetails" data-enquiry-id="'+aData['id']+'"><a href="javascript:void(0)"';
             action += 'title="Delete" style="color:#337ab7;"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
             action += '</td>';

             $('td:eq(8)', nRow).html(action);            

             
         },

     });

     $('#email').on('change', function () {
        enquiriesListTable.draw();
     });   

     $('#arrival_time').on('change', function () {
        enquiriesListTable.draw();
     });

     $('#departure_time').on('change', function () {
        enquiriesListTable.draw();
     });

     $('#property_title').on('change', function () {
        enquiriesListTable.draw();
     });

     $(document).on('click','td.enquiry-more-details-btn', function(e){
        var link = $(this).find('a.enquiry_anchor_tag');
        var enq_id = link.attr('data-enquiry-id');
        var modalBody = $(this).find(".modal-body");
        var url = public_path+'api/v1/enquiries/'+enq_id;
        $.ajax({                    
            url:url,
            method:'get',          
            success:function(result){console.log(result);
               if(result.success=='1'){
                $('.client_name').text(result.enquiry_details.first_name+' '+result.enquiry_details.surname);
                $('.client_arrival').text(result.enquiry_details.earrival_time);
                $('.client_departure').text(result.enquiry_details.edeparture_time);
                $('.client_guests').text(result.enquiry_details.guest_limit);
                $('.client_message').text(result.enquiry_details.message);
                
                $('.client_booking_amount').text(result.enquiry_details.booking_amount);
                $('.client_deal_discount').text(result.enquiry_details.deal_discount);
                $('.client_coupon').text(result.enquiry_details.coupon);
                $('.client_security_deposit').text(result.enquiry_details.security_deposit);
                $('.client_paid_amount').text(result.enquiry_details.paid_amount);
                $('.client_phone').text(result.enquiry_details.phone);
               }
            },
            error:function(error){

            }

        });
        
     });

     
     /*$("#owner-enuqiry-dash-Modal").on("shown.bs.modal", function(e) {

        var link = $(e.relatedTarget);
        var enq_id = link.attr('data-enquiry-id');
        var modalBody = $(this).find(".modal-body")

        var url = public_path+'api/v1/enquiries/'+enq_id;
        $.ajax({                    
            url:url,
            method:'get',          
            success:function(result){console.log(result);
               if(result.success=='1'){
                $('.client_name').text(result.enquiry_details.first_name+' '+result.enquiry_details.surname);
                $('.client_arrival').text(result.enquiry_details.arrival_time);
                $('.client_departure').text(result.enquiry_details.departure_time);
                $('.client_guests').text(result.enquiry_details.guest_limit);
                $('.client_message').text(result.enquiry_details.message);
               }
            },
            error:function(error){

            }

        });
        
     });*/

    /*----- Enquiries Data table end -----*/


    /*---- Notifications data table start----*/

    var notificationsListTable = $('#notificationsListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/notifications-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Notifications- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Notifications- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "title",
             "name": "title",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);             

             var action = '<td class="admin-center editNotificationsDetails">';            
             action += '<a href="notification/edit/'+aData['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
             action += '</td>';            

             $('td:eq(2)', nRow).html(action);

             var action1 = '<td class="admin-center deleteNotificationsDetails" data-notification-id="'+aData['id']+'"><a href="javascript:void(0)"';
             action1 += 'title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
             action1 += '</td>';

             $('td:eq(4)', nRow).html(action1);

             
         },

     });     

    /*---- Notifications data table end----*/


    /*---- Testimonials data table start----*/

    var testimonialsTable = $('#testimonialsTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path +'super-admin/testimonials-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                    
                     "testimonial_status": $('#testimonial_status').val() || ''
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Testimonials- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Testimonials- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "name",
             "name": "name",
             "defaultContent": '-'
         }, {
             "data": "property_title",
             "name": "property_title",
             "defaultContent": '-'
         }, {
             "data": "testimonial",
             "name": "testimonial",
             "defaultContent": '-'
         }, {
             "data": "priority",
             "name": "priority",
             "defaultContent": '-'
         }, 
         // {
         //     "data": "status",
         //     "name": "status",
         //     "defaultContent": '-'
         // }, 
         {
             "data": "admin_status",
             "name": "admin_status",
             "defaultContent": '-'
         }, 
         {
            "data": "testimonial_created_at",
            "name": "testimonial_created_at",
            "defaultContent": '-'

         },{
            "data": "id",
            "name": "id",
             render:function(data, type, full, index){
                
                            
                var action = '<a href="edit-testimonial/'+full['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
            

                return action;
             },
             "defaultContent": '-'
         }, {
             "data": "id",
             "name": "id",
             render:function(data, type, full, index){
                
                var action1 = '<a href="javascript:void(0)" class="admin-center deleteTestimonialDetails"  data-testimonial-id="'+full['id']+'" ';
                action1 += 'title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
                //var action = '<a href="edit-testimonial/'+full['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
            

                return action1;
             },
         }],
         

         "order": [
             
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);             

             // var action = '<td class="admin-center">';            
             // action += '<a href="edit-testimonial/'+aData['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
             // action += '</td>';            

             // $('td:eq(7)', nRow).html(action);

             // var action1 = '<td class="admin-center deleteTestimonialDetails"  data-testimonial-id="'+aData['id']+'"><a href="javascript:void(0)"';
             // action1 += 'title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
             // action1 += '</td>';

             // $('td:eq(9)', nRow).html(action1);

             
         },

     }); 

     $('#testimonial_status').on('change', function () {
        testimonialsTable.draw();
        if($(this).val()=='active'){
            var pnotify = new PNotify({
                          title: 'Info',
                          text: 'Top 10 are published online',
                          type: 'info',
                          styling: 'bootstrap3',
                      });     
        }
        
     });    

    /*---- Testimonials data table end----*/


    /*---- Benifits data table start----*/

    var benifitsListTable = $('#benifitsListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path +'super-admin/benifits-json-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Benifits- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Benifits- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "benifits",
             "name": "benifits",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);             

             var action = '<td class="admin-center">';            
             action += '<a href="edit-benifits/'+aData['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
             action += '</td>';            

             $('td:eq(2)', nRow).html(action);

             var action1 = '<td class="admin-center deleteBenifitDetails"  data-benifit-id="'+aData['id']+'"><a href="javascript:void(0)"';
             action1 += 'title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
             action1 += '</td>';

             $('td:eq(4)', nRow).html(action1);

             
         },

     });     

    /*---- Benifits data table end----*/


    /*---- CMS data table start----*/

    var cmsTable = $('#cmsTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/cms-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'CMS- Directowners'
            },
            {
                extend: 'csv',
                filename: 'CMS- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "title",
             "name": "title",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);             

             var action = '<td class="admin-center editNotificationsDetails">';            
             action += '<a href="edit-cms/'+aData['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
             action += '</td>';            

             $('td:eq(2)', nRow).html(action);     

             
         },

     });     

    /*---- CMS data table end----*/

    /*----- Account Data table start -----*/

    var accountsListTable = $('#accountsListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/accounts-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     "name": $('#name').val() || '',
                     "expiry_from": $('#expiry_from').val() || '',
                     "expiry_to": $('#expiry_to').val() || '',
                     "status": $('#status').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excelHtml5', 
                filename: 'Accounts- Directowners'
            },
            {
                extend: 'csvHtml5',
                filename: 'Accounts- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "name",
             "name": "name",
             "defaultContent": '-'
         }, {
             "data": "properties",
             'name':'properties',
             "defaultContent": '-'
         }, {
             "data": "renewal_date",
             "name": "renewal_date",
             "defaultContent": '-'
         }, {
             "data": "expiry_date",
             "name": "expiry_date",
             "defaultContent": '-'
         }, {
             "data": "price",
             "name":"price",
             "defaultContent": '-'
         }, {
             "data": "status",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);
             
             if(aData['status']=='Paid'){
                var clsName = 'paid';
             }else if(aData['status']=='Pending'){
                var clsName = 'pending';
             }else{
                var clsName = 'expired';
             }

             var action = '<td align="center" class="account-status '+clsName+'">'+aData['status'];
             action += '</td>';
             $('td:eq(6)', nRow).html(action);         

         },

     });

     $('#name').on('change', function () {
        accountsListTable.draw();
     });   

     $('#expiry_from').on('change', function () {
        accountsListTable.draw();
     });

     $('#expiry_to').on('change', function () {
        accountsListTable.draw();
     });

     $('#status').on('change', function () {
        accountsListTable.draw();
     });



    $("#accounts-dash-Modal").on("shown.bs.modal", function(e) {
        var link = $(e.relatedTarget);
        var user_id = link.attr('data-user-id');
        var modalBody = $(this).find(".modal-body")

        var url = public_path+'super-admin/user-accounts-list/'+user_id;
        $.ajax({                    
            url:url,
            method:'get',          
            success:function(result){
               if(result.success=='1'){
                var len = result.data.length;
                $('.accountsInnerListTable').empty();
                    for(var i=0; i<len; i++){

                        if(result.data[i].status=='pending'){
                            var astatus = '<td><span class="admin-invoice-pending-txt">Pending</span></td>';
                        }else{
                            var astatus = '<td>Closed</td>';
                        }
                        if(result.data[i].renewal_date){
                            var renew = new Date(result.data[i].renewal_date);
                            var renew_date = renew.getDate()+'/'+renew.getMonth()+'/'+renew.getFullYear();
                        }
                        if(result.data[i].expiry_date){//console.log(result.data[i].expiry_date);
                            var expiry =new Date(result.data[i].expiry_date);
                            var expiry_date = expiry.getDate()+'/'+expiry.getMonth()+'/'+expiry.getFullYear();
                        }

                        $('.accountsInnerListTable').append('<tr>'+
                            '<td>'+renew_date+'</td>'+
                            '<td>'+expiry_date+'</td>'+
                            '<td>'+result.data[i].price+'</td>'+
                            ''+astatus+''+    
                            '</tr>');    
                    }
               }else{

                    $('.accountsInnerListTable').append('<tr><td col-span="6">No results found</td></tr>') 
               }
            },
            error:function(error){
                $('.accountsInnerListTable').empty();
                if(error){
                    $('.accountsInnerListTable').append('<tr><td col-span="6">No results found</td></tr>')
                }
            }

        });
        
     });

    /*----- Account Data table end -----*/

    /*----- Property Bookings Data table start -----*/

    var bookingsListTable = $('#bookingsListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/property-bookings-json-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     "arrival_time": $('#pb_arrival_time').val() || '',
                     "departure_time": $('#pb_departure_time').val() || '',
                     "property_title": $('#pb_property_title').val() || '',
                     'paypal_status' : $('#pb_paypal_status').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Bookings- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Bookings- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "property_title",
             "name": "property_title",
             "defaultContent": '-'
         }, {
             "data": "at",
             "name": "at",
             "defaultContent": '-'
         }, {
             "data": "dt",
             "name":"dt",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }, {
             "data": "status",
             "name":"status",
             "defaultContent": '-'
         }, {
             "data": "paid_amount",
             "name":"paid_amount",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                      
            var property_details = '<td class="admin-center">\
                                    <a href="javascript:void(0)" title="View" data-toggle="modal" data-target="#property_details_modal" class="view_booked_property_details" data-id="'+aData['id']+'">\
                                         '+aData['property_title']+'\
                                    </a>&nbsp;&nbsp; \
                                </td>';
            $('td:eq(1)', nRow).html(property_details);

            var view_bdetails = '<td class="admin-center">\
                                    <a href="javascript:void(0)" title="View" data-toggle="modal" data-target="#user_property_booked_details_modal" class="view_booking_details" data-id="'+aData['id']+'">\
                                        <i class="fa fa-info-circle" aria-hidden="true"></i> View\
                                    </a>&nbsp;&nbsp; \
                                </td>';
            $('td:eq(5)', nRow).html(view_bdetails);
             
         },

     });

     $(document).on('click', 'td>a.view_booked_property_details', function(){

           var booking_id = $(this).data('id');
           var url = public_path+'api/v1/booked-property-details?booking_id='+booking_id

           $.ajax({
                url:url,
                method:'get',
                success:function(obj){console.log(obj);

                    if(obj.success==1){

                        $('.bproperty_name').text(obj.data.property_title);
                        $('.bproperty_id').text(obj.data.property_id);
                        $('.bproperty_rate_per_week').text(obj.data.rate_per_week);
                        $('.bproperty_rate_per_night').text(obj.data.rate_per_night);
                        $('.bproperty_owner_name').text(obj.data.name);
                        $('.bproperty_owner_phone').text(obj.data.phone);
                        $('.bproperty_owner_email').text(obj.data.email);
                        $('.bproperty_owner_minimum_stay').text(obj.data.minimum_stay+' Days');
                        $('.bproperty_owner_city').text(obj.data.city);
                        $('.bproperty_owner_state').text(obj.data.state);
                        $('.bproperty_owner_area_code').text(obj.data.area_code);
                        $('.bproperty_owner_country').text(obj.data.country);
                        $('.bproperty_page').html('<a href="'+public_path+'#/property-details/'+obj.data.property_id+'">Click Here</a>');

                    }
                },
                error:function(error){

                    
                }
            });
     });
     
     $(document).on('click', 'td>a.view_booking_details', function(){

            var booking_id = $(this).data('id');
            var url = public_path+'api/v1/property-booking-details?booking_id='+booking_id;
            $.ajax({
                url:url,
                method:'get',
                success:function(obj){console.log(obj);

                    if(obj.success==1){

                        $('.prop_holiday_maker_booked_date').text(obj.data.created_at);
                        $('.prop_holiday_maker_arrival_date').text(obj.data.arrival_time);
                        $('.prop_holiday_maker_departure_date').text(obj.data.departure_time);
                        $('.prop_holiday_maker_name').text(obj.data.name);
                        $('.prop_holiday_maker_email').text(obj.data.email);
                        $('.prop_holiday_maker_phone').text(obj.data.phone);
                        $('.prop_holiday_maker_security_deposit').text(obj.data.security_deposit);
                        $('.prop_holiday_maker_coupon_amount').text(obj.data.coupon);
                        $('.prop_holiday_maker_deal_discount').text(obj.data.deal_discount);
                        $('.prop_holiday_maker_guests').text(obj.data.guest_limit);
                        $('.prop_holiday_maker_total_amount').text(obj.data.total_paid_amount);
                        $('.prop_holiday_maker_message').text(obj.data.message);

                    }
                },
                error:function(error){

                    
                }
            });
     });

     $('#pb_arrival_time').on('change', function () {
        bookingsListTable.draw();
     });

     $('#pb_departure_time').on('change', function () {
        bookingsListTable.draw();
     });

     $('#pb_property_title').on('change', function () {
        bookingsListTable.draw();
     });

     $('#pb_paypal_status').on('change', function () {
        bookingsListTable.draw();
     });


    /*----- Property Bookings Data table end -----*/

    /*----- Cancel Property Bookings Data table start -----*/

    var cancelBookingsListTable = $('#cancelBookingsListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/cancel-property-bookings-json-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {                     
                     "property_title": $('#cancel_property_title').val() || '',
                     'cancel_status' : $('#cancel_property_status').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Bookings- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Bookings- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "property_title",
             "name": "property_title",
             "defaultContent": '-'
         }, {
             "data": "status",
             "name":"status",
             "defaultContent": '-'
         }, {
             "data": "paid_amount",
             "name":"paid_amount",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {                      
                
             var property_details = '<td class="admin-center">\
                                    <a href="javascript:void(0)" title="View" data-toggle="modal" data-target="#property_details_modal" class="view_booked_property_details" data-id="'+aData['id']+'">\
                                         '+aData['property_title']+'\
                                    </a>&nbsp;&nbsp; \
                                </td>';
             $('td:eq(1)', nRow).html(property_details);   

             if(aData['owner_cancel_request']=='yes' && aData['admin_cancel_status']=='yes'){
                
                var td_data = '<td class="admin-center">Dates Unblocked</td>';
             
             }else if(aData['owner_cancel_request']=='yes' && aData['admin_cancel_status']=='no'){
                
                var td_data = '<td class="admin-center">Disapproved</td>';
             
             }else{
                
                var td_data = '<td class="admin-center">\
                <a href="javascript:void(0);" class="cancelProeprtyBooking" data-booking-id="'+aData['id']+'" title="Approve">\
                    <i class="fa fa-check" aria-hidden="true"></i> Approve\
                </a> &nbsp; &nbsp;<a href="javascript:void(0);" class="notCancelProeprtyBooking" data-booking-id="'+aData['id']+'" "title="Disapprove">\
                    <i class="fa fa-times" aria-hidden="true"></i> Reject</a></td>';
             }   

             var action1 = td_data;

             $('td:eq(5)', nRow).html(action1);
             

             var view_bdetails = '<td class="admin-center">\
                                    <a href="javascript:void(0)" title="View" data-toggle="modal" data-target="#user_property_booked_details_modal" class="view_booking_details" data-id="'+aData['id']+'">\
                                        <i class="fa fa-info-circle" aria-hidden="true"></i> View\
                                    </a>&nbsp;&nbsp; \
                                </td>';
             $('td:eq(7)', nRow).html(view_bdetails);

             var view_comment = '<td class="admin-center">\
                                    <a href="javascript:void(0)" data-user-name="'+aData['name']+'" data-user-email="'+aData['email']+'" data-owner-comment="'+aData['cancel_comment']+'" title="View" data-toggle="modal" data-target="#cancel_view_comment_modal" class="view_cancel_comment view_cancel_comment_more_details" data-id="'+aData['id']+'">\
                                        <i class="fa fa-eye" aria-hidden="true"></i> View\
                                    </a>&nbsp;&nbsp; \
                                </td>';
             $('td:eq(9)', nRow).html(view_comment);

             var send_email = '<td class="admin-center">\
                                    <a href="javascript:void(0)" data-user-name="'+aData['name']+'" data-user-email="'+aData['email']+'" data-owner-comment="'+aData['cancel_comment']+'" title="View" data-toggle="modal" data-target="#send_email_to_user_modal" class="send_email_to_holidaymaker" data-id="'+aData['id']+'">\
                                        <i class="fa fa-envelope" aria-hidden="true"></i> Send Mail\
                                    </a>&nbsp;&nbsp; \
                                </td>';
             $('td:eq(11)', nRow).html(send_email);
         },

     });

	 $('#cancel_property_title').on('change', function () {
        cancelBookingsListTable.draw();
     });

     $('#cancel_property_status').on('change', function () {
        cancelBookingsListTable.draw();
     });
        

     $(document).on('click', 'td>a.send_email_to_holidaymaker', function(){

           var booking_id = $(this).data('id');
           var url = public_path+'api/v1/property-booking-details?booking_id='+booking_id;
            $.ajax({
                url:url,
                method:'get',
                success:function(obj){console.log(obj);

                    if(obj.success==1){

                        $('.send_email_prop_booked_date').text(obj.data.created_at);
                        $('.send_email_prop_arrival_date').text(obj.data.arrival_time);
                        $('.send_email_prop_departure_date').text(obj.data.departure_time);
                        $('.send_email_prop_email').text(obj.data.email);
                        $('.send_mail_property_id').text(obj.data.property_id);
                        $('.send_mail_property_name').text(obj.data.property_title);
                        $('#prop_booked_id').val(obj.data.id);

                    }
                },
                error:function(error){

                    
                }
            });
     });   
     
     $(document).on('click', 'td>a.view_booked_property_details', function(){

           var booking_id = $(this).data('id');
           var url = public_path+'api/v1/booked-property-details?booking_id='+booking_id

           $.ajax({
                url:url,
                method:'get',
                success:function(obj){console.log(obj);

                    if(obj.success==1){

                        $('.bproperty_name').text(obj.data.property_title);
                        $('.bproperty_id').text(obj.data.property_id);
                        $('.bproperty_rate_per_week').text(obj.data.rate_per_week);
                        $('.bproperty_rate_per_night').text(obj.data.rate_per_night);
                        $('.bproperty_owner_name').text(obj.data.name);
                        $('.bproperty_owner_phone').text(obj.data.phone);
                        $('.bproperty_owner_email').text(obj.data.email);
                        $('.bproperty_owner_minimum_stay').text(obj.data.minimum_stay+' Days');
                        $('.bproperty_owner_city').text(obj.data.city);
                        $('.bproperty_owner_state').text(obj.data.state);
                        $('.bproperty_owner_area_code').text(obj.data.area_code);
                        $('.bproperty_owner_country').text(obj.data.country);
                        $('.bproperty_page').html('<a href="'+public_path+'#/property-details/'+obj.data.property_id+'">Click Here</a>');
                        

                    }
                },
                error:function(error){

                    
                }
            });
     });
     
     $(document).on('click', 'td>a.view_booking_details', function(){

            var booking_id = $(this).data('id');
            var url = public_path+'api/v1/property-booking-details?booking_id='+booking_id;
            $.ajax({
                url:url,
                method:'get',
                success:function(obj){console.log(obj);

                    if(obj.success==1){

                        $('.prop_holiday_maker_booked_date').text(obj.data.created_at);
                        $('.prop_holiday_maker_arrival_date').text(obj.data.arrival_time);
                        $('.prop_holiday_maker_departure_date').text(obj.data.departure_time);
                        $('.prop_holiday_maker_name').text(obj.data.name);
                        $('.prop_holiday_maker_email').text(obj.data.email);
                        $('.prop_holiday_maker_phone').text(obj.data.phone);
                        $('.prop_holiday_maker_security_deposit').text(obj.data.security_deposit);
                        $('.prop_holiday_maker_coupon_amount').text(obj.data.coupon);
                        $('.prop_holiday_maker_deal_discount').text(obj.data.deal_discount);
                        $('.prop_holiday_maker_guests').text(obj.data.guest_limit);
                        $('.prop_holiday_maker_total_amount').text(obj.data.total_paid_amount);
                        $('.prop_holiday_maker_message').text(obj.data.message);

                    }
                },
                error:function(error){

                    
                }
            });
     });

     $(document).on('click', 'td>a.view_cancel_comment_more_details', function(){

            var holidaymaker_name = $(this).data('user-name');
            var holidaymaker_email = $(this).data('user-email');
            var owner_comment = $(this).data('owner-comment');

            $('#cancel_property_holiday_maker_nm').text(holidaymaker_name);
            $('#cancel_property_holiday_maker_em').text(holidaymaker_email);
            $('#cancel_request_comment').text(owner_comment);
     });

     $(document).on('click', 'td>a.cancelProeprtyBooking', function(){
        var booking_id = $(this).attr('data-booking-id');
        var url = public_path+'super-admin/delete-bookings?booking_id='+booking_id+'&admin_cancel_status=yes';
        $.ajax({                    
            url:url,
            method:'get',          
            success:function(data){
               if(data.success=='1'){
                    var pnotify = new PNotify({
                        title: 'Success',
                        text: data.message,
                        type: 'success',
                        styling: 'bootstrap3',
                        delay: 2000
                    });
                    cancelBookingsListTable.draw();
                }else{

                    var pnotify = new PNotify({
                        title: 'Error',
                        text: data.message,
                        type: 'error',
                        styling: 'bootstrap3',
                        delay: 2000
                    });
                }
            },
            error:function(error){

            }

        });
     });


     $(document).on('click', 'td>a.notCancelProeprtyBooking', function(){
        var booking_id = $(this).attr('data-booking-id');
        var url = public_path+'super-admin/delete-bookings?booking_id='+booking_id+'&admin_cancel_status=no';
        $.ajax({                    
            url:url,
            method:'get',          
            success:function(data){
               if(data.success=='1'){
                    var pnotify = new PNotify({
                        title: 'Success',
                        text: data.message,
                        type: 'success',
                        styling: 'bootstrap3',
                        delay: 2000
                    });
                    cancelBookingsListTable.draw();
                }else{

                    var pnotify = new PNotify({
                        title: 'Error',
                        text: data.message,
                        type: 'error',
                        styling: 'bootstrap3',
                        delay: 2000
                    });
                }
            },
            error:function(error){

            }

        });
     });   
    /*----- Cancel Property Bookings Data table end -----*/

    /*----- Flash Sales Data table start -----*/

    var flashSalesTable = $('#flashSalesTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/flash-sales-json-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'FlashSales- Directowners'
            },
            {
                extend: 'csv',
                filename: 'FlashSales- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
             "data": "minimum_value",
             "name": "minimum_value",
             "defaultContent": '-'
         }, {
             "data": "discount_amount",
             "name": "discount_amount",
             "defaultContent": '-'
         }, {
             "data": "start_date",
             "name": "start_date",
             "defaultContent": '-'
         }, {
             "data": "end_date",
             "name": "end_date",
             "defaultContent": '-'
         }, {
             "data": "coupon_code",
             "name": "coupon_code",
             "defaultContent": '-'
         }, {
             "data": "country",
             "name":"country",
             "defaultContent": '-'
         }, {
             "data": "id",
             "name":"id",
             "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {                      

             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);

             if(aData['discount_type']=='percentage'){

                var discount_amount = '<td class="admin-center">'+aData['discount_amount']+'%</td>';

             }else{

                var discount_amount = '<td class="admin-center">£ '+aData['discount_amount']+'</td>';
             }
             $('td:eq(2)', nRow).html(discount_amount);    
             var url = public_path+'super-admin/flash-sales/edit?id='+aData['id'];  
               
             var td_data = '<td class="admin-center"><a href="'+url+'" title="Edit" class="edit_flash_sale" data-id="'+aData['id']+'"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a>&nbsp;&nbsp; <a href="javascript:void(0)"title="Delete" class="delete_flash_sale" data-id="'+aData['id']+'"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td>';
             var action1 = td_data;
             $('td:eq(6)', nRow).html(action1);
         },

     });

     $(document).on('click', 'td>a.delete_flash_sale', function(){

        var flash_sale_id = $(this).attr('data-id');
        var url         = public_path+'super-admin/delete-flash-sale';
        (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {

                $.ajax({
                    url:url,
                    method:'get',
                    data:'id='+flash_sale_id,
                    success:function(flashObj){
                     console.log(flashObj);
                      if(flashObj.success==0){

                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: flashObj.message,
                                        type: 'error',
                                        styling: 'bootstrap3',                                    
                                      });

                        flashSalesTable.draw();

                      }else if(flashObj.success==1){

                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: flashObj.message,
                                        type: 'success',
                                        styling: 'bootstrap3',                                    
                                      });

                        flashSalesTable.draw();
                      }
                    },
                    error:function(error){

                    }
                  });

                 flashSalesTable.draw();
                $(".ui-pnotify-modal-overlay").remove();

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });          

     });  
    /*----- Flash Sales Data table end -----*/
});
