@extends('layouts.super_admin.main')
@section('script')
<script type="text/javascript" src="{{asset('js/plugins/jquery-1.12.4.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jquery-ui.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jquery.dataTables.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/dataTables.buttons.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jszip.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/buttons.html5.min.js')}}"></script>
<script src="{{asset('super-admin/js/fnPagingInfo.js')}}?r=<?php echo time();?>"></script>
<script type="text/javascript" src="{{asset('js/plugins/buttons.print.min.js')}}"></script>
<script src="{{asset('super-admin/js/super-admin-data-tables.js')}}?r=<?php echo time();?>"></script>
@stop   
@section('content')  
<!-- Enquiries -->
<div class="bhoechie-tab-content admin-tab-content">
  <div class="row add-dashboard-right ">
    <div class="col-md-12 test1 admin-test">
      <h2 class="admin-heading">Holiday Essentials</h2>
      <div class="row form-row ">
          <div class="col-md-3 col-xs-12 form-col ">
               <div class="form-group need-margin-tb admin-vp-link">
                  <a href="{{asset('super-admin/add-holiday-essential')}}"><i class="fa fa-plus" aria-hidden="true"></i>&nbsp; Add Holiday Essential</a>
               </div>
          </div>    
      </div>
      <div class="row form-row">
        <div class="col-md-12 form-col">
          <div class="table-responsive">
            <table class="table" id="HETable">
            <thead>
              <tr>
                <th>Sl.No</th>
                <th>Image</th>                  
                <th>Name</th>
                <th>Web Link</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody>                                                                            
            </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>    
</div>
<script type="text/javascript">
  var HEDataTable = $('#HETable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": super_admin_api_public_path + '/super-admin/holiday-essential-json-list',
             "type": "GET",
             "data": function(d) {
                return $.extend({}, d, {
                     
                });
             }
         },
         buttons: [
            {
                extend: 'excel',
                filename: 'Holiday Essentials- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Holiday Essentials- Directowners'
            }],
         "columns": [{
             "data": "id",
             "name": "id"
         }, {
              "data": "image",
              render:function(data, type, full, index){

                if(full['image']){

                    var img = '<img style="width:20px; height:20px;" src="{{$_s3_path}}/holiday_essentials/'+full['image']+'"/>';
                }else{
                    var img = '<img style="width:20px; height:20px;" src="{{$_s3_path}}/property_images/default.jpg"/>';
                }
                
                return img;
              },
              "defaultContent": '-'
         }, {
             "data": "name",
             "name": "name",
             "defaultContent": '-'
         }, {
              "data": "web_link",
              render:function(data, type, full, index){
                
                var href   = '<a href="'+full['web_link']+'" target="_blank">'+full['web_link']+'</a>'; 
                return href;
              },
             "defaultContent": '-'
         }, {
              "data": "id",
              render:function(data, type, full, index){
                
                            
                var action1 = '<a href="'+super_admin_api_public_path+'/super-admin/edit-holiday-essential/'+full['id']+'" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a> &nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" class="admin-center deleteHEDetails"  data-id="'+full['id']+'" ';
                action1 += 'title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
            

                return action1;
              },
              "defaultContent": '-'
         }],
         

         "order": [
             [0, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {                      

             var page = this.fnPagingInfo().iPage;
             var length = this.fnPagingInfo().iLength;
             var index  = (page * length + (iDisplayIndex +1));
             $('td:eq(0)', nRow).html(index);
         },

     });

     $(document).on('click', 'td>a.deleteHEDetails', function(){

        var id = $(this).attr('data-id');
        var url         = super_admin_api_public_path+'/super-admin/delete-he';
        (new PNotify({
                title: 'Are you sure to want to delete?',
                icon: 'glyphicon glyphicon-question-sign',
                hide: false,
                confirm: {
                  confirm: true
                },
                buttons: {
                  closer: false,
                  sticker: false
                },
                history: {
                  history: false
                },
                addclass: 'stack-modal',
                stack: {
                  'dir1': 'down',
                  'dir2': 'right',
                  'modal': true
                }
            })).get().on('pnotify.confirm', function() {

                $.ajax({
                  url:url,
                  method:'get',
                  data:'id='+id,
                  success:function(data){
                //console.log(data);
                    if(data.success==1){

                        var pnotify = new PNotify({
                                        title: 'Success',
                                        text: data.message,
                                        type: 'success',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                        
                    }else{
                        var pnotify = new PNotify({
                                        title: 'Error',
                                        text: data.message,
                                        type: 'error',
                                        styling: 'bootstrap3',
                                        delay: 2000
                                    });
                    }  

                    HEDataTable.ajax.reload();                    
                  },
                  error:function(error){

                  }
                });
                
                
                $(".ui-pnotify-modal-overlay").remove();

            }).on('pnotify.cancel', function() {
                $(".ui-pnotify-modal-overlay").remove();
            });          

     });
</script>               
 @stop    

