@extends('layouts.super_admin.main')
@section('script')
<script type="text/javascript" src="{{asset('js/plugins/jquery-1.12.4.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jquery-ui.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jquery.dataTables.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/dataTables.buttons.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/jszip.min.js')}}"></script>
<script type="text/javascript" src="{{asset('js/plugins/buttons.html5.min.js')}}"></script>
<script src="{{asset('super-admin/js/fnPagingInfo.js')}}?r=<?php echo time();?>"></script>
<script type="text/javascript" src="{{asset('js/plugins/buttons.print.min.js')}}"></script>
<script src="{{asset('super-admin/js/super-admin-data-tables.js')}}?r=<?php echo time();?>"></script>
@stop   
@section('content')  
<!-- List Properties section -->
    <div class="bhoechie-tab-content admin-tab-content">
    <div class="row add-dashboard-right ">
         <div class="col-md-12 test1 admin-test "> 
                <h2 class="admin-heading">List Properties</h2>
              <form class="propertyListFilters"> 
                 <div class="row form-row ">                                     
                   <div class="col-md-3 form-col">
                      <select name="country" id="country" class="form-control dashboard-drop-down vp-property-drop">
                          <option value="">Country</option>
                          @foreach($countries as $c)
                          <option value="{!!$c['country']!!}">{!! $c['country'] !!}</option>
                          @endforeach
                      </select>
                  </div>
                   <div class="col-md-3 form-col">
                      <select id="space_type" name="space_type" class="form-control dashboard-drop-down vp-property-drop"> 
                          <option value = "" label = "Please Select">Property Type</option>                                          
                          @foreach(Config::get('dropdown.space_type') as $value)
                            <option value="{!!$value!!}" >{!!$value!!}</option> 
                          @endforeach
                      </select> 
                  </div>
                  <div class="col-md-3 form-col">
                      <select name="status" id="status" class="form-control dashboard-drop-down vp-property-drop">
                          <option {{$status === '' ? "selected=selected" : "" }} value=""> Status</option>
                          <option {{$status === 'active' ? "selected=selected" : "" }} value="active">Active</option>
                          <option {{$status === 'inactive' ? "selected=selected" : "" }} value="inactive">In-Active</option>
                      </select>
                  </div>                   
                </div>
              </form>
                <div class="row form-row">
                <div class="col-md-12 form-col">
                  <div class="table-responsive admin-table">
                      <table class="table" id="propertyListTable">
                      
                      <thead>
                        <tr>
                          <th>Image</th>
                          <th>Title</th>
                          <th>Property Type</th>    
                          <th>Country</th>
                          <th>Price</th>
                          <th>Listed Date</th>    
                          <th>Status</th>
                          <th class="admin-center">Edit</th>
                          <th class="admin-center">Delete</th>
                        </tr>
                      </thead>                    
                      
                      <tbody>                      
                         
                      </tbody>
                      </table>
                    </div>
                </div>
            </div>                                                           
        </div>
    </div>       
</div>
<script type="text/javascript">
  
  /*----- Properties Data table start -----*/
    var public_path = super_admin_api_public_path+'/';
    var propertyListTable = $('#propertyListTable').DataTable({
         "dom": '<"html5buttons"B>Tgiltp',
         "bServerSide": true,
         "serverSide": true,
         "processing": true,
         "bRetrieve": true,
         "ajax": {
             "url": public_path + 'super-admin/property-list',
             "type": "GET",
             "data": function(d) {
                 return $.extend({}, d, {
                     "country": $('#country').val() || '',
                     "space_type": $('#space_type').val() || '',
                     "status": $('#status').val() || '',
                 });
             }
         },
         buttons: [
            {
                extend: 'excel',
                text:'Excel',
                filename: 'Properties- Directowners'
            },
            {
                extend: 'csv',
                filename: 'Properties- Directowners'
            }],
         "columns": [{
             "data": "image_name",
             "name": "image_name"
         }, {
             "data": "property_title",
             "name": "property_title",
             "defaultContent": '-'
         }, {
             "data": "space_type",
             "name": "space_type",
             "defaultContent": '-'
         }, {
             "data": "country",
             "name": "country",
             "defaultContent": '-'
         }, {
             "data": "standard_rate_per_week",
             "defaultContent": '-'
         }, {
             "data": "created_at",
             "defaultContent": '-'
         }, {
             "data": "status",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }, {
             "data": "id",
             "defaultContent": '-'
         }],
         

         "order": [
             [5, "desc"]
         ],

         "fnRowCallback": function(nRow, aData, iDisplayIndex) {

           if(aData['property_image']){
               var imageLink = '<img src="{{$_s3_path}}/property_images/' + aData['property_id'] + '/'+aData['property_image']+'">';
               $('td:eq(0)', nRow).html(imageLink);
           }else{
            var imageLink = '<img src="{{$_s3_path}}/property_images/default.jpg">';
               $('td:eq(0)', nRow).html(imageLink);
           } 
             var spc_range_price = aData['min_week_rate']?aData['min_week_rate']:aData['week_rate']   
             var prop_price = aData['standard_rate_per_week']?aData['standard_rate_per_week']:spc_range_price;   
             var td_prop_price = '<td> €'+prop_price+'</td>';            
                         

             $('td:eq(4)', nRow).html(td_prop_price);

             var action = '<td align="center" class="editPropertyDetails">';            
             action += '<a href="' + public_path + 'super-admin/edit-property-details/' + aData['property_id'] + '" class="text-warning mr-sm" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>';
             action += '</td>';            

             $('td:eq(8)', nRow).html(action);             

             var action1 = '<td align="center" class="deletePropertyDetails" data-property-id="'+aData['property_id']+'"><a href="javascript:void(0)"';
             action1 += 'title="Delete" style="color:#337ab7;"><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
             action1 += '</td>';

             $('td:eq(10)', nRow).html(action1);

             
         },

     });

    //  $(document).on('click','deleteUserDetails', function(){
    //     if (confirm("Are you sure to want to delete from database?")){
    //         var userId = $(this).attr('data-user-id');
    //         var deleteUrl = public_path+'api/v1/delete-user/'+userId;
    //         $.ajax({                    
    //             url:deleteUrl,
    //             method:'get',           
    //             success:function(result){

    //                 var pnotify = new PNotify({
    //                                 title: 'Success',
    //                                 text: 'Owner deleted successfully!',
    //                                 type: 'success',
    //                                 styling: 'bootstrap3'
    //                             });                     
    //                 $('#ownersListTable').DataTable().ajax.reload();
    //             },
    //             error:function(error){

    //                 var pnotify = new PNotify({
    //                                 title: 'Error',
    //                                 text: 'Owner not deleted successfully!',
    //                                 type: 'error',
    //                                 styling: 'bootstrap3'
    //                             });
    //             }
    //         });
    //     }
    // });

     $('#country').on('change', function () {
        propertyListTable.draw();
     });

     $('#space_type').on('change', function () {
        propertyListTable.draw();
     });

     $('#status').on('change', function () {
        propertyListTable.draw();
     });
        
    /*----- Properties Data table end -----*/
</script>
 @stop    

