<?php
/**
 * OcrPhotoTextElement
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ocrapi
 *
 * The powerful Optical Character Recognition (OCR) APIs let you convert scanned images of pages into recognized text.
 *
 * OpenAPI spec version: v1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * OcrPhotoTextElement Class Doc Comment
 *
 * @category Class
 * @description A single text in an OCR document
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OcrPhotoTextElement implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'OcrPhotoTextElement';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'text' => 'string',
        'x_left' => 'int',
        'y_top' => 'int',
        'width' => 'int',
        'height' => 'int',
        'bounding_points' => '\Swagger\Client\Model\Point[]',
        'confidence_level' => 'double'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'text' => null,
        'x_left' => 'int32',
        'y_top' => 'int32',
        'width' => 'int32',
        'height' => 'int32',
        'bounding_points' => null,
        'confidence_level' => 'double'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'text' => 'Text',
        'x_left' => 'XLeft',
        'y_top' => 'YTop',
        'width' => 'Width',
        'height' => 'Height',
        'bounding_points' => 'BoundingPoints',
        'confidence_level' => 'ConfidenceLevel'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'text' => 'setText',
        'x_left' => 'setXLeft',
        'y_top' => 'setYTop',
        'width' => 'setWidth',
        'height' => 'setHeight',
        'bounding_points' => 'setBoundingPoints',
        'confidence_level' => 'setConfidenceLevel'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'text' => 'getText',
        'x_left' => 'getXLeft',
        'y_top' => 'getYTop',
        'width' => 'getWidth',
        'height' => 'getHeight',
        'bounding_points' => 'getBoundingPoints',
        'confidence_level' => 'getConfidenceLevel'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['text'] = isset($data['text']) ? $data['text'] : null;
        $this->container['x_left'] = isset($data['x_left']) ? $data['x_left'] : null;
        $this->container['y_top'] = isset($data['y_top']) ? $data['y_top'] : null;
        $this->container['width'] = isset($data['width']) ? $data['width'] : null;
        $this->container['height'] = isset($data['height']) ? $data['height'] : null;
        $this->container['bounding_points'] = isset($data['bounding_points']) ? $data['bounding_points'] : null;
        $this->container['confidence_level'] = isset($data['confidence_level']) ? $data['confidence_level'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets text
     *
     * @return string
     */
    public function getText()
    {
        return $this->container['text'];
    }

    /**
     * Sets text
     *
     * @param string $text Text of the word
     *
     * @return $this
     */
    public function setText($text)
    {
        $this->container['text'] = $text;

        return $this;
    }

    /**
     * Gets x_left
     *
     * @return int
     */
    public function getXLeft()
    {
        return $this->container['x_left'];
    }

    /**
     * Sets x_left
     *
     * @param int $x_left X location of the left edge of the word in pixels
     *
     * @return $this
     */
    public function setXLeft($x_left)
    {
        $this->container['x_left'] = $x_left;

        return $this;
    }

    /**
     * Gets y_top
     *
     * @return int
     */
    public function getYTop()
    {
        return $this->container['y_top'];
    }

    /**
     * Sets y_top
     *
     * @param int $y_top Y location of the top edge of the word in pixels
     *
     * @return $this
     */
    public function setYTop($y_top)
    {
        $this->container['y_top'] = $y_top;

        return $this;
    }

    /**
     * Gets width
     *
     * @return int
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param int $width Width of the word in pixels
     *
     * @return $this
     */
    public function setWidth($width)
    {
        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets height
     *
     * @return int
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param int $height Height of the word in pixels
     *
     * @return $this
     */
    public function setHeight($height)
    {
        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets bounding_points
     *
     * @return \Swagger\Client\Model\Point[]
     */
    public function getBoundingPoints()
    {
        return $this->container['bounding_points'];
    }

    /**
     * Sets bounding_points
     *
     * @param \Swagger\Client\Model\Point[] $bounding_points Points that form the bounding polygon around the text
     *
     * @return $this
     */
    public function setBoundingPoints($bounding_points)
    {
        $this->container['bounding_points'] = $bounding_points;

        return $this;
    }

    /**
     * Gets confidence_level
     *
     * @return double
     */
    public function getConfidenceLevel()
    {
        return $this->container['confidence_level'];
    }

    /**
     * Sets confidence_level
     *
     * @param double $confidence_level Confidence level of the machine learning result; possible values are 0.0 (lowest accuracy) - 1.0 (highest accuracy)
     *
     * @return $this
     */
    public function setConfidenceLevel($confidence_level)
    {
        $this->container['confidence_level'] = $confidence_level;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


