<?php
/**
 * ReceiptRecognitionResult
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ocrapi
 *
 * The powerful Optical Character Recognition (OCR) APIs let you convert scanned images of pages into recognized text.
 *
 * OpenAPI spec version: v1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * ReceiptRecognitionResult Class Doc Comment
 *
 * @category Class
 * @description Result of recognizing a receipt, to extract the key information from the receipt
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ReceiptRecognitionResult implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'ReceiptRecognitionResult';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'successful' => 'bool',
        'timestamp' => '\DateTime',
        'business_name' => 'string',
        'business_website' => 'string',
        'address_string' => 'string',
        'phone_number' => 'string',
        'receipt_items' => '\Swagger\Client\Model\ReceiptLineItem[]',
        'receipt_sub_total' => 'double',
        'receipt_total' => 'double'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'successful' => null,
        'timestamp' => 'date-time',
        'business_name' => null,
        'business_website' => null,
        'address_string' => null,
        'phone_number' => null,
        'receipt_items' => null,
        'receipt_sub_total' => 'double',
        'receipt_total' => 'double'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'successful' => 'Successful',
        'timestamp' => 'Timestamp',
        'business_name' => 'BusinessName',
        'business_website' => 'BusinessWebsite',
        'address_string' => 'AddressString',
        'phone_number' => 'PhoneNumber',
        'receipt_items' => 'ReceiptItems',
        'receipt_sub_total' => 'ReceiptSubTotal',
        'receipt_total' => 'ReceiptTotal'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'successful' => 'setSuccessful',
        'timestamp' => 'setTimestamp',
        'business_name' => 'setBusinessName',
        'business_website' => 'setBusinessWebsite',
        'address_string' => 'setAddressString',
        'phone_number' => 'setPhoneNumber',
        'receipt_items' => 'setReceiptItems',
        'receipt_sub_total' => 'setReceiptSubTotal',
        'receipt_total' => 'setReceiptTotal'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'successful' => 'getSuccessful',
        'timestamp' => 'getTimestamp',
        'business_name' => 'getBusinessName',
        'business_website' => 'getBusinessWebsite',
        'address_string' => 'getAddressString',
        'phone_number' => 'getPhoneNumber',
        'receipt_items' => 'getReceiptItems',
        'receipt_sub_total' => 'getReceiptSubTotal',
        'receipt_total' => 'getReceiptTotal'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['successful'] = isset($data['successful']) ? $data['successful'] : null;
        $this->container['timestamp'] = isset($data['timestamp']) ? $data['timestamp'] : null;
        $this->container['business_name'] = isset($data['business_name']) ? $data['business_name'] : null;
        $this->container['business_website'] = isset($data['business_website']) ? $data['business_website'] : null;
        $this->container['address_string'] = isset($data['address_string']) ? $data['address_string'] : null;
        $this->container['phone_number'] = isset($data['phone_number']) ? $data['phone_number'] : null;
        $this->container['receipt_items'] = isset($data['receipt_items']) ? $data['receipt_items'] : null;
        $this->container['receipt_sub_total'] = isset($data['receipt_sub_total']) ? $data['receipt_sub_total'] : null;
        $this->container['receipt_total'] = isset($data['receipt_total']) ? $data['receipt_total'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets successful
     *
     * @return bool
     */
    public function getSuccessful()
    {
        return $this->container['successful'];
    }

    /**
     * Sets successful
     *
     * @param bool $successful True if the operation was successful, false otherwise
     *
     * @return $this
     */
    public function setSuccessful($successful)
    {
        $this->container['successful'] = $successful;

        return $this;
    }

    /**
     * Gets timestamp
     *
     * @return \DateTime
     */
    public function getTimestamp()
    {
        return $this->container['timestamp'];
    }

    /**
     * Sets timestamp
     *
     * @param \DateTime $timestamp The date and time printed on the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->container['timestamp'] = $timestamp;

        return $this;
    }

    /**
     * Gets business_name
     *
     * @return string
     */
    public function getBusinessName()
    {
        return $this->container['business_name'];
    }

    /**
     * Sets business_name
     *
     * @param string $business_name The name of the business printed on the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setBusinessName($business_name)
    {
        $this->container['business_name'] = $business_name;

        return $this;
    }

    /**
     * Gets business_website
     *
     * @return string
     */
    public function getBusinessWebsite()
    {
        return $this->container['business_website'];
    }

    /**
     * Sets business_website
     *
     * @param string $business_website The website URL of the business printed on the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setBusinessWebsite($business_website)
    {
        $this->container['business_website'] = $business_website;

        return $this;
    }

    /**
     * Gets address_string
     *
     * @return string
     */
    public function getAddressString()
    {
        return $this->container['address_string'];
    }

    /**
     * Sets address_string
     *
     * @param string $address_string The address of the business printed on the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setAddressString($address_string)
    {
        $this->container['address_string'] = $address_string;

        return $this;
    }

    /**
     * Gets phone_number
     *
     * @return string
     */
    public function getPhoneNumber()
    {
        return $this->container['phone_number'];
    }

    /**
     * Sets phone_number
     *
     * @param string $phone_number The phone number printed on the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setPhoneNumber($phone_number)
    {
        $this->container['phone_number'] = $phone_number;

        return $this;
    }

    /**
     * Gets receipt_items
     *
     * @return \Swagger\Client\Model\ReceiptLineItem[]
     */
    public function getReceiptItems()
    {
        return $this->container['receipt_items'];
    }

    /**
     * Sets receipt_items
     *
     * @param \Swagger\Client\Model\ReceiptLineItem[] $receipt_items The individual line items comprising the order; does not include total (see ReceiptTotal)
     *
     * @return $this
     */
    public function setReceiptItems($receipt_items)
    {
        $this->container['receipt_items'] = $receipt_items;

        return $this;
    }

    /**
     * Gets receipt_sub_total
     *
     * @return double
     */
    public function getReceiptSubTotal()
    {
        return $this->container['receipt_sub_total'];
    }

    /**
     * Sets receipt_sub_total
     *
     * @param double $receipt_sub_total Optional; if available, the monetary value of the receipt subtotal - typically not including specialized line items such as Tax. If this value is not available, it will be 0.
     *
     * @return $this
     */
    public function setReceiptSubTotal($receipt_sub_total)
    {
        $this->container['receipt_sub_total'] = $receipt_sub_total;

        return $this;
    }

    /**
     * Gets receipt_total
     *
     * @return double
     */
    public function getReceiptTotal()
    {
        return $this->container['receipt_total'];
    }

    /**
     * Sets receipt_total
     *
     * @param double $receipt_total The total monetary value of the receipt (if included on the receipt)
     *
     * @return $this
     */
    public function setReceiptTotal($receipt_total)
    {
        $this->container['receipt_total'] = $receipt_total;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


